/* Generated automatically by the program `genemit'
from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "optabs.h"
#include "dfp.h"
#include "output.h"
#include "recog.h"
#include "df.h"
#include "resource.h"
#include "reload.h"
#include "diagnostic-core.h"
#include "regs.h"
#include "tm-constrs.h"
#include "ggc.h"
#include "target.h"

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md:365 */
rtx
gen_nop (void)
{
  return const0_rtx;
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md:631 */
rtx
gen_movsi_insn (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	operand1);
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md:722 */
rtx
gen_real_loadv2hi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (2,
		operand0,
		operand1),
	11);
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md:785 */
rtx
gen_movmisaligndi_store (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (DImode,
	gen_rtvec (1,
		operand1),
	2)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md:933 */
rtx
gen_real_zero_extendhi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (2,
		operand0,
		gen_rtx_ZERO_EXTEND (SImode,
	operand1)),
	11);
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md:1383 */
rtx
gen_br_false (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_fmt_ee (GET_CODE (operand0), VOIDmode,
		operand1,
		const0_rtx),
	pc_rtx,
	gen_rtx_LABEL_REF (VOIDmode,
	operand2)));
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md:1592 */
rtx
gen_call_value_shadow (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_CALL (VOIDmode,
	gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		operand1),
	13),
	const0_rtx));
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md:1790 */
rtx
gen_adddf3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_PLUS (DFmode,
	operand1,
	operand2));
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md:1911 */
rtx
gen_floatsidf2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_FLOAT (DFmode,
	operand1));
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md:2053 */
rtx
gen_callp (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (VOIDmode,
	operand0),
	const0_rtx),
		gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		const_int_rtx[MAX_SAVED_CONST_INT + (6)]),
	0)));
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md:2181 */
rtx
gen_lshrsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_LSHIFTRT (SImode,
	operand1,
	operand2));
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md:2402 */
rtx
gen_divmodsi4_insn (void)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (12,
		gen_rtx_SET (gen_rtx_REG (SImode,
	4),
	gen_rtx_DIV (SImode,
	gen_rtx_REG (SImode,
	4),
	gen_rtx_REG (SImode,
	36))),
		gen_rtx_SET (gen_rtx_REG (SImode,
	5),
	gen_rtx_MOD (SImode,
	gen_rtx_REG (SImode,
	4),
	gen_rtx_REG (SImode,
	36))),
		gen_hard_reg_clobber (SImode, 1),
		gen_hard_reg_clobber (SImode, 2),
		gen_hard_reg_clobber (SImode, 6),
		gen_hard_reg_clobber (SImode, 32),
		gen_hard_reg_clobber (SImode, 33),
		gen_hard_reg_clobber (SImode, 34),
		gen_hard_reg_clobber (SImode, 35),
		gen_hard_reg_clobber (SImode, 36),
		gen_hard_reg_clobber (SImode, 62),
		gen_hard_reg_clobber (SImode, 63)));
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md:2788 */
rtx
gen_rcpdf2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (DFmode,
	gen_rtvec (1,
		operand1),
	1));
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md:2970 */
rtx
gen_andv2hi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_AND (V2HImode,
	operand1,
	operand2));
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md:2970 */
rtx
gen_iorv4qi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_IOR (V4QImode,
	operand1,
	operand2));
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md:3001 */
rtx
gen_ss_addv2hi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_SS_PLUS (V2HImode,
	operand1,
	operand2));
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md:3053 */
rtx
gen_umaxv4qi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UMAX (V4QImode,
	operand1,
	operand2));
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md:40 */
rtx
gen_bitrevsi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		operand1),
	7));
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md:151 */
rtx
gen_umulhisi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_MULT (SImode,
	gen_rtx_ZERO_EXTEND (SImode,
	operand1),
	gen_rtx_ZERO_EXTEND (SImode,
	operand2)));
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md:276 */
rtx
gen_umulsidi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_MULT (DImode,
	gen_rtx_ZERO_EXTEND (DImode,
	operand1),
	gen_rtx_ZERO_EXTEND (DImode,
	operand2)));
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md:399 */
rtx
gen_mulhqsq3_hl (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_SS_MULT (SQmode,
	gen_rtx_FRACT_CONVERT (SQmode,
	gen_rtx_TRUNCATE (HQmode,
	operand1)),
	gen_rtx_FRACT_CONVERT (SQmode,
	operand2)));
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md:545 */
rtx
gen_mulhisi3_hl_real (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (2,
		operand0,
		gen_rtx_MULT (SImode,
	gen_rtx_ASHIFTRT (SImode,
	operand1,
	const_int_rtx[MAX_SAVED_CONST_INT + (16)]),
	gen_rtx_SIGN_EXTEND (SImode,
	operand2))),
	12);
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md:697 */
rtx
gen_umulsidi3_real (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (2,
		operand0,
		gen_rtx_MULT (DImode,
	gen_rtx_ZERO_EXTEND (DImode,
	operand1),
	gen_rtx_ZERO_EXTEND (DImode,
	operand2))),
	12);
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md:807 */
rtx
gen_mulhqsq3_lh_real (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (2,
		operand0,
		gen_rtx_SS_MULT (SQmode,
	gen_rtx_FRACT_CONVERT (SQmode,
	operand1),
	gen_rtx_FRACT_CONVERT (SQmode,
	gen_rtx_TRUNCATE (HQmode,
	operand2)))),
	12);
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/sync.md:172 */
rtx
gen_sync_old_subsi_insn (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_MINUS (SImode,
	copy_rtx (operand1),
	operand2)),
	17)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/sync.md:230 */
rtx
gen_sync_old_nandsi_insn (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_NOT (SImode,
	gen_rtx_AND (SImode,
	copy_rtx (operand1),
	operand2))),
	17)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md:688 */
extern rtx_insn *gen_split_9 (rtx_insn *, rtx *);
rtx_insn *
gen_split_9 (rtx_insn *curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx operand4;
  rtx operand5;
  rtx_insn *_val = NULL;
  if (dump_file)
    fprintf (dump_file, "Splitting with gen_split_9 (c6x.md:688)\n");
  start_sequence ();
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 699 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
{
  rtx lo_half[2], hi_half[2];
  split_di (operands, 2, lo_half, hi_half);

  /* We can't have overlap for a register-register move, but if
     memory is involved, we have to make sure we don't clobber the
     address.  */
  if (reg_overlap_mentioned_p (lo_half[0], hi_half[1]))
    {
      operands[2] = hi_half[0];
      operands[3] = hi_half[1];
      operands[4] = lo_half[0];
      operands[5] = lo_half[1];
    }
  else
    {
      operands[2] = lo_half[0];
      operands[3] = lo_half[1];
      operands[4] = hi_half[0];
      operands[5] = hi_half[1];
    }
}
#undef DONE
#undef FAIL
  operand0 = operands[0];
  (void) operand0;
  operand1 = operands[1];
  (void) operand1;
  operand2 = operands[2];
  (void) operand2;
  operand3 = operands[3];
  (void) operand3;
  operand4 = operands[4];
  (void) operand4;
  operand5 = operands[5];
  (void) operand5;
  emit_insn (gen_rtx_SET (operand2,
	operand3));
  emit_insn (gen_rtx_SET (operand4,
	operand5));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md:763 */
rtx
gen_movsi (rtx operand0,
	rtx operand1)
{
  rtx_insn *_val = 0;
  start_sequence ();
  {
    rtx operands[2];
    operands[0] = operand0;
    operands[1] = operand1;
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 767 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
{
  if (expand_move (operands, SImode))
    DONE;
}
#undef DONE
#undef FAIL
    operand0 = operands[0];
    (void) operand0;
    operand1 = operands[1];
    (void) operand1;
  }
  emit_insn (gen_rtx_SET (operand0,
	operand1));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md:763 */
rtx
gen_movv4hi (rtx operand0,
	rtx operand1)
{
  rtx_insn *_val = 0;
  start_sequence ();
  {
    rtx operands[2];
    operands[0] = operand0;
    operands[1] = operand1;
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 767 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
{
  if (expand_move (operands, V4HImode))
    DONE;
}
#undef DONE
#undef FAIL
    operand0 = operands[0];
    (void) operand0;
    operand1 = operands[1];
    (void) operand1;
  }
  emit_insn (gen_rtx_SET (operand0,
	operand1));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md:826 */
extern rtx_insn *gen_split_18 (rtx_insn *, rtx *);
rtx_insn *
gen_split_18 (rtx_insn *curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx_insn *_val = NULL;
  if (dump_file)
    fprintf (dump_file, "Splitting with gen_split_18 (c6x.md:826)\n");
  start_sequence ();
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 839 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
{
  rtx addr = XEXP (operands[1], 0);
  rtx tmpreg = (GET_MODE (operands[0]) == SImode ? operands[0]
		: operand_subword_force (operands[0], 0, DImode));

  if (GET_CODE (addr) == PLUS && XEXP (addr, 0) == stack_pointer_rtx
      && GET_CODE (XEXP (addr, 1)) == CONST_INT)
    {
      unsigned HOST_WIDE_INT val = INTVAL (XEXP (addr, 1));
      val &= GET_MODE_SIZE (SImode) - 1;
      if (val == 0)
	{
	  emit_move_insn (operands[0], operands[1]);
	  DONE;
	}
    }
  operands[2] = change_address (operands[1], SImode, tmpreg);
  emit_move_insn (tmpreg, addr);
}
#undef DONE
#undef FAIL
  operand0 = operands[0];
  (void) operand0;
  operand1 = operands[1];
  (void) operand1;
  operand2 = operands[2];
  (void) operand2;
  emit_insn (gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		operand2),
	2)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md:1188 */
extern rtx_insn *gen_split_22 (rtx_insn *, rtx *);
rtx_insn *
gen_split_22 (rtx_insn *curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx_insn *_val = NULL;
  if (dump_file)
    fprintf (dump_file, "Splitting with gen_split_22 (c6x.md:1188)\n");
  start_sequence ();
  operand0 = operands[0];
  (void) operand0;
  operand1 = operands[1];
  (void) operand1;
  operand2 = operands[2];
  (void) operand2;
  emit_insn (gen_rtx_SET (operand0,
	operand1));
  emit_insn (gen_rtx_SET (copy_rtx (operand0),
	gen_rtx_IF_THEN_ELSE (SImode,
	gen_rtx_NE (SImode,
	copy_rtx (operand0),
	const0_rtx),
	copy_rtx (operand0),
	operand2)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md:1354 */
rtx
gen_cbranchdf4 (rtx operand0,
	rtx operand1,
	rtx operand2,
	rtx operand3)
{
  rtx_insn *_val = 0;
  start_sequence ();
  {
    rtx operands[4];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
    operands[3] = operand3;
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 1362 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
{
  rtx t = c6x_expand_compare (operands[0], VOIDmode);
  operands[0] = t;
  operands[1] = XEXP (t, 0);
  operands[2] = XEXP (t, 1);
}
#undef DONE
#undef FAIL
    operand0 = operands[0];
    (void) operand0;
    operand1 = operands[1];
    (void) operand1;
    operand2 = operands[2];
    (void) operand2;
    operand3 = operands[3];
    (void) operand3;
  }
  emit_jump_insn (gen_rtx_SET (pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_fmt_ee (GET_CODE (operand0), VOIDmode,
		operand1,
		operand2),
	gen_rtx_LABEL_REF (VOIDmode,
	operand3),
	pc_rtx)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md:2145 */
rtx
gen_ctzdi2 (rtx operand0,
	rtx operand1)
{
  rtx_insn *_val = 0;
  start_sequence ();
  {
    rtx operands[2];
    operands[0] = operand0;
    operands[1] = operand1;
#define FAIL _Pragma ("GCC error \"ctzdi2 cannot FAIL\"") (void)0
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 2149 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
{
  rtx tmpreg = gen_reg_rtx (DImode);
  rtx out;
  emit_insn (gen_bitrevsi2 (gen_highpart (SImode, tmpreg),
			    gen_lowpart (SImode, operands[1])));
  emit_insn (gen_bitrevsi2 (gen_lowpart (SImode, tmpreg),
			    gen_highpart (SImode, operands[1])));
  out = expand_unop (DImode, clz_optab, tmpreg, operands[0], 1);
  if (!rtx_equal_p (out, operands[0]))
    emit_move_insn (operands[0], out);
  DONE;
}
#undef DONE
#undef FAIL
    operand0 = operands[0];
    (void) operand0;
    operand1 = operands[1];
    (void) operand1;
  }
  emit_insn (gen_rtx_SET (operand0,
	gen_rtx_CTZ (DImode,
	operand1)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md:2820 */
rtx
gen_divdf3 (rtx operand0,
	rtx operand1,
	rtx operand2)
{
  rtx operand3;
  rtx operand4;
  rtx operand5;
  rtx operand6;
  rtx_insn *_val = 0;
  start_sequence ();
  {
    rtx operands[7];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 2837 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
{
  operands[3] = force_reg (DFmode,
			   const_double_from_real_value (dconst2, DFmode));
  operands[4] = gen_reg_rtx (DFmode);
  operands[5] = gen_reg_rtx (DFmode);
  operands[6] = gen_reg_rtx (DFmode);
}
#undef DONE
#undef FAIL
    operand0 = operands[0];
    (void) operand0;
    operand1 = operands[1];
    (void) operand1;
    operand2 = operands[2];
    (void) operand2;
    operand3 = operands[3];
    (void) operand3;
    operand4 = operands[4];
    (void) operand4;
    operand5 = operands[5];
    (void) operand5;
    operand6 = operands[6];
    (void) operand6;
  }
  emit_insn (gen_rtx_SET (operand4,
	gen_rtx_UNSPEC (DFmode,
	gen_rtvec (1,
		operand2),
	1)));
  emit_insn (gen_rtx_SET (operand5,
	gen_rtx_MULT (DFmode,
	copy_rtx (operand2),
	copy_rtx (operand4))));
  emit_insn (gen_rtx_SET (operand6,
	gen_rtx_MINUS (DFmode,
	operand3,
	copy_rtx (operand5))));
  emit_insn (gen_rtx_SET (copy_rtx (operand4),
	gen_rtx_MULT (DFmode,
	copy_rtx (operand4),
	copy_rtx (operand6))));
  emit_insn (gen_rtx_SET (copy_rtx (operand5),
	gen_rtx_MULT (DFmode,
	copy_rtx (operand2),
	copy_rtx (operand4))));
  emit_insn (gen_rtx_SET (copy_rtx (operand6),
	gen_rtx_MINUS (DFmode,
	copy_rtx (operand3),
	copy_rtx (operand5))));
  emit_insn (gen_rtx_SET (copy_rtx (operand4),
	gen_rtx_MULT (DFmode,
	copy_rtx (operand4),
	copy_rtx (operand6))));
  emit_insn (gen_rtx_SET (copy_rtx (operand5),
	gen_rtx_MULT (DFmode,
	copy_rtx (operand2),
	copy_rtx (operand4))));
  emit_insn (gen_rtx_SET (copy_rtx (operand6),
	gen_rtx_MINUS (DFmode,
	copy_rtx (operand3),
	copy_rtx (operand5))));
  emit_insn (gen_rtx_SET (copy_rtx (operand4),
	gen_rtx_MULT (DFmode,
	copy_rtx (operand4),
	copy_rtx (operand6))));
  emit_insn (gen_rtx_SET (operand0,
	gen_rtx_MULT (DFmode,
	operand1,
	copy_rtx (operand4))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/sync.md:97 */
rtx
gen_sync_nandsi (rtx operand0,
	rtx operand1)
{
  rtx_insn *_val = 0;
  start_sequence ();
  {
    rtx operands[3];
    operands[0] = operand0;
    operands[1] = operand1;
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 106 "../../gcc-15.0.1-20250313/gcc/config/c6x/sync.md"
{
}
#undef DONE
#undef FAIL
    operand0 = operands[0];
    (void) operand0;
    operand1 = operands[1];
    (void) operand1;
  }
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_NOT (SImode,
	gen_rtx_AND (SImode,
	copy_rtx (operand0),
	operand1))),
	17)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)))), false);
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md:826 */
extern rtx_insn *gen_split_34 (rtx_insn *, rtx *);
rtx_insn *
gen_split_34 (rtx_insn *curr_insn ATTRIBUTE_UNUSED, rtx *operands)
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx_insn *_val = NULL;
  if (dump_file)
    fprintf (dump_file, "Splitting with gen_split_34 (c6x.md:826)\n");
  start_sequence ();
#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)
#line 839 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
{
  rtx addr = XEXP (operands[1], 0);
  rtx tmpreg = (GET_MODE (operands[0]) == SImode ? operands[0]
		: operand_subword_force (operands[0], 0, DImode));

  if (GET_CODE (addr) == PLUS && XEXP (addr, 0) == stack_pointer_rtx
      && GET_CODE (XEXP (addr, 1)) == CONST_INT)
    {
      unsigned HOST_WIDE_INT val = INTVAL (XEXP (addr, 1));
      val &= GET_MODE_SIZE (V2HImode) - 1;
      if (val == 0)
	{
	  emit_move_insn (operands[0], operands[1]);
	  DONE;
	}
    }
  operands[2] = change_address (operands[1], V2HImode, tmpreg);
  emit_move_insn (tmpreg, addr);
}
#undef DONE
#undef FAIL
  operand0 = operands[0];
  (void) operand0;
  operand1 = operands[1];
  (void) operand1;
  operand2 = operands[2];
  (void) operand2;
  operand3 = operands[3];
  (void) operand3;
  emit_insn (gen_rtx_COND_EXEC (VOIDmode,
	gen_rtx_fmt_ee (GET_CODE (operand2), VOIDmode,
		operand3,
		const0_rtx),
	gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (V2HImode,
	gen_rtvec (1,
		operand2),
	2))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

