/* Generated automatically by the program `genoutput'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "flags.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "memmodel.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "tm_p.h"
#include "regs.h"
#include "conditions.h"
#include "insn-attr.h"

#include "recog.h"

#include "diagnostic-core.h"
#include "output.h"
#include "target.h"
#include "tm-constrs.h"

static const char * const output_10[] = {
  "addk\t%0,%z1,%2",
  "addik\t%0,%z1,%2",
  "addik\t%0,%z1,%2",
};

static const char * const output_11[] = {
  "add\t%L0,%L1,%L2\n\taddc\t%M0,%M1,%M2",
  "addi\t%L0,%L1,%2\n\taddc\t%M0,%M1,r0",
  "addi\t%L0,%L1,%2\n\taddc\t%M0,%M1,r0\n\taddi\t%M0,%M0,-1",
};

static const char * const output_12[] = {
  "rsubk\t%0,%2,%z1",
  "addik\t%0,%z1,-%2",
};

static const char *
output_13 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 520 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
{
    operands[2] = gen_rtx_REG (SImode, MB_ABI_ASM_TEMP_REGNUM);
    return "mfs\t%2,rpc\n\twic\t%2,r0";
  }
}

static const char * const output_15[] = {
  "mul\t%0,%1,%2",
  "muli\t%0,%1,%2",
  "muli\t%0,%1,%2",
};

static const char * const output_28[] = {
  "and\t%0,%1,%2",
  "andi\t%0,%1,%2 #and1",
  "andi\t%0,%1,%2 #and2",
  "andi\t%0,%1,%2 #and3",
};

static const char * const output_29[] = {
  "or\t%0,%1,%2",
  "ori\t%0,%1,%2",
  "ori\t%0,%1,%2",
  "ori\t%0,%1,%2",
};

static const char * const output_30[] = {
  "xor\t%0,%1,%2",
  "xori\t%0,%1,%2",
  "xori\t%0,%1,%2",
};

static const char * const output_31[] = {
  "andi\t%0,%1,0xffff",
  "lhu%i1\t%0,%1",
  "lhu%i1\t%0,%1",
};

static const char * const output_32[] = {
  "andi\t%0,%1,0x00ff",
  "lbu%i1\t%0,%1",
  "lbu%i1\t%0,%1",
};

static const char * const output_33[] = {
  "andi\t%0,%1,0x00ff",
  "lbu%i1\t%0,%1",
  "lbu%i1\t%0,%1",
};

static const char *
output_36 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 879 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
{ 
     if (which_alternative == 0)
       output_asm_insn ("addk\t%L0,r0,%1", operands);
     else
       output_asm_insn ("lw%i1\t%L0,%1", operands);

     output_asm_insn ("add\t%M0,%L0,%L0", operands);
     output_asm_insn ("addc\t%M0,r0,r0", operands);
     output_asm_insn ("beqi\t%M0,.+8", operands);
     return "addi\t%M0,r0,0xffffffff";
  }
}

static const char *
output_37 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 940 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
{ 
    switch (which_alternative)
    {
      case 0:
        return "addk\t%0,%1\n\taddk\t%D0,%d1";
      case 1:
	return "addik\t%M0,r0,%h1\n\taddik\t%L0,r0,%j1 #li => la";
      case 2:
	  return "addk\t%0,r0,r0\n\taddk\t%D0,r0,r0";
      case 3:
      case 4:
        if (reg_mentioned_p (operands[0], operands[1]))
          return "lwi\t%D0,%o1\n\tlwi\t%0,%1";
	else
	  return "lwi\t%0,%1\n\tlwi\t%D0,%o1";
      case 5:
      case 6:
        return "swi\t%1,%0\n\tswi\t%D1,%o0";
    }
    return "unreachable";
  }
}

static const char * const output_38[] = {
  "mfs\t%0,%1  #mfs",
  "addk\t%0,%1,r0 #add movsi",
  "mts\t%0,%1  #mts",
};

static const char * const output_39[] = {
  "addk\t%0,r0,r0",
  "addik\t%0,r0,%1\t# %X1",
  "addik\t%0,r0,%1\t# %X1",
};

static const char *
output_40 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1036 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
{ 
     gcc_unreachable ();
  }
}

static const char * const output_41[] = {
  "addk\t%0,%1,r0",
  "addik\t%0,r0,%1\t# %X1",
  "addik\t%0,%a1",
  "lw%i1\t%0,%1",
  "lw%i1\t%0,%1",
  "sw%i0\t%z1,%0",
  "sw%i0\t%z1,%0",
};

static const char * const output_42[] = {
  "addik\t%0,r0,%1\t# %X1",
  "addk\t%0,%1,r0",
  "lhu%i1\t%0,%1",
  "lhu%i1\t%0,%1",
  "sh%i0\t%z1,%0",
  "sh%i0\t%z1,%0",
};

static const char * const output_43[] = {
  "addk\t%0,r0,%z1",
  "addik\t%0,r0,%1\t# %X1",
  "addk\t%0,%1,r0",
  "lbu%i1\t%0,%1",
  "lbu%i1\t%0,%1",
  "sb%i0\t%z1,%0",
  "sbi\t%z1,%0",
};

static const char * const output_44[] = {
  "lwr\t%0,%y1,r0",
  "swr\t%1,%y0,r0",
};

static const char * const output_45[] = {
  "addk\t%0,r0,r0",
  "addk\t%0,%1,r0",
  "lw%i1\t%0,%1",
  "addik\t%0,r0,%F1",
  "lw%i1\t%0,%1",
  "sw%i0\t%z1,%0",
  "swi\t%z1,%0",
};

static const char *
output_46 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1252 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
{
    switch (which_alternative)
    {
      case 0:
	return "addk\t%0,r0,r0\n\taddk\t%D0,r0,r0";
      case 1:
      case 3:
	if (reg_mentioned_p (operands[0], operands[1]))
          return "lwi\t%D0,%o1\n\tlwi\t%0,%1";
        else
	  return "lwi\t%0,%1\n\tlwi\t%D0,%o1";
      case 2:
      {
	return "addik\t%0,r0,%h1 \n\taddik\t%D0,r0,%j1 #Xfer Lo";
      }
      case 4:
	return "swi\t%1,%0\n\tswi\t%D1,%o0";
    }
    gcc_unreachable ();
  }
}

static const char * const output_48[] = {
  "bslli\t%0,%1,%2",
  "bsll\t%0,%1,%2",
};

static const char *
output_51 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1379 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
{
    operands[3] = gen_rtx_REG (SImode, MB_ABI_ASM_TEMP_REGNUM);

    output_asm_insn ("ori\t%3,r0,%2", operands);
    if (REGNO (operands[0]) != REGNO (operands[1]))
        output_asm_insn ("addk\t%0,%1,r0", operands);

    output_asm_insn ("addik\t%3,%3,-1", operands);
    output_asm_insn ("bneid\t%3,.-4", operands);
    return "addk\t%0,%0,%0";
  }
}

static const char *
output_52 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1400 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
{
    int i, nshift;
    
    nshift = INTVAL (operands[2]);
    operands[3] = gen_int_mode (0xFFFFFFFF << nshift, SImode);

    /* We do one extra shift so that the first bit (carry) coming into the MSB
       will be masked out */
    output_asm_insn ("src\t%0,%1", operands);
    for (i = 0; i < (32 - nshift); i++)
       output_asm_insn ("src\t%0,%0", operands);

    return "andi\t%0,%0,%3";
  }
}

static const char *
output_53 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1424 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
{
    int i;
    int nshift = INTVAL (operands[2]);
    if (REGNO (operands[0]) != REGNO (operands[1]))
      output_asm_insn ("addk\t%0,r0,%1", operands);
    output_asm_insn ("addk\t%0,%1,%1", operands);
    for (i = 0; i < (nshift - 2); i++)
      output_asm_insn ("addk\t%0,%0,%0", operands);
    return "addk\t%0,%0,%0";
  }
}

static const char *
output_54 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1444 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
{
    operands[3] = gen_rtx_REG (SImode, MB_ABI_ASM_TEMP_REGNUM);
    output_asm_insn ("andi\t%3,%2,31", operands);
    if (REGNO (operands[0]) != REGNO (operands[1])) 
      output_asm_insn ("addk\t%0,r0,%1", operands);
    /* Exit the loop if zero shift. */
    output_asm_insn ("beqid\t%3,.+20", operands);
    /* Emit the loop.  */
    output_asm_insn ("addk\t%0,%0,r0", operands);
    output_asm_insn ("addik\t%3,%3,-1", operands);
    output_asm_insn ("bneid\t%3,.-4", operands);
    return "addk\t%0,%0,%0";
  }
}

static const char * const output_56[] = {
  "bsrai\t%0,%1,%2",
  "bsra\t%0,%1,%2",
};

static const char *
output_57 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1513 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
{
    int i;
    int nshift = INTVAL (operands[2]);
    if (REGNO (operands[0]) != REGNO (operands[1]))
      output_asm_insn ("addk\t%0,r0,%1", operands);
    output_asm_insn ("sra\t%0,%1", operands);
    for (i = 0; i < (nshift - 2); i++)
      output_asm_insn ("sra\t%0,%0", operands);
    return "sra\t%0,%0";
  }
}

static const char *
output_58 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1533 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
{
    operands[3] = gen_rtx_REG (SImode, MB_ABI_ASM_TEMP_REGNUM);
    output_asm_insn ("andi\t%3,%2,31", operands);
    if (REGNO (operands[0]) != REGNO (operands[1])) 
      output_asm_insn ("addk\t%0,r0,%1", operands);
    /* Exit the loop if zero shift. */
    output_asm_insn ("beqid\t%3,.+20", operands);
    /* Emit the loop.  */
    output_asm_insn ("addk\t%0,%0,r0", operands);
    output_asm_insn ("addik\t%3,%3,-1", operands);
    output_asm_insn ("bneid\t%3,.-4", operands);
    return "sra\t%0,%0";
  }
}

static const char * const output_60[] = {
  "bsrli\t%0,%1,%2",
  "bsrl\t%0,%1,%2",
};

static const char *
output_61 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1602 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
{
    int i;
    int nshift = INTVAL (operands[2]);
    if (REGNO (operands[0]) != REGNO (operands[1]))
      output_asm_insn ("addk\t%0,r0,%1", operands);
    output_asm_insn ("srl\t%0,%1", operands);
    for (i = 0; i < (nshift - 2); i++)
      output_asm_insn ("srl\t%0,%0", operands);
    return "srl\t%0,%0";
  }
}

static const char *
output_62 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1622 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
{
    operands[3] = gen_rtx_REG (SImode, MB_ABI_ASM_TEMP_REGNUM);
    output_asm_insn ("andi\t%3,%2,31", operands);
    if (REGNO (operands[0]) != REGNO (operands[1])) 
      output_asm_insn ("addk\t%0,r0,%1", operands);
    /* Exit the loop if zero shift. */
    output_asm_insn ("beqid\t%3,.+20", operands);
    /* Emit the loop.  */
    output_asm_insn ("addk\t%0,%0,r0", operands);
    output_asm_insn ("addik\t%3,%3,-1", operands);
    output_asm_insn ("bneid\t%3,.-4", operands);
    return "srl\t%0,%0";
  }
}

static const char *
output_66 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1753 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
{
    if (operands[3] == pc_rtx) 
      return "b%C0i%?\t%z1,%2";
    else 
      return "b%N0i%?\t%z1,%3";
  }
}

static const char *
output_67 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1774 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
{
    operands[4] = gen_rtx_REG (SImode, MB_ABI_ASM_TEMP_REGNUM);
    enum rtx_code code = GET_CODE (operands[0]);

    if (code == GT || code == LE)
      {
        output_asm_insn ("cmp\tr18,%z1,%z2", operands);
        code = swap_condition (code);
      }
    else if (code == GTU || code == LEU)
      {
        output_asm_insn ("cmpu\tr18,%z1,%z2", operands);
        code = swap_condition (code);
      }
    else if (code == GE || code == LT)
      {
        output_asm_insn ("cmp\tr18,%z2,%z1", operands);
      }
    else if (code == GEU || code == LTU)
      {
        output_asm_insn ("cmpu\tr18,%z2,%z1", operands);
      }

    operands[0] = gen_rtx_fmt_ee (signed_condition (code), SImode, operands[4], const0_rtx);
    return "b%C0i%?\tr18,%3";
  }
}

static const char *
output_68 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1812 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
{
    if (GET_CODE (operands[0]) == REG)
        return "br%?\t%0";
    else	
        return "bri%?\t%l0";
  }
}

static const char *
output_71 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1889 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
{
    output_asm_insn ("addk\t%0,%0,r20",operands);
    return "bra%?\t%0";
}
}

static const char *
output_72 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2001 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
{
    if (microblaze_is_break_handler ())
        return "rtbd\tr16, 8\n\t%#";
    else if (microblaze_is_interrupt_variant ())
        return "rtid\tr14, 0\n\t%#";
    else
        return "rtsd\tr15, 8\n\t%#";
  }
}

static const char *
output_73 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2001 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
{
    if (microblaze_is_break_handler ())
        return "rtbd\tr16, 8\n\t%#";
    else if (microblaze_is_interrupt_variant ())
        return "rtid\tr14, 0\n\t%#";
    else
        return "rtsd\tr15, 8\n\t%#";
  }
}

static const char *
output_74 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2020 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
{
    if (microblaze_is_break_handler ())
        return "rtbd\tr16,8\n\t%#";
    else if (microblaze_is_interrupt_variant ())
        return "rtid\tr14,0 \n\t%#";
    else
        return "rtsd\tr15,8 \n\t%#";
  }
}

static const char *
output_75 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2020 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
{
    if (microblaze_is_break_handler ())
        return "rtbd\tr16,8\n\t%#";
    else if (microblaze_is_interrupt_variant ())
        return "rtid\tr14,0 \n\t%#";
    else
        return "rtsd\tr15,8 \n\t%#";
  }
}

static const char *
output_77 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2109 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
{
    rtx target2
      = gen_rtx_REG (Pmode, GP_REG_FIRST + MB_ABI_SUB_RETURN_ADDR_REGNUM);
    gen_rtx_CLOBBER (VOIDmode, target2);
    return "brlid\tr15,%0\n\t%#";
  }
}

static const char *
output_78 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2124 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
{
    rtx target = operands[0];
    rtx target2
      = gen_rtx_REG (Pmode, GP_REG_FIRST + MB_ABI_SUB_RETURN_ADDR_REGNUM);
    if (GET_CODE (target) == SYMBOL_REF) {
        if (microblaze_break_function_p (SYMBOL_REF_DECL (target))) {
            gen_rtx_CLOBBER (VOIDmode, target2);
            return "brki\tr16,%0\n\t%#";
        }
        else {
            gen_rtx_CLOBBER (VOIDmode, target2);
            return "brlid\tr15,%0\n\t%#";
        }
    } else if (GET_CODE (target) == CONST_INT)
        return "la\t%@,r0,%0\n\tbrald\tr15,%@\n\t%#";
    else if (GET_CODE (target) == REG)
        return "brald\tr15,%0\n\t%#";	
    else {
        fprintf (stderr,"Unsupported call insn\n");
        return NULL;
    }
  }
}

static const char *
output_79 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2218 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
{ 
    rtx target2
      = gen_rtx_REG (Pmode,GP_REG_FIRST + MB_ABI_SUB_RETURN_ADDR_REGNUM);

    gen_rtx_CLOBBER (VOIDmode,target2);
    return "brlid\tr15,%1\n\t%#";
  }
}

static const char *
output_80 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2235 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
{ 
    rtx target = operands[1];
    rtx target2
      = gen_rtx_REG (Pmode,GP_REG_FIRST + MB_ABI_SUB_RETURN_ADDR_REGNUM);

    if (GET_CODE (target) == SYMBOL_REF)
    {
      gen_rtx_CLOBBER (VOIDmode,target2);
      if (microblaze_break_function_p (SYMBOL_REF_DECL (target)))
        return "brki\tr16,%1\n\t%#";
      else if (SYMBOL_REF_FLAGS (target) & SYMBOL_FLAG_FUNCTION)
        {
	  return "brlid\tr15,%1\n\t%#";
        }
      else
        {
	    return "bralid\tr15,%1\n\t%#";
        }
    }
    else if (GET_CODE (target) == CONST_INT)
        return "la\t%@,r0,%1\n\tbrald\tr15,%@\n\t%#";
    else if (GET_CODE (target) == REG)
        return "brald\tr15,%1\n\t%#";	
    else 
        return "Unsupported call insn\n";
  }
}

static const char *
output_86 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 31 "../../gcc-15.0.1-20250313/gcc/config/microblaze/sync.md"
{
    output_asm_insn ("addc \tr0,r0,r0", operands);
    output_asm_insn ("lwx  \t%1,%y2,r0", operands);
    output_asm_insn ("addic\t%8,r0,0", operands);
    output_asm_insn ("bnei \t%8,.-8", operands);
    output_asm_insn ("cmp  \t%0,%1,%3", operands);
    output_asm_insn ("bnei \t%0,.+16", operands);
    output_asm_insn ("swx  \t%4,%y2,r0", operands);
    output_asm_insn ("addic\t%8,r0,0", operands);
    output_asm_insn ("bnei \t%8,.-28", operands);
    return "";
  }
}



static const struct insn_operand_data operand_data[] = 
{
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    0,
    0
  },
  {
    register_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=d",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "d",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "d",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=d",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "d",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=d,d,d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    reg_or_0_operand,
    "%dJ,dJ,dJ",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_plus_operand,
    "d,I,i",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=d,d,d",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%d,d,d",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand32,
    "d,P,N",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=d,d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "d,d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "d,n",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "n",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=&d",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "d",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand32,
    "d",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=d,d,d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "d,d,d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "d,I,i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=&d",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=d",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "d",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=d,d,d,d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "%d,d,d,d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "d,I,i,M",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=d,d,d,d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "%d,d,d,d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "d,I,M,i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=d,d,d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "%d,d,d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "d,I,i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=d,d,d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "d,R,m",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=d,d,d",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "d,R,m",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=d,d,d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "d,R,m",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "d",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "d",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=d,d,d",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "d,R,m",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=d,d,d,d,d,R,o",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "d,i,J,R,o,d,d",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=d,d,z",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "z,d,d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "=d,d,d",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    immediate_operand,
    "J,I,Mnis",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=d,d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    call_insn_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=d,d,d,d,d,R,m",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    move_src_operand,
    "d,I,Mnis,R,m,dJ,dJ",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=d,d,d,d,R,m",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "I,d,R,m,dJ,dJ",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=d,d,d,d,d,R,m",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "J,I,d,R,m,dJ,dJ",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    reg_or_mem_operand,
    "=r,Q",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    reg_or_mem_operand,
    "Q,r",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=d,d,d,d,d,R,m",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "G,d,R,F,m,d,d",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=d,d,d,d,o",
    E_DFmode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "dG,o,F,T,d",
    E_DFmode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "I",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=d,d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "d,d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "I,d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    immediate_operand,
    "I",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=&d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    immediate_operand,
    "I",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=&d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    ordered_comparison_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    ordered_comparison_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    pc_or_label_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    pc_or_label_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    cmp_op,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    call_insn_plt_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    call_insn_simple_operand,
    "ri",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=d",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    call_insn_plt_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=d",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    call_insn_operand,
    "ri",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=&d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=&d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "+Q",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    scratch_operand,
    "=&d",
    E_SImode,
    0,
    0,
    0,
    0
  },
  {
    nonimmediate_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_BLKmode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_BLKmode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "",
    E_DFmode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_DFmode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=&d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    ordered_comparison_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    ordered_comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "I,i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    ordered_comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    ordered_comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "d",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "d",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "d",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    memory_operand,
    "m",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=d",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    memory_operand,
    "m",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
};


#if GCC_VERSION >= 2007
__extension__
#endif

const struct insn_data_d insn_data[] = 
{
  /* <internal>:0 */
  {
    "*placeholder_for_nothing",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { 0 },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:362 */
  {
    "bswapsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "swapb %0, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_bswapsi2 },
    &operand_data[1],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:369 */
  {
    "bswaphi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "swapb %0, %1\n\
   swaph %0, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_bswaphi2 },
    &operand_data[3],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:392 */
  {
    "addsf3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "fadd\t%0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addsf3 },
    &operand_data[5],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:402 */
  {
    "subsf3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "frsub\t%0,%2,%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subsf3 },
    &operand_data[5],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:412 */
  {
    "mulsf3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "fmul\t%0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsf3 },
    &operand_data[5],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:423 */
  {
    "divsf3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "fdiv\t%0,%2,%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_divsf3 },
    &operand_data[5],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:433 */
  {
    "sqrtsf2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "fsqrt\t%0,%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sqrtsf2 },
    &operand_data[5],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:442 */
  {
    "floatsisf2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "flt\t%0,%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_floatsisf2 },
    &operand_data[8],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:451 */
  {
    "fix_truncsfsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "fint\t%0,%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_fix_truncsfsi2 },
    &operand_data[10],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:466 */
  {
    "addsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_10 },
#else
    { 0, output_10, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addsi3 },
    &operand_data[12],
    3,
    3,
    0,
    3,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:487 */
  {
    "adddi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_11 },
#else
    { 0, output_11, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_adddi3 },
    &operand_data[15],
    3,
    3,
    0,
    3,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:504 */
  {
    "subsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_12 },
#else
    { 0, output_12, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subsi3 },
    &operand_data[18],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:516 */
  {
    "iprefetch",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_13 },
#else
    { 0, 0, output_13 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_iprefetch },
    &operand_data[21],
    1,
    1,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:532 */
  {
    "subdi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "rsub\t%L0,%L2,%L1\n\trsubc\t%M0,%M2,%M1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subdi3 },
    &operand_data[22],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:547 */
  {
    "mulsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_15 },
#else
    { 0, output_15, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsi3 },
    &operand_data[25],
    3,
    3,
    0,
    3,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:560 */
  {
    "mulsidi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mul\t%L0,%1,%2\n\tmulh\t%M0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsidi3 },
    &operand_data[28],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:571 */
  {
    "umulsidi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mul\t%L0,%1,%2\n\tmulhu\t%M0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_umulsidi3 },
    &operand_data[28],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:582 */
  {
    "usmulsidi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mul\t%L0,%1,%2\n\tmulhsu\t%M0,%2,%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_usmulsidi3 },
    &operand_data[28],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:593 */
  {
    "*smulsi3_highpart",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mulh\t%0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[31],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:606 */
  {
    "*umulsi3_highpart",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mulhu\t%0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[31],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:620 */
  {
    "*usmulsi3_highpart",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mulhsu\t%0,%2,%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[31],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:659 */
  {
    "divsi3_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "idiv\t%0,%2,%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_divsi3_internal },
    &operand_data[31],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:671 */
  {
    "udivsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "idivu\t%0,%2,%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_udivsi3 },
    &operand_data[31],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:712 */
  {
    "negsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "rsubk\t%0,%1,r0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_negsi2 },
    &operand_data[31],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:721 */
  {
    "negdi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "rsub\t%L0,%L1,r0\n\trsubc\t%M0,%M1,r0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_negdi2 },
    &operand_data[34],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:731 */
  {
    "one_cmplsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "xori\t%0,%1,-1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_one_cmplsi2 },
    &operand_data[31],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:740 */
  {
    "*one_cmpldi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "nor\t%M0,r0,%M1\n\tnor\t%L0,r0,%L1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[34],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:766 */
  {
    "andsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_28 },
#else
    { 0, output_28, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_andsi3 },
    &operand_data[36],
    3,
    3,
    0,
    4,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:781 */
  {
    "iorsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_29 },
#else
    { 0, output_29, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_iorsi3 },
    &operand_data[39],
    3,
    3,
    0,
    4,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:795 */
  {
    "xorsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_30 },
#else
    { 0, output_30, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_xorsi3 },
    &operand_data[42],
    3,
    3,
    0,
    3,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:812 */
  {
    "zero_extendhisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_31 },
#else
    { 0, output_31, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendhisi2 },
    &operand_data[45],
    2,
    2,
    0,
    3,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:824 */
  {
    "zero_extendqihi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_32 },
#else
    { 0, output_32, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendqihi2 },
    &operand_data[47],
    2,
    2,
    0,
    3,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:836 */
  {
    "zero_extendqisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_33 },
#else
    { 0, output_33, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendqisi2 },
    &operand_data[49],
    2,
    2,
    0,
    3,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:854 */
  {
    "extendqisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "sext8\t%0,%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendqisi2 },
    &operand_data[51],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:863 */
  {
    "extendhisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "sext16\t%0,%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendhisi2 },
    &operand_data[53],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:875 */
  {
    "extendsidi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_36 },
#else
    { 0, 0, output_36 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendsidi2 },
    &operand_data[55],
    2,
    2,
    0,
    3,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:936 */
  {
    "*movdi_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_37 },
#else
    { 0, 0, output_37 },
#endif
    { 0 },
    &operand_data[57],
    2,
    2,
    0,
    7,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1003 */
  {
    "movsi_status",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_38 },
#else
    { 0, output_38, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsi_status },
    &operand_data[59],
    2,
    2,
    0,
    3,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1016 */
  {
    "*movsi_internal3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_39 },
#else
    { 0, output_39, 0 },
#endif
    { 0 },
    &operand_data[61],
    2,
    2,
    0,
    3,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1031 */
  {
    "*movsi_internal5_pltop",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_40 },
#else
    { 0, 0, output_40 },
#endif
    { 0 },
    &operand_data[63],
    2,
    2,
    0,
    2,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1043 */
  {
    "*movsi_internal2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_41 },
#else
    { 0, output_41, 0 },
#endif
    { 0 },
    &operand_data[65],
    2,
    2,
    0,
    7,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1085 */
  {
    "*movhi_internal2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_42 },
#else
    { 0, output_42, 0 },
#endif
    { 0 },
    &operand_data[67],
    2,
    2,
    0,
    6,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1125 */
  {
    "*movqi_internal2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_43 },
#else
    { 0, output_43, 0 },
#endif
    { 0 },
    &operand_data[69],
    2,
    2,
    0,
    7,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1163 */
  {
    "movsi4_rev",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_44 },
#else
    { 0, output_44, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsi4_rev },
    &operand_data[71],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1196 */
  {
    "*movsf_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_45 },
#else
    { 0, output_45, 0 },
#endif
    { 0 },
    &operand_data[73],
    2,
    2,
    0,
    7,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1248 */
  {
    "*movdf_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_46 },
#else
    { 0, 0, output_46 },
#endif
    { 0 },
    &operand_data[75],
    2,
    2,
    0,
    5,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1322 */
  {
    "*ashlsi3_byone",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "addk\t%0,%1,%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[77],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1334 */
  {
    "ashlsi3_bshift",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_48 },
#else
    { 0, output_48, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashlsi3_bshift },
    &operand_data[80],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1349 */
  {
    "*ashlsi3_with_mul_delay",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "muli\t%0,%1,%m2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[83],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1362 */
  {
    "*ashlsi3_with_mul_nodelay",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "muli\t%0,%1,%m2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[83],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1374 */
  {
    "*ashlsi3_with_size_opt",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_51 },
#else
    { 0, 0, output_51 },
#endif
    { 0 },
    &operand_data[86],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1395 */
  {
    "*ashlsi3_with_rotate",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_52 },
#else
    { 0, 0, output_52 },
#endif
    { 0 },
    &operand_data[86],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1419 */
  {
    "*ashlsi_inline",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_53 },
#else
    { 0, 0, output_53 },
#endif
    { 0 },
    &operand_data[86],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1439 */
  {
    "*ashlsi_reg",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_54 },
#else
    { 0, 0, output_54 },
#endif
    { 0 },
    &operand_data[89],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1483 */
  {
    "*ashrsi3_byone",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "sra\t%0,%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[77],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1495 */
  {
    "*ashrsi3_bshift",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_56 },
#else
    { 0, output_56, 0 },
#endif
    { 0 },
    &operand_data[80],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1508 */
  {
    "*ashrsi_inline",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_57 },
#else
    { 0, 0, output_57 },
#endif
    { 0 },
    &operand_data[86],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1528 */
  {
    "*ashrsi_reg",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_58 },
#else
    { 0, 0, output_58 },
#endif
    { 0 },
    &operand_data[89],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1572 */
  {
    "*lshrsi3_byone",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "srl\t%0,%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[77],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1584 */
  {
    "*lshrsi3_bshift",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_60 },
#else
    { 0, output_60, 0 },
#endif
    { 0 },
    &operand_data[80],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1597 */
  {
    "*lshrsi_inline",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_61 },
#else
    { 0, 0, output_61 },
#endif
    { 0 },
    &operand_data[86],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1617 */
  {
    "*lshrsi_reg",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_62 },
#else
    { 0, 0, output_62 },
#endif
    { 0 },
    &operand_data[89],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1654 */
  {
    "seq_internal_pat",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "pcmpeq\t%0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_seq_internal_pat },
    &operand_data[31],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1666 */
  {
    "sne_internal_pat",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "pcmpne\t%0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sne_internal_pat },
    &operand_data[31],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1681 */
  {
    "cstoresf4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "fcmp.%C1\t%0,%3,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cstoresf4 },
    &operand_data[92],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1744 */
  {
    "branch_zero",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_66 },
#else
    { 0, 0, output_66 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_branch_zero },
    &operand_data[96],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1764 */
  {
    "branch_compare",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_67 },
#else
    { 0, 0, output_67 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_branch_compare },
    &operand_data[100],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1808 */
  {
    "jump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_68 },
#else
    { 0, 0, output_68 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_jump },
    &operand_data[103],
    1,
    1,
    0,
    0,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1837 */
  {
    "indirect_jump_internal1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "bra%?\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_indirect_jump_internal1 },
    &operand_data[9],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1861 */
  {
    "tablejump_internal1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "bra%?\t%0 ",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_tablejump_internal1 },
    &operand_data[102],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1881 */
  {
    "*microblaze.md:1881",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_71 },
#else
    { 0, 0, output_71 },
#endif
    { 0 },
    &operand_data[102],
    2,
    2,
    1,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1998 */
  {
    "*return",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_72 },
#else
    { 0, 0, output_72 },
#endif
    { 0 },
    &operand_data[0],
    0,
    0,
    0,
    0,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1998 */
  {
    "*simple_return",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_73 },
#else
    { 0, 0, output_73 },
#endif
    { 0 },
    &operand_data[0],
    0,
    0,
    0,
    0,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:2016 */
  {
    "return_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_74 },
#else
    { 0, 0, output_74 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_return_internal },
    &operand_data[104],
    1,
    1,
    0,
    0,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:2016 */
  {
    "simple_return_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_75 },
#else
    { 0, 0, output_75 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_simple_return_internal },
    &operand_data[104],
    1,
    1,
    0,
    0,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:2035 */
  {
    "blockage",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_blockage },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:2103 */
  {
    "call_internal_plt",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_77 },
#else
    { 0, 0, output_77 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_internal_plt },
    &operand_data[105],
    2,
    2,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:2119 */
  {
    "call_internal1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_78 },
#else
    { 0, 0, output_78 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_internal1 },
    &operand_data[107],
    2,
    2,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:2211 */
  {
    "call_value_intern_plt",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_79 },
#else
    { 0, 0, output_79 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_value_intern_plt },
    &operand_data[109],
    5,
    5,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:2229 */
  {
    "call_value_intern",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_80 },
#else
    { 0, 0, output_80 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_value_intern },
    &operand_data[114],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:2296 */
  {
    "nop",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "nop",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_nop },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:2305 */
  {
    "trap",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "bri\t0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_trap },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:2314 */
  {
    "set_got",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mfs\t%0,rpc\n\taddik\t%0,%0,_GLOBAL_OFFSET_TABLE_+8",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_set_got },
    &operand_data[1],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:2325 */
  {
    "set_text",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mfs\t%0,rpc\n\taddik\t%0,%0,8@TXTPCREL",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_set_text },
    &operand_data[1],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:2336 */
  {
    "clzsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "clz\t%0,%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_clzsi2 },
    &operand_data[1],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/sync.md:20 */
  {
    "atomic_compare_and_swapsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_86 },
#else
    { 0, 0, output_86 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_atomic_compare_and_swapsi },
    &operand_data[118],
    8,
    9,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:638 */
  {
    "divsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_divsi3 },
    &operand_data[31],
    3,
    3,
    0,
    1,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:904 */
  {
    "movdi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movdi },
    &operand_data[127],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:993 */
  {
    "movsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsi },
    &operand_data[129],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1067 */
  {
    "movhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movhi },
    &operand_data[131],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1107 */
  {
    "movqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movqi },
    &operand_data[133],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1147 */
  {
    "cpymemsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cpymemsi },
    &operand_data[135],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1176 */
  {
    "movsf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsf },
    &operand_data[139],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1215 */
  {
    "movdf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movdf },
    &operand_data[141],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1305 */
  {
    "ashlsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashlsi3 },
    &operand_data[143],
    3,
    3,
    0,
    1,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1466 */
  {
    "ashrsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashrsi3 },
    &operand_data[143],
    3,
    3,
    0,
    1,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1555 */
  {
    "lshrsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_lshrsi3 },
    &operand_data[143],
    3,
    3,
    0,
    1,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1643 */
  {
    "cstoresi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cstoresi4 },
    &operand_data[146],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1697 */
  {
    "cbranchsi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchsi4 },
    &operand_data[150],
    4,
    4,
    0,
    2,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1710 */
  {
    "cbranchsi4_reg",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchsi4_reg },
    &operand_data[154],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1723 */
  {
    "cbranchsf4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchsf4 },
    &operand_data[158],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1738 */
  {
    "condjump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_condjump },
    &operand_data[161],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1822 */
  {
    "indirect_jump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_indirect_jump },
    &operand_data[163],
    1,
    1,
    0,
    1,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1845 */
  {
    "tablejump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_tablejump },
    &operand_data[163],
    2,
    2,
    0,
    1,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1871 */
  {
    "tablejump_internal3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_tablejump_internal3 },
    &operand_data[165],
    2,
    2,
    1,
    1,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1897 */
  {
    "tablejump_internal4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_tablejump_internal4 },
    &operand_data[167],
    2,
    2,
    1,
    1,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1909 */
  {
    "prologue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_prologue },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1918 */
  {
    "epilogue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_epilogue },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1931 */
  {
    "allocate_stack",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_allocate_stack },
    &operand_data[169],
    2,
    2,
    1,
    1,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1958 */
  {
    "save_stack_block",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_save_stack_block },
    &operand_data[170],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1968 */
  {
    "restore_stack_block",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_restore_stack_block },
    &operand_data[170],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1986 */
  {
    "return",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_return },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:1992 */
  {
    "simple_return",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_simple_return },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:2048 */
  {
    "call",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call },
    &operand_data[172],
    4,
    4,
    0,
    1,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:2084 */
  {
    "call_internal0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_internal0 },
    &operand_data[174],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:2093 */
  {
    "call_internal_plt0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_internal_plt0 },
    &operand_data[174],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:2152 */
  {
    "call_value",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_value },
    &operand_data[178],
    4,
    4,
    0,
    1,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:2191 */
  {
    "call_value_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_value_internal },
    &operand_data[181],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:2201 */
  {
    "call_value_intern_plt0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_value_intern_plt0 },
    &operand_data[181],
    5,
    5,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:2267 */
  {
    "untyped_call",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_untyped_call },
    &operand_data[181],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md:2346 */
  {
    "eh_return",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_eh_return },
    &operand_data[186],
    1,
    1,
    0,
    0,
    0
  },
};


const char *
get_insn_name (int code)
{
  if (code == NOOP_MOVE_INSN_CODE)
    return "NOOP_MOVE";
  else
    return insn_data[code].name;
}
