/* Generated automatically by the program `genextract'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "diagnostic-core.h"

/* This variable is used as the "location" of any missing operand
   whose numbers are skipped by a given pattern.  */
static rtx junk ATTRIBUTE_UNUSED;

void
insn_extract (rtx_insn *insn)
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED; /* only for peepholes */

  if (flag_checking)
    {
      memset (ro, 0xab, sizeof (*ro) * MAX_RECOG_OPERANDS);
      memset (ro_loc, 0xab, sizeof (*ro_loc) * MAX_RECOG_OPERANDS);
    }

  switch (INSN_CODE (insn))
    {
    default:
      /* Control reaches here if insn_extract has been called with an
         unrecognizable insn (code -1), or an insn whose INSN_CODE
         corresponds to a DEFINE_EXPAND in the machine description;
         either way, a bug.  */
      if (INSN_CODE (insn) < 0)
        fatal_insn ("unrecognizable insn:", insn);
      else
        fatal_insn ("insn with invalid code number:", insn);

    case 90:  /* *sibcall_value */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 89:  /* *call_value */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 88:  /* *sibcall */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 87:  /* *call */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 86:  /* store_conditional_si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 1));
      break;

    case 85:  /* load_locked_si */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      break;

    case 84:  /* *msync */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0);
      recog_data.dup_num[0] = 0;
      break;

    case 83:  /* frame_addsi3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 82:  /* set_got */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      break;

    case 81:  /* set_got_tmp */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      break;

    case 80:  /* *simple_return */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 79:  /* indirect_jump */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      break;

    case 78:  /* jump */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 77:  /* *cbranch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 76:  /* *cmovsi */
    case 75:  /* *cmovhi */
    case 74:  /* *cmovqi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 72:  /* *sf_fp_insn */
    case 71:  /* *sf_fp_insn */
    case 70:  /* *sf_fp_insn */
    case 69:  /* *sf_fp_insn */
    case 68:  /* *sf_fp_insn */
    case 67:  /* *sf_fp_insn */
    case 66:  /* *sf_fp_insn */
    case 65:  /* *sf_fp_insn */
    case 64:  /* *sf_fp_insn */
    case 63:  /* *sf_fp_insn */
    case 62:  /* *sf_fp_insn */
    case 61:  /* *sf_fp_insn */
    case 60:  /* *sf_fp_insn */
    case 59:  /* *sf_fp_insn */
    case 58:  /* *sf_fp_insn */
    case 57:  /* *sf_fp_insn */
    case 56:  /* *sf_fp_insn */
    case 55:  /* *sf_fp_insn */
    case 54:  /* *sf_fp_insn */
    case 53:  /* *sf_fp_insn */
    case 52:  /* *sf_fp_insn */
    case 51:  /* *sf_fp_insn */
    case 50:  /* *sf_fp_insn */
    case 49:  /* *sf_fp_insn */
    case 48:  /* *sf_insn */
    case 47:  /* *sf_insn */
    case 46:  /* *sf_insn */
    case 45:  /* *sf_insn */
    case 44:  /* *sf_insn */
    case 43:  /* *sf_insn */
    case 42:  /* *sf_insn */
    case 41:  /* *sf_insn */
    case 40:  /* *sf_insn */
    case 39:  /* *sf_insn */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 73:  /* *scc */
    case 32:  /* *movdi */
    case 28:  /* *movsi_internal */
    case 27:  /* *movhi_internal */
    case 26:  /* *movqi_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 38:  /* *extendhisi2_mem */
    case 37:  /* *extendqisi2_mem */
    case 36:  /* extendhisi2 */
    case 35:  /* extendqisi2 */
    case 34:  /* zero_extendhisi2 */
    case 33:  /* zero_extendqisi2 */
    case 29:  /* movsi_high */
    case 18:  /* fix_truncdfdi2 */
    case 17:  /* fix_truncsfsi2 */
    case 16:  /* floatdidf2 */
    case 15:  /* floatsisf2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 31:  /* *movsi_lo_sum_addi */
    case 30:  /* *movsi_lo_sum_iori */
    case 25:  /* iorsi3 */
    case 24:  /* xorsi3 */
    case 23:  /* andsi3 */
    case 22:  /* rotrsi3 */
    case 21:  /* lshrsi3 */
    case 20:  /* ashrsi3 */
    case 19:  /* ashlsi3 */
    case 14:  /* divdf3 */
    case 13:  /* muldf3 */
    case 12:  /* subdf3 */
    case 11:  /* adddf3 */
    case 10:  /* divsf3 */
    case 9:  /* mulsf3 */
    case 8:  /* subsf3 */
    case 7:  /* addsf3 */
    case 6:  /* subsi3 */
    case 5:  /* udivsi3 */
    case 4:  /* divsi3 */
    case 3:  /* mulsi3 */
    case 2:  /* addsi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 1:  /* nop */
      break;

    }
}
