/* Generated automatically by the program `genpeep'
from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "tree.h"
#include "rtl.h"
#include "insn-config.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "regs.h"
#include "output.h"
#include "recog.h"
#include "except.h"
#include "diagnostic-core.h"
#include "flags.h"
#include "tm-constrs.h"

extern rtx peep_operand[];

#define operands peep_operand

rtx_insn *
peephole (rtx_insn *ins1)
{
  rtx_insn *insn ATTRIBUTE_UNUSED;
  rtx x ATTRIBUTE_UNUSED, pat ATTRIBUTE_UNUSED;

  if (NEXT_INSN (ins1)
      && BARRIER_P (NEXT_INSN (ins1)))
    return 0;

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4395;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L4395;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L4395;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4395; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4395;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4395;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V16QImode)) goto L4395;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4395;
  if (GET_MODE (x) != V16QImode) goto L4395;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4395;
  if (GET_MODE (x) != SImode) goto L4395;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L4395;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L4395;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L4395;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4395;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4395:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4396;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L4396;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L4396;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4396; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4396;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4396;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V16QImode)) goto L4396;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4396;
  if (GET_MODE (x) != V16QImode) goto L4396;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4396;
  if (GET_MODE (x) != DImode) goto L4396;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L4396;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L4396;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L4396;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4396;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4396:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4397;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L4397;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L4397;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4397; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4397;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4397;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V8HImode)) goto L4397;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4397;
  if (GET_MODE (x) != V8HImode) goto L4397;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4397;
  if (GET_MODE (x) != SImode) goto L4397;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L4397;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L4397;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L4397;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4397;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4397:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4398;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L4398;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L4398;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4398; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4398;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4398;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V8HImode)) goto L4398;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4398;
  if (GET_MODE (x) != V8HImode) goto L4398;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4398;
  if (GET_MODE (x) != DImode) goto L4398;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L4398;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L4398;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L4398;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4398;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4398:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4399;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L4399;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L4399;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4399; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4399;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4399;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SImode)) goto L4399;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4399;
  if (GET_MODE (x) != V4SImode) goto L4399;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4399;
  if (GET_MODE (x) != SImode) goto L4399;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L4399;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L4399;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L4399;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4399;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4399:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4400;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L4400;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L4400;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4400; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4400;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4400;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SImode)) goto L4400;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4400;
  if (GET_MODE (x) != V4SImode) goto L4400;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4400;
  if (GET_MODE (x) != DImode) goto L4400;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L4400;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L4400;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L4400;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4400;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4400:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4401;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L4401;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L4401;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4401; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4401;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4401;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DImode)) goto L4401;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4401;
  if (GET_MODE (x) != V2DImode) goto L4401;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4401;
  if (GET_MODE (x) != SImode) goto L4401;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L4401;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L4401;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L4401;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4401;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4401:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4402;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L4402;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L4402;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4402; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4402;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4402;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DImode)) goto L4402;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4402;
  if (GET_MODE (x) != V2DImode) goto L4402;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4402;
  if (GET_MODE (x) != DImode) goto L4402;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L4402;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L4402;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L4402;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4402;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4402:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4403;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L4403;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L4403;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4403; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4403;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4403;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SFmode)) goto L4403;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4403;
  if (GET_MODE (x) != V4SFmode) goto L4403;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4403;
  if (GET_MODE (x) != SImode) goto L4403;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L4403;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L4403;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L4403;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4403;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4403:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4404;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L4404;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L4404;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4404; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4404;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4404;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SFmode)) goto L4404;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4404;
  if (GET_MODE (x) != V4SFmode) goto L4404;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4404;
  if (GET_MODE (x) != DImode) goto L4404;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L4404;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L4404;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L4404;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4404;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4404:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4405;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L4405;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L4405;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4405; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4405;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4405;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DFmode)) goto L4405;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4405;
  if (GET_MODE (x) != V2DFmode) goto L4405;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4405;
  if (GET_MODE (x) != SImode) goto L4405;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L4405;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L4405;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L4405;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4405;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4405:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4406;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L4406;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L4406;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4406; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4406;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4406;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DFmode)) goto L4406;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4406;
  if (GET_MODE (x) != V2DFmode) goto L4406;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4406;
  if (GET_MODE (x) != DImode) goto L4406;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L4406;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L4406;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L4406;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4406;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4406:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4407;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L4407;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L4407;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4407; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4407;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4407;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V1TImode)) goto L4407;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4407;
  if (GET_MODE (x) != V1TImode) goto L4407;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4407;
  if (GET_MODE (x) != SImode) goto L4407;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L4407;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L4407;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L4407;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4407;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4407:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4408;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L4408;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L4408;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4408; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4408;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4408;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V1TImode)) goto L4408;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4408;
  if (GET_MODE (x) != V1TImode) goto L4408;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4408;
  if (GET_MODE (x) != DImode) goto L4408;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L4408;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L4408;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L4408;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4408;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4408:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4409;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L4409;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L4409;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4409; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4409;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4409;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, KFmode)) goto L4409;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4409;
  if (GET_MODE (x) != KFmode) goto L4409;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4409;
  if (GET_MODE (x) != SImode) goto L4409;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L4409;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L4409;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (((((TARGET_32BIT) && (FLOAT128_VECTOR_P (KFmode))) && (FLOAT128_VECTOR_P (KFmode))) && (TARGET_32BIT)) && (TARGET_32BIT)))) goto L4409;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4409;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4409:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4410;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L4410;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L4410;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4410; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4410;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4410;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, KFmode)) goto L4410;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4410;
  if (GET_MODE (x) != KFmode) goto L4410;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4410;
  if (GET_MODE (x) != DImode) goto L4410;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L4410;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L4410;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (((((TARGET_64BIT) && (FLOAT128_VECTOR_P (KFmode))) && (FLOAT128_VECTOR_P (KFmode))) && (TARGET_64BIT)) && (TARGET_64BIT)))) goto L4410;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4410;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4410:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4411;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L4411;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L4411;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4411; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4411;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4411;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, TFmode)) goto L4411;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4411;
  if (GET_MODE (x) != TFmode) goto L4411;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4411;
  if (GET_MODE (x) != SImode) goto L4411;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L4411;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L4411;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (((((TARGET_32BIT) && (FLOAT128_VECTOR_P (TFmode))) && (FLOAT128_VECTOR_P (TFmode))) && (TARGET_32BIT)) && (TARGET_32BIT)))) goto L4411;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4411;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4411:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4412;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L4412;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L4412;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4412; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4412;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4412;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, TFmode)) goto L4412;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4412;
  if (GET_MODE (x) != TFmode) goto L4412;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4412;
  if (GET_MODE (x) != DImode) goto L4412;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L4412;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L4412;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (((((TARGET_64BIT) && (FLOAT128_VECTOR_P (TFmode))) && (FLOAT128_VECTOR_P (TFmode))) && (TARGET_64BIT)) && (TARGET_64BIT)))) goto L4412;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4412;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4412:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4413;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L4413;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L4413;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4413; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4413;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4413;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, TImode)) goto L4413;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4413;
  if (GET_MODE (x) != TImode) goto L4413;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4413;
  if (GET_MODE (x) != SImode) goto L4413;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L4413;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L4413;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L4413;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4413;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4413:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4414;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L4414;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L4414;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4414; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4414;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4414;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, TImode)) goto L4414;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4414;
  if (GET_MODE (x) != TImode) goto L4414;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4414;
  if (GET_MODE (x) != DImode) goto L4414;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L4414;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L4414;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L4414;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4414;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4414:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4415;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L4415;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L4415;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4415; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4415;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4415;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V16QImode)) goto L4415;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4415;
  if (GET_MODE (x) != V16QImode) goto L4415;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4415;
  if (GET_MODE (x) != SImode) goto L4415;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L4415;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L4415;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L4415;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4415;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4415:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4416;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L4416;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L4416;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4416; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4416;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4416;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V16QImode)) goto L4416;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4416;
  if (GET_MODE (x) != V16QImode) goto L4416;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4416;
  if (GET_MODE (x) != DImode) goto L4416;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L4416;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L4416;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L4416;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4416;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4416:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4417;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L4417;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L4417;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4417; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4417;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4417;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V8HImode)) goto L4417;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4417;
  if (GET_MODE (x) != V8HImode) goto L4417;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4417;
  if (GET_MODE (x) != SImode) goto L4417;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L4417;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L4417;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L4417;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4417;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4417:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4418;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L4418;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L4418;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4418; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4418;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4418;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V8HImode)) goto L4418;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4418;
  if (GET_MODE (x) != V8HImode) goto L4418;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4418;
  if (GET_MODE (x) != DImode) goto L4418;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L4418;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L4418;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L4418;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4418;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4418:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4419;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L4419;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L4419;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4419; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4419;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4419;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SImode)) goto L4419;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4419;
  if (GET_MODE (x) != V4SImode) goto L4419;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4419;
  if (GET_MODE (x) != SImode) goto L4419;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L4419;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L4419;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L4419;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4419;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4419:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4420;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L4420;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L4420;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4420; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4420;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4420;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SImode)) goto L4420;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4420;
  if (GET_MODE (x) != V4SImode) goto L4420;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4420;
  if (GET_MODE (x) != DImode) goto L4420;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L4420;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L4420;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L4420;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4420;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4420:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4421;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L4421;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L4421;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4421; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4421;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4421;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DImode)) goto L4421;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4421;
  if (GET_MODE (x) != V2DImode) goto L4421;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4421;
  if (GET_MODE (x) != SImode) goto L4421;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L4421;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L4421;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L4421;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4421;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4421:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4422;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L4422;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L4422;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4422; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4422;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4422;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DImode)) goto L4422;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4422;
  if (GET_MODE (x) != V2DImode) goto L4422;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4422;
  if (GET_MODE (x) != DImode) goto L4422;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L4422;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L4422;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L4422;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4422;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4422:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4423;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L4423;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L4423;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4423; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4423;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4423;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SFmode)) goto L4423;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4423;
  if (GET_MODE (x) != V4SFmode) goto L4423;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4423;
  if (GET_MODE (x) != SImode) goto L4423;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L4423;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L4423;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L4423;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4423;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4423:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4424;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L4424;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L4424;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4424; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4424;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4424;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SFmode)) goto L4424;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4424;
  if (GET_MODE (x) != V4SFmode) goto L4424;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4424;
  if (GET_MODE (x) != DImode) goto L4424;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L4424;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L4424;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L4424;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4424;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4424:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4425;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L4425;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L4425;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4425; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4425;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4425;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DFmode)) goto L4425;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4425;
  if (GET_MODE (x) != V2DFmode) goto L4425;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4425;
  if (GET_MODE (x) != SImode) goto L4425;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L4425;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L4425;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L4425;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4425;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4425:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4426;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L4426;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L4426;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4426; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4426;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4426;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DFmode)) goto L4426;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4426;
  if (GET_MODE (x) != V2DFmode) goto L4426;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4426;
  if (GET_MODE (x) != DImode) goto L4426;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L4426;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L4426;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L4426;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4426;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4426:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4427;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L4427;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L4427;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4427; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4427;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4427;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V1TImode)) goto L4427;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4427;
  if (GET_MODE (x) != V1TImode) goto L4427;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4427;
  if (GET_MODE (x) != SImode) goto L4427;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L4427;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L4427;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L4427;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4427;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4427:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4428;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L4428;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L4428;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4428; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4428;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4428;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V1TImode)) goto L4428;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4428;
  if (GET_MODE (x) != V1TImode) goto L4428;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4428;
  if (GET_MODE (x) != DImode) goto L4428;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L4428;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L4428;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L4428;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4428;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4428:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4429;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L4429;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L4429;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4429; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4429;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4429;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, KFmode)) goto L4429;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4429;
  if (GET_MODE (x) != KFmode) goto L4429;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4429;
  if (GET_MODE (x) != SImode) goto L4429;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L4429;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L4429;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (((((TARGET_32BIT) && (FLOAT128_VECTOR_P (KFmode))) && (FLOAT128_VECTOR_P (KFmode))) && (TARGET_32BIT)) && (TARGET_32BIT)))) goto L4429;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4429;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4429:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4430;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L4430;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L4430;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4430; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4430;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4430;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, KFmode)) goto L4430;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4430;
  if (GET_MODE (x) != KFmode) goto L4430;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4430;
  if (GET_MODE (x) != DImode) goto L4430;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L4430;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L4430;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (((((TARGET_64BIT) && (FLOAT128_VECTOR_P (KFmode))) && (FLOAT128_VECTOR_P (KFmode))) && (TARGET_64BIT)) && (TARGET_64BIT)))) goto L4430;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4430;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4430:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4431;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L4431;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L4431;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4431; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4431;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4431;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, TFmode)) goto L4431;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4431;
  if (GET_MODE (x) != TFmode) goto L4431;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4431;
  if (GET_MODE (x) != SImode) goto L4431;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L4431;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L4431;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (((((TARGET_32BIT) && (FLOAT128_VECTOR_P (TFmode))) && (FLOAT128_VECTOR_P (TFmode))) && (TARGET_32BIT)) && (TARGET_32BIT)))) goto L4431;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4431;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4431:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4432;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L4432;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L4432;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4432; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4432;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4432;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, TFmode)) goto L4432;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4432;
  if (GET_MODE (x) != TFmode) goto L4432;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4432;
  if (GET_MODE (x) != DImode) goto L4432;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L4432;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L4432;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (((((TARGET_64BIT) && (FLOAT128_VECTOR_P (TFmode))) && (FLOAT128_VECTOR_P (TFmode))) && (TARGET_64BIT)) && (TARGET_64BIT)))) goto L4432;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4432;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4432:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4433;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L4433;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L4433;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4433; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4433;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4433;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, TImode)) goto L4433;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4433;
  if (GET_MODE (x) != TImode) goto L4433;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4433;
  if (GET_MODE (x) != SImode) goto L4433;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L4433;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L4433;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L4433;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4433;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4433:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4434;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L4434;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L4434;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L4434; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L4434;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L4434;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, TImode)) goto L4434;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L4434;
  if (GET_MODE (x) != TImode) goto L4434;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L4434;
  if (GET_MODE (x) != DImode) goto L4434;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L4434;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L4434;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L4434;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 4434;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L4434:

  return 0;
}

rtx peep_operand[4];
