/* Generated automatically by the program `genattrtab'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "options.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "insn-attr.h"
#include "memmodel.h"
#include "tm_p.h"
#include "insn-config.h"
#include "recog.h"
#include "regs.h"
#include "real.h"
#include "output.h"
#include "toplev.h"
#include "flags.h"
#include "emit-rtl.h"

#define operands recog_data.operand

int
insn_current_length (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

int
insn_variable_length_p (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

int
insn_min_length (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 65:  /* movsf_internal */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x7ULL))
        {
	  return 3;
        }
      else if (which_alternative == 3)
        {
	  return 2;
        }
      else if (which_alternative == 4)
        {
	  return 3;
        }
      else if (((1ULL << which_alternative) & 0x60ULL))
        {
	  return 2;
        }
      else if (((1ULL << which_alternative) & 0x780ULL))
        {
	  return 3;
        }
      else if (which_alternative == 11)
        {
	  return 6;
        }
      else
        {
	  return 3;
        }

    case 62:  /* movsi_internal */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3fULL))
        {
	  return 2;
        }
      else if (((1ULL << which_alternative) & 0x3c0ULL))
        {
	  return 3;
        }
      else if (which_alternative == 10)
        {
	  return 6;
        }
      else
        {
	  return 3;
        }

    case 64:  /* movqi_internal */
    case 63:  /* movhi_internal */
    case 1:  /* addsi3 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3ULL))
        {
	  return 2;
        }
      else
        {
	  return 3;
        }

    case 142:  /* *eqne_INT_MIN */
      extract_constrain_insn_cached (insn);
      if (
#line 3316 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(GET_CODE (operands[2]) == EQ))
        {
	  return 6;
        }
      else
        {
	  if (
#line 3318 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY))
	    {
	      return 8;
	    }
	  else
	    {
	      return 9;
	    }
        }

    case 140:  /* eqne_zero */
      extract_constrain_insn_cached (insn);
      if (
#line 3316 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(GET_CODE (operands[2]) == EQ))
        {
	  if (
#line 3318 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY))
	    {
	      return 7;
	    }
	  else
	    {
	      return 9;
	    }
        }
      else
        {
	  if (
#line 3318 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY))
	    {
	      return 5;
	    }
	  else
	    {
	      return 6;
	    }
        }

    case 139:  /* eq_zero_NSA */
    case 136:  /* sync_compare_and_swapsi */
    case 85:  /* *btrue_INT_MIN */
    case 83:  /* rotrsi3 */
    case 82:  /* rotlsi3 */
    case 81:  /* *shlrd_per_byte_omit_AND */
    case 80:  /* *shlrd_per_byte */
    case 79:  /* *shlrd_const */
    case 78:  /* *shlrd_reg */
    case 77:  /* *shlrd_reg */
    case 75:  /* *shift_per_byte_omit_AND_0 */
    case 74:  /* *shift_per_byte */
    case 50:  /* *extzvsi-1bit_addsubx */
    case 38:  /* *andsi3_const_negative_pow2 */
    case 36:  /* *andsi3_bitcmpl */
      return 6;

    case 138:  /* *signed_ge_zero */
    case 137:  /* *round_up_to_even */
    case 33:  /* one_cmplsi2 */
      extract_constrain_insn_cached (insn);
      if (
#line 3318 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY))
        {
	  return 5;
        }
      else
        {
	  return 6;
        }

    case 126:  /* *unspec_nop */
    case 123:  /* *frame_blockage */
    case 122:  /* blockage */
    case 96:  /* loop_end */
    case 95:  /* zero_cost_loop_end */
      return 0;

    case 125:  /* set_frame_ptr */
    case 119:  /* nop */
    case 118:  /* return */
      extract_constrain_insn_cached (insn);
      if (
#line 3318 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY))
        {
	  return 2;
        }
      else
        {
	  return 3;
        }

    case 124:  /* trap */
      extract_constrain_insn_cached (insn);
      if (
#line 2896 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(!TARGET_DEBUG && TARGET_DENSITY))
        {
	  return 2;
        }
      else
        {
	  return 3;
        }

    case 93:  /* *masktrue_const_shifted_mask */
      extract_constrain_insn_cached (insn);
      if (
#line 2257 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
				   && (uint32_t)INTVAL (operands[2]) >> ctz_hwi (INTVAL (operands[1])) == 0))
        {
	  return 5;
        }
      else
        {
	  return 6;
        }

    case 92:  /* *masktrue_const_negative_pow2 */
      extract_constrain_insn_cached (insn);
      if (
#line 2216 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY && INTVAL (operands[2]) == 0))
        {
	  return 5;
        }
      else
        {
	  return 6;
        }

    case 91:  /* *masktrue_const_pow2_minus_one */
      extract_constrain_insn_cached (insn);
      if (
#line 2176 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
((TARGET_DENSITY && INTVAL (operands[1]) == 0x7FFFFFFF)
				   && INTVAL (operands[2]) == 0))
        {
	  return 4;
        }
      else
        {
	  if (
#line 2179 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
						 && (INTVAL (operands[1]) == 0x7FFFFFFF
						     || INTVAL (operands[2]) == 0)))
	    {
	      return 5;
	    }
	  else
	    {
	      return 6;
	    }
        }

    case 90:  /* *masktrue_const_bitcmpl */
      extract_constrain_insn_cached (insn);
      if (
#line 2118 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
				   && IN_RANGE (INTVAL (operands[1]), -32, 95)))
        {
	  return 5;
        }
      else
        {
	  if (
#line 2121 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(xtensa_simm12b (INTVAL (operands[1]))))
	    {
	      return 6;
	    }
	  else
	    {
	      return 10 /* 0xa */;
	    }
        }

    case 84:  /* *btrue */
      extract_constrain_insn_cached (insn);
      if (
#line 1962 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
				   && CONST_INT_P (operands[1])
				   && INTVAL (operands[1]) == 0
				   && (GET_CODE (operands[3]) == EQ
				       || GET_CODE (operands[3]) == NE)))
        {
	  return 2;
        }
      else
        {
	  return 3;
        }

    case 76:  /* *shift_per_byte_omit_AND_1 */
    case 30:  /* bswaphi2 */
      return 9;

    case 73:  /* lshrsi3 */
    case 72:  /* ashrsi3 */
    case 71:  /* ashlsi3_internal */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 3;
        }
      else
        {
	  return 6;
        }

    case 49:  /* *extzvsi-1bit_ashlsi3 */
      extract_constrain_insn_cached (insn);
      if (
#line 1107 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY && INTVAL (operands[3]) == 2))
        {
	  return 5;
        }
      else
        {
	  return 6;
        }

    case 42:  /* *splice_bits */
      extract_constrain_insn_cached (insn);
      if (
#line 931 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
				   && (INTVAL (operands[3]) == 0x7FFFFFFF
				       || INTVAL (operands[4]) == 0x7FFFFFFF)))
        {
	  return 11 /* 0xb */;
        }
      else
        {
	  return 12 /* 0xc */;
        }

    case 39:  /* *andsi3_const_shifted_mask */
      extract_constrain_insn_cached (insn);
      if (
#line 841 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
				   && ctz_hwi (INTVAL (operands[2])) == 1))
        {
	  return 5;
        }
      else
        {
	  return 6;
        }

    case 37:  /* *andsi3_const_pow2_minus_one */
      extract_constrain_insn_cached (insn);
      if (
#line 788 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
				   && INTVAL (operands[2]) == 0x7FFFFFFF))
        {
	  return 5;
        }
      else
        {
	  return 6;
        }

    case 31:  /* bswapsi2_internal */
      return 15 /* 0xf */;

    case 5:  /* *subsi3_from_const */
      extract_constrain_insn_cached (insn);
      if (
#line 287 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
				   && xtensa_m1_or_1_thru_15 (-INTVAL (operands[1]))))
        {
	  return 5;
        }
      else
        {
	  return 6;
        }

    case 141:  /* *eqne_zero_masked_bits */
    case 121:  /* eh_set_a0_call0 */
    case 120:  /* eh_set_a0_windowed */
    case 70:  /* movdf_internal */
    case 61:  /* movdi_internal */
      return 1;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 3;

    }
}

int
insn_default_length (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 65:  /* movsf_internal */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x7ULL))
        {
	  return 3;
        }
      else if (which_alternative == 3)
        {
	  return 2;
        }
      else if (which_alternative == 4)
        {
	  return 3;
        }
      else if (((1ULL << which_alternative) & 0x60ULL))
        {
	  return 2;
        }
      else if (((1ULL << which_alternative) & 0x780ULL))
        {
	  return 3;
        }
      else if (which_alternative == 11)
        {
	  return 6;
        }
      else
        {
	  return 3;
        }

    case 62:  /* movsi_internal */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3fULL))
        {
	  return 2;
        }
      else if (((1ULL << which_alternative) & 0x3c0ULL))
        {
	  return 3;
        }
      else if (which_alternative == 10)
        {
	  return 6;
        }
      else
        {
	  return 3;
        }

    case 64:  /* movqi_internal */
    case 63:  /* movhi_internal */
    case 1:  /* addsi3 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3ULL))
        {
	  return 2;
        }
      else
        {
	  return 3;
        }

    case 142:  /* *eqne_INT_MIN */
      extract_constrain_insn_cached (insn);
      if (
#line 3316 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(GET_CODE (operands[2]) == EQ))
        {
	  return 6;
        }
      else
        {
	  if (
#line 3318 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY))
	    {
	      return 8;
	    }
	  else
	    {
	      return 9;
	    }
        }

    case 140:  /* eqne_zero */
      extract_constrain_insn_cached (insn);
      if (
#line 3316 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(GET_CODE (operands[2]) == EQ))
        {
	  if (
#line 3318 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY))
	    {
	      return 7;
	    }
	  else
	    {
	      return 9;
	    }
        }
      else
        {
	  if (
#line 3318 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY))
	    {
	      return 5;
	    }
	  else
	    {
	      return 6;
	    }
        }

    case 139:  /* eq_zero_NSA */
    case 136:  /* sync_compare_and_swapsi */
    case 85:  /* *btrue_INT_MIN */
    case 83:  /* rotrsi3 */
    case 82:  /* rotlsi3 */
    case 81:  /* *shlrd_per_byte_omit_AND */
    case 80:  /* *shlrd_per_byte */
    case 79:  /* *shlrd_const */
    case 78:  /* *shlrd_reg */
    case 77:  /* *shlrd_reg */
    case 75:  /* *shift_per_byte_omit_AND_0 */
    case 74:  /* *shift_per_byte */
    case 50:  /* *extzvsi-1bit_addsubx */
    case 38:  /* *andsi3_const_negative_pow2 */
    case 36:  /* *andsi3_bitcmpl */
      return 6;

    case 138:  /* *signed_ge_zero */
    case 137:  /* *round_up_to_even */
    case 33:  /* one_cmplsi2 */
      extract_constrain_insn_cached (insn);
      if (
#line 3318 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY))
        {
	  return 5;
        }
      else
        {
	  return 6;
        }

    case 126:  /* *unspec_nop */
    case 123:  /* *frame_blockage */
    case 122:  /* blockage */
    case 96:  /* loop_end */
    case 95:  /* zero_cost_loop_end */
      return 0;

    case 125:  /* set_frame_ptr */
    case 119:  /* nop */
    case 118:  /* return */
      extract_constrain_insn_cached (insn);
      if (
#line 3318 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY))
        {
	  return 2;
        }
      else
        {
	  return 3;
        }

    case 124:  /* trap */
      extract_constrain_insn_cached (insn);
      if (
#line 2896 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(!TARGET_DEBUG && TARGET_DENSITY))
        {
	  return 2;
        }
      else
        {
	  return 3;
        }

    case 93:  /* *masktrue_const_shifted_mask */
      extract_constrain_insn_cached (insn);
      if (
#line 2257 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
				   && (uint32_t)INTVAL (operands[2]) >> ctz_hwi (INTVAL (operands[1])) == 0))
        {
	  return 5;
        }
      else
        {
	  return 6;
        }

    case 92:  /* *masktrue_const_negative_pow2 */
      extract_constrain_insn_cached (insn);
      if (
#line 2216 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY && INTVAL (operands[2]) == 0))
        {
	  return 5;
        }
      else
        {
	  return 6;
        }

    case 91:  /* *masktrue_const_pow2_minus_one */
      extract_constrain_insn_cached (insn);
      if (
#line 2176 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
((TARGET_DENSITY && INTVAL (operands[1]) == 0x7FFFFFFF)
				   && INTVAL (operands[2]) == 0))
        {
	  return 4;
        }
      else
        {
	  if (
#line 2179 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
						 && (INTVAL (operands[1]) == 0x7FFFFFFF
						     || INTVAL (operands[2]) == 0)))
	    {
	      return 5;
	    }
	  else
	    {
	      return 6;
	    }
        }

    case 90:  /* *masktrue_const_bitcmpl */
      extract_constrain_insn_cached (insn);
      if (
#line 2118 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
				   && IN_RANGE (INTVAL (operands[1]), -32, 95)))
        {
	  return 5;
        }
      else
        {
	  if (
#line 2121 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(xtensa_simm12b (INTVAL (operands[1]))))
	    {
	      return 6;
	    }
	  else
	    {
	      return 10 /* 0xa */;
	    }
        }

    case 84:  /* *btrue */
      extract_constrain_insn_cached (insn);
      if (
#line 1962 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
				   && CONST_INT_P (operands[1])
				   && INTVAL (operands[1]) == 0
				   && (GET_CODE (operands[3]) == EQ
				       || GET_CODE (operands[3]) == NE)))
        {
	  return 2;
        }
      else
        {
	  return 3;
        }

    case 76:  /* *shift_per_byte_omit_AND_1 */
    case 30:  /* bswaphi2 */
      return 9;

    case 73:  /* lshrsi3 */
    case 72:  /* ashrsi3 */
    case 71:  /* ashlsi3_internal */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 3;
        }
      else
        {
	  return 6;
        }

    case 49:  /* *extzvsi-1bit_ashlsi3 */
      extract_constrain_insn_cached (insn);
      if (
#line 1107 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY && INTVAL (operands[3]) == 2))
        {
	  return 5;
        }
      else
        {
	  return 6;
        }

    case 42:  /* *splice_bits */
      extract_constrain_insn_cached (insn);
      if (
#line 931 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
				   && (INTVAL (operands[3]) == 0x7FFFFFFF
				       || INTVAL (operands[4]) == 0x7FFFFFFF)))
        {
	  return 11 /* 0xb */;
        }
      else
        {
	  return 12 /* 0xc */;
        }

    case 39:  /* *andsi3_const_shifted_mask */
      extract_constrain_insn_cached (insn);
      if (
#line 841 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
				   && ctz_hwi (INTVAL (operands[2])) == 1))
        {
	  return 5;
        }
      else
        {
	  return 6;
        }

    case 37:  /* *andsi3_const_pow2_minus_one */
      extract_constrain_insn_cached (insn);
      if (
#line 788 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
				   && INTVAL (operands[2]) == 0x7FFFFFFF))
        {
	  return 5;
        }
      else
        {
	  return 6;
        }

    case 31:  /* bswapsi2_internal */
      return 15 /* 0xf */;

    case 5:  /* *subsi3_from_const */
      extract_constrain_insn_cached (insn);
      if (
#line 287 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY
				   && xtensa_m1_or_1_thru_15 (-INTVAL (operands[1]))))
        {
	  return 5;
        }
      else
        {
	  return 6;
        }

    case 141:  /* *eqne_zero_masked_bits */
    case 121:  /* eh_set_a0_call0 */
    case 120:  /* eh_set_a0_windowed */
    case 70:  /* movdf_internal */
    case 61:  /* movdi_internal */
      return 1;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 3;

    }
}

int
bypass_p (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

int
num_delay_slots (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

attr_mode
get_attr_mode (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 103:  /* seq_sf */
    case 104:  /* slt_sf */
    case 105:  /* sle_sf */
    case 106:  /* suneq_sf */
    case 107:  /* sunlt_sf */
    case 108:  /* sunle_sf */
    case 109:  /* sunordered_sf */
      return MODE_BL;

    case 3:  /* addsf3 */
    case 6:  /* subsf3 */
    case 14:  /* mulsf3 */
    case 15:  /* fmasf4 */
    case 16:  /* fnmasf4 */
    case 22:  /* abssf2 */
    case 34:  /* negsf2 */
    case 51:  /* fix_truncsfsi2 */
    case 52:  /* fixuns_truncsfsi2 */
    case 53:  /* *fix_truncsfsi2_2x */
    case 54:  /* *fixuns_truncsfsi2_2x */
    case 55:  /* *fix_truncsfsi2_scaled */
    case 56:  /* *fixuns_truncsfsi2_scaled */
    case 57:  /* floatsisf2 */
    case 58:  /* floatunssisf2 */
    case 59:  /* *floatsisf2_scaled */
    case 60:  /* *floatunssisf2_scaled */
    case 65:  /* movsf_internal */
    case 66:  /* *lsiu */
    case 67:  /* *ssiu */
    case 68:  /* *lsip */
    case 69:  /* *ssip */
    case 101:  /* movsfcc_internal0 */
    case 102:  /* movsfcc_internal1 */
      return MODE_SF;

    case 30:  /* bswaphi2 */
    case 63:  /* movhi_internal */
      return MODE_HI;

    case 64:  /* movqi_internal */
      return MODE_QI;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    case 84:  /* *btrue */
    case 85:  /* *btrue_INT_MIN */
    case 86:  /* *ubtrue */
    case 87:  /* *bittrue */
    case 88:  /* *masktrue */
    case 89:  /* *masktrue_bitcmpl */
    case 90:  /* *masktrue_const_bitcmpl */
    case 91:  /* *masktrue_const_pow2_minus_one */
    case 92:  /* *masktrue_const_negative_pow2 */
    case 93:  /* *masktrue_const_shifted_mask */
    case 94:  /* zero_cost_loop_start */
    case 95:  /* zero_cost_loop_end */
    case 96:  /* loop_end */
    case 110:  /* jump */
    case 111:  /* indirect_jump_internal */
    case 112:  /* tablejump_internal */
    case 113:  /* call_internal */
    case 114:  /* call_value_internal */
    case 115:  /* sibcall_internal */
    case 116:  /* sibcall_value_internal */
    case 118:  /* return */
    case 119:  /* nop */
    case 122:  /* blockage */
    case 123:  /* *frame_blockage */
    case 124:  /* trap */
    case 126:  /* *unspec_nop */
    case 131:  /* tls_call */
    case 132:  /* *booltrue */
    case 133:  /* *boolfalse */
    case 134:  /* *memory_barrier */
      return MODE_NONE;

    case 61:  /* movdi_internal */
    case 70:  /* movdf_internal */
    case 120:  /* eh_set_a0_windowed */
    case 121:  /* eh_set_a0_call0 */
    case 141:  /* *eqne_zero_masked_bits */
      return MODE_UNKNOWN;

    default:
      return MODE_SI;

    }
}

attr_type
get_attr_type (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 65:  /* movsf_internal */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return TYPE_FARITH;
        }
      else if (which_alternative == 1)
        {
	  return TYPE_FLOAD;
        }
      else if (which_alternative == 2)
        {
	  return TYPE_FSTORE;
        }
      else if (which_alternative == 3)
        {
	  return TYPE_MOVE;
        }
      else if (((1ULL << which_alternative) & 0x30ULL))
        {
	  return TYPE_LOAD;
        }
      else if (which_alternative == 6)
        {
	  return TYPE_STORE;
        }
      else if (which_alternative == 7)
        {
	  return TYPE_MOVE;
        }
      else if (((1ULL << which_alternative) & 0x300ULL))
        {
	  return TYPE_FARITH;
        }
      else if (((1ULL << which_alternative) & 0xc00ULL))
        {
	  return TYPE_MOVE;
        }
      else if (which_alternative == 12)
        {
	  return TYPE_LOAD;
        }
      else
        {
	  return TYPE_STORE;
        }

    case 64:  /* movqi_internal */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0xfULL))
        {
	  return TYPE_MOVE;
        }
      else if (which_alternative == 4)
        {
	  return TYPE_LOAD;
        }
      else if (which_alternative == 5)
        {
	  return TYPE_STORE;
        }
      else if (which_alternative == 6)
        {
	  return TYPE_RSR;
        }
      else
        {
	  return TYPE_WSR;
        }

    case 63:  /* movhi_internal */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x1fULL))
        {
	  return TYPE_MOVE;
        }
      else if (((1ULL << which_alternative) & 0x60ULL))
        {
	  return TYPE_LOAD;
        }
      else if (which_alternative == 7)
        {
	  return TYPE_STORE;
        }
      else if (which_alternative == 8)
        {
	  return TYPE_RSR;
        }
      else
        {
	  return TYPE_WSR;
        }

    case 62:  /* movsi_internal */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x7ULL))
        {
	  return TYPE_MOVE;
        }
      else if (which_alternative == 3)
        {
	  return TYPE_LOAD;
        }
      else if (((1ULL << which_alternative) & 0x30ULL))
        {
	  return TYPE_STORE;
        }
      else if (((1ULL << which_alternative) & 0x7c0ULL))
        {
	  return TYPE_MOVE;
        }
      else if (((1ULL << which_alternative) & 0x1800ULL))
        {
	  return TYPE_LOAD;
        }
      else if (which_alternative == 13)
        {
	  return TYPE_STORE;
        }
      else if (which_alternative == 14)
        {
	  return TYPE_RSR;
        }
      else
        {
	  return TYPE_WSR;
        }

    case 10:  /* mulhisi3 */
    case 11:  /* umulhisi3 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return TYPE_MUL16;
        }
      else
        {
	  return TYPE_MAC16;
        }

    case 43:  /* zero_extendhisi2 */
    case 44:  /* zero_extendqisi2 */
    case 45:  /* extendhisi2_internal */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return TYPE_ARITH;
        }
      else
        {
	  return TYPE_LOAD;
        }

    case 124:  /* trap */
      return TYPE_TRAP;

    case 117:  /* entry */
      return TYPE_ENTRY;

    case 128:  /* set_thread_pointersi */
      return TYPE_WSR;

    case 127:  /* get_thread_pointersi */
      return TYPE_RSR;

    case 12:  /* muladdhisi */
    case 13:  /* mulsubhisi */
      return TYPE_MAC16;

    case 17:  /* divsi3 */
    case 18:  /* udivsi3 */
    case 19:  /* modsi3 */
    case 20:  /* umodsi3 */
      return TYPE_DIV32;

    case 7:  /* mulsi3_highpart */
    case 8:  /* umulsi3_highpart */
    case 9:  /* mulsi3 */
      return TYPE_MUL32;

    case 67:  /* *ssiu */
    case 69:  /* *ssip */
      return TYPE_FSTORE;

    case 66:  /* *lsiu */
    case 68:  /* *lsip */
      return TYPE_FLOAD;

    case 51:  /* fix_truncsfsi2 */
    case 52:  /* fixuns_truncsfsi2 */
    case 53:  /* *fix_truncsfsi2_2x */
    case 54:  /* *fixuns_truncsfsi2_2x */
    case 55:  /* *fix_truncsfsi2_scaled */
    case 56:  /* *fixuns_truncsfsi2_scaled */
    case 57:  /* floatsisf2 */
    case 58:  /* floatunssisf2 */
    case 59:  /* *floatsisf2_scaled */
    case 60:  /* *floatunssisf2_scaled */
      return TYPE_FCONV;

    case 3:  /* addsf3 */
    case 6:  /* subsf3 */
    case 14:  /* mulsf3 */
    case 15:  /* fmasf4 */
    case 16:  /* fnmasf4 */
      return TYPE_FMADD;

    case 22:  /* abssf2 */
    case 34:  /* negsf2 */
    case 103:  /* seq_sf */
    case 104:  /* slt_sf */
    case 105:  /* sle_sf */
    case 106:  /* suneq_sf */
    case 107:  /* sunlt_sf */
    case 108:  /* sunle_sf */
    case 109:  /* sunordered_sf */
      return TYPE_FARITH;

    case 119:  /* nop */
    case 122:  /* blockage */
    case 123:  /* *frame_blockage */
    case 126:  /* *unspec_nop */
      return TYPE_NOP;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    case 82:  /* rotlsi3 */
    case 83:  /* rotrsi3 */
    case 136:  /* sync_compare_and_swapsi */
      return TYPE_MULTI;

    case 99:  /* movsicc_internal0 */
    case 100:  /* movsicc_internal1 */
    case 101:  /* movsfcc_internal0 */
    case 102:  /* movsfcc_internal1 */
    case 125:  /* set_frame_ptr */
    case 139:  /* eq_zero_NSA */
    case 140:  /* eqne_zero */
    case 142:  /* *eqne_INT_MIN */
      return TYPE_MOVE;

    case 135:  /* sync_lock_releasesi */
      return TYPE_STORE;

    case 129:  /* tls_func */
    case 130:  /* tls_arg */
      return TYPE_LOAD;

    case 113:  /* call_internal */
    case 114:  /* call_value_internal */
    case 115:  /* sibcall_internal */
    case 116:  /* sibcall_value_internal */
    case 131:  /* tls_call */
      return TYPE_CALL;

    case 84:  /* *btrue */
    case 85:  /* *btrue_INT_MIN */
    case 86:  /* *ubtrue */
    case 87:  /* *bittrue */
    case 88:  /* *masktrue */
    case 89:  /* *masktrue_bitcmpl */
    case 90:  /* *masktrue_const_bitcmpl */
    case 91:  /* *masktrue_const_pow2_minus_one */
    case 92:  /* *masktrue_const_negative_pow2 */
    case 93:  /* *masktrue_const_shifted_mask */
    case 94:  /* zero_cost_loop_start */
    case 95:  /* zero_cost_loop_end */
    case 96:  /* loop_end */
    case 110:  /* jump */
    case 111:  /* indirect_jump_internal */
    case 112:  /* tablejump_internal */
    case 118:  /* return */
    case 132:  /* *booltrue */
    case 133:  /* *boolfalse */
      return TYPE_JUMP;

    case 61:  /* movdi_internal */
    case 70:  /* movdf_internal */
    case 120:  /* eh_set_a0_windowed */
    case 121:  /* eh_set_a0_call0 */
    case 134:  /* *memory_barrier */
    case 141:  /* *eqne_zero_masked_bits */
      return TYPE_UNKNOWN;

    default:
      return TYPE_ARITH;

    }
}

int
eligible_for_delay (rtx_insn *delay_insn ATTRIBUTE_UNUSED, int slot, 
		   rtx_insn *candidate_insn, int flags ATTRIBUTE_UNUSED)
{
  rtx_insn *insn ATTRIBUTE_UNUSED;

  if (num_delay_slots (delay_insn) == 0)
    return 0;
  gcc_assert (slot < 0);

  if (!INSN_P (candidate_insn))
    return 0;

  insn = candidate_insn;
  switch (slot)
    {
    default:
      gcc_unreachable ();
    }
}

int
eligible_for_annul_true (rtx_insn *delay_insn ATTRIBUTE_UNUSED,
    int slot ATTRIBUTE_UNUSED,
    rtx_insn *candidate_insn ATTRIBUTE_UNUSED,
    int flags ATTRIBUTE_UNUSED)
{
  return 0;
}

int
eligible_for_annul_false (rtx_insn *delay_insn ATTRIBUTE_UNUSED,
    int slot ATTRIBUTE_UNUSED,
    rtx_insn *candidate_insn ATTRIBUTE_UNUSED,
    int flags ATTRIBUTE_UNUSED)
{
  return 0;
}

int
const_num_delay_slots (rtx_insn *insn)
{
  switch (recog_memoized (insn))
    {
    default:
      return 1;
    }
}

EXPORTED_CONST int length_unit_log = 0;
