/* Generated automatically by the program `genoutput'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "flags.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "memmodel.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "tm_p.h"
#include "regs.h"
#include "conditions.h"
#include "insn-attr.h"

#include "recog.h"

#include "diagnostic-core.h"
#include "output.h"
#include "target.h"
#include "tm-constrs.h"

static const char * const output_1[] = {
  "add.n\t%0, %1, %2",
  "addi.n\t%0, %1, %d2",
  "add\t%0, %1, %2",
  "addi\t%0, %1, %d2",
  "addmi\t%0, %1, %x2",
};

static const char *
output_2 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 193 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  operands[3] = GEN_INT (1 << INTVAL (operands[3]));
  return GET_CODE (operands[4]) == PLUS
	  ? "addx%3\t%0, %1, %2" : "subx%3\t%0, %1, %2";
}
}

static const char * const output_10[] = {
  "mul16s\t%0, %1, %2",
  "mul.aa.ll\t%1, %2",
};

static const char * const output_11[] = {
  "mul16u\t%0, %1, %2",
  "umul.aa.ll\t%1, %2",
};

static const char *
output_27 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 556 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  static char result[64];
  rtx bound = operands[GET_CODE (operands[4]) == SMAX ? 2 : 3];
  sprintf (result, "clamps\t%%0, %%1, %d", floor_log2 (-INTVAL (bound)));
  return result;
}
}

static const char *
output_31 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 652 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  rtx_insn *prev_insn = prev_nonnote_nondebug_insn (insn);
  const char *init = "ssai\t8\n\t";
  static char result[128];
  if (prev_insn && NONJUMP_INSN_P (prev_insn))
    {
      rtx x = PATTERN (prev_insn);
      if (GET_CODE (x) == PARALLEL && XVECLEN (x, 0) == 2
	  && GET_CODE (XVECEXP (x, 0, 0)) == SET
	  && GET_CODE (XVECEXP (x, 0, 1)) == CLOBBER)
	{
	  x = XEXP (XVECEXP (x, 0, 0), 1);
	  if (GET_CODE (x) == BSWAP && GET_MODE (x) == SImode)
	    init = "";
	}
    }
  sprintf (result,
	   (which_alternative == 0)
	   ? "%s" "srli\t%%2, %%1, 16\n\tsrc\t%%2, %%2, %%1\n\tsrc\t%%2, %%2, %%2\n\tsrc\t%%0, %%1, %%2"
	   : "%s" "srli\t%%0, %%1, 16\n\tsrc\t%%0, %%0, %%1\n\tsrc\t%%0, %%0, %%0\n\tsrc\t%%0, %%1, %%0",
	   init);
  return result;
}
}

static const char * const output_35[] = {
  "extui\t%0, %1, 0, %K2",
  "and\t%0, %1, %2",
};

static const char * const output_43[] = {
  "extui\t%0, %1, 0, 16",
  "%v1l16ui\t%0, %1",
};

static const char * const output_44[] = {
  "extui\t%0, %1, 0, 8",
  "%v1l8ui\t%0, %1",
};

static const char * const output_45[] = {
  "sext\t%0, %1, 15",
  "%v1l16si\t%0, %1",
};

static const char *
output_47 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1038 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  int fldsz = INTVAL (operands[2]);
  operands[2] = GEN_INT (fldsz - 1);
  return "sext\t%0, %1, %2";
}
}

static const char *
output_48 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1067 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  int shift;
  if (BITS_BIG_ENDIAN)
    shift = (32 - (INTVAL (operands[2]) + INTVAL (operands[3]))) & 0x1f;
  else
    shift = INTVAL (operands[3]) & 0x1f;
  operands[3] = GEN_INT (shift);
  return "extui\t%0, %1, %3, %2";
}
}

static const char *
output_55 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  static char result[64];
  sprintf (result, "trunc.s\t%%0, %%1, %d",
	   REAL_EXP (CONST_DOUBLE_REAL_VALUE (operands[2])) - 1);
  return result;
}
}

static const char *
output_56 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  static char result[64];
  sprintf (result, "utrunc.s\t%%0, %%1, %d",
	   REAL_EXP (CONST_DOUBLE_REAL_VALUE (operands[2])) - 1);
  return result;
}
}

static const char *
output_59 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  static char result[64];
  sprintf (result, "float.s\t%%0, %%1, %d",
	   1 - REAL_EXP (CONST_DOUBLE_REAL_VALUE (operands[2])));
  return result;
}
}

static const char *
output_60 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  static char result[64];
  sprintf (result, "ufloat.s\t%%0, %%1, %d",
	   1 - REAL_EXP (CONST_DOUBLE_REAL_VALUE (operands[2])));
  return result;
}
}

static const char * const output_62[] = {
  "movi.n\t%0, %x1",
  "mov.n\t%0, %1",
  "mov.n\t%0, %1",
  "%v1l32i.n\t%0, %1",
  "%v0s32i.n\t%1, %0",
  "%v0s32i.n\t%1, %0",
  "mov\t%0, %1",
  "movsp\t%0, %1",
  "movi\t%0, %x1",
  "movi\t%0, %1",
  "const16\t%0, %t1\n\tconst16\t%0, %b1",
  "%v1l32r\t%0, %1",
  "%v1l32i\t%0, %1",
  "%v0s32i\t%1, %0",
  "rsr\t%0, ACCLO",
  "wsr\t%1, ACCLO",
};

static const char * const output_63[] = {
  "movi.n\t%0, %x1",
  "mov.n\t%0, %1",
  "mov\t%0, %1",
  "movi\t%0, %x1",
  "movi\t%0, %1",
  "%v1l32r\t%0, %1",
  "%v1l16ui\t%0, %1",
  "%v0s16i\t%1, %0",
  "rsr\t%0, ACCLO",
  "wsr\t%1, ACCLO",
};

static const char * const output_64[] = {
  "movi.n\t%0, %x1",
  "mov.n\t%0, %1",
  "mov\t%0, %1",
  "movi\t%0, %x1",
  "%v1l8ui\t%0, %1",
  "%v0s8i\t%1, %0",
  "rsr\t%0, ACCLO",
  "wsr\t%1, ACCLO",
};

static const char * const output_65[] = {
  "mov.s\t%0, %1",
  "%v1lsi\t%0, %1",
  "%v0ssi\t%1, %0",
  "mov.n\t%0, %1",
  "%v1l32r\t%0, %1",
  "%v1l32i.n\t%0, %1",
  "%v0s32i.n\t%1, %0",
  "mov\t%0, %1",
  "wfr\t%0, %1",
  "rfr\t%0, %1",
  "movi\t%0, %y1",
  "const16\t%0, %t1\n\tconst16\t%0, %b1",
  "%v1l32i\t%0, %1",
  "%v0s32i\t%1, %0",
};

static const char *
output_66 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1488 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  if (TARGET_SERIALIZE_VOLATILE && volatile_refs_p (PATTERN (insn)))
    output_asm_insn ("memw", operands);
  return "lsiu\t%0, %1, %2";
}
}

static const char *
output_67 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1504 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  if (TARGET_SERIALIZE_VOLATILE && volatile_refs_p (PATTERN (insn)))
    output_asm_insn ("memw", operands);
  return "ssiu\t%2, %0, %1";
}
}

static const char *
output_68 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1520 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  if (TARGET_SERIALIZE_VOLATILE && volatile_refs_p (PATTERN (insn)))
    output_asm_insn ("memw", operands);
  return "lsip\t%0, %1, %2";
}
}

static const char *
output_69 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1536 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  if (TARGET_SERIALIZE_VOLATILE && volatile_refs_p (PATTERN (insn)))
    output_asm_insn ("memw", operands);
  return "ssip\t%1, %0, %2";
}
}

static const char * const output_71[] = {
  "slli\t%0, %1, %R2",
  "ssl\t%2\n\tsll\t%0, %1",
};

static const char * const output_72[] = {
  "srai\t%0, %1, %R2",
  "ssr\t%2\n\tsra\t%0, %1",
};

static const char *
output_73 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1681 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  if (which_alternative == 0)
    {
      if ((INTVAL (operands[2]) & 0x1f) < 16)
	return "srli\t%0, %1, %R2";
      else
	return "extui\t%0, %1, %R2, %L2";
    }
  return "ssr\t%2\n\tsrl\t%0, %1";
}
}

static const char *
output_74 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1702 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  switch (GET_CODE (operands[3]))
    {
    case ASHIFT:	return "ssa8b\t%2\n\tsll\t%0, %1";
    case ASHIFTRT:	return "ssa8l\t%2\n\tsra\t%0, %1";
    case LSHIFTRT:	return "ssa8l\t%2\n\tsrl\t%0, %1";
    default:		gcc_unreachable ();
    }
}
}

static const char *
output_77 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1772 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  switch (xtensa_shlrd_which_direction (operands[4], operands[5]))
    {
    case ASHIFT:	return "ssl\t%3\n\tsrc\t%0, %1, %2";
    case LSHIFTRT:	return "ssr\t%3\n\tsrc\t%0, %2, %1";
    default:		gcc_unreachable ();
    }
}
}

static const char *
output_79 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1825 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  switch (xtensa_shlrd_which_direction (operands[5], operands[6]))
    {
    case ASHIFT:	return "ssai\t%L3\n\tsrc\t%0, %1, %2";
    case LSHIFTRT:	return "ssai\t%R3\n\tsrc\t%0, %2, %1";
    default:		gcc_unreachable ();
    }
}
}

static const char *
output_80 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1850 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  switch (xtensa_shlrd_which_direction (operands[4], operands[5]))
    {
    case ASHIFT:	return "ssa8b\t%2\n\tsrc\t%0, %1, %3";
    case LSHIFTRT:	return "ssa8l\t%2\n\tsrc\t%0, %3, %1";
    default:		gcc_unreachable ();
    }
}
}

static const char * const output_82[] = {
  "ssai\t%L2\n\tsrc\t%0, %1, %1",
  "ssl\t%2\n\tsrc\t%0, %1, %1",
};

static const char * const output_83[] = {
  "ssai\t%R2\n\tsrc\t%0, %1, %1",
  "ssr\t%2\n\tsrc\t%0, %1, %1",
};

static const char *
output_84 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1956 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_branch (which_alternative == 0, operands);
}
}

static const char *
output_86 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2009 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_branch (which_alternative == 0, operands);
}
}

static const char *
output_87 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2028 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  static char result[64];
  char op;
  switch (GET_CODE (operands[3]))
    {
    case EQ:	op = 'c'; break;
    case NE:	op = 's'; break;
    default:	gcc_unreachable ();
    }
  if (which_alternative == 0)
    {
      operands[1] = GEN_INT (INTVAL (operands[1]) & 0x1f);
      sprintf (result, "bb%ci\t%%0, %%d1, %%2", op);
    }
  else
    sprintf (result, "bb%c\t%%0, %%1, %%2", op);
  return result;
}
}

static const char *
output_88 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2059 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  switch (GET_CODE (operands[3]))
    {
    case EQ:	return "bnone\t%0, %1, %2";
    case NE:	return "bany\t%0, %1, %2";
    default:	gcc_unreachable ();
    }
}
}

static const char *
output_89 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2080 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  switch (GET_CODE (operands[3]))
    {
    case EQ:	return "ball\t%0, %1, %2";
    case NE:	return "bnall\t%0, %1, %2";
    default:	gcc_unreachable ();
    }
}
}

static const char *
output_96 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2314 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  xtensa_emit_loop_end (insn, operands);
  return "";
}
}

static const char *
output_99 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2458 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_movcc (which_alternative == 1, false, false, operands);
}
}

static const char *
output_100 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2473 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_movcc (which_alternative == 1, false, true, operands);
}
}

static const char *
output_101 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2488 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_movcc ((which_alternative & 1) == 1,
			    which_alternative >= 2, false, operands);
}
}

static const char *
output_102 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2504 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_movcc ((which_alternative & 1) == 1,
			    which_alternative >= 2, true, operands);
}
}

static const char *
output_113 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2608 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_call (0, operands);
}
}

static const char *
output_114 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2630 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_call (1, operands);
}
}

static const char *
output_115 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2650 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_sibcall (0, operands);
}
}

static const char *
output_116 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2672 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_sibcall (1, operands);
}
}

static const char *
output_118 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2717 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  return TARGET_WINDOWED_ABI ?
      (TARGET_DENSITY ? "retw.n" : "retw") :
      (TARGET_DENSITY ? "ret.n" : "ret");
}
}

static const char *
output_119 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2787 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  return (TARGET_DENSITY ? "nop.n" : "nop");
}
}

static const char *
output_124 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2887 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  if (TARGET_DEBUG)
    return "break\t1, 15";
  else
    return (TARGET_DENSITY ? "ill.n" : "ill");
}
}

static const char *
output_125 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2918 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  if (frame_pointer_needed)
    return (TARGET_DENSITY ? "mov.n\ta7, sp" : "mov\ta7, sp");
  return "";
}
}

static const char *
output_131 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 3006 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  if (TARGET_WINDOWED_ABI)
    return "callx8.tls %1, %2@TLSCALL";
  else
    return "callx0.tls %1, %2@TLSCALL";
}
}

static const char *
output_132 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 3027 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  if (GET_CODE (operands[2]) == EQ)
    return "bf\t%0, %1";
  else
    return "bt\t%0, %1";
}
}

static const char *
output_133 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 3045 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
{
  if (GET_CODE (operands[2]) == EQ)
    return "bt\t%0, %1";
  else
    return "bf\t%0, %1";
}
}



static const struct insn_operand_data operand_data[] = 
{
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    0,
    0
  },
  {
    register_operand,
    "=D,D,a,a,a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%d,d,r,r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    add_operand,
    "d,O,r,J,N",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    addsubx_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    addsub_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=C,A",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%r,r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=A",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=A",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    xtensa_sminmax_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    xtensa_sminmax_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    scratch_operand,
    "=&a",
    E_HImode,
    0,
    0,
    0,
    0
  },
  {
    register_operand,
    "=a,&a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    scratch_operand,
    "=&a,X",
    E_SImode,
    0,
    0,
    0,
    0
  },
  {
    register_operand,
    "=a,a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    mask_operand,
    "P,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    shifted_mask_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a,a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmed_operand,
    "r,U",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=a,a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmed_operand,
    "r,U",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=B,a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    sext_operand,
    "r,U",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=B",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    sext_fldsz_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    lsbitnum_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    extui_fldsz_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    logical_shift_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=&a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    addsub_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    logical_shift_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    fix_scaling_operand,
    "F",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    float_scaling_operand,
    "F",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    nonimmed_operand,
    "=a,W,a,a,U",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    move_operand,
    "r,i,T,U,r",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "=D,D,D,D,R,R,a,q,a,a,W,a,a,U,*a,*A",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    move_operand,
    "M,D,d,R,D,d,r,r,I,Y,i,T,U,r,*A,*r",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "=D,D,a,a,a,a,a,U,*a,*A",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    move_operand,
    "M,d,r,I,Y,T,U,r,*A,*r",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "=D,D,a,a,a,U,*a,*A",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    move_operand,
    "M,d,r,I,U,r,*A,*r",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "=f,f,^U,D,a,D,R,a,f,a,a,W,a,U",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    move_operand,
    "f,^U,f,d,T,R,d,r,r,f,Y,iF,U,r",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "+a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    fpmem_offset_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "+a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    fpmem_offset_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmed_operand,
    "=a,a,W,a,a,U",
    E_DFmode,
    0,
    0,
    1,
    1
  },
  {
    move_operand,
    "r,Y,iF,T,U,r",
    E_DFmode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=a,a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "J,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    xtensa_shift_per_byte_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    xtensa_shift_per_byte_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    logical_shift_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    logical_shift_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    xtensa_bit_join_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    logical_shift_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    logical_shift_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    xtensa_bit_join_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    logical_shift_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    logical_shift_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    xtensa_bit_join_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    branch_operand,
    "K,?r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    branch_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    ubranch_operand,
    "L,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    ubranch_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "J,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    shifted_mask_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "=a,m",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "0,0",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    scratch_operand,
    "=X,&r",
    E_SImode,
    0,
    0,
    0,
    0
  },
  {
    register_operand,
    "=a,a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    branch_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a,a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "b,b",
    E_CCmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a,a,f,f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,r,r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,0,f,0",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,r,0,f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    branch_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a,a,f,f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "b,b,b,b",
    E_CCmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,0,f,0",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,r,0,f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=b",
    E_CCmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    call_insn_operand,
    "nir",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    call_insn_operand,
    "nir",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    call_insn_operand,
    "nic",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    call_insn_operand,
    "nic",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    scratch_operand,
    "=r",
    E_SImode,
    0,
    0,
    0,
    0
  },
  {
    0,
    "",
    E_BLKmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    tls_symbol_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    tls_symbol_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "b",
    E_CCmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    mem_operand,
    "=U",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    mem_operand,
    "+U",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a,&a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    scratch_operand,
    "=&a,X",
    E_SImode,
    0,
    0,
    0,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmed_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    constantpool_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=&r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    constantpool_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=&r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmed_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "",
    E_DFmode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_DFmode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_BLKmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_BLKmode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    memory_operand,
    "",
    E_BLKmode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    xtensa_cstoresi_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    memory_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    memory_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    nonimmed_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    add_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    mem_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    mem_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    memory_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    memory_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    0
  },
};


#if GCC_VERSION >= 2007
__extension__
#endif

const struct insn_data_d insn_data[] = 
{
  /* <internal>:0 */
  {
    "*placeholder_for_nothing",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { 0 },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:171 */
  {
    "addsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_1 },
#else
    { 0, output_1, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addsi3 },
    &operand_data[1],
    3,
    3,
    0,
    5,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:186 */
  {
    "*addsubx",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_2 },
#else
    { 0, 0, output_2 },
#endif
    { 0 },
    &operand_data[4],
    5,
    5,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:245 */
  {
    "addsf3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "add.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addsf3 },
    &operand_data[9],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:258 */
  {
    "subsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "sub\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subsi3 },
    &operand_data[4],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:268 */
  {
    "*subsi3_from_const",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[12],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:315 */
  {
    "subsf3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "sub.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subsf3 },
    &operand_data[15],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:364 */
  {
    "mulsi3_highpart",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mulsh\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsi3_highpart },
    &operand_data[18],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:364 */
  {
    "umulsi3_highpart",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "muluh\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_umulsi3_highpart },
    &operand_data[18],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:377 */
  {
    "mulsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mull\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsi3 },
    &operand_data[18],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:387 */
  {
    "mulhisi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_10 },
#else
    { 0, output_10, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulhisi3 },
    &operand_data[21],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:387 */
  {
    "umulhisi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_11 },
#else
    { 0, output_11, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_umulhisi3 },
    &operand_data[21],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:401 */
  {
    "muladdhisi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mula.aa.ll\t%1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_muladdhisi },
    &operand_data[24],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:414 */
  {
    "mulsubhisi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "muls.aa.ll\t%2, %3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsubhisi },
    &operand_data[28],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:427 */
  {
    "mulsf3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mul.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsf3 },
    &operand_data[9],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:437 */
  {
    "fmasf4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "madd.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_fmasf4 },
    &operand_data[32],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:449 */
  {
    "fnmasf4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "msub.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_fnmasf4 },
    &operand_data[32],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:463 */
  {
    "divsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "quos\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_divsi3 },
    &operand_data[4],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:473 */
  {
    "udivsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "quou\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_udivsi3 },
    &operand_data[4],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:486 */
  {
    "modsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "rems\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_modsi3 },
    &operand_data[4],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:496 */
  {
    "umodsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "remu\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_umodsi3 },
    &operand_data[4],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:509 */
  {
    "abssi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "abs\t%0, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_abssi2 },
    &operand_data[4],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:518 */
  {
    "abssf2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "abs.s\t%0, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_abssf2 },
    &operand_data[15],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:530 */
  {
    "sminsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "min\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sminsi3 },
    &operand_data[18],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:530 */
  {
    "uminsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "minu\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_uminsi3 },
    &operand_data[18],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:530 */
  {
    "smaxsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "max\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_smaxsi3 },
    &operand_data[18],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:530 */
  {
    "umaxsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "maxu\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_umaxsi3 },
    &operand_data[18],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:543 */
  {
    "*xtensa_clamps",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_27 },
#else
    { 0, 0, output_27 },
#endif
    { 0 },
    &operand_data[36],
    6,
    6,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:570 */
  {
    "clrsbsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "nsa\t%0, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_clrsbsi2 },
    &operand_data[4],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:579 */
  {
    "clzsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "nsau\t%0, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_clzsi2 },
    &operand_data[4],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:619 */
  {
    "bswaphi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "extui\t%2, %1, 8, 8\n\tslli\t%0, %1, 8\n\tor\t%0, %0, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_bswaphi2 },
    &operand_data[42],
    2,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:647 */
  {
    "bswapsi2_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_31 },
#else
    { 0, 0, output_31 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_bswapsi2_internal },
    &operand_data[45],
    2,
    3,
    0,
    2,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:695 */
  {
    "negsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "neg\t%0, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_negsi2 },
    &operand_data[4],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:704 */
  {
    "one_cmplsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_one_cmplsi2 },
    &operand_data[4],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:725 */
  {
    "negsf2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "neg.s\t%0, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_negsf2 },
    &operand_data[15],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:737 */
  {
    "andsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_35 },
#else
    { 0, output_35, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_andsi3 },
    &operand_data[48],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:749 */
  {
    "*andsi3_bitcmpl",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[4],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:769 */
  {
    "*andsi3_const_pow2_minus_one",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[36],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:793 */
  {
    "*andsi3_const_negative_pow2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[36],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:813 */
  {
    "*andsi3_const_shifted_mask",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[51],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:846 */
  {
    "iorsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "or\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_iorsi3 },
    &operand_data[18],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:880 */
  {
    "xorsi3_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "xor\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_xorsi3_internal },
    &operand_data[18],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:890 */
  {
    "*splice_bits",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[54],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:940 */
  {
    "zero_extendhisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_43 },
#else
    { 0, output_43, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendhisi2 },
    &operand_data[59],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:951 */
  {
    "zero_extendqisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_44 },
#else
    { 0, output_44, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendqisi2 },
    &operand_data[61],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:977 */
  {
    "extendhisi2_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_45 },
#else
    { 0, output_45, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendhisi2_internal },
    &operand_data[63],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1000 */
  {
    "extendqisi2_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "sext\t%0, %1, 7",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendqisi2_internal },
    &operand_data[65],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1032 */
  {
    "extvsi_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_47 },
#else
    { 0, 0, output_47 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extvsi_internal },
    &operand_data[67],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1061 */
  {
    "extzvsi_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_48 },
#else
    { 0, 0, output_48 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extzvsi_internal },
    &operand_data[71],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1080 */
  {
    "*extzvsi-1bit_ashlsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[75],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1111 */
  {
    "*extzvsi-1bit_addsubx",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[80],
    7,
    7,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1147 */
  {
    "fix_truncsfsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "trunc.s\t%0, %1, 0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_fix_truncsfsi2 },
    &operand_data[87],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1147 */
  {
    "fixuns_truncsfsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "utrunc.s\t%0, %1, 0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_fixuns_truncsfsi2 },
    &operand_data[87],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1156 */
  {
    "*fix_truncsfsi2_2x",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "trunc.s\t%0, %1, 1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[87],
    2,
    2,
    1,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1156 */
  {
    "*fixuns_truncsfsi2_2x",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "utrunc.s\t%0, %1, 1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[87],
    2,
    2,
    1,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1166 */
  {
    "*fix_truncsfsi2_scaled",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_55 },
#else
    { 0, 0, output_55 },
#endif
    { 0 },
    &operand_data[87],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1166 */
  {
    "*fixuns_truncsfsi2_scaled",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_56 },
#else
    { 0, 0, output_56 },
#endif
    { 0 },
    &operand_data[87],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1181 */
  {
    "floatsisf2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "float.s\t%0, %1, 0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_floatsisf2 },
    &operand_data[90],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1181 */
  {
    "floatunssisf2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ufloat.s\t%0, %1, 0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_floatunssisf2 },
    &operand_data[90],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1190 */
  {
    "*floatsisf2_scaled",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_59 },
#else
    { 0, 0, output_59 },
#endif
    { 0 },
    &operand_data[90],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1190 */
  {
    "*floatunssisf2_scaled",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_60 },
#else
    { 0, 0, output_60 },
#endif
    { 0 },
    &operand_data[90],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1239 */
  {
    "movdi_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movdi_internal },
    &operand_data[93],
    2,
    2,
    0,
    5,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1281 */
  {
    "movsi_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_62 },
#else
    { 0, output_62, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsi_internal },
    &operand_data[95],
    2,
    2,
    0,
    16,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1353 */
  {
    "movhi_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_63 },
#else
    { 0, output_63, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movhi_internal },
    &operand_data[97],
    2,
    2,
    0,
    10,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1383 */
  {
    "movqi_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_64 },
#else
    { 0, output_64, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movqi_internal },
    &operand_data[99],
    2,
    2,
    0,
    8,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1455 */
  {
    "movsf_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_65 },
#else
    { 0, output_65, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsf_internal },
    &operand_data[101],
    2,
    2,
    0,
    14,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1481 */
  {
    "*lsiu",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_66 },
#else
    { 0, 0, output_66 },
#endif
    { 0 },
    &operand_data[103],
    3,
    3,
    3,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1497 */
  {
    "*ssiu",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_67 },
#else
    { 0, 0, output_67 },
#endif
    { 0 },
    &operand_data[104],
    3,
    3,
    3,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1513 */
  {
    "*lsip",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_68 },
#else
    { 0, 0, output_68 },
#endif
    { 0 },
    &operand_data[103],
    3,
    3,
    2,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1529 */
  {
    "*ssip",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_69 },
#else
    { 0, 0, output_69 },
#endif
    { 0 },
    &operand_data[107],
    3,
    3,
    2,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1585 */
  {
    "movdf_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movdf_internal },
    &operand_data[110],
    2,
    2,
    0,
    6,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1643 */
  {
    "ashlsi3_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_71 },
#else
    { 0, output_71, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashlsi3_internal },
    &operand_data[112],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1664 */
  {
    "ashrsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_72 },
#else
    { 0, output_72, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashrsi3 },
    &operand_data[112],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1676 */
  {
    "lshrsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_73 },
#else
    { 0, 0, output_73 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_lshrsi3 },
    &operand_data[112],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1695 */
  {
    "*shift_per_byte",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_74 },
#else
    { 0, 0, output_74 },
#endif
    { 0 },
    &operand_data[115],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1715 */
  {
    "*shift_per_byte_omit_AND_0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[119],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1736 */
  {
    "*shift_per_byte_omit_AND_1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[119],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1761 */
  {
    "*shlrd_reg",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_77 },
#else
    { 0, 0, output_77 },
#endif
    { 0 },
    &operand_data[124],
    7,
    7,
    1,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1784 */
  {
    "*shlrd_reg",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[124],
    7,
    7,
    1,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1811 */
  {
    "*shlrd_const",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_79 },
#else
    { 0, 0, output_79 },
#endif
    { 0 },
    &operand_data[131],
    8,
    8,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1837 */
  {
    "*shlrd_per_byte",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_80 },
#else
    { 0, 0, output_80 },
#endif
    { 0 },
    &operand_data[124],
    7,
    7,
    1,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1862 */
  {
    "*shlrd_per_byte_omit_AND",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[139],
    8,
    8,
    2,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1895 */
  {
    "rotlsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_82 },
#else
    { 0, output_82, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_rotlsi3 },
    &operand_data[112],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1907 */
  {
    "rotrsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_83 },
#else
    { 0, output_83, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_rotrsi3 },
    &operand_data[112],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1948 */
  {
    "*btrue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_84 },
#else
    { 0, 0, output_84 },
#endif
    { 0 },
    &operand_data[147],
    4,
    4,
    0,
    2,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1970 */
  {
    "*btrue_INT_MIN",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[151],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2001 */
  {
    "*ubtrue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_86 },
#else
    { 0, 0, output_86 },
#endif
    { 0 },
    &operand_data[154],
    4,
    4,
    0,
    2,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2018 */
  {
    "*bittrue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_87 },
#else
    { 0, 0, output_87 },
#endif
    { 0 },
    &operand_data[158],
    4,
    4,
    0,
    2,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2050 */
  {
    "*masktrue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_88 },
#else
    { 0, 0, output_88 },
#endif
    { 0 },
    &operand_data[162],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2071 */
  {
    "*masktrue_bitcmpl",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_89 },
#else
    { 0, 0, output_89 },
#endif
    { 0 },
    &operand_data[162],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2092 */
  {
    "*masktrue_const_bitcmpl",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[166],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2145 */
  {
    "*masktrue_const_pow2_minus_one",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[170],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2185 */
  {
    "*masktrue_const_negative_pow2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[170],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2220 */
  {
    "*masktrue_const_shifted_mask",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[175],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2270 */
  {
    "zero_cost_loop_start",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "loop\t%0, %l1_LEND",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_cost_loop_start },
    &operand_data[180],
    3,
    3,
    1,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2286 */
  {
    "zero_cost_loop_end",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_cost_loop_end },
    &operand_data[183],
    3,
    4,
    1,
    2,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2303 */
  {
    "loop_end",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_96 },
#else
    { 0, 0, output_96 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_loop_end },
    &operand_data[180],
    3,
    3,
    1,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2390 */
  {
    "salt",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "salt\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_salt },
    &operand_data[4],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2400 */
  {
    "saltu",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "saltu\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_saltu },
    &operand_data[4],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2450 */
  {
    "movsicc_internal0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_99 },
#else
    { 0, 0, output_99 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsicc_internal0 },
    &operand_data[187],
    5,
    5,
    0,
    2,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2465 */
  {
    "movsicc_internal1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_100 },
#else
    { 0, 0, output_100 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsicc_internal1 },
    &operand_data[192],
    5,
    5,
    0,
    2,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2480 */
  {
    "movsfcc_internal0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_101 },
#else
    { 0, 0, output_101 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsfcc_internal0 },
    &operand_data[197],
    5,
    5,
    0,
    4,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2496 */
  {
    "movsfcc_internal1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_102 },
#else
    { 0, 0, output_102 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsfcc_internal1 },
    &operand_data[202],
    5,
    5,
    0,
    4,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2515 */
  {
    "seq_sf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "oeq.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_seq_sf },
    &operand_data[207],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2515 */
  {
    "slt_sf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "olt.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_slt_sf },
    &operand_data[207],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2515 */
  {
    "sle_sf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ole.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sle_sf },
    &operand_data[207],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2515 */
  {
    "suneq_sf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ueq.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_suneq_sf },
    &operand_data[207],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2515 */
  {
    "sunlt_sf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ult.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sunlt_sf },
    &operand_data[207],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2515 */
  {
    "sunle_sf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ule.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sunle_sf },
    &operand_data[207],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2515 */
  {
    "sunordered_sf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "un.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sunordered_sf },
    &operand_data[207],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2528 */
  {
    "jump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "j\t%l0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_jump },
    &operand_data[149],
    1,
    1,
    0,
    0,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2550 */
  {
    "indirect_jump_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "jx\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_indirect_jump_internal },
    &operand_data[5],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2577 */
  {
    "tablejump_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "jx\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_tablejump_internal },
    &operand_data[151],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2604 */
  {
    "call_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_113 },
#else
    { 0, 0, output_113 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_internal },
    &operand_data[210],
    2,
    2,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2625 */
  {
    "call_value_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_114 },
#else
    { 0, 0, output_114 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_value_internal },
    &operand_data[212],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2646 */
  {
    "sibcall_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_115 },
#else
    { 0, 0, output_115 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sibcall_internal },
    &operand_data[215],
    2,
    2,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2667 */
  {
    "sibcall_value_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_116 },
#else
    { 0, 0, output_116 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sibcall_value_internal },
    &operand_data[217],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2700 */
  {
    "entry",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "entry\tsp, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_entry },
    &operand_data[13],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2710 */
  {
    "return",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_118 },
#else
    { 0, 0, output_118 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_return },
    &operand_data[0],
    0,
    0,
    0,
    0,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2784 */
  {
    "nop",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_119 },
#else
    { 0, 0, output_119 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_nop },
    &operand_data[0],
    0,
    0,
    0,
    0,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2826 */
  {
    "eh_set_a0_windowed",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_eh_set_a0_windowed },
    &operand_data[220],
    1,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2839 */
  {
    "eh_set_a0_call0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_eh_set_a0_call0 },
    &operand_data[220],
    1,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2855 */
  {
    "blockage",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_blockage },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2875 */
  {
    "*frame_blockage",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[222],
    2,
    2,
    0,
    0,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2884 */
  {
    "trap",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_124 },
#else
    { 0, 0, output_124 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_trap },
    &operand_data[0],
    0,
    0,
    0,
    0,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2915 */
  {
    "set_frame_ptr",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_125 },
#else
    { 0, 0, output_125 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_set_frame_ptr },
    &operand_data[0],
    0,
    0,
    0,
    0,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2940 */
  {
    "*unspec_nop",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2961 */
  {
    "get_thread_pointersi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "rur\t%0, THREADPTR",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_get_thread_pointersi },
    &operand_data[4],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2970 */
  {
    "set_thread_pointersi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "wur\t%0, THREADPTR",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_set_thread_pointersi },
    &operand_data[5],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2979 */
  {
    "tls_func",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "movi\t%0, %1@TLSFUNC",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_tls_func },
    &operand_data[224],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2989 */
  {
    "tls_arg",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "movi\t%0, %1@TLSARG",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_tls_arg },
    &operand_data[224],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2999 */
  {
    "tls_call",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_131 },
#else
    { 0, 0, output_131 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_tls_call },
    &operand_data[226],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3019 */
  {
    "*booltrue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_132 },
#else
    { 0, 0, output_132 },
#endif
    { 0 },
    &operand_data[230],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3037 */
  {
    "*boolfalse",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_133 },
#else
    { 0, 0, output_133 },
#endif
    { 0 },
    &operand_data[230],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3067 */
  {
    "*memory_barrier",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "memw",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[222],
    1,
    1,
    1,
    0,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3078 */
  {
    "sync_lock_releasesi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "s32ri\t%1, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_lock_releasesi },
    &operand_data[233],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3089 */
  {
    "sync_compare_and_swapsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "wsr\t%2, SCOMPARE1\n\ts32c1i\t%3, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_compare_and_swapsi },
    &operand_data[235],
    4,
    4,
    2,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3165 */
  {
    "*round_up_to_even",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[4],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3189 */
  {
    "*signed_ge_zero",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[4],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3210 */
  {
    "eq_zero_NSA",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_eq_zero_NSA },
    &operand_data[4],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3227 */
  {
    "eqne_zero",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_eqne_zero },
    &operand_data[239],
    3,
    4,
    0,
    2,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3264 */
  {
    "*eqne_zero_masked_bits",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[243],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3293 */
  {
    "*eqne_INT_MIN",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[247],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:216 */
  {
    "adddi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_adddi3 },
    &operand_data[250],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:292 */
  {
    "subdi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subdi3 },
    &operand_data[250],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:328 */
  {
    "mulsidi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsidi3 },
    &operand_data[252],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:342 */
  {
    "umulsidi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_umulsidi3 },
    &operand_data[252],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:588 */
  {
    "ctzsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ctzsi2 },
    &operand_data[253],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:602 */
  {
    "ffssi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ffssi2 },
    &operand_data[253],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:629 */
  {
    "bswapsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_bswapsi2 },
    &operand_data[253],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:679 */
  {
    "bswapdi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_bswapdi2 },
    &operand_data[250],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:856 */
  {
    "xorsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_xorsi3 },
    &operand_data[253],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:965 */
  {
    "extendhisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendhisi2 },
    &operand_data[256],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:988 */
  {
    "extendqisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendqisi2 },
    &operand_data[258],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1012 */
  {
    "extvsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extvsi },
    &operand_data[260],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1047 */
  {
    "extzvsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extzvsi },
    &operand_data[260],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1210 */
  {
    "movdi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movdi },
    &operand_data[264],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1272 */
  {
    "movsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsi },
    &operand_data[266],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1344 */
  {
    "movhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movhi },
    &operand_data[268],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1374 */
  {
    "movqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movqi },
    &operand_data[270],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1402 */
  {
    "reloadhi_literal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_reloadhi_literal },
    &operand_data[272],
    3,
    3,
    0,
    1,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1402 */
  {
    "reloadqi_literal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_reloadqi_literal },
    &operand_data[275],
    3,
    3,
    0,
    1,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1436 */
  {
    "movsf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsf },
    &operand_data[278],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1570 */
  {
    "movdf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movdf },
    &operand_data[280],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1605 */
  {
    "cpymemsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cpymemsi },
    &operand_data[282],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1619 */
  {
    "setmemsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_setmemsi },
    &operand_data[286],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1634 */
  {
    "ashlsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashlsi3 },
    &operand_data[290],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1924 */
  {
    "cbranchsi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchsi4 },
    &operand_data[293],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:1935 */
  {
    "cbranchsf4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchsf4 },
    &operand_data[297],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2358 */
  {
    "doloop_end",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_doloop_end },
    &operand_data[301],
    2,
    2,
    2,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2378 */
  {
    "cstoresi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cstoresi4 },
    &operand_data[303],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2410 */
  {
    "cstoresf4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cstoresf4 },
    &operand_data[307],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2426 */
  {
    "movsicc",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsicc },
    &operand_data[311],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2438 */
  {
    "movsfcc",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsfcc },
    &operand_data[315],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2537 */
  {
    "indirect_jump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_indirect_jump },
    &operand_data[319],
    1,
    1,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2559 */
  {
    "tablejump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_tablejump },
    &operand_data[320],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2590 */
  {
    "sym_PLT",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sym_PLT },
    &operand_data[223],
    1,
    1,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2595 */
  {
    "call",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call },
    &operand_data[322],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2615 */
  {
    "call_value",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_value },
    &operand_data[324],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2637 */
  {
    "sibcall",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sibcall },
    &operand_data[322],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2657 */
  {
    "sibcall_value",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sibcall_value },
    &operand_data[324],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2679 */
  {
    "untyped_call",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_untyped_call },
    &operand_data[326],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2736 */
  {
    "allocate_stack",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_allocate_stack },
    &operand_data[329],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2758 */
  {
    "prologue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_prologue },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2766 */
  {
    "epilogue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_epilogue },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2775 */
  {
    "sibcall_epilogue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sibcall_epilogue },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2797 */
  {
    "nonlocal_goto",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_nonlocal_goto },
    &operand_data[331],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2815 */
  {
    "eh_return",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_eh_return },
    &operand_data[335],
    1,
    1,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2865 */
  {
    "frame_blockage",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_frame_blockage },
    &operand_data[0],
    0,
    0,
    2,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2951 */
  {
    "sym_TPOFF",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sym_TPOFF },
    &operand_data[223],
    1,
    1,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:2956 */
  {
    "sym_DTPOFF",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sym_DTPOFF },
    &operand_data[223],
    1,
    1,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3058 */
  {
    "memory_barrier",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_memory_barrier },
    &operand_data[0],
    0,
    0,
    2,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3105 */
  {
    "sync_compare_and_swaphi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_compare_and_swaphi },
    &operand_data[336],
    4,
    4,
    2,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3105 */
  {
    "sync_compare_and_swapqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_compare_and_swapqi },
    &operand_data[340],
    4,
    4,
    2,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3122 */
  {
    "sync_lock_test_and_sethi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_lock_test_and_sethi },
    &operand_data[344],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3122 */
  {
    "sync_lock_test_and_setqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_lock_test_and_setqi },
    &operand_data[347],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3132 */
  {
    "sync_andhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_andhi },
    &operand_data[345],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3132 */
  {
    "sync_iorhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_iorhi },
    &operand_data[345],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3132 */
  {
    "sync_xorhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_xorhi },
    &operand_data[345],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3132 */
  {
    "sync_addhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_addhi },
    &operand_data[345],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3132 */
  {
    "sync_subhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_subhi },
    &operand_data[345],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3132 */
  {
    "sync_nandhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_nandhi },
    &operand_data[345],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3132 */
  {
    "sync_andqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_andqi },
    &operand_data[348],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3132 */
  {
    "sync_iorqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_iorqi },
    &operand_data[348],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3132 */
  {
    "sync_xorqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_xorqi },
    &operand_data[348],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3132 */
  {
    "sync_addqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_addqi },
    &operand_data[348],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3132 */
  {
    "sync_subqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_subqi },
    &operand_data[348],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3132 */
  {
    "sync_nandqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_nandqi },
    &operand_data[348],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3142 */
  {
    "sync_old_andhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_andhi },
    &operand_data[344],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3142 */
  {
    "sync_old_iorhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_iorhi },
    &operand_data[344],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3142 */
  {
    "sync_old_xorhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_xorhi },
    &operand_data[344],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3142 */
  {
    "sync_old_addhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_addhi },
    &operand_data[344],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3142 */
  {
    "sync_old_subhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_subhi },
    &operand_data[344],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3142 */
  {
    "sync_old_nandhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_nandhi },
    &operand_data[344],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3142 */
  {
    "sync_old_andqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_andqi },
    &operand_data[347],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3142 */
  {
    "sync_old_iorqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_iorqi },
    &operand_data[347],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3142 */
  {
    "sync_old_xorqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_xorqi },
    &operand_data[347],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3142 */
  {
    "sync_old_addqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_addqi },
    &operand_data[347],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3142 */
  {
    "sync_old_subqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_subqi },
    &operand_data[347],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3142 */
  {
    "sync_old_nandqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_nandqi },
    &operand_data[347],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3154 */
  {
    "sync_new_andhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_andhi },
    &operand_data[344],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3154 */
  {
    "sync_new_iorhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_iorhi },
    &operand_data[344],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3154 */
  {
    "sync_new_xorhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_xorhi },
    &operand_data[344],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3154 */
  {
    "sync_new_addhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_addhi },
    &operand_data[344],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3154 */
  {
    "sync_new_subhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_subhi },
    &operand_data[344],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3154 */
  {
    "sync_new_nandhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_nandhi },
    &operand_data[344],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3154 */
  {
    "sync_new_andqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_andqi },
    &operand_data[347],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3154 */
  {
    "sync_new_iorqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_iorqi },
    &operand_data[347],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3154 */
  {
    "sync_new_xorqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_xorqi },
    &operand_data[347],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3154 */
  {
    "sync_new_addqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_addqi },
    &operand_data[347],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3154 */
  {
    "sync_new_subqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_subqi },
    &operand_data[347],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md:3154 */
  {
    "sync_new_nandqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_nandqi },
    &operand_data[347],
    3,
    3,
    3,
    0,
    0
  },
};


const char *
get_insn_name (int code)
{
  if (code == NOOP_MOVE_INSN_CODE)
    return "NOOP_MOVE";
  else
    return insn_data[code].name;
}
