/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md'.  */

#ifndef GCC_TM_CONSTRS_H
#define GCC_TM_CONSTRS_H

static inline bool
satisfies_constraint_m (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 54 "../../gcc-15.0.1-20250313/gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op))));
}
static inline bool
satisfies_constraint_o (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 60 "../../gcc-15.0.1-20250313/gcc/common.md"
(offsettable_nonstrict_memref_p (op)));
}
static inline bool
satisfies_constraint_V (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 69 "../../gcc-15.0.1-20250313/gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op)))) && (!(
#line 71 "../../gcc-15.0.1-20250313/gcc/common.md"
(offsettable_nonstrict_memref_p (op)))));
}
static inline bool
satisfies_constraint__l (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 78 "../../gcc-15.0.1-20250313/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_DEC)) || (
#line 79 "../../gcc-15.0.1-20250313/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_DEC)));
}
static inline bool
satisfies_constraint__g (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 85 "../../gcc-15.0.1-20250313/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_INC)) || (
#line 86 "../../gcc-15.0.1-20250313/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_INC)));
}
static inline bool
satisfies_constraint_p (rtx ARG_UNUSED (op))
{
  return 
#line 90 "../../gcc-15.0.1-20250313/gcc/common.md"
(address_operand (op, VOIDmode));
}
static inline bool
satisfies_constraint_i (rtx op)
{
  return (
#line 94 "../../gcc-15.0.1-20250313/gcc/common.md"
(CONSTANT_P (op))) && (
#line 95 "../../gcc-15.0.1-20250313/gcc/common.md"
(!flag_pic || raw_constraint_p || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_s (rtx op)
{
  return (
#line 99 "../../gcc-15.0.1-20250313/gcc/common.md"
(CONSTANT_P (op))) && ((
#line 100 "../../gcc-15.0.1-20250313/gcc/common.md"
(!CONST_SCALAR_INT_P (op))) && (
#line 101 "../../gcc-15.0.1-20250313/gcc/common.md"
(!flag_pic || raw_constraint_p || LEGITIMATE_PIC_OPERAND_P (op))));
}
static inline bool
satisfies_constraint__c (rtx op)
{
  return (
#line 105 "../../gcc-15.0.1-20250313/gcc/common.md"
(CONSTANT_P (op))) && (
#line 106 "../../gcc-15.0.1-20250313/gcc/common.md"
(!CONST_SCALAR_INT_P (op)));
}
static inline bool
satisfies_constraint_n (rtx op)
{
  return (
#line 110 "../../gcc-15.0.1-20250313/gcc/common.md"
(CONST_SCALAR_INT_P (op))) && (
#line 111 "../../gcc-15.0.1-20250313/gcc/common.md"
(!flag_pic || raw_constraint_p || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_E (rtx op)
{
  return (
#line 115 "../../gcc-15.0.1-20250313/gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 116 "../../gcc-15.0.1-20250313/gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_F (rtx op)
{
  return (
#line 122 "../../gcc-15.0.1-20250313/gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 123 "../../gcc-15.0.1-20250313/gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_X (rtx ARG_UNUSED (op))
{
  return 
#line 128 "../../gcc-15.0.1-20250313/gcc/common.md"
(true);
}
static inline bool
satisfies_constraint_I (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 76 "../../gcc-15.0.1-20250313/gcc/config/xtensa/constraints.md"
(xtensa_simm12b (ival)));
}
static inline bool
satisfies_constraint_J (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 81 "../../gcc-15.0.1-20250313/gcc/config/xtensa/constraints.md"
(xtensa_simm8 (ival)));
}
static inline bool
satisfies_constraint_K (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 88 "../../gcc-15.0.1-20250313/gcc/config/xtensa/constraints.md"
(xtensa_b4const_or_zero (ival)));
}
static inline bool
satisfies_constraint_L (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 94 "../../gcc-15.0.1-20250313/gcc/config/xtensa/constraints.md"
(xtensa_b4constu (ival)));
}
static inline bool
satisfies_constraint_M (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 100 "../../gcc-15.0.1-20250313/gcc/config/xtensa/constraints.md"
(IN_RANGE (ival, -32, 95)));
}
static inline bool
satisfies_constraint_N (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 106 "../../gcc-15.0.1-20250313/gcc/config/xtensa/constraints.md"
(xtensa_simm8x256 (ival)));
}
static inline bool
satisfies_constraint_O (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 111 "../../gcc-15.0.1-20250313/gcc/config/xtensa/constraints.md"
(xtensa_m1_or_1_thru_15 (ival)));
}
static inline bool
satisfies_constraint_P (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 117 "../../gcc-15.0.1-20250313/gcc/config/xtensa/constraints.md"
(xtensa_mask_immediate (ival)));
}
static inline bool
satisfies_constraint_Y (rtx op)
{
  return ((GET_CODE (op) == CONST_INT || GET_CODE (op) == CONST_DOUBLE || GET_CODE (op) == CONST || GET_CODE (op) == SYMBOL_REF || GET_CODE (op) == LABEL_REF) && (
#line 122 "../../gcc-15.0.1-20250313/gcc/config/xtensa/constraints.md"
(TARGET_AUTO_LITPOOLS))) || ((GET_CODE (op) == CONST_INT) && (
#line 124 "../../gcc-15.0.1-20250313/gcc/config/xtensa/constraints.md"
(! xtensa_split1_finished_p ())));
}
static inline bool
satisfies_constraint_R (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 131 "../../gcc-15.0.1-20250313/gcc/config/xtensa/constraints.md"
(smalloffset_mem_p (op)));
}
static inline bool
satisfies_constraint_T (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 136 "../../gcc-15.0.1-20250313/gcc/config/xtensa/constraints.md"
(!TARGET_CONST16 && constantpool_mem_p (op)));
}
static inline bool
satisfies_constraint_U (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 141 "../../gcc-15.0.1-20250313/gcc/config/xtensa/constraints.md"
(! constantpool_mem_p (op)));
}
#endif /* tm-constrs.h */
