/* Generated automatically by the program `genopinit'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "optabs.h"

struct optab_pat {
  unsigned scode;
  enum insn_code icode;
};

static const struct optab_pat pats[NUM_OPTAB_PATTERNS] = {
  { 0x101005, CODE_FOR_extendqihi2 },
  { 0x101006, CODE_FOR_extendqisi2 },
  { 0x101007, CODE_FOR_extendqidi2 },
  { 0x101406, CODE_FOR_extendhisi2 },
  { 0x101407, CODE_FOR_extendhidi2 },
  { 0x101807, CODE_FOR_extendsidi2 },
  { 0x300c06, CODE_FOR_zero_extendbisi2 },
  { 0x301005, CODE_FOR_zero_extendqihi2 },
  { 0x301006, CODE_FOR_zero_extendqisi2 },
  { 0x301007, CODE_FOR_zero_extendqidi2 },
  { 0x301406, CODE_FOR_zero_extendhisi2 },
  { 0x301407, CODE_FOR_zero_extendhidi2 },
  { 0x1401406, CODE_FOR_mulhisi3 },
  { 0x1501406, CODE_FOR_umulhisi3 },
  { 0x1601406, CODE_FOR_usmulhisi3 },
  { 0x3b00006, CODE_FOR_addsi3 },
  { 0x3b00007, CODE_FOR_adddi3 },
  { 0x3b00009, CODE_FOR_addpdi3 },
  { 0x3b00029, CODE_FOR_addv2hi3 },
  { 0x3d00005, CODE_FOR_ssaddhi3 },
  { 0x3d00006, CODE_FOR_ssaddsi3 },
  { 0x3d00029, CODE_FOR_ssaddv2hi3 },
  { 0x3f00006, CODE_FOR_subsi3 },
  { 0x3f00007, CODE_FOR_subdi3 },
  { 0x3f00029, CODE_FOR_subv2hi3 },
  { 0x4100005, CODE_FOR_sssubhi3 },
  { 0x4100006, CODE_FOR_sssubsi3 },
  { 0x4100029, CODE_FOR_sssubv2hi3 },
  { 0x4300006, CODE_FOR_mulsi3 },
  { 0x4300029, CODE_FOR_mulv2hi3 },
  { 0x5100006, CODE_FOR_andsi3 },
  { 0x5100007, CODE_FOR_anddi3 },
  { 0x5200006, CODE_FOR_iorsi3 },
  { 0x5200007, CODE_FOR_iordi3 },
  { 0x5300006, CODE_FOR_xorsi3 },
  { 0x5300007, CODE_FOR_xordi3 },
  { 0x5400006, CODE_FOR_ashlsi3 },
  { 0x5400007, CODE_FOR_ashldi3 },
  { 0x5700006, CODE_FOR_ashrsi3 },
  { 0x5700007, CODE_FOR_ashrdi3 },
  { 0x5700009, CODE_FOR_ashrpdi3 },
  { 0x5800006, CODE_FOR_lshrsi3 },
  { 0x5800007, CODE_FOR_lshrdi3 },
  { 0x5800009, CODE_FOR_lshrpdi3 },
  { 0x5900006, CODE_FOR_rotlsi3 },
  { 0x5a00006, CODE_FOR_rotrsi3 },
  { 0x6000005, CODE_FOR_sminhi3 },
  { 0x6000006, CODE_FOR_sminsi3 },
  { 0x6000029, CODE_FOR_sminv2hi3 },
  { 0x6100005, CODE_FOR_smaxhi3 },
  { 0x6100006, CODE_FOR_smaxsi3 },
  { 0x6100029, CODE_FOR_smaxv2hi3 },
  { 0x6400005, CODE_FOR_neghi2 },
  { 0x6400006, CODE_FOR_negsi2 },
  { 0x6800005, CODE_FOR_abshi2 },
  { 0x6a00006, CODE_FOR_one_cmplsi2 },
  { 0x6f00005, CODE_FOR_clrsbhi2 },
  { 0x6f00006, CODE_FOR_clrsbsi2 },
  { 0x7000005, CODE_FOR_popcounthi2 },
  { 0x7000006, CODE_FOR_popcountsi2 },
  { 0x7d00006, CODE_FOR_sync_old_addsi },
  { 0x7e00006, CODE_FOR_sync_old_subsi },
  { 0x7f00006, CODE_FOR_sync_old_iorsi },
  { 0x8000006, CODE_FOR_sync_old_andsi },
  { 0x8100006, CODE_FOR_sync_old_xorsi },
  { 0x8300006, CODE_FOR_sync_new_addsi },
  { 0x8400006, CODE_FOR_sync_new_subsi },
  { 0x8500006, CODE_FOR_sync_new_iorsi },
  { 0x8600006, CODE_FOR_sync_new_andsi },
  { 0x8700006, CODE_FOR_sync_new_xorsi },
  { 0x8900006, CODE_FOR_sync_compare_and_swapsi },
  { 0x8b00003, CODE_FOR_movbi },
  { 0x8b00004, CODE_FOR_movqi },
  { 0x8b00005, CODE_FOR_movhi },
  { 0x8b00006, CODE_FOR_movsi },
  { 0x8b00007, CODE_FOR_movdi },
  { 0x8b00009, CODE_FOR_movpdi },
  { 0x8b0001c, CODE_FOR_movsf },
  { 0x8b0001d, CODE_FOR_movdf },
  { 0x8b00029, CODE_FOR_movv2hi },
  { 0x9600006, CODE_FOR_reload_insi },
  { 0x9600009, CODE_FOR_reload_inpdi },
  { 0x960002b, CODE_FOR_reload_inv2pdi },
  { 0x9700009, CODE_FOR_reload_outpdi },
  { 0x970002b, CODE_FOR_reload_outv2pdi },
  { 0x9800003, CODE_FOR_cbranchbi4 },
  { 0x9800006, CODE_FOR_cbranchsi4 },
  { 0x9e00004, CODE_FOR_movqicc },
  { 0x9e00005, CODE_FOR_movhicc },
  { 0x9e00006, CODE_FOR_movsicc },
  { 0xd500003, CODE_FOR_cstorebi4 },
  { 0xd500006, CODE_FOR_cstoresi4 },
  { 0xe200006, CODE_FOR_smulsi3_highpart },
  { 0xe300006, CODE_FOR_umulsi3_highpart },
  { 0xe700006, CODE_FOR_cpymemsi },
  { 0x19200006, CODE_FOR_sync_addsi },
  { 0x19300006, CODE_FOR_sync_andsi },
  { 0x19400006, CODE_FOR_sync_iorsi },
  { 0x19700006, CODE_FOR_sync_subsi },
  { 0x19800006, CODE_FOR_sync_xorsi },
};

void
init_all_optabs (struct target_optabs *optabs)
{
  bool *ena = optabs->pat_enable;
  ena[0] = HAVE_extendqihi2;
  ena[1] = HAVE_extendqisi2;
  ena[2] = HAVE_extendqidi2;
  ena[3] = HAVE_extendhisi2;
  ena[4] = HAVE_extendhidi2;
  ena[5] = HAVE_extendsidi2;
  ena[6] = HAVE_zero_extendbisi2;
  ena[7] = HAVE_zero_extendqihi2;
  ena[8] = HAVE_zero_extendqisi2;
  ena[9] = HAVE_zero_extendqidi2;
  ena[10] = HAVE_zero_extendhisi2;
  ena[11] = HAVE_zero_extendhidi2;
  ena[12] = HAVE_mulhisi3;
  ena[13] = HAVE_umulhisi3;
  ena[14] = HAVE_usmulhisi3;
  ena[15] = HAVE_addsi3;
  ena[16] = HAVE_adddi3;
  ena[17] = HAVE_addpdi3;
  ena[18] = HAVE_addv2hi3;
  ena[19] = HAVE_ssaddhi3;
  ena[20] = HAVE_ssaddsi3;
  ena[21] = HAVE_ssaddv2hi3;
  ena[22] = HAVE_subsi3;
  ena[23] = HAVE_subdi3;
  ena[24] = HAVE_subv2hi3;
  ena[25] = HAVE_sssubhi3;
  ena[26] = HAVE_sssubsi3;
  ena[27] = HAVE_sssubv2hi3;
  ena[28] = HAVE_mulsi3;
  ena[29] = HAVE_mulv2hi3;
  ena[30] = HAVE_andsi3;
  ena[31] = HAVE_anddi3;
  ena[32] = HAVE_iorsi3;
  ena[33] = HAVE_iordi3;
  ena[34] = HAVE_xorsi3;
  ena[35] = HAVE_xordi3;
  ena[36] = HAVE_ashlsi3;
  ena[37] = HAVE_ashldi3;
  ena[38] = HAVE_ashrsi3;
  ena[39] = HAVE_ashrdi3;
  ena[40] = HAVE_ashrpdi3;
  ena[41] = HAVE_lshrsi3;
  ena[42] = HAVE_lshrdi3;
  ena[43] = HAVE_lshrpdi3;
  ena[44] = HAVE_rotlsi3;
  ena[45] = HAVE_rotrsi3;
  ena[46] = HAVE_sminhi3;
  ena[47] = HAVE_sminsi3;
  ena[48] = HAVE_sminv2hi3;
  ena[49] = HAVE_smaxhi3;
  ena[50] = HAVE_smaxsi3;
  ena[51] = HAVE_smaxv2hi3;
  ena[52] = HAVE_neghi2;
  ena[53] = HAVE_negsi2;
  ena[54] = HAVE_abshi2;
  ena[55] = HAVE_one_cmplsi2;
  ena[56] = HAVE_clrsbhi2;
  ena[57] = HAVE_clrsbsi2;
  ena[58] = HAVE_popcounthi2;
  ena[59] = HAVE_popcountsi2;
  ena[60] = HAVE_sync_old_addsi;
  ena[61] = HAVE_sync_old_subsi;
  ena[62] = HAVE_sync_old_iorsi;
  ena[63] = HAVE_sync_old_andsi;
  ena[64] = HAVE_sync_old_xorsi;
  ena[65] = HAVE_sync_new_addsi;
  ena[66] = HAVE_sync_new_subsi;
  ena[67] = HAVE_sync_new_iorsi;
  ena[68] = HAVE_sync_new_andsi;
  ena[69] = HAVE_sync_new_xorsi;
  ena[70] = HAVE_sync_compare_and_swapsi;
  ena[71] = HAVE_movbi;
  ena[72] = HAVE_movqi;
  ena[73] = HAVE_movhi;
  ena[74] = HAVE_movsi;
  ena[75] = HAVE_movdi;
  ena[76] = HAVE_movpdi;
  ena[77] = HAVE_movsf;
  ena[78] = HAVE_movdf;
  ena[79] = HAVE_movv2hi;
  ena[80] = HAVE_reload_insi;
  ena[81] = HAVE_reload_inpdi;
  ena[82] = HAVE_reload_inv2pdi;
  ena[83] = HAVE_reload_outpdi;
  ena[84] = HAVE_reload_outv2pdi;
  ena[85] = HAVE_cbranchbi4;
  ena[86] = HAVE_cbranchsi4;
  ena[87] = HAVE_movqicc;
  ena[88] = HAVE_movhicc;
  ena[89] = HAVE_movsicc;
  ena[90] = HAVE_cstorebi4;
  ena[91] = HAVE_cstoresi4;
  ena[92] = HAVE_smulsi3_highpart;
  ena[93] = HAVE_umulsi3_highpart;
  ena[94] = HAVE_cpymemsi;
  ena[95] = HAVE_sync_addsi;
  ena[96] = HAVE_sync_andsi;
  ena[97] = HAVE_sync_iorsi;
  ena[98] = HAVE_sync_subsi;
  ena[99] = HAVE_sync_xorsi;
}

/* Returns TRUE if the target supports any of the partial vector
   optabs: while_ult_optab, len_load_optab, len_store_optab,
   mask_len_load_optab or mask_len_store_optab,
   for any mode.  */
bool
partial_vectors_supported_p (void)
{
	return false;
}
static int
lookup_handler (unsigned scode)
{
  int l = 0, h = ARRAY_SIZE (pats), m;
  while (h > l)
    {
      m = (h + l) / 2;
      if (scode == pats[m].scode)
        return m;
      else if (scode < pats[m].scode)
        h = m;
      else
        l = m + 1;
    }
  return -1;
}

enum insn_code
raw_optab_handler (unsigned scode)
{
  int i = lookup_handler (scode);
  return (i >= 0 && this_fn_optabs->pat_enable[i]
          ? pats[i].icode : CODE_FOR_nothing);
}

bool
swap_optab_enable (optab op, machine_mode m, bool set)
{
  unsigned scode = (op << 20) | m;
  int i = lookup_handler (scode);
  if (i >= 0)
    {
      bool ret = this_fn_optabs->pat_enable[i];
      this_fn_optabs->pat_enable[i] = set;
      return ret;
    }
  else
    {
      gcc_assert (!set);
      return false;
    }
}

const struct convert_optab_libcall_d convlib_def[NUM_CONVLIB_OPTABS] = {
  { "extend", gen_extend_conv_libfunc },
  { "trunc", gen_trunc_conv_libfunc },
  { NULL, NULL },
  { "fix", gen_fp_to_int_conv_libfunc },
  { "fixuns", gen_fp_to_int_conv_libfunc },
  { "float", gen_int_to_fp_conv_libfunc },
  { NULL, gen_ufloat_conv_libfunc },
  { "lrint", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lround", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lfloor", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lceil", gen_int_to_fp_nondecimal_conv_libfunc },
  { "fract", gen_fract_conv_libfunc },
  { "fractuns", gen_fractuns_conv_libfunc },
  { "satfract", gen_satfract_conv_libfunc },
  { "satfractuns", gen_satfractuns_conv_libfunc },
  { "ustrunc", NULL },
  { "sstrunc", NULL },
};

const struct optab_libcall_d normlib_def[NUM_NORMLIB_OPTABS] = {
  { '3', "add", gen_int_fp_fixed_libfunc },
  { '3', "add", gen_intv_fp_libfunc },
  { '3', "ssadd", gen_signed_fixed_libfunc },
  { '3', "usadd", gen_unsigned_fixed_libfunc },
  { '3', "sub", gen_int_fp_fixed_libfunc },
  { '3', "sub", gen_intv_fp_libfunc },
  { '3', "sssub", gen_signed_fixed_libfunc },
  { '3', "ussub", gen_unsigned_fixed_libfunc },
  { '3', "mul", gen_int_fp_fixed_libfunc },
  { '3', "mul", gen_intv_fp_libfunc },
  { '3', "ssmul", gen_signed_fixed_libfunc },
  { '3', "usmul", gen_unsigned_fixed_libfunc },
  { '3', "div", gen_int_fp_signed_fixed_libfunc },
  { '3', "divv", gen_int_libfunc },
  { '3', "ssdiv", gen_signed_fixed_libfunc },
  { '3', "udiv", gen_int_unsigned_fixed_libfunc },
  { '3', "usdiv", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "mod", gen_int_libfunc },
  { '3', "umod", gen_int_libfunc },
  { '2', "ftrunc", gen_fp_libfunc },
  { '3', "and", gen_int_libfunc },
  { '3', "ior", gen_int_libfunc },
  { '3', "xor", gen_int_libfunc },
  { '3', "ashl", gen_int_fixed_libfunc },
  { '3', "ssashl", gen_signed_fixed_libfunc },
  { '3', "usashl", gen_unsigned_fixed_libfunc },
  { '3', "ashr", gen_int_signed_fixed_libfunc },
  { '3', "lshr", gen_int_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "min", gen_int_fp_libfunc },
  { '3', "max", gen_int_fp_libfunc },
  { '3', "umin", gen_int_libfunc },
  { '3', "umax", gen_int_libfunc },
  { '2', "neg", gen_int_fp_fixed_libfunc },
  { '2', "neg", gen_intv_fp_libfunc },
  { '2', "ssneg", gen_signed_fixed_libfunc },
  { '2', "usneg", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '2', "one_cmpl", gen_int_libfunc },
  { '\0', NULL, NULL },
  { '2', "ffs", gen_int_libfunc },
  { '2', "clz", gen_int_libfunc },
  { '2', "ctz", gen_int_libfunc },
  { '2', "clrsb", gen_int_libfunc },
  { '2', "popcount", gen_int_libfunc },
  { '2', "parity", gen_int_libfunc },
  { '2', "cmp", gen_int_fp_fixed_libfunc },
  { '2', "ucmp", gen_int_libfunc },
  { '2', "eq", gen_fp_libfunc },
  { '2', "ne", gen_fp_libfunc },
  { '2', "gt", gen_fp_libfunc },
  { '2', "ge", gen_fp_libfunc },
  { '2', "lt", gen_fp_libfunc },
  { '2', "le", gen_fp_libfunc },
  { '2', "unord", gen_fp_libfunc },
  { '2', "powi", gen_fp_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
};

enum rtx_code const optab_to_code_[NUM_OPTABS] = {
  UNKNOWN,
  SIGN_EXTEND,
  TRUNCATE,
  ZERO_EXTEND,
  FIX,
  UNSIGNED_FIX,
  FLOAT,
  UNSIGNED_FLOAT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FRACT_CONVERT,
  UNSIGNED_FRACT_CONVERT,
  SAT_FRACT,
  UNSIGNED_SAT_FRACT,
  US_TRUNCATE,
  SS_TRUNCATE,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  PLUS,
  PLUS,
  SS_PLUS,
  US_PLUS,
  MINUS,
  MINUS,
  SS_MINUS,
  US_MINUS,
  MULT,
  MULT,
  SS_MULT,
  US_MULT,
  DIV,
  DIV,
  SS_DIV,
  UDIV,
  US_DIV,
  UNKNOWN,
  UNKNOWN,
  MOD,
  UMOD,
  UNKNOWN,
  AND,
  IOR,
  XOR,
  ASHIFT,
  SS_ASHIFT,
  US_ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  SMIN,
  SMAX,
  UMIN,
  UMAX,
  NEG,
  NEG,
  SS_NEG,
  US_NEG,
  ABS,
  ABS,
  NOT,
  BSWAP,
  FFS,
  CLZ,
  CTZ,
  CLRSB,
  POPCOUNT,
  PARITY,
  UNKNOWN,
  UNKNOWN,
  EQ,
  NE,
  GT,
  GE,
  LT,
  LE,
  UNORDERED,
  UNKNOWN,
  SQRT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  SET,
  STRICT_LOW_PART,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  COMPARE,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FMA,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  VEC_DUPLICATE,
  VEC_SERIES,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
};

const optab code_to_optab_[NUM_RTX_CODE] = {
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  mov_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  movstrict_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  cbranch_optab,
  add_optab,
  sub_optab,
  neg_optab,
  smul_optab,
  ssmul_optab,
  usmul_optab,
  unknown_optab,
  unknown_optab,
  sdiv_optab,
  ssdiv_optab,
  usdiv_optab,
  smod_optab,
  udiv_optab,
  umod_optab,
  and_optab,
  ior_optab,
  xor_optab,
  one_cmpl_optab,
  ashl_optab,
  rotl_optab,
  ashr_optab,
  lshr_optab,
  rotr_optab,
  smin_optab,
  smax_optab,
  umin_optab,
  umax_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  ne_optab,
  eq_optab,
  ge_optab,
  gt_optab,
  le_optab,
  lt_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unord_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  abs_optab,
  sqrt_optab,
  bswap_optab,
  ffs_optab,
  clrsb_optab,
  clz_optab,
  ctz_optab,
  popcount_optab,
  parity_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  vec_duplicate_optab,
  vec_series_optab,
  ssadd_optab,
  usadd_optab,
  sssub_optab,
  ssneg_optab,
  usneg_optab,
  unknown_optab,
  ssashl_optab,
  usashl_optab,
  ussub_optab,
  unknown_optab,
  unknown_optab,
  fma_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
};

