/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != IF_THEN_ELSE)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NE)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  x7 = XEXP (x3, 2);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_CODE (x8) != PC)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != SET)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != PLUS)
    return -1;
  x11 = XEXP (x10, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != UNSPEC
      || XVECLEN (x12, 0) != 1
      || XINT (x12, 1) != 10)
    return -1;
  x13 = XVECEXP (x12, 0, 0);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x14 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x15) != CLOBBER)
    return -1;
  x16 = XEXP (x15, 0);
  if (GET_CODE (x16) != REG
      || REGNO (x16) != 34
      || GET_MODE (x16) != E_BImode)
    return -1;
  return 0;
}

int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != VEC_SELECT
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  x6 = XEXP (x2, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_V2HImode))
    return -1;
  x7 = XVECEXP (x3, 0, 0);
  operands[3] = x7;
  if (!const01_operand (operands[3], E_VOIDmode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_V2HImode))
    return -1;
  x9 = XVECEXP (x5, 0, 0);
  operands[4] = x9;
  if (!const01_operand (operands[4], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  operands[5] = x10;
  return 0;
}

int
pattern41 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case USE:
      if (pnum_clobbers == NULL
          || !register_operand (operands[3], E_SImode))
        return -1;
      x2 = XEXP (x1, 0);
      operands[4] = x2;
      return 0;

    case CLOBBER:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != REG
          || REGNO (x2) != 35
          || GET_MODE (x2) != E_SImode)
        return -1;
      return 1;

    case RETURN:
      return 2;

    default:
      return -1;
    }
}

int
pattern49 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != MEM
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  x8 = XVECEXP (x7, 0, 0);
  if (GET_CODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != MEM
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x5, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x11 = XEXP (x4, 1);
  operands[2] = x11;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x12 = XEXP (x9, 0);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  x13 = XEXP (x8, 1);
  if (!rtx_equal_p (x13, operands[2]))
    return -1;
  x14 = XEXP (x6, 0);
  x15 = XEXP (x14, 0);
  if (!rtx_equal_p (x15, operands[1]))
    return -1;
  return 0;
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      if (XINT (x2, 1) != 11
          || GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!nonmemory_operand (operands[1], E_SImode))
        return -1;
      return 20; /* *movsi_insn32 */

    case 3:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XVECEXP (x2, 0, 2);
      if (!const_int_operand (x5, E_VOIDmode))
        return -1;
      switch (XINT (x2, 1))
        {
        case 6:
          x4 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[1] = x4;
              x6 = XVECEXP (x2, 0, 1);
              operands[2] = x6;
              operands[3] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_HImode:
                  if (pattern32 (x2, 
E_HImode) != 0)
                    return -1;
                  return 179; /* flag_mulhi */

                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || GET_MODE (x2) != E_SImode
                      || !register_operand (operands[1], E_HImode)
                      || !register_operand (operands[2], E_HImode))
                    return -1;
                  return 181; /* flag_mulhisi */

                case E_V2HImode:
                  if (pattern32 (x2, 
E_V2HImode) != 0)
                    return -1;
                  return 189; /* flag_mulv2hi */

                default:
                  return -1;
                }

            case VEC_SELECT:
              if (pattern26 (x2) != 0)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_HImode:
                  if (!register_operand (operands[0], E_HImode)
                      || GET_MODE (x2) != E_HImode)
                    return -1;
                  return 180; /* flag_mulhi_parts */

                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || GET_MODE (x2) != E_SImode)
                    return -1;
                  return 182; /* flag_mulhisi_parts */

                default:
                  return -1;
                }

            case VEC_CONCAT:
              if (pattern27 (x2, 
E_V2HImode) != 0)
                return -1;
              return 190; /* flag_mulv2hi_parts */

            default:
              return -1;
            }

        case 7:
          x4 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[1] = x4;
              if (!register_operand (operands[1], E_HImode)
                  || !register_operand (operands[0], E_PDImode)
                  || GET_MODE (x2) != E_PDImode)
                return -1;
              x6 = XVECEXP (x2, 0, 1);
              operands[2] = x6;
              if (!register_operand (operands[2], E_HImode))
                return -1;
              operands[3] = x5;
              return 187; /* flag_macinit1hi */

            case VEC_CONCAT:
              if (pattern27 (x2, 
E_V2PDImode) != 0)
                return -1;
              return 194; /* flag_macinit1v2hi_parts */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 5:
      if (XINT (x2, 1) != 7
          || GET_MODE (x2) != E_PDImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_PDImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      if (!const01_operand (x7, E_VOIDmode))
        return -1;
      x8 = XVECEXP (x2, 0, 4);
      if (!const_int_operand (x8, E_VOIDmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!register_operand (operands[1], E_HImode))
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          if (!register_operand (operands[2], E_HImode))
            return -1;
          x5 = XVECEXP (x2, 0, 2);
          operands[3] = x5;
          if (!register_operand (operands[3], E_VOIDmode))
            return -1;
          operands[4] = x7;
          operands[5] = x8;
          return 184; /* flag_machi_acconly */

        case VEC_SELECT:
          if (pattern26 (x2) != 0
              || !register_operand (operands[5], E_PDImode))
            return -1;
          operands[6] = x7;
          operands[7] = x8;
          return 185; /* flag_machi_parts_acconly */

        default:
          return -1;
        }

    case 6:
      if (XINT (x2, 1) != 7
          || GET_MODE (x2) != E_V2PDImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x4) != VEC_CONCAT
          || GET_MODE (x4) != E_V2HImode)
        return -1;
      x9 = XEXP (x4, 0);
      if (GET_CODE (x9) != VEC_SELECT
          || GET_MODE (x9) != E_HImode)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PARALLEL
          || XVECLEN (x10, 0) != 1)
        return -1;
      x11 = XEXP (x4, 1);
      if (GET_CODE (x11) != VEC_SELECT
          || GET_MODE (x11) != E_HImode)
        return -1;
      x12 = XEXP (x11, 1);
      if (GET_CODE (x12) != PARALLEL
          || XVECLEN (x12, 0) != 1)
        return -1;
      x6 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x6) != VEC_CONCAT
          || GET_MODE (x6) != E_V2HImode)
        return -1;
      x13 = XEXP (x6, 0);
      if (GET_CODE (x13) != VEC_SELECT
          || GET_MODE (x13) != E_HImode)
        return -1;
      x14 = XEXP (x13, 1);
      if (GET_CODE (x14) != PARALLEL
          || XVECLEN (x14, 0) != 1)
        return -1;
      x15 = XEXP (x6, 1);
      if (GET_CODE (x15) != VEC_SELECT
          || GET_MODE (x15) != E_HImode)
        return -1;
      x16 = XEXP (x15, 1);
      if (GET_CODE (x16) != PARALLEL
          || XVECLEN (x16, 0) != 1)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2PDImode))
        return -1;
      x17 = XEXP (x9, 0);
      operands[1] = x17;
      if (!register_operand (operands[1], E_V2HImode))
        return -1;
      x18 = XVECEXP (x10, 0, 0);
      operands[3] = x18;
      if (!const01_operand (operands[3], E_VOIDmode))
        return -1;
      x19 = XVECEXP (x12, 0, 0);
      operands[4] = x19;
      if (!const01_operand (operands[4], E_VOIDmode))
        return -1;
      x20 = XEXP (x13, 0);
      operands[2] = x20;
      if (!register_operand (operands[2], E_V2HImode))
        return -1;
      x21 = XVECEXP (x14, 0, 0);
      operands[5] = x21;
      if (!const01_operand (operands[5], E_VOIDmode))
        return -1;
      x22 = XVECEXP (x16, 0, 0);
      operands[6] = x22;
      if (!const01_operand (operands[6], E_VOIDmode))
        return -1;
      x5 = XVECEXP (x2, 0, 2);
      operands[7] = x5;
      if (!register_operand (operands[7], E_V2PDImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[8] = x7;
      if (!const01_operand (operands[8], E_VOIDmode))
        return -1;
      x8 = XVECEXP (x2, 0, 4);
      operands[9] = x8;
      if (!const01_operand (operands[9], E_VOIDmode))
        return -1;
      x23 = XVECEXP (x2, 0, 5);
      operands[10] = x23;
      if (!const_int_operand (operands[10], E_VOIDmode))
        return -1;
      x24 = XEXP (x11, 0);
      if (!rtx_equal_p (x24, operands[1]))
        return -1;
      x25 = XEXP (x15, 0);
      if (!rtx_equal_p (x25, operands[2]))
        return -1;
      return 192; /* flag_macv2hi_parts_acconly */

    case 2:
      if (pnum_clobbers == NULL
          || XINT (x2, 1) != 13
          || GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_SImode)
        return -1;
      x26 = XEXP (x3, 0);
      operands[0] = x26;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XVECEXP (x2, 0, 1);
      operands[2] = x6;
      if (!register_no_elim_operand (operands[2], E_SImode))
        return -1;
      switch (GET_CODE (x4))
        {
        case PLUS:
          if (pattern39 (x4) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 244; /* sync_addsi_internal */

        case MINUS:
          if (pattern39 (x4) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 245; /* sync_subsi_internal */

        case IOR:
          if (pattern39 (x4) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 246; /* sync_iorsi_internal */

        case AND:
          if (pattern39 (x4) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 247; /* sync_andsi_internal */

        case XOR:
          if (pattern39 (x4) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 248; /* sync_xorsi_internal */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
