/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!reg_or_ucst5_operand (operands[2], E_SImode))
    return -1;
  return pattern4 (x3); /* [-1, 1] */
}

int
pattern11 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 9);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i5)
    return -1;
  x4 = XVECEXP (x1, 0, 10);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i4)
    return -1;
  x6 = XVECEXP (x1, 0, 11);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i3)
    return -1;
  x8 = XVECEXP (x1, 0, 12);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != i2)
    return -1;
  x10 = XVECEXP (x1, 0, 13);
  x11 = XEXP (x10, 0);
  if (REGNO (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 0);
  x13 = XEXP (x12, 1);
  x14 = XEXP (x13, 0);
  operands[1] = x14;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x15 = XEXP (x13, 1);
  operands[2] = x15;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x16 = XVECEXP (x1, 0, 1);
  x17 = XEXP (x16, 1);
  x18 = XEXP (x17, 0);
  if (!rtx_equal_p (x18, operands[1]))
    return -1;
  x19 = XEXP (x17, 1);
  if (!rtx_equal_p (x19, operands[2]))
    return -1;
  return 0;
}

int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 4
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_MODE (x4) != E_SImode
      || !register_operand (operands[1], E_HImode))
    return -1;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern43 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  if (!reg_or_ucst5_operand (operands[2], E_SImode))
    return -1;
  return pattern42 (x6); /* [-1, 1] */
}

int
pattern49 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern55 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
      || pattern54 (x1, 
E_HImode, 
E_SImode) != 0)
    return -1;
  return 0;
}

int
pattern60 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[1], E_HImode))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!reg_or_scst5_operand (operands[2], E_HImode))
    return -1;
  return 0;
}

int
pattern68 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

int
pattern74 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !reg_or_scst5_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern77 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_MODE (x4) != E_SImode
      || !register_operand (operands[1], E_HImode))
    return -1;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern88 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[1], E_HImode))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!reg_or_scst5_operand (operands[2], E_HImode))
    return -1;
  return 0;
}

int
pattern96 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 47
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + -16])
    return -1;
  return 0;
}

int
pattern103 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 6);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i5)
    return -1;
  x4 = XVECEXP (x1, 0, 7);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i4)
    return -1;
  x6 = XVECEXP (x1, 0, 8);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i3)
    return -1;
  x8 = XVECEXP (x1, 0, 9);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != i2)
    return -1;
  x10 = XVECEXP (x1, 0, 10);
  x11 = XEXP (x10, 0);
  if (REGNO (x11) != i1)
    return -1;
  return 0;
}

int
pattern112 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 5);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 6)
    return -1;
  x6 = XVECEXP (x1, 0, 7);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != 32)
    return -1;
  x8 = XVECEXP (x1, 0, 8);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != 33)
    return -1;
  x10 = XVECEXP (x1, 0, 9);
  x11 = XEXP (x10, 0);
  if (REGNO (x11) != 34)
    return -1;
  x12 = XVECEXP (x1, 0, 10);
  x13 = XEXP (x12, 0);
  if (REGNO (x13) != 35)
    return -1;
  x14 = XVECEXP (x1, 0, 11);
  x15 = XEXP (x14, 0);
  if (REGNO (x15) != 36)
    return -1;
  x16 = XVECEXP (x1, 0, 2);
  x17 = XEXP (x16, 0);
  operands[0] = x17;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != MULT
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_CODE (x7) != LABEL_REF)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_CODE (x8) != PC)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x5, 0);
  operands[0] = x10;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x11 = XEXP (x7, 0);
  operands[1] = x11;
  x12 = XEXP (x9, 0);
  operands[2] = x12;
  if (!scratch_operand (operands[2], E_SImode)
      || !
#line 1333 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(flag_pic && TARGET_INSNS_64))
    return -1;
  return 73; /* casesi_internal */
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case CONST_INT:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[1] = x7;
      if (!const_int_or_symbolic_operand (operands[1], E_SImode)
          || !
#line 406 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(reload_completed))
        return -1;
      return 344; /* *p movsi_high */

    case UNSPEC:
      if (XVECLEN (x7, 0) != 1
          || XINT (x7, 1) != 8
          || GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      operands[1] = x8;
      if (!symbolic_operand (operands[1], E_SImode)
          || !
#line 423 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(flag_pic == 2))
        return -1;
      return 346; /* *p movsi_gotoff_high */

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !addsi_operand (operands[2], E_SImode))
            return -1;
          return 415; /* *p addsi3 */

        case E_SFmode:
          if (pattern37 (x4, 
E_SFmode) != 0
              || !
#line 1782 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
            return -1;
          return 420; /* *p addsf3 */

        case E_DFmode:
          if (pattern37 (x4, 
E_DFmode) != 0
              || !
#line 1794 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
            return -1;
          return 421; /* *p adddf3 */

        case E_V2HImode:
          if (pattern37 (x4, 
E_V2HImode) != 0)
            return -1;
          return 483; /* *p addv2hi3 */

        case E_V4QImode:
          if (pattern37 (x4, 
E_V4QImode) != 0
              || !
#line 2996 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 485; /* *p addv4qi3 */

        default:
          return -1;
        }

    case MULT:
      if (GET_MODE (x5) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      x9 = XEXP (x5, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          operands[2] = x9;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x6 = XEXP (x1, 0);
          operands[4] = x6;
          x7 = XEXP (x6, 0);
          operands[5] = x7;
          x10 = XEXP (x5, 1);
          operands[3] = x10;
          if (!adda_scale_operand (operands[3], E_SImode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[1] = x8;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 417; /* *p *addshiftsi */

        case SIGN_EXTEND:
          if (GET_MODE (x9) != E_SImode)
            return -1;
          x11 = XEXP (x9, 0);
          if (GET_CODE (x11) != VEC_SELECT
              || GET_MODE (x11) != E_HImode)
            return -1;
          x12 = XEXP (x11, 1);
          if (GET_CODE (x12) != PARALLEL
              || XVECLEN (x12, 0) != 1)
            return -1;
          x13 = XVECEXP (x12, 0, 0);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x10 = XEXP (x5, 1);
          if (GET_CODE (x10) != SIGN_EXTEND
              || GET_MODE (x10) != E_SImode)
            return -1;
          x14 = XEXP (x10, 0);
          if (GET_CODE (x14) != VEC_SELECT
              || GET_MODE (x14) != E_HImode)
            return -1;
          x15 = XEXP (x14, 1);
          if (GET_CODE (x15) != PARALLEL
              || XVECLEN (x15, 0) != 1)
            return -1;
          x16 = XVECEXP (x15, 0, 0);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x8 = XEXP (x4, 1);
          if (pattern95 (x8, 
E_SImode, 
SIGN_EXTEND, 
MULT) != 0)
            return -1;
          x17 = XEXP (x8, 0);
          x18 = XEXP (x17, 0);
          if (GET_CODE (x18) != VEC_SELECT
              || GET_MODE (x18) != E_HImode)
            return -1;
          x19 = XEXP (x18, 1);
          if (GET_CODE (x19) != PARALLEL
              || XVECLEN (x19, 0) != 1)
            return -1;
          x20 = XVECEXP (x19, 0, 0);
          if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x21 = XEXP (x8, 1);
          if (GET_CODE (x21) != SIGN_EXTEND
              || GET_MODE (x21) != E_SImode)
            return -1;
          x22 = XEXP (x21, 0);
          if (GET_CODE (x22) != VEC_SELECT
              || GET_MODE (x22) != E_HImode)
            return -1;
          x23 = XEXP (x22, 1);
          if (GET_CODE (x23) != PARALLEL
              || XVECLEN (x23, 0) != 1)
            return -1;
          x24 = XVECEXP (x23, 0, 0);
          if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x6 = XEXP (x1, 0);
          operands[3] = x6;
          x7 = XEXP (x6, 0);
          operands[4] = x7;
          x25 = XEXP (x11, 0);
          operands[1] = x25;
          if (!register_operand (operands[1], E_V2HImode))
            return -1;
          x26 = XEXP (x14, 0);
          operands[2] = x26;
          if (!register_operand (operands[2], E_V2HImode))
            return -1;
          x27 = XEXP (x18, 0);
          if (!rtx_equal_p (x27, operands[1]))
            return -1;
          x28 = XEXP (x22, 0);
          if (!rtx_equal_p (x28, operands[2])
              || !
#line 352 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
            return -1;
          return 529; /* *p dotv2hi */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != ZERO_EXTEND
          || GET_MODE (x8) != E_DImode
          || pattern71 (x1, 
E_DImode) != 0)
        return -1;
      return 419; /* *p addsidi3_widen */

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 2:
      x3 = XVECEXP (x2, 0, 0);
      switch (GET_CODE (x3))
        {
        case SET:
          x4 = XEXP (x3, 1);
          if (GET_CODE (x4) != UNSPEC
              || XVECLEN (x4, 0) != 1)
            return -1;
          x5 = XEXP (x1, 0);
          operands[3] = x5;
          x6 = XEXP (x5, 0);
          operands[4] = x6;
          x7 = XEXP (x3, 0);
          operands[0] = x7;
          switch (XINT (x4, 1))
            {
            case 2:
              x8 = XVECEXP (x2, 0, 1);
              if (GET_CODE (x8) != CLOBBER)
                return -1;
              x9 = XVECEXP (x4, 0, 0);
              operands[1] = x9;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!scratch_operand (operands[2], E_SImode))
                return -1;
              switch (pattern91 (x4))
                {
                case 0:
                  if (!
#line 790 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
                    return -1;
                  return 373; /* *p movmisalignsi_store */

                case 1:
                  if (!
#line 790 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
                    return -1;
                  return 374; /* *p movmisaligndi_store */

                case 2:
                  if (!
#line 790 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
                    return -1;
                  return 375; /* *p movmisalignv2hi_store */

                case 3:
                  if (!
#line 790 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
                    return -1;
                  return 376; /* *p movmisalignv4qi_store */

                default:
                  return -1;
                }

            case 3:
              if (GET_MODE (x4) != E_SImode)
                return -1;
              x8 = XVECEXP (x2, 0, 1);
              if (GET_CODE (x8) != UNSPEC
                  || XVECLEN (x8, 0) != 1
                  || XINT (x8, 1) != 0
                  || !register_operand (operands[0], E_SImode))
                return -1;
              x9 = XVECEXP (x4, 0, 0);
              operands[1] = x9;
              x11 = XVECEXP (x8, 0, 0);
              operands[2] = x11;
              if (!const_int_operand (operands[2], E_VOIDmode)
                  || !
#line 2091 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
                return -1;
              return 439; /* *p addkpc */

            case 17:
              if (GET_MODE (x4) != E_SImode)
                return -1;
              x8 = XVECEXP (x2, 0, 1);
              if (GET_CODE (x8) != CLOBBER
                  || !memory_operand (operands[0], E_SImode))
                return -1;
              x9 = XVECEXP (x4, 0, 0);
              if (GET_MODE (x9) != E_SImode)
                return -1;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!scratch_operand (operands[2], E_SImode))
                return -1;
              switch (GET_CODE (x9))
                {
                case PLUS:
                  x12 = XEXP (x9, 1);
                  operands[1] = x12;
                  if (!reg_or_scst5_operand (operands[1], E_SImode))
                    return -1;
                  x13 = XEXP (x9, 0);
                  if (!rtx_equal_p (x13, operands[0]))
                    return -1;
                  return 568; /* *p sync_addsi_insn */

                case MINUS:
                  x12 = XEXP (x9, 1);
                  operands[1] = x12;
                  if (!register_operand (operands[1], E_SImode))
                    return -1;
                  x13 = XEXP (x9, 0);
                  if (!rtx_equal_p (x13, operands[0]))
                    return -1;
                  return 569; /* *p sync_subsi_insn */

                case IOR:
                  x12 = XEXP (x9, 1);
                  operands[1] = x12;
                  if (!reg_or_scst5_operand (operands[1], E_SImode))
                    return -1;
                  x13 = XEXP (x9, 0);
                  if (!rtx_equal_p (x13, operands[0]))
                    return -1;
                  return 570; /* *p sync_iorsi_insn */

                case XOR:
                  x12 = XEXP (x9, 1);
                  operands[1] = x12;
                  if (!reg_or_scst5_operand (operands[1], E_SImode))
                    return -1;
                  x13 = XEXP (x9, 0);
                  if (!rtx_equal_p (x13, operands[0]))
                    return -1;
                  return 571; /* *p sync_xorsi_insn */

                case AND:
                  x12 = XEXP (x9, 1);
                  operands[1] = x12;
                  if (!reg_or_scst5_operand (operands[1], E_SImode))
                    return -1;
                  x13 = XEXP (x9, 0);
                  if (!rtx_equal_p (x13, operands[0]))
                    return -1;
                  return 572; /* *p sync_andsi_insn */

                case NOT:
                  x13 = XEXP (x9, 0);
                  if (GET_CODE (x13) != AND
                      || GET_MODE (x13) != E_SImode)
                    return -1;
                  x14 = XEXP (x13, 1);
                  operands[1] = x14;
                  if (!reg_or_scst5_operand (operands[1], E_SImode))
                    return -1;
                  x15 = XEXP (x13, 0);
                  if (!rtx_equal_p (x15, operands[0]))
                    return -1;
                  return 583; /* *p sync_nandsi_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          if (XVECLEN (x3, 0) != 1
              || XINT (x3, 1) != 3)
            return -1;
          x8 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x8) != CLOBBER)
            return -1;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x16 = XVECEXP (x3, 0, 0);
          operands[0] = x16;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x10 = XEXP (x8, 0);
          operands[1] = x10;
          if (!scratch_operand (operands[1], E_SImode))
            return -1;
          return 401; /* *p eh_return */

        case UNSPEC:
          if (XVECLEN (x3, 0) != 1
              || XINT (x3, 1) != 13)
            return -1;
          x16 = XVECEXP (x3, 0, 0);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x8 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x8) != RETURN)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          return 414; /* *p return_shadow */

        case RETURN:
          x8 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x8) != USE)
            return -1;
          x5 = XEXP (x1, 0);
          operands[1] = x5;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          x10 = XEXP (x8, 0);
          operands[0] = x10;
          if (!register_operand (operands[0], E_SImode)
              || !
#line 2081 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(reload_completed))
            return -1;
          return 438; /* *p return_internal */

        default:
          return -1;
        }

    case 3:
      return recog_20 (x1, insn, pnum_clobbers);

    case 13:
      if (pattern46 (x2) != 0
          || pattern69 (x2) != 0)
        return -1;
      x17 = XVECEXP (x2, 0, 11);
      x18 = XEXP (x17, 0);
      if (REGNO (x18) != 62
          || pattern98 (x2, 
63) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      x4 = XEXP (x3, 1);
      if (GET_MODE (x4) != E_SImode)
        return -1;
      switch (GET_CODE (x4))
        {
        case DIV:
          if (pattern102 (x2, 
CLOBBER) != 0)
            return -1;
          x8 = XVECEXP (x2, 0, 1);
          x10 = XEXP (x8, 0);
          if (GET_CODE (x10) != REG
              || REGNO (x10) != 0
              || GET_MODE (x10) != E_SImode)
            return -1;
          x19 = XVECEXP (x2, 0, 2);
          x20 = XEXP (x19, 0);
          if (REGNO (x20) != 1)
            return -1;
          x21 = XVECEXP (x2, 0, 3);
          x22 = XEXP (x21, 0);
          if (REGNO (x22) != 2)
            return -1;
          x23 = XVECEXP (x2, 0, 4);
          x24 = XEXP (x23, 0);
          if (REGNO (x24) != 6)
            return -1;
          x25 = XVECEXP (x2, 0, 5);
          x26 = XEXP (x25, 0);
          if (REGNO (x26) != 32
              || pattern108 (x2, 
37, 
36, 
35, 
34, 
33) != 0)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          return 452; /* *p divsi3_insn */

        case UDIV:
          if (pattern67 (x4) != 0
              || pattern109 (x2, 
2, 
1, 
0) != 0)
            return -1;
          x8 = XVECEXP (x2, 0, 1);
          switch (GET_CODE (x8))
            {
            case USE:
              x5 = XEXP (x1, 0);
              operands[1] = x5;
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              x10 = XEXP (x8, 0);
              operands[0] = x10;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              return 455; /* *p udivsi3_insn_indcall */

            case SET:
              x27 = XEXP (x8, 1);
              if (GET_CODE (x27) != UMOD
                  || GET_MODE (x27) != E_SImode)
                return -1;
              x28 = XEXP (x27, 0);
              if (GET_CODE (x28) != REG
                  || REGNO (x28) != 4
                  || GET_MODE (x28) != E_SImode)
                return -1;
              x29 = XEXP (x27, 1);
              if (GET_CODE (x29) != REG
                  || REGNO (x29) != 36
                  || GET_MODE (x29) != E_SImode)
                return -1;
              x10 = XEXP (x8, 0);
              if (GET_CODE (x10) != REG
                  || REGNO (x10) != 5
                  || GET_MODE (x10) != E_SImode)
                return -1;
              x5 = XEXP (x1, 0);
              operands[0] = x5;
              x6 = XEXP (x5, 0);
              operands[1] = x6;
              return 462; /* *p udivmodsi4_insn */

            default:
              return -1;
            }

        case MOD:
          x30 = XEXP (x4, 0);
          if (GET_CODE (x30) != REG
              || REGNO (x30) != 4
              || GET_MODE (x30) != E_SImode)
            return -1;
          x31 = XEXP (x4, 1);
          if (GET_CODE (x31) != REG
              || REGNO (x31) != 36
              || GET_MODE (x31) != E_SImode)
            return -1;
          x8 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x8) != USE
              || pattern109 (x2, 
5, 
2, 
1) != 0)
            return -1;
          x5 = XEXP (x1, 0);
          operands[1] = x5;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          x10 = XEXP (x8, 0);
          operands[0] = x10;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          return 457; /* *p modsi3_insn_indcall */

        default:
          return -1;
        }

    case 14:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x3) != SET)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 4
          || GET_MODE (x7) != E_SImode
          || pattern69 (x2) != 0
          || pattern98 (x2, 
62) != 0)
        return -1;
      x32 = XVECEXP (x2, 0, 13);
      if (GET_CODE (x32) != CLOBBER)
        return -1;
      x33 = XEXP (x32, 0);
      if (GET_CODE (x33) != REG
          || REGNO (x33) != 63
          || GET_MODE (x33) != E_SImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[1] = x5;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x4 = XEXP (x3, 1);
      if (GET_MODE (x4) != E_SImode)
        return -1;
      switch (GET_CODE (x4))
        {
        case DIV:
          if (pattern67 (x4) != 0)
            return -1;
          x21 = XVECEXP (x2, 0, 3);
          x22 = XEXP (x21, 0);
          if (REGNO (x22) != 1)
            return -1;
          x23 = XVECEXP (x2, 0, 4);
          x24 = XEXP (x23, 0);
          if (REGNO (x24) != 2)
            return -1;
          x8 = XVECEXP (x2, 0, 1);
          switch (GET_CODE (x8))
            {
            case USE:
              x19 = XVECEXP (x2, 0, 2);
              if (GET_CODE (x19) != CLOBBER)
                return -1;
              x20 = XEXP (x19, 0);
              if (GET_CODE (x20) != REG
                  || REGNO (x20) != 0
                  || GET_MODE (x20) != E_SImode)
                return -1;
              x25 = XVECEXP (x2, 0, 5);
              x26 = XEXP (x25, 0);
              if (REGNO (x26) != 6
                  || pattern108 (x2, 
36, 
35, 
34, 
33, 
32) != 0)
                return -1;
              x17 = XVECEXP (x2, 0, 11);
              x18 = XEXP (x17, 0);
              if (REGNO (x18) != 37)
                return -1;
              x10 = XEXP (x8, 0);
              operands[0] = x10;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              return 453; /* *p divsi3_insn_indcall */

            case SET:
              if (pattern111 (x2, 
MOD) != 0
                  || pattern114 (x2, 
5) != 0)
                return -1;
              return 459; /* *p divmodsi4_insn_indcall */

            default:
              return -1;
            }

        case UDIV:
          if (pattern102 (x2, 
SET) != 0
              || pattern111 (x2, 
UMOD) != 0)
            return -1;
          x21 = XVECEXP (x2, 0, 3);
          x22 = XEXP (x21, 0);
          if (REGNO (x22) != 0)
            return -1;
          x23 = XVECEXP (x2, 0, 4);
          x24 = XEXP (x23, 0);
          if (REGNO (x24) != 1
              || pattern114 (x2, 
2) != 0)
            return -1;
          return 463; /* *p udivmodsi4_insn_indcall */

        default:
          return -1;
        }

    case 12:
      return recog_21 (x1, insn, pnum_clobbers);

    case 11:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x3) != SET)
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != UMOD
          || GET_MODE (x4) != E_SImode
          || pattern67 (x4) != 0)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 4
          || GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x8) != CLOBBER)
        return -1;
      x10 = XEXP (x8, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 1
          || GET_MODE (x10) != E_SImode)
        return -1;
      x19 = XVECEXP (x2, 0, 2);
      if (GET_CODE (x19) != CLOBBER)
        return -1;
      x20 = XEXP (x19, 0);
      if (GET_CODE (x20) != REG
          || REGNO (x20) != 5
          || GET_MODE (x20) != E_SImode)
        return -1;
      x21 = XVECEXP (x2, 0, 3);
      if (GET_CODE (x21) != CLOBBER)
        return -1;
      x22 = XEXP (x21, 0);
      if (GET_CODE (x22) != REG
          || REGNO (x22) != 7
          || GET_MODE (x22) != E_SImode)
        return -1;
      x23 = XVECEXP (x2, 0, 4);
      if (GET_CODE (x23) != CLOBBER)
        return -1;
      x24 = XEXP (x23, 0);
      if (GET_CODE (x24) != REG
          || REGNO (x24) != 32
          || pattern93 (x2, 
33) != 0)
        return -1;
      x25 = XVECEXP (x2, 0, 5);
      x26 = XEXP (x25, 0);
      if (GET_MODE (x26) != E_SImode)
        return -1;
      x34 = XVECEXP (x2, 0, 6);
      if (GET_CODE (x34) != CLOBBER)
        return -1;
      x35 = XEXP (x34, 0);
      if (GET_CODE (x35) != REG
          || REGNO (x35) != 34
          || GET_MODE (x35) != E_SImode)
        return -1;
      x36 = XVECEXP (x2, 0, 7);
      if (GET_CODE (x36) != CLOBBER)
        return -1;
      x37 = XEXP (x36, 0);
      if (GET_CODE (x37) != REG
          || REGNO (x37) != 35
          || GET_MODE (x37) != E_SImode)
        return -1;
      x38 = XVECEXP (x2, 0, 8);
      if (GET_CODE (x38) != CLOBBER)
        return -1;
      x39 = XEXP (x38, 0);
      if (GET_CODE (x39) != REG
          || REGNO (x39) != 36
          || GET_MODE (x39) != E_SImode)
        return -1;
      x40 = XVECEXP (x2, 0, 9);
      if (GET_CODE (x40) != CLOBBER)
        return -1;
      x41 = XEXP (x40, 0);
      if (GET_CODE (x41) != REG
          || REGNO (x41) != 62
          || GET_MODE (x41) != E_SImode)
        return -1;
      x42 = XVECEXP (x2, 0, 10);
      if (GET_CODE (x42) != CLOBBER)
        return -1;
      x43 = XEXP (x42, 0);
      if (GET_CODE (x43) != REG
          || REGNO (x43) != 63
          || GET_MODE (x43) != E_SImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      return 460; /* *p umodsi3_insn */

    case 16:
      switch (pattern48 (x1))
        {
        case 0:
          return 464; /* *p divmodsi4 */

        case 1:
          return 465; /* *p udivmodsi4 */

        default:
          return -1;
        }

    case 10:
      return recog_19 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}
