/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern7 (x3, 
E_HImode); /* [-1, 0] */

    case E_V2HImode:
      if (pattern7 (x3, 
E_V2HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 0
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 1
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 2
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 4
      || GET_MODE (x11) != E_SImode)
    return -1;
  x12 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 5
      || GET_MODE (x13) != E_SImode)
    return -1;
  x14 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 6
      || GET_MODE (x15) != E_SImode)
    return -1;
  x16 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x16) != CLOBBER)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || GET_MODE (x17) != E_SImode)
    return -1;
  x18 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x18) != CLOBBER)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != REG
      || GET_MODE (x19) != E_SImode)
    return -1;
  x20 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x20) != CLOBBER)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || GET_MODE (x21) != E_SImode)
    return -1;
  x22 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x22) != CLOBBER)
    return -1;
  x23 = XEXP (x22, 0);
  if (GET_CODE (x23) != REG
      || GET_MODE (x23) != E_SImode)
    return -1;
  x24 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x24) != CLOBBER)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_CODE (x25) != REG
      || GET_MODE (x25) != E_SImode)
    return -1;
  x26 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x26) != CLOBBER)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != REG
      || GET_MODE (x27) != E_SImode)
    return -1;
  x28 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x28) != CLOBBER)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_CODE (x29) != REG
      || REGNO (x29) != 62
      || GET_MODE (x29) != E_SImode)
    return -1;
  x30 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x30) != CLOBBER)
    return -1;
  x31 = XEXP (x30, 0);
  if (GET_CODE (x31) != REG
      || REGNO (x31) != 63
      || GET_MODE (x31) != E_SImode)
    return -1;
  x32 = XEXP (x2, 0);
  operands[0] = x32;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x33 = XEXP (x2, 1);
  if (GET_MODE (x33) != E_SImode)
    return -1;
  x34 = XEXP (x3, 0);
  operands[3] = x34;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x35 = XEXP (x3, 1);
  if (GET_MODE (x35) != E_SImode)
    return -1;
  switch (GET_CODE (x33))
    {
    case DIV:
      if (GET_CODE (x35) != MOD
          || REGNO (x17) != 32
          || pattern11 (x1, 
37, 
36, 
35, 
34, 
33) != 0)
        return -1;
      return 0;

    case UDIV:
      if (GET_CODE (x35) != UMOD
          || REGNO (x17) != 7
          || pattern11 (x1, 
36, 
35, 
34, 
33, 
32) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern67 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 4
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern71 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x5, 1);
  x9 = XEXP (x8, 0);
  operands[2] = x9;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern79 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern85 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern92 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 47
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + -8])
    return -1;
  return 0;
}

int
pattern98 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 11);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i1
      || GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

int
pattern105 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i3
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  x6 = XEXP (x5, 0);
  if (REGNO (x6) != i2)
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  x8 = XEXP (x7, 0);
  if (REGNO (x8) != i1)
    return -1;
  x9 = XVECEXP (x2, 0, 4);
  x10 = XEXP (x9, 0);
  if (REGNO (x10) != 6)
    return -1;
  x11 = XEXP (x1, 0);
  operands[0] = x11;
  x12 = XEXP (x11, 0);
  operands[1] = x12;
  return 0;
}

int
pattern115 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 47
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + -48])
    return -1;
  return 0;
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case MEM:
      res = recog_1 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      res = recog_2 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || !general_operand (operands[1], E_QImode)
          || !
#line 607 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) == REG))
        return -1;
      return 10; /* movqi_insn */

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || !general_operand (operands[1], E_HImode)
          || !
#line 607 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) == REG))
        return -1;
      return 11; /* movhi_insn */

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !general_operand (operands[1], E_SImode)
          || !
#line 636 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
((GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) == REG
    || (GET_CODE (operands[1]) == SUBREG && REG_P (SUBREG_REG (operands[1]))))))
        return -1;
      return 12; /* movsi_insn */

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || !general_operand (operands[1], E_SFmode)
          || !
#line 636 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
((GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) == REG
    || (GET_CODE (operands[1]) == SUBREG && REG_P (SUBREG_REG (operands[1]))))))
        return -1;
      return 13; /* movsf_insn */

    case E_V2HImode:
      if (!nonimmediate_operand (operands[0], E_V2HImode)
          || !general_operand (operands[1], E_V2HImode)
          || !
#line 636 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
((GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) == REG
    || (GET_CODE (operands[1]) == SUBREG && REG_P (SUBREG_REG (operands[1]))))))
        return -1;
      return 14; /* movv2hi_insn */

    case E_V4QImode:
      if (!nonimmediate_operand (operands[0], E_V4QImode)
          || !general_operand (operands[1], E_V4QImode)
          || !
#line 636 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
((GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) == REG
    || (GET_CODE (operands[1]) == SUBREG && REG_P (SUBREG_REG (operands[1]))))))
        return -1;
      return 15; /* movv4qi_insn */

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !general_operand (operands[1], E_DImode)
          || !
#line 670 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
((!MEM_P (operands[0]) || REG_P (operands[1])
    || (GET_CODE (operands[1]) == SUBREG && REG_P (SUBREG_REG (operands[1]))))))
        return -1;
      return 16; /* *movdi_insn */

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || !general_operand (operands[1], E_DFmode)
          || !
#line 670 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
((!MEM_P (operands[0]) || REG_P (operands[1])
    || (GET_CODE (operands[1]) == SUBREG && REG_P (SUBREG_REG (operands[1]))))))
        return -1;
      return 17; /* *movdf_insn */

    case E_V2SImode:
      if (!nonimmediate_operand (operands[0], E_V2SImode)
          || !general_operand (operands[1], E_V2SImode)
          || !
#line 670 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
((!MEM_P (operands[0]) || REG_P (operands[1])
    || (GET_CODE (operands[1]) == SUBREG && REG_P (SUBREG_REG (operands[1]))))))
        return -1;
      return 18; /* *movv2si_insn */

    case E_V4HImode:
      if (!nonimmediate_operand (operands[0], E_V4HImode)
          || !general_operand (operands[1], E_V4HImode)
          || !
#line 670 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
((!MEM_P (operands[0]) || REG_P (operands[1])
    || (GET_CODE (operands[1]) == SUBREG && REG_P (SUBREG_REG (operands[1]))))))
        return -1;
      return 19; /* *movv4hi_insn */

    case E_V8QImode:
      if (!nonimmediate_operand (operands[0], E_V8QImode)
          || !general_operand (operands[1], E_V8QImode)
          || !
#line 670 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
((!MEM_P (operands[0]) || REG_P (operands[1])
    || (GET_CODE (operands[1]) == SUBREG && REG_P (SUBREG_REG (operands[1]))))))
        return -1;
      return 20; /* *movv8qi_insn */

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case HIGH:
      res = recog_13 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case REG:
    case SUBREG:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case PC:
          x5 = XEXP (x1, 0);
          operands[1] = x5;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          operands[0] = x3;
          if (register_operand (operands[0], E_SImode))
            return 399; /* *p indirect_jump */
          break;

        case STRICT_LOW_PART:
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x4, 0);
          operands[0] = x7;
          if (register_operand (operands[0], E_HImode))
            {
              operands[1] = x3;
              if (register_operand (operands[1], E_HImode)
                  && 
#line 3130 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
                return 502; /* *p movstricthi */
            }
          break;

        default:
          break;
        }
      break;

    case LABEL_REF:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) == PC)
        {
          x5 = XEXP (x1, 0);
          operands[1] = x5;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          x8 = XEXP (x3, 0);
          operands[0] = x8;
          return 400; /* *p jump */
        }
      break;

    default:
      break;
    }
  operands[1] = x3;
  if (nonmemory_operand (operands[1], E_SImode))
    {
      res = recog_14 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x5 = XEXP (x1, 0);
  operands[2] = x5;
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || !general_operand (operands[1], E_QImode)
          || !
#line 607 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) == REG))
        return -1;
      return 349; /* *p movqi_insn */

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || !general_operand (operands[1], E_HImode)
          || !
#line 607 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) == REG))
        return -1;
      return 350; /* *p movhi_insn */

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !general_operand (operands[1], E_SImode)
          || !
#line 636 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
((GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) == REG
    || (GET_CODE (operands[1]) == SUBREG && REG_P (SUBREG_REG (operands[1]))))))
        return -1;
      return 351; /* *p movsi_insn */

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || !general_operand (operands[1], E_SFmode)
          || !
#line 636 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
((GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) == REG
    || (GET_CODE (operands[1]) == SUBREG && REG_P (SUBREG_REG (operands[1]))))))
        return -1;
      return 352; /* *p movsf_insn */

    case E_V2HImode:
      if (!nonimmediate_operand (operands[0], E_V2HImode)
          || !general_operand (operands[1], E_V2HImode)
          || !
#line 636 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
((GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) == REG
    || (GET_CODE (operands[1]) == SUBREG && REG_P (SUBREG_REG (operands[1]))))))
        return -1;
      return 353; /* *p movv2hi_insn */

    case E_V4QImode:
      if (!nonimmediate_operand (operands[0], E_V4QImode)
          || !general_operand (operands[1], E_V4QImode)
          || !
#line 636 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
((GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) == REG
    || (GET_CODE (operands[1]) == SUBREG && REG_P (SUBREG_REG (operands[1]))))))
        return -1;
      return 354; /* *p movv4qi_insn */

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !general_operand (operands[1], E_DImode)
          || !
#line 670 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
((!MEM_P (operands[0]) || REG_P (operands[1])
    || (GET_CODE (operands[1]) == SUBREG && REG_P (SUBREG_REG (operands[1]))))))
        return -1;
      return 355; /* *p *movdi_insn */

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || !general_operand (operands[1], E_DFmode)
          || !
#line 670 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
((!MEM_P (operands[0]) || REG_P (operands[1])
    || (GET_CODE (operands[1]) == SUBREG && REG_P (SUBREG_REG (operands[1]))))))
        return -1;
      return 356; /* *p *movdf_insn */

    case E_V2SImode:
      if (!nonimmediate_operand (operands[0], E_V2SImode)
          || !general_operand (operands[1], E_V2SImode)
          || !
#line 670 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
((!MEM_P (operands[0]) || REG_P (operands[1])
    || (GET_CODE (operands[1]) == SUBREG && REG_P (SUBREG_REG (operands[1]))))))
        return -1;
      return 357; /* *p *movv2si_insn */

    case E_V4HImode:
      if (!nonimmediate_operand (operands[0], E_V4HImode)
          || !general_operand (operands[1], E_V4HImode)
          || !
#line 670 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
((!MEM_P (operands[0]) || REG_P (operands[1])
    || (GET_CODE (operands[1]) == SUBREG && REG_P (SUBREG_REG (operands[1]))))))
        return -1;
      return 358; /* *p *movv4hi_insn */

    case E_V8QImode:
      if (!nonimmediate_operand (operands[0], E_V8QImode)
          || !general_operand (operands[1], E_V8QImode)
          || !
#line 670 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
((!MEM_P (operands[0]) || REG_P (operands[1])
    || (GET_CODE (operands[1]) == SUBREG && REG_P (SUBREG_REG (operands[1]))))))
        return -1;
      return 359; /* *p *movv8qi_insn */

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (!eqne_operator (x2, E_VOIDmode))
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  if (!predicate_register (x4, E_VOIDmode))
    return -1;
  x5 = XEXP (x1, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
      if (XWINT (x5, 0) != 0L)
        return -1;
      operands[0] = x2;
      operands[1] = x4;
      return 341; /* *p nop */

    case UNSPEC:
      switch (XVECLEN (x5, 0))
        {
        case 1:
          if (XINT (x5, 1) != 0)
            return -1;
          operands[1] = x2;
          operands[2] = x4;
          x6 = XVECEXP (x5, 0, 0);
          operands[0] = x6;
          if (!const_int_operand (operands[0], E_VOIDmode))
            return -1;
          return 342; /* *p nop_count */

        case 2:
          x6 = XVECEXP (x5, 0, 0);
          operands[0] = x6;
          switch (XINT (x5, 1))
            {
            case 11:
              operands[2] = x2;
              operands[3] = x4;
              if (!const_int_operand (operands[0], E_VOIDmode))
                return -1;
              x7 = XVECEXP (x5, 0, 1);
              switch (GET_CODE (x7))
                {
                case SUBREG:
                case MEM:
                  operands[1] = x7;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_QImode:
                      if (!memory_operand (operands[1], E_QImode))
                        return -1;
                      return 360; /* *p real_loadqi */

                    case E_HImode:
                      if (!memory_operand (operands[1], E_HImode))
                        return -1;
                      return 361; /* *p real_loadhi */

                    case E_SImode:
                      if (!memory_operand (operands[1], E_SImode))
                        return -1;
                      return 362; /* *p real_loadsi */

                    case E_SFmode:
                      if (!memory_operand (operands[1], E_SFmode))
                        return -1;
                      return 363; /* *p real_loadsf */

                    case E_V2HImode:
                      if (!memory_operand (operands[1], E_V2HImode))
                        return -1;
                      return 364; /* *p real_loadv2hi */

                    case E_V4QImode:
                      if (!memory_operand (operands[1], E_V4QImode))
                        return -1;
                      return 365; /* *p real_loadv4qi */

                    case E_DImode:
                      if (!memory_operand (operands[1], E_DImode)
                          || !
#line 738 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_LDDW))
                        return -1;
                      return 366; /* *p real_loaddi */

                    case E_DFmode:
                      if (!memory_operand (operands[1], E_DFmode)
                          || !
#line 738 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_LDDW))
                        return -1;
                      return 367; /* *p real_loaddf */

                    case E_V2SImode:
                      if (!memory_operand (operands[1], E_V2SImode)
                          || !
#line 738 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_LDDW))
                        return -1;
                      return 368; /* *p real_loadv2si */

                    case E_V4HImode:
                      if (!memory_operand (operands[1], E_V4HImode)
                          || !
#line 738 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_LDDW))
                        return -1;
                      return 369; /* *p real_loadv4hi */

                    case E_V8QImode:
                      if (!memory_operand (operands[1], E_V8QImode)
                          || !
#line 738 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_LDDW))
                        return -1;
                      return 370; /* *p real_loadv8qi */

                    default:
                      return -1;
                    }

                case ZERO_EXTEND:
                  switch (pattern72 (x7))
                    {
                    case 0:
                      return 387; /* *p real_zero_extendqi */

                    case 1:
                      return 389; /* *p real_zero_extendhi */

                    default:
                      return -1;
                    }

                case SIGN_EXTEND:
                  switch (pattern72 (x7))
                    {
                    case 0:
                      return 388; /* *p real_sign_extendqi */

                    case 1:
                      return 390; /* *p real_sign_extendhi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 10:
              x7 = XVECEXP (x5, 0, 1);
              if (GET_CODE (x7) != CONST_INT)
                return -1;
              operands[1] = x2;
              operands[2] = x4;
              switch (XWINT (x7, 0))
                {
                case 0L:
                  if (!c6x_jump_operand (operands[0], E_VOIDmode))
                    return -1;
                  return 403; /* *p real_jump */

                case 2L:
                  if (!register_operand (operands[0], E_VOIDmode))
                    return -1;
                  return 404; /* *p real_ret */

                default:
                  return -1;
                }

            case 12:
              x7 = XVECEXP (x5, 0, 1);
              switch (GET_CODE (x7))
                {
                case ROTATE:
                  if (GET_MODE (x7) != E_SImode)
                    return -1;
                  operands[3] = x2;
                  operands[4] = x4;
                  if (!const_int_operand (operands[0], E_SImode))
                    return -1;
                  x8 = XEXP (x7, 0);
                  operands[1] = x8;
                  if (!register_operand (operands[1], E_SImode))
                    return -1;
                  x9 = XEXP (x7, 1);
                  operands[2] = x9;
                  if (!reg_or_ucst5_operand (operands[2], E_SImode)
                      || !
#line 455 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
                    return -1;
                  return 535; /* *p rotlsi3_real */

                case UNSPEC:
                  if (!const_int_operand (operands[0], E_SImode))
                    return -1;
                  switch (XVECLEN (x7, 0))
                    {
                    case 1:
                      if (XINT (x7, 1) != 7
                          || GET_MODE (x7) != E_SImode)
                        return -1;
                      operands[2] = x2;
                      operands[3] = x4;
                      x10 = XVECEXP (x7, 0, 0);
                      operands[1] = x10;
                      if (!register_operand (operands[1], E_SImode)
                          || !
#line 465 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
                        return -1;
                      return 536; /* *p bitrevsi2_real */

                    case 2:
                      if (XINT (x7, 1) != 22)
                        return -1;
                      operands[3] = x2;
                      operands[4] = x4;
                      x10 = XVECEXP (x7, 0, 0);
                      operands[1] = x10;
                      x11 = XVECEXP (x7, 0, 1);
                      operands[2] = x11;
                      switch (GET_MODE (x7))
                        {
                        case E_V2HImode:
                          if (!register_operand (operands[1], E_V2HImode)
                              || !register_operand (operands[2], E_V2HImode)
                              || !
#line 477 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
                            return -1;
                          return 537; /* *p avgv2hi3_real */

                        case E_V4QImode:
                          if (!register_operand (operands[1], E_V4QImode)
                              || !register_operand (operands[2], E_V4QImode)
                              || !
#line 487 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
                            return -1;
                          return 538; /* *p uavgv4qi3_real */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case MULT:
                  operands[3] = x2;
                  operands[4] = x4;
                  x8 = XEXP (x7, 0);
                  switch (GET_CODE (x8))
                    {
                    case REG:
                    case SUBREG:
                      operands[1] = x8;
                      if (register_operand (operands[1], E_HImode)
                          && const_int_operand (operands[0], E_HImode)
                          && GET_MODE (x7) == E_HImode)
                        {
                          x9 = XEXP (x7, 1);
                          operands[2] = x9;
                          if (reg_or_scst5_operand (operands[2], E_HImode))
                            return 539; /* *p mulhi3_real */
                        }
                      if (!register_operand (operands[1], E_SImode)
                          || !const_int_operand (operands[0], E_SImode)
                          || GET_MODE (x7) != E_SImode)
                        return -1;
                      x9 = XEXP (x7, 1);
                      operands[2] = x9;
                      if (!register_operand (operands[2], E_SImode)
                          || !
#line 691 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_MPY32))
                        return -1;
                      return 554; /* *p mulsi3_insn_real */

                    case SIGN_EXTEND:
                      x12 = XEXP (x8, 0);
                      operands[1] = x12;
                      x9 = XEXP (x7, 1);
                      switch (GET_CODE (x9))
                        {
                        case CONST_INT:
                          if (pattern82 (x7, 
E_HImode) != 0)
                            return -1;
                          return 540; /* *p mulhisi3_const_real */

                        case SIGN_EXTEND:
                          if (GET_MODE (x9) == E_SImode
                              && pattern88 (x7) == 0)
                            return 541; /* *p *mulhisi3_insn_real */
                          if (GET_MODE (x9) == E_DImode
                              && pattern83 (x7, 
E_SImode, 
E_DImode) == 0
                              && 
#line 703 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_MPY32))
                            return 556; /* *p mulsidi3_real */
                          if (GET_MODE (x9) != E_V2SImode
                              || pattern89 (x7, 
E_V2HImode, 
E_V2SImode) != 0
                              || !
#line 728 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
                            return -1;
                          return 558; /* *p mulv2hiv2si3_real */

                        case ASHIFTRT:
                          if (pattern84 (x7) != 0)
                            return -1;
                          return 542; /* *p mulhisi3_lh_real */

                        default:
                          return -1;
                        }

                    case ASHIFTRT:
                      if (pattern73 (x7) != 0)
                        return -1;
                      x9 = XEXP (x7, 1);
                      switch (GET_CODE (x9))
                        {
                        case SIGN_EXTEND:
                          x13 = XEXP (x9, 0);
                          operands[2] = x13;
                          if (!register_operand (operands[2], E_HImode))
                            return -1;
                          return 543; /* *p mulhisi3_hl_real */

                        case ASHIFTRT:
                          x14 = XEXP (x9, 1);
                          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                            return -1;
                          x13 = XEXP (x9, 0);
                          operands[2] = x13;
                          if (!register_operand (operands[2], E_SImode))
                            return -1;
                          return 544; /* *p mulhisi3_hh_real */

                        default:
                          return -1;
                        }

                    case ZERO_EXTEND:
                      x12 = XEXP (x8, 0);
                      operands[1] = x12;
                      x9 = XEXP (x7, 1);
                      switch (GET_CODE (x9))
                        {
                        case ZERO_EXTEND:
                          if (GET_MODE (x9) == E_SImode
                              && pattern89 (x7, 
E_HImode, 
E_SImode) == 0)
                            return 545; /* *p umulhisi3_real */
                          if (GET_MODE (x9) == E_DImode
                              && pattern83 (x7, 
E_SImode, 
E_DImode) == 0
                              && 
#line 703 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_MPY32))
                            return 555; /* *p umulsidi3_real */
                          if (GET_MODE (x9) != E_V4HImode
                              || pattern89 (x7, 
E_V4QImode, 
E_V4HImode) != 0
                              || !
#line 739 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
                            return -1;
                          return 559; /* *p umulv4qiv4hi3_real */

                        case LSHIFTRT:
                          if (pattern84 (x7) != 0)
                            return -1;
                          return 546; /* *p umulhisi3_lh_real */

                        case CONST_INT:
                          if (pattern82 (x7, 
E_SImode) != 0)
                            return -1;
                          return 549; /* *p usmulhisi3_const_real */

                        case SIGN_EXTEND:
                          if (GET_MODE (x9) == E_SImode
                              && pattern88 (x7) == 0)
                            return 550; /* *p *usmulhisi3_insn_real */
                          if (GET_MODE (x9) == E_DImode
                              && pattern83 (x7, 
E_SImode, 
E_DImode) == 0
                              && 
#line 715 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_MPY32))
                            return 557; /* *p usmulsidi3_real */
                          if (GET_MODE (x9) != E_V4HImode
                              || pattern89 (x7, 
E_V4QImode, 
E_V4HImode) != 0
                              || !
#line 750 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
                            return -1;
                          return 560; /* *p usmulv4qiv4hi3_real */

                        case ASHIFTRT:
                          if (pattern84 (x7) != 0)
                            return -1;
                          return 551; /* *p usmulhisi3_lh_real */

                        default:
                          return -1;
                        }

                    case LSHIFTRT:
                      if (pattern73 (x7) != 0)
                        return -1;
                      x9 = XEXP (x7, 1);
                      switch (GET_CODE (x9))
                        {
                        case ZERO_EXTEND:
                          x13 = XEXP (x9, 0);
                          operands[2] = x13;
                          if (!register_operand (operands[2], E_HImode))
                            return -1;
                          return 547; /* *p umulhisi3_hl_real */

                        case LSHIFTRT:
                          x14 = XEXP (x9, 1);
                          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                            return -1;
                          x13 = XEXP (x9, 0);
                          operands[2] = x13;
                          if (!register_operand (operands[2], E_SImode))
                            return -1;
                          return 548; /* *p umulhisi3_hh_real */

                        case SIGN_EXTEND:
                          x13 = XEXP (x9, 0);
                          operands[2] = x13;
                          if (!register_operand (operands[2], E_HImode))
                            return -1;
                          return 552; /* *p usmulhisi3_hl_real */

                        case ASHIFTRT:
                          x14 = XEXP (x9, 1);
                          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                            return -1;
                          x13 = XEXP (x9, 0);
                          operands[2] = x13;
                          if (!register_operand (operands[2], E_SImode))
                            return -1;
                          return 553; /* *p usmulhisi3_hh_real */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case PLUS:
                  if (GET_MODE (x7) != E_SImode)
                    return -1;
                  x8 = XEXP (x7, 0);
                  if (GET_CODE (x8) != MULT
                      || GET_MODE (x8) != E_SImode)
                    return -1;
                  x12 = XEXP (x8, 0);
                  if (GET_CODE (x12) != SIGN_EXTEND
                      || GET_MODE (x12) != E_SImode)
                    return -1;
                  x15 = XEXP (x12, 0);
                  if (GET_CODE (x15) != VEC_SELECT
                      || GET_MODE (x15) != E_HImode)
                    return -1;
                  x16 = XEXP (x15, 1);
                  if (GET_CODE (x16) != PARALLEL
                      || XVECLEN (x16, 0) != 1)
                    return -1;
                  x17 = XVECEXP (x16, 0, 0);
                  if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return -1;
                  x18 = XEXP (x8, 1);
                  if (GET_CODE (x18) != SIGN_EXTEND
                      || GET_MODE (x18) != E_SImode)
                    return -1;
                  x19 = XEXP (x18, 0);
                  if (GET_CODE (x19) != VEC_SELECT
                      || GET_MODE (x19) != E_HImode)
                    return -1;
                  x20 = XEXP (x19, 1);
                  if (GET_CODE (x20) != PARALLEL
                      || XVECLEN (x20, 0) != 1)
                    return -1;
                  x21 = XVECEXP (x20, 0, 0);
                  if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return -1;
                  x9 = XEXP (x7, 1);
                  if (GET_CODE (x9) != MULT
                      || GET_MODE (x9) != E_SImode)
                    return -1;
                  x13 = XEXP (x9, 0);
                  if (GET_CODE (x13) != SIGN_EXTEND
                      || GET_MODE (x13) != E_SImode)
                    return -1;
                  x22 = XEXP (x13, 0);
                  if (GET_CODE (x22) != VEC_SELECT
                      || GET_MODE (x22) != E_HImode)
                    return -1;
                  x23 = XEXP (x22, 1);
                  if (GET_CODE (x23) != PARALLEL
                      || XVECLEN (x23, 0) != 1)
                    return -1;
                  x24 = XVECEXP (x23, 0, 0);
                  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  x14 = XEXP (x9, 1);
                  if (GET_CODE (x14) != SIGN_EXTEND
                      || GET_MODE (x14) != E_SImode)
                    return -1;
                  x25 = XEXP (x14, 0);
                  if (GET_CODE (x25) != VEC_SELECT
                      || GET_MODE (x25) != E_HImode)
                    return -1;
                  x26 = XEXP (x25, 1);
                  if (GET_CODE (x26) != PARALLEL
                      || XVECLEN (x26, 0) != 1)
                    return -1;
                  x27 = XVECEXP (x26, 0, 0);
                  if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  operands[3] = x2;
                  operands[4] = x4;
                  if (!const_int_operand (operands[0], E_SImode))
                    return -1;
                  x28 = XEXP (x15, 0);
                  operands[1] = x28;
                  if (!register_operand (operands[1], E_V2HImode))
                    return -1;
                  x29 = XEXP (x19, 0);
                  operands[2] = x29;
                  if (!register_operand (operands[2], E_V2HImode))
                    return -1;
                  x30 = XEXP (x22, 0);
                  if (!rtx_equal_p (x30, operands[1]))
                    return -1;
                  x31 = XEXP (x25, 0);
                  if (!rtx_equal_p (x31, operands[2])
                      || !
#line 773 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
                    return -1;
                  return 561; /* *p dotv2hi_real */

                case SS_MULT:
                  x8 = XEXP (x7, 0);
                  if (GET_CODE (x8) != FRACT_CONVERT)
                    return -1;
                  x9 = XEXP (x7, 1);
                  if (GET_CODE (x9) != FRACT_CONVERT)
                    return -1;
                  operands[3] = x2;
                  operands[4] = x4;
                  if (!const_int_operand (operands[0], E_SImode))
                    return -1;
                  x12 = XEXP (x8, 0);
                  switch (GET_CODE (x12))
                    {
                    case REG:
                    case SUBREG:
                      operands[1] = x12;
                      x13 = XEXP (x9, 0);
                      switch (GET_CODE (x13))
                        {
                        case REG:
                        case SUBREG:
                          operands[2] = x13;
                          switch (GET_MODE (x7))
                            {
                            case E_V2SQmode:
                              if (pattern94 (x7, 
E_V2HQmode, 
E_V2SQmode) != 0)
                                return -1;
                              return 562; /* *p mulv2hqv2sq3_real */

                            case E_SQmode:
                              if (pattern94 (x7, 
E_HQmode, 
E_SQmode) != 0)
                                return -1;
                              return 563; /* *p mulhqsq3_real */

                            default:
                              return -1;
                            }

                        case TRUNCATE:
                          if (GET_MODE (x13) != E_HQmode
                              || GET_MODE (x7) != E_SQmode
                              || GET_MODE (x8) != E_SQmode
                              || !register_operand (operands[1], E_HQmode)
                              || GET_MODE (x9) != E_SQmode)
                            return -1;
                          x22 = XEXP (x13, 0);
                          operands[2] = x22;
                          if (!register_operand (operands[2], E_SQmode))
                            return -1;
                          return 564; /* *p mulhqsq3_lh_real */

                        default:
                          return -1;
                        }

                    case TRUNCATE:
                      if (GET_MODE (x12) != E_HQmode
                          || GET_MODE (x7) != E_SQmode
                          || GET_MODE (x8) != E_SQmode)
                        return -1;
                      x15 = XEXP (x12, 0);
                      operands[1] = x15;
                      if (!register_operand (operands[1], E_SQmode)
                          || GET_MODE (x9) != E_SQmode)
                        return -1;
                      x13 = XEXP (x9, 0);
                      switch (GET_CODE (x13))
                        {
                        case REG:
                        case SUBREG:
                          operands[2] = x13;
                          if (!register_operand (operands[2], E_HQmode))
                            return -1;
                          return 565; /* *p mulhqsq3_hl_real */

                        case TRUNCATE:
                          if (GET_MODE (x13) != E_HQmode)
                            return -1;
                          x22 = XEXP (x13, 0);
                          operands[2] = x22;
                          if (!register_operand (operands[2], E_SQmode))
                            return -1;
                          return 566; /* *p mulhqsq3_hh_real */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      return recog_22 (x1, insn, pnum_clobbers);

    case PARALLEL:
      return recog_23 (x1, insn, pnum_clobbers);

    case CALL:
      x32 = XEXP (x5, 0);
      if (GET_CODE (x32) != UNSPEC
          || XVECLEN (x32, 0) != 1
          || XINT (x32, 1) != 13)
        return -1;
      x33 = XEXP (x5, 1);
      if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x34 = XVECEXP (x32, 0, 0);
      if (GET_CODE (x34) == PC)
        {
          operands[0] = x2;
          operands[1] = x4;
          if (
#line 1581 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(SIBLING_CALL_P (insn)))
            return 407; /* *p indirect_sibcall_shadow */
          return 408; /* *p indirect_call_shadow */
        }
      operands[1] = x2;
      operands[2] = x4;
      operands[0] = x34;
      if (
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(!SIBLING_CALL_P (insn)))
        return 410; /* *p call_shadow */
      if (!
#line 1610 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(SIBLING_CALL_P (insn)))
        return -1;
      return 411; /* *p sibcall_shadow */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 0)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[0] = x2;
      operands[1] = x4;
      return 472; /* *p blockage */

    default:
      return -1;
    }
}
