/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_DImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  operands[6] = x7;
  if (!register_operand (operands[6], E_DImode))
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  x9 = XEXP (x8, 0);
  operands[7] = x9;
  if (!register_operand (operands[7], E_DImode))
    return -1;
  x10 = XVECEXP (x1, 0, 5);
  x11 = XEXP (x10, 0);
  operands[8] = x11;
  if (!register_operand (operands[8], E_DImode))
    return -1;
  x12 = XVECEXP (x1, 0, 6);
  x13 = XEXP (x12, 0);
  operands[4] = x13;
  if (!arith14_operand (operands[4], E_DImode))
    return -1;
  x14 = XVECEXP (x1, 0, 7);
  x15 = XEXP (x14, 0);
  operands[5] = x15;
  if (!const_int_operand (operands[5], E_DImode))
    return -1;
  return 0;
}

int
pattern23 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case TRAP_IF:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != NE)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != i1)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != SIGN_EXTEND)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != SIGN_EXTEND)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != SIGN_EXTEND)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != i1)
        return -1;
      x9 = XEXP (x2, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XVECEXP (x1, 0, 0);
      x11 = XEXP (x10, 0);
      operands[0] = x11;
      x12 = XEXP (x10, 1);
      x13 = XEXP (x12, 0);
      operands[1] = x13;
      x14 = XEXP (x12, 1);
      operands[2] = x14;
      x15 = XEXP (x5, 0);
      if (!rtx_equal_p (x15, operands[1]))
        return -1;
      x16 = XEXP (x6, 0);
      if (!rtx_equal_p (x16, operands[2]))
        return -1;
      x17 = XEXP (x8, 0);
      if (!rtx_equal_p (x17, operands[1]))
        return -1;
      x18 = XEXP (x8, 1);
      if (!rtx_equal_p (x18, operands[2]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          return 0;

        case E_SImode:
          return 1;

        case E_TImode:
          return 2;

        default:
          return -1;
        }

    case SET:
      x9 = XEXP (x2, 1);
      if (GET_CODE (x9) != MULT)
        return -1;
      x10 = XVECEXP (x1, 0, 0);
      x11 = XEXP (x10, 0);
      operands[3] = x11;
      if (!register_operand (operands[3], E_VOIDmode))
        return -1;
      x12 = XEXP (x10, 1);
      x13 = XEXP (x12, 0);
      operands[4] = x13;
      if (!register_operand (operands[4], E_VOIDmode))
        return -1;
      x14 = XEXP (x12, 1);
      operands[5] = x14;
      if (!register_operand (operands[5], E_VOIDmode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_VOIDmode))
        return -1;
      x19 = XEXP (x9, 0);
      operands[1] = x19;
      if (!register_operand (operands[1], E_VOIDmode))
        return -1;
      x20 = XEXP (x9, 1);
      operands[2] = x20;
      if (!register_operand (operands[2], E_VOIDmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern67 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !ordered_comparison_operator (operands[4], i1)
      || !register_operand (operands[2], i1)
      || !arith11_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern75 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern81 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = PATTERN (peep2_next_insn (1));
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      if (!register_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[3], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern91 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      operands[3] = x3;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
          operands[6] = x4;
          x5 = XEXP (x3, 0);
          operands[1] = x5;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          x7 = XEXP (x4, 0);
          operands[4] = x7;
          x8 = XEXP (x4, 1);
          operands[5] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern76 (x2, 
E_SImode) != 0)
                return -1;
              return 7; /* iorscc */

            case E_DImode:
              if (pattern76 (x2, 
E_DImode) != 0)
                return -1;
              return 8; /* *pa.md:809 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern52 (x2, 
E_DImode) != 0)
                return -1;
              return 196; /* *pa.md:5989 */

            case E_SImode:
              if (pattern52 (x2, 
E_SImode) != 0)
                return -1;
              return 198; /* *pa.md:6015 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern10 (x2, 
E_DImode) != 0)
                return -1;
              return 197; /* *pa.md:5998 */

            case E_SImode:
              if (pattern10 (x2, 
E_SImode) != 0)
                return -1;
              return 199; /* *pa.md:6024 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern21 (x2))
        {
        case 0:
          if (!
#line 6685 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(exact_log2 (INTVAL (operands[1]) + 1) > 0))
            return -1;
          return 245; /* vdepi_ior */

        case 1:
          if (!
#line 6843 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_64BIT && exact_log2 (INTVAL (operands[1]) + 1) > 0))
            return -1;
          return 250; /* *pa.md:6836 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!ordered_comparison_operator (operands[2], E_VOIDmode)
      || pattern33 (x1) != 0)
    return -1;
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  if (!reg_before_reload_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x5, 1);
  operands[1] = x7;
  if (!int5_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x3, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  x10 = XVECEXP (x1, 0, 1);
  x11 = XEXP (x10, 1);
  x12 = XEXP (x11, 0);
  if (!rtx_equal_p (x12, operands[0]))
    return -1;
  x13 = XEXP (x11, 1);
  if (!rtx_equal_p (x13, operands[1]))
    return -1;
  x14 = XEXP (x10, 0);
  if (!rtx_equal_p (x14, operands[0]))
    return -1;
  *pnum_clobbers = 1;
  return 308; /* decrement_and_branch_until_zero */
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case BSWAP:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          if (!scratch_operand (operands[2], E_DImode))
            return -1;
          return 47; /* bswapdi2 */

        case MEM:
          return recog_17 (x1, insn, pnum_clobbers);

        case ZERO_EXTEND:
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != MEM)
            return -1;
          x8 = XEXP (x6, 0);
          if (GET_CODE (x8) != PLUS)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x9 = XEXP (x4, 1);
          if (GET_CODE (x9) != PLUS)
            return -1;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x10 = XEXP (x8, 0);
          operands[1] = x10;
          x11 = XEXP (x8, 1);
          operands[2] = x11;
          x12 = XEXP (x9, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          x13 = XEXP (x9, 1);
          if (!rtx_equal_p (x13, operands[2]))
            return -1;
          x7 = XEXP (x4, 0);
          if (!rtx_equal_p (x7, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || GET_MODE (x8) != E_DImode
                  || !register_operand (operands[1], E_DImode)
                  || !int5_operand (operands[2], E_DImode)
                  || GET_MODE (x9) != E_DImode)
                return -1;
              switch (GET_MODE (x6))
                {
                case E_SImode:
                  return 82; /* *pa.md:2479 */

                case E_HImode:
                  return 104; /* *pa.md:3015 */

                case E_QImode:
                  return 113; /* *pa.md:3173 */

                default:
                  return -1;
                }

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              switch (GET_MODE (x6))
                {
                case E_HImode:
                  switch (pattern90 (x1))
                    {
                    case 0:
                      return 105; /* *pa.md:3028 */

                    case 1:
                      return 106; /* *pa.md:3041 */

                    default:
                      return -1;
                    }

                case E_QImode:
                  switch (pattern90 (x1))
                    {
                    case 0:
                      return 114; /* *pa.md:3184 */

                    case 1:
                      return 115; /* *pa.md:3195 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode
                  || GET_MODE (x6) != E_QImode)
                return -1;
              switch (pattern90 (x1))
                {
                case 0:
                  return 116; /* *pa.md:3206 */

                case 1:
                  return 117; /* *pa.md:3217 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_DOUBLE:
        case REG:
        case SUBREG:
          x5 = XEXP (x2, 0);
          switch (GET_CODE (x5))
            {
            case MEM:
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != SET)
                return -1;
              x9 = XEXP (x4, 1);
              if (GET_CODE (x9) != PLUS)
                return -1;
              x14 = XEXP (x5, 0);
              switch (GET_CODE (x14))
                {
                case PLUS:
                  x15 = XEXP (x14, 0);
                  operands[0] = x15;
                  x16 = XEXP (x14, 1);
                  operands[1] = x16;
                  operands[2] = x3;
                  x12 = XEXP (x9, 0);
                  if (!rtx_equal_p (x12, operands[0]))
                    return -1;
                  x13 = XEXP (x9, 1);
                  if (!rtx_equal_p (x13, operands[1]))
                    return -1;
                  x7 = XEXP (x4, 0);
                  if (!rtx_equal_p (x7, operands[0]))
                    return -1;
                  switch (GET_MODE (x5))
                    {
                    case E_SImode:
                      if (GET_MODE (x14) != E_SImode
                          || !register_operand (operands[0], E_SImode)
                          || !pre_cint_operand (operands[1], E_SImode)
                          || !reg_or_0_operand (operands[2], E_SImode)
                          || GET_MODE (x9) != E_SImode)
                        return -1;
                      return 85; /* *pa.md:2537 */

                    case E_HImode:
                      switch (pattern83 (x1, 
E_HImode))
                        {
                        case 0:
                          return 107; /* *pa.md:3054 */

                        case 1:
                          return 108; /* *pa.md:3065 */

                        default:
                          return -1;
                        }

                    case E_QImode:
                      switch (pattern83 (x1, 
E_QImode))
                        {
                        case 0:
                          return 118; /* *pa.md:3228 */

                        case 1:
                          return 119; /* *pa.md:3239 */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case REG:
                case SUBREG:
                  operands[0] = x14;
                  operands[1] = x3;
                  x13 = XEXP (x9, 1);
                  operands[2] = x13;
                  x12 = XEXP (x9, 0);
                  if (!rtx_equal_p (x12, operands[0]))
                    return -1;
                  x7 = XEXP (x4, 0);
                  if (!rtx_equal_p (x7, operands[0]))
                    return -1;
                  switch (GET_MODE (x5))
                    {
                    case E_SImode:
                      if (pattern79 (x9, 
E_SImode) != 0)
                        return -1;
                      return 87; /* post_stw */

                    case E_DImode:
                      if (pattern79 (x9, 
E_DImode) != 0)
                        return -1;
                      return 88; /* post_std */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case PC:
              x4 = XVECEXP (x1, 0, 1);
              if (pattern16 (x4, 
E_DImode, 
CLOBBER) != 0)
                return -1;
              operands[0] = x3;
              if (!pmode_register_operand (operands[0], E_VOIDmode))
                return -1;
              return 295; /* *pa.md:9145 */

            default:
              return -1;
            }

        case PLUS:
          x6 = XEXP (x3, 0);
          switch (GET_CODE (x6))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case REG:
            case SUBREG:
              switch (pattern23 (x1, 
PLUS))
                {
                case 0:
                  if (!register_operand (operands[0], E_DImode)
                      || GET_MODE (x3) != E_DImode
                      || !reg_or_0_operand (operands[1], E_DImode)
                      || !register_operand (operands[2], E_DImode))
                    return -1;
                  x4 = XVECEXP (x1, 0, 1);
                  x7 = XEXP (x4, 0);
                  if (pattern91 (x7, 
E_DImode, 
E_TImode) != 0)
                    return -1;
                  return 174; /* *pa.md:5198 */

                case 1:
                  if (!register_operand (operands[0], E_SImode)
                      || GET_MODE (x3) != E_SImode
                      || !reg_or_0_operand (operands[1], E_SImode)
                      || !arith11_operand (operands[2], E_SImode))
                    return -1;
                  x4 = XVECEXP (x1, 0, 1);
                  x7 = XEXP (x4, 0);
                  if (pattern91 (x7, 
E_SImode, 
E_DImode) != 0)
                    return -1;
                  return 176; /* addvsi3 */

                case 2:
                  if (!register_operand (operands[0], E_TImode)
                      || GET_MODE (x3) != E_TImode
                      || !register_operand (operands[1], E_TImode)
                      || !arith11_operand (operands[2], E_TImode))
                    return -1;
                  x4 = XVECEXP (x1, 0, 1);
                  x7 = XEXP (x4, 0);
                  if (pattern91 (x7, 
E_TImode, 
E_OImode) != 0)
                    return -1;
                  return 182; /* addvti3 */

                case 3:
                  if (!
#line 9909 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT
   && reload_completed && pa_fmpyaddoperands (operands)))
                    return -1;
                  return 317; /* *pa.md:9902 */

                default:
                  return -1;
                }

            case UNSPEC:
              if (XVECLEN (x6, 0) != 1)
                return -1;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER)
                return -1;
              x7 = XEXP (x4, 0);
              if (GET_CODE (x7) != REG
                  || REGNO (x7) != 1)
                return -1;
              x5 = XEXP (x2, 0);
              operands[0] = x5;
              x17 = XVECEXP (x6, 0, 0);
              operands[1] = x17;
              x18 = XEXP (x3, 1);
              operands[2] = x18;
              switch (XINT (x6, 1))
                {
                case 6:
                  if (!tld_symbolic_operand (operands[1], E_VOIDmode))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern84 (x1, 
E_SImode) != 0
                          || !
#line 125 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(Pmode == SImode))
                        return -1;
                      return 329; /* tld_offset_loadsi */

                    case E_DImode:
                      if (pattern84 (x1, 
E_DImode) != 0
                          || !
#line 125 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(Pmode == DImode))
                        return -1;
                      return 330; /* tld_offset_loaddi */

                    default:
                      return -1;
                    }

                case 9:
                  if (!tle_symbolic_operand (operands[1], E_VOIDmode))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern84 (x1, 
E_SImode) != 0
                          || !
#line 125 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(Pmode == SImode))
                        return -1;
                      return 333; /* tle_loadsi */

                    case E_DImode:
                      if (pattern84 (x1, 
E_DImode) != 0
                          || !
#line 125 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(Pmode == DImode))
                        return -1;
                      return 334; /* tle_loaddi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case MINUS:
          switch (pattern23 (x1, 
MINUS))
            {
            case 0:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !register_operand (operands[1], E_DImode)
                  || !reg_or_0_operand (operands[2], E_DImode))
                return -1;
              x4 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x4, 0);
              if (pattern91 (x7, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 178; /* *pa.md:5391 */

            case 1:
              if (pattern92 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 180; /* subvsi3 */

            case 2:
              if (pattern92 (x1, 
E_TImode, 
E_OImode) != 0)
                return -1;
              return 184; /* subvti3 */

            case 3:
              if (!
#line 9957 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT
   && reload_completed && pa_fmpysuboperands (operands)))
                return -1;
              return 319; /* *pa.md:9950 */

            default:
              return -1;
            }

        case MULT:
          if (pnum_clobbers != NULL
              && pattern27 (x1) == 0)
            {
              *pnum_clobbers = 3;
              return 187; /* *pa.md:5649 */
            }
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_VOIDmode))
            return -1;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_VOIDmode))
            return -1;
          x18 = XEXP (x3, 1);
          operands[2] = x18;
          if (!register_operand (operands[2], E_VOIDmode))
            return -1;
          x7 = XEXP (x4, 0);
          operands[3] = x7;
          if (!register_operand (operands[3], E_VOIDmode))
            return -1;
          x9 = XEXP (x4, 1);
          switch (GET_CODE (x9))
            {
            case PLUS:
              x12 = XEXP (x9, 0);
              operands[4] = x12;
              if (!register_operand (operands[4], E_VOIDmode))
                return -1;
              x13 = XEXP (x9, 1);
              operands[5] = x13;
              if (!register_operand (operands[5], E_VOIDmode)
                  || !
#line 9880 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT
   && reload_completed && pa_fmpyaddoperands (operands)))
                return -1;
              return 316; /* *pa.md:9873 */

            case MINUS:
              x12 = XEXP (x9, 0);
              operands[4] = x12;
              if (!register_operand (operands[4], E_VOIDmode))
                return -1;
              x13 = XEXP (x9, 1);
              operands[5] = x13;
              if (!register_operand (operands[5], E_VOIDmode)
                  || !
#line 9938 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT
   && reload_completed && pa_fmpysuboperands (operands)))
                return -1;
              return 318; /* *pa.md:9931 */

            default:
              return -1;
            }

        case DIV:
          if (pattern24 (x1, pnum_clobbers) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 188; /* *pa.md:5774 */

        case UDIV:
          if (pattern24 (x1, pnum_clobbers) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 189; /* *pa.md:5823 */

        case MOD:
          if (pnum_clobbers == NULL
              || pattern27 (x1) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 190; /* *pa.md:5870 */

        case UMOD:
          if (pnum_clobbers == NULL
              || pattern27 (x1) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 191; /* *pa.md:5917 */

        case NEG:
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = XEXP (x3, 0);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              operands[1] = x6;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != TRAP_IF)
                return -1;
              x7 = XEXP (x4, 0);
              if (GET_CODE (x7) != NE)
                return -1;
              x19 = XEXP (x7, 0);
              if (GET_CODE (x19) != NEG)
                return -1;
              x20 = XEXP (x19, 0);
              if (GET_CODE (x20) != SIGN_EXTEND)
                return -1;
              x21 = XEXP (x7, 1);
              if (GET_CODE (x21) != SIGN_EXTEND)
                return -1;
              x22 = XEXP (x21, 0);
              if (GET_CODE (x22) != NEG)
                return -1;
              x9 = XEXP (x4, 1);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x23 = XEXP (x20, 0);
              if (!rtx_equal_p (x23, operands[1]))
                return -1;
              x24 = XEXP (x22, 0);
              if (!rtx_equal_p (x24, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern89 (x1, 
E_DImode, 
E_TImode) != 0)
                    return -1;
                  return 204; /* *pa.md:6108 */

                case E_TImode:
                  if (pattern89 (x1, 
E_TImode, 
E_OImode) != 0)
                    return -1;
                  return 205; /* negvti2 */

                case E_SImode:
                  if (pattern89 (x1, 
E_SImode, 
E_DImode) != 0)
                    return -1;
                  return 207; /* negvsi2 */

                default:
                  return -1;
                }

            case ABS:
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != SET)
                return -1;
              switch (pattern37 (x1))
                {
                case 0:
                  if (!
#line 6439 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
((! TARGET_SOFT_FLOAT && TARGET_PA_20
    && ! reg_overlap_mentioned_p (operands[2], operands[1]))))
                    return -1;
                  return 230; /* *pa.md:6435 */

                case 1:
                  if (!
#line 6458 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
((! TARGET_SOFT_FLOAT && TARGET_PA_20
    && ! reg_overlap_mentioned_p (operands[2], operands[1]))))
                    return -1;
                  return 231; /* *pa.md:6454 */

                default:
                  return -1;
                }

            case MULT:
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != SET)
                return -1;
              switch (pattern39 (x1))
                {
                case 0:
                  if (!
#line 6499 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
((!TARGET_SOFT_FLOAT && TARGET_PA_20 && !flag_signed_zeros
    && ! (reg_overlap_mentioned_p (operands[3], operands[1])
          || reg_overlap_mentioned_p (operands[3], operands[2])))))
                    return -1;
                  return 234; /* *pa.md:6493 */

                case 1:
                  if (!
#line 6523 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
((!TARGET_SOFT_FLOAT && TARGET_PA_20 && !flag_signed_zeros
    && ! (reg_overlap_mentioned_p (operands[3], operands[1])
          || reg_overlap_mentioned_p (operands[3], operands[2])))))
                    return -1;
                  return 235; /* *pa.md:6517 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case LABEL_REF:
          x5 = XEXP (x2, 0);
          switch (GET_CODE (x5))
            {
            case REG:
            case SUBREG:
              operands[0] = x5;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x4 = XVECEXP (x1, 0, 1);
              if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || GET_MODE (x3) != E_SImode)
                return -1;
              x6 = XEXP (x3, 0);
              operands[1] = x6;
              return 274; /* lcla2 */

            case PC:
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != SET)
                return -1;
              x7 = XEXP (x4, 0);
              operands[0] = x7;
              x9 = XEXP (x4, 1);
              switch (GET_CODE (x9))
                {
                case PLUS:
                  if (GET_MODE (x9) != E_SImode)
                    return -1;
                  x6 = XEXP (x3, 0);
                  operands[3] = x6;
                  if (!ireg_operand (operands[0], E_SImode))
                    return -1;
                  x12 = XEXP (x9, 0);
                  operands[1] = x12;
                  if (!ireg_operand (operands[1], E_SImode))
                    return -1;
                  x13 = XEXP (x9, 1);
                  operands[2] = x13;
                  if (!ireg_or_int5_operand (operands[2], E_SImode)
                      || !
#line 9762 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
((reload_completed && operands[0] == operands[1]) || operands[0] == operands[2]))
                    return -1;
                  return 311; /* *pa.md:9757 */

                case CONST_INT:
                case REG:
                  operands[1] = x9;
                  x6 = XEXP (x3, 0);
                  operands[2] = x6;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SFmode:
                      if (!ireg_operand (operands[0], E_SFmode)
                          || !ireg_or_int5_operand (operands[1], E_SFmode)
                          || !
#line 9785 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(reload_completed))
                        return -1;
                      return 312; /* *pa.md:9781 */

                    case E_SImode:
                      if (!ireg_operand (operands[0], E_SImode)
                          || !ireg_or_int5_operand (operands[1], E_SImode)
                          || !
#line 9808 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(reload_completed))
                        return -1;
                      return 313; /* *pa.md:9804 */

                    case E_HImode:
                      if (!ireg_operand (operands[0], E_HImode)
                          || !ireg_or_int5_operand (operands[1], E_HImode)
                          || !
#line 9831 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(reload_completed))
                        return -1;
                      return 314; /* *pa.md:9827 */

                    case E_QImode:
                      if (!ireg_operand (operands[0], E_QImode)
                          || !ireg_or_int5_operand (operands[1], E_QImode)
                          || !
#line 9854 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(reload_completed))
                        return -1;
                      return 315; /* *pa.md:9850 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          x6 = XEXP (x3, 0);
          switch (GET_CODE (x6))
            {
            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
              if (pnum_clobbers != NULL)
                {
                  res = recog_16 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              if (!movb_comparison_operator (x6, E_VOIDmode))
                return -1;
              operands[2] = x6;
              x25 = XEXP (x6, 1);
              if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x5 = XEXP (x2, 0);
              if (GET_CODE (x5) != PC)
                return -1;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != SET)
                return -1;
              x8 = XEXP (x6, 0);
              operands[1] = x8;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x7 = XEXP (x4, 0);
              operands[0] = x7;
              if (!reg_before_reload_operand (operands[0], E_SImode))
                return -1;
              x9 = XEXP (x4, 1);
              if (!rtx_equal_p (x9, operands[1]))
                return -1;
              x18 = XEXP (x3, 1);
              switch (GET_CODE (x18))
                {
                case LABEL_REF:
                  x26 = XEXP (x3, 2);
                  if (GET_CODE (x26) != PC)
                    return -1;
                  x27 = XEXP (x18, 0);
                  operands[3] = x27;
                  return 309; /* *pa.md:9614 */

                case PC:
                  x26 = XEXP (x3, 2);
                  if (GET_CODE (x26) != LABEL_REF)
                    return -1;
                  x28 = XEXP (x26, 0);
                  operands[3] = x28;
                  return 310; /* *pa.md:9686 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x3, 0) != 1
              || XINT (x3, 1) != 13
              || GET_MODE (x3) != E_BLKmode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!pmode_register_operand (operands[1], E_VOIDmode))
            return -1;
          x29 = XVECEXP (x3, 0, 0);
          if (!rtx_equal_p (x29, operands[0]))
            return -1;
          if (
#line 10824 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_PA_20 && TARGET_COHERENT_LDCW))
            return 335; /* *memory_barrier_coherent */
          return 336; /* *memory_barrier_64 */

        case UNSPEC_VOLATILE:
          if (XVECLEN (x3, 0) != 1
              || XINT (x3, 1) != 6
              || GET_MODE (x3) != E_SImode)
            return -1;
          x29 = XVECEXP (x3, 0, 0);
          if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!scratch_operand (operands[1], E_DImode)
              || !
#line 10889 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && TARGET_64BIT))
            return -1;
          return 338; /* get_fpsr_64 */

        default:
          return -1;
        }

    case RETURN:
      x4 = XVECEXP (x1, 0, 1);
      if (pattern16 (x4, 
E_SImode, 
USE) != 0)
        return -1;
      if (
#line 7202 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(pa_can_use_return_insn ()))
        return 271; /* return */
      return 272; /* return_internal */

    default:
      return -1;
    }
}
