/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], E_XFmode)
      || GET_MODE (x1) != E_XFmode
      || !xfreg_or_fp01_operand (operands[1], E_XFmode)
      || !xfreg_or_fp01_operand (operands[2], E_XFmode))
    return -1;
  return 0;
}

int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x3, 0);
  operands[0] = x7;
  if (!call_operand (operands[0], E_DImode))
    return -1;
  x8 = XEXP (x5, 0);
  operands[1] = x8;
  if (!scratch_operand (operands[1], E_DImode))
    return -1;
  x9 = XEXP (x6, 0);
  operands[2] = x9;
  if (!scratch_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern25 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gr_register_operand (operands[1], i1)
      || !gr_reg_or_5bit_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || !gr_register_operand (operands[1], E_DImode)
      || !shift_count_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern37 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[4] = x4;
  x5 = XEXP (x4, 0);
  operands[5] = x5;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!gr_register_operand (operands[0], E_DImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!gr_register_operand (operands[1], E_DImode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  if (!extr_len_operand (operands[2], E_DImode))
    return -1;
  x9 = XEXP (x3, 2);
  operands[3] = x9;
  if (!shift_count_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern49 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !grfr_register_operand (operands[1], i1)
      || !grfr_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern53 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[2] = x5;
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  if (!gr_register_operand (operands[0], E_DImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_BImode))
    return -1;
  return 0;
}

int
pattern62 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gr_register_operand (operands[1], i1)
      || !gr_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern70 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!memory_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!memory_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!memory_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern75 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!grfr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !grfr_register_operand (operands[1], i1)
      || !grfr_reg_or_8bit_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern80 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_BImode))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_BImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_BImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (!register_operand (x6, E_BImode))
    return -1;
  switch (GET_CODE (x4))
    {
    case NE:
      return pattern79 (x1); /* [-1, 1] */

    case EQ:
      res = pattern79 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern92 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gr_register_operand (operands[1], i1)
      || !gr_reg_or_5bit_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern100 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!not_postinc_destination_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !not_postinc_move_operand (operands[2], i1)
      || !not_postinc_move_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern106 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gr_register_operand (operands[1], i1)
      || !gr_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern114 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !fr_reg_or_fp01_operand (operands[1], i1)
      || !fr_reg_or_fp01_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern119 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !gr_reg_or_0_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !gr_reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern128 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !fr_reg_or_fp01_operand (operands[1], i1)
      || !fr_reg_or_fp01_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !fr_reg_or_signed_fp01_operand (operands[3], i1))
    return -1;
  return 0;
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  operands[1] = x3;
  if (const_int_operand (operands[1], E_DImode))
    {
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (gr_register_operand (operands[0], E_DImode))
        {
          x5 = XEXP (x2, 2);
          operands[2] = x5;
          if (const_int_operand (operands[2], E_DImode))
            {
              x6 = XEXP (x1, 1);
              operands[3] = x6;
              if (nonmemory_operand (operands[3], E_DImode)
                  && 
#line 1479 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
((gr_register_operand (operands[3], DImode) && INTVAL (operands[1]) <= 16)
   || operands[3] == const0_rtx || operands[3] == constm1_rtx))
                return 160; /* *insv_internal */
            }
        }
    }
  if (XWINT (x3, 0) != 32L)
    return -1;
  x5 = XEXP (x2, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!gr_register_operand (operands[0], E_DImode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[1] = x6;
  if (!gr_reg_or_0_operand (operands[1], E_DImode))
    return -1;
  return 165; /* mix4right */
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_DOUBLE:
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!fr_register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (!fr_reg_or_fp01_operand (operands[1], E_DFmode))
                return -1;
              return 141; /* truncdfsf2 */

            case E_XFmode:
              if (!fr_reg_or_fp01_operand (operands[1], E_XFmode))
                return -1;
              return 142; /* truncxfsf2 */

            case E_RFmode:
              if (!fr_reg_or_fp01_operand (operands[1], E_RFmode))
                return -1;
              return 508; /* truncrfsf2 */

            default:
              return -1;
            }

        case E_DFmode:
          if (!fr_register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_XFmode:
              if (!fr_reg_or_fp01_operand (operands[1], E_XFmode))
                return -1;
              return 143; /* truncxfdf2 */

            case E_RFmode:
              if (!fr_reg_or_fp01_operand (operands[1], E_RFmode))
                return -1;
              return 509; /* truncrfdf2 */

            default:
              return -1;
            }

        case E_XFmode:
          if (!fr_register_operand (operands[0], E_XFmode)
              || GET_MODE (x3) != E_XFmode
              || !fr_reg_or_fp01_operand (operands[1], E_RFmode))
            return -1;
          return 510; /* truncrfxf2 */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern16 (x3))
        {
        case 0:
          return 240; /* *adddf3_trunc */

        case 1:
          return 261; /* *addxf3_truncsf */

        case 2:
          return 262; /* *addxf3_truncdf */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern16 (x3))
        {
        case 0:
          return 242; /* *subdf3_trunc */

        case 1:
          return 264; /* *subxf3_truncsf */

        case 2:
          return 265; /* *subxf3_truncdf */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!fr_register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DFmode:
              if (!fr_reg_or_fp01_operand (operands[1], E_DFmode)
                  || !fr_reg_or_fp01_operand (operands[2], E_DFmode))
                return -1;
              return 244; /* *muldf3_trunc */

            case E_XFmode:
              if (!xfreg_or_fp01_operand (operands[1], E_XFmode)
                  || !xfreg_or_fp01_operand (operands[2], E_XFmode))
                return -1;
              return 267; /* *mulxf3_truncsf */

            default:
              return -1;
            }

        case E_DFmode:
          if (pattern48 (x3, 
E_DFmode) != 0)
            return -1;
          return 268; /* *mulxf3_truncdf */

        default:
          return -1;
        }

    case NEG:
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != MULT)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!fr_register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DFmode:
              if (GET_MODE (x5) != E_DFmode
                  || !fr_reg_or_fp01_operand (operands[1], E_DFmode)
                  || !fr_reg_or_fp01_operand (operands[2], E_DFmode))
                return -1;
              return 253; /* *nmuldf3_trunc */

            case E_XFmode:
              if (GET_MODE (x5) != E_XFmode
                  || !xfreg_or_fp01_operand (operands[1], E_XFmode)
                  || !xfreg_or_fp01_operand (operands[2], E_XFmode))
                return -1;
              return 277; /* *nmulxf3_truncsf */

            default:
              return -1;
            }

        case E_DFmode:
          if (!fr_register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || GET_MODE (x4) != E_XFmode
              || GET_MODE (x5) != E_XFmode
              || !xfreg_or_fp01_operand (operands[1], E_XFmode)
              || !xfreg_or_fp01_operand (operands[2], E_XFmode))
            return -1;
          return 278; /* *nmulxf3_truncdf */

        default:
          return -1;
        }

    case FMA:
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case CONST_DOUBLE:
        case REG:
        case SUBREG:
          operands[1] = x5;
          x9 = XEXP (x4, 2);
          switch (GET_CODE (x9))
            {
            case CONST_DOUBLE:
            case REG:
            case SUBREG:
              operands[3] = x9;
              switch (pattern58 (x3))
                {
                case 0:
                  if (!fr_reg_or_fp01_operand (operands[1], E_DFmode)
                      || !fr_reg_or_fp01_operand (operands[2], E_DFmode)
                      || !fr_reg_or_signed_fp01_operand (operands[3], E_DFmode))
                    return -1;
                  return 255; /* *fmadf_trunc_sf */

                case 1:
                  if (!fr_reg_or_fp01_operand (operands[1], E_XFmode)
                      || !fr_reg_or_fp01_operand (operands[2], E_XFmode)
                      || !fr_reg_or_signed_fp01_operand (operands[3], E_XFmode))
                    return -1;
                  return 280; /* *fmaxf_trunc_sf */

                case 2:
                  if (!fr_reg_or_fp01_operand (operands[1], E_XFmode)
                      || !fr_reg_or_fp01_operand (operands[2], E_XFmode)
                      || !fr_reg_or_signed_fp01_operand (operands[3], E_XFmode))
                    return -1;
                  return 281; /* *fmaxf_trunc_df */

                default:
                  return -1;
                }

            case NEG:
              x10 = XEXP (x9, 0);
              operands[3] = x10;
              switch (pattern58 (x3))
                {
                case 0:
                  if (pattern101 (x9, 
E_DFmode) != 0)
                    return -1;
                  return 257; /* *fmsdf_trunc_sf */

                case 1:
                  if (pattern101 (x9, 
E_XFmode) != 0)
                    return -1;
                  return 283; /* *fmsxf_trunc_sf */

                case 2:
                  if (pattern101 (x9, 
E_XFmode) != 0)
                    return -1;
                  return 284; /* *fmsxf_trunc_df */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          x9 = XEXP (x4, 2);
          operands[3] = x9;
          switch (pattern58 (x3))
            {
            case 0:
              if (pattern88 (x5, 
E_DFmode) != 0)
                return -1;
              return 259; /* *fnmadf_trunc_sf */

            case 1:
              if (pattern88 (x5, 
E_XFmode) != 0)
                return -1;
              return 286; /* *fnmaxf_trunc_sf */

            case 2:
              if (pattern88 (x5, 
E_XFmode) != 0)
                return -1;
              return 287; /* *fnmaxf_trunc_df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ZERO_EXTRACT
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x5 = XEXP (x3, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  operands[2] = x6;
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  x8 = XEXP (x3, 0);
  operands[0] = x8;
  if (!gr_register_operand (operands[0], E_DImode))
    return -1;
  x9 = XEXP (x2, 1);
  if (GET_MODE (x9) != E_DImode
      || !gr_register_operand (operands[1], E_DImode))
    return -1;
  return 935; /* *p *mix4left */
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  if (!adjusted_comparison_operator (operands[1], E_BImode))
    return -1;
  x4 = XEXP (x1, 0);
  operands[4] = x4;
  x5 = XEXP (x4, 0);
  operands[5] = x5;
  if (!register_operand (operands[0], E_BImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[2] = x6;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!gr_register_operand (operands[2], E_SImode)
          || !gr_reg_or_8bit_adjusted_operand (operands[3], E_SImode))
        return -1;
      return 1081; /* *p *cmpsi_adjusted */

    case E_DImode:
      if (!gr_register_operand (operands[2], E_DImode)
          || !gr_reg_or_8bit_adjusted_operand (operands[3], E_DImode))
        return -1;
      return 1083; /* *p *cmpdi_adjusted */

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case CONST_DOUBLE:
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!fr_register_operand (operands[0], E_SFmode)
              || GET_MODE (x4) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (!fr_reg_or_fp01_operand (operands[1], E_DFmode))
                return -1;
              return 912; /* *p truncdfsf2 */

            case E_XFmode:
              if (!fr_reg_or_fp01_operand (operands[1], E_XFmode))
                return -1;
              return 913; /* *p truncxfsf2 */

            case E_RFmode:
              if (!fr_reg_or_fp01_operand (operands[1], E_RFmode))
                return -1;
              return 1244; /* *p truncrfsf2 */

            default:
              return -1;
            }

        case E_DFmode:
          if (!fr_register_operand (operands[0], E_DFmode)
              || GET_MODE (x4) != E_DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_XFmode:
              if (!fr_reg_or_fp01_operand (operands[1], E_XFmode))
                return -1;
              return 914; /* *p truncxfdf2 */

            case E_RFmode:
              if (!fr_reg_or_fp01_operand (operands[1], E_RFmode))
                return -1;
              return 1245; /* *p truncrfdf2 */

            default:
              return -1;
            }

        case E_XFmode:
          if (!fr_register_operand (operands[0], E_XFmode)
              || GET_MODE (x4) != E_XFmode
              || !fr_reg_or_fp01_operand (operands[1], E_RFmode))
            return -1;
          return 1246; /* *p truncrfxf2 */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern66 (x1))
        {
        case 0:
          return 1011; /* *p *adddf3_trunc */

        case 1:
          return 1032; /* *p *addxf3_truncsf */

        case 2:
          return 1033; /* *p *addxf3_truncdf */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern66 (x1))
        {
        case 0:
          return 1013; /* *p *subdf3_trunc */

        case 1:
          return 1035; /* *p *subxf3_truncsf */

        case 2:
          return 1036; /* *p *subxf3_truncdf */

        default:
          return -1;
        }

    case MULT:
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      x9 = XEXP (x5, 1);
      operands[2] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!fr_register_operand (operands[0], E_SFmode)
              || GET_MODE (x4) != E_SFmode)
            return -1;
          switch (GET_MODE (x5))
            {
            case E_DFmode:
              if (!fr_reg_or_fp01_operand (operands[1], E_DFmode)
                  || !fr_reg_or_fp01_operand (operands[2], E_DFmode))
                return -1;
              return 1015; /* *p *muldf3_trunc */

            case E_XFmode:
              if (!xfreg_or_fp01_operand (operands[1], E_XFmode)
                  || !xfreg_or_fp01_operand (operands[2], E_XFmode))
                return -1;
              return 1038; /* *p *mulxf3_truncsf */

            default:
              return -1;
            }

        case E_DFmode:
          if (pattern108 (x4, 
E_DFmode) != 0)
            return -1;
          return 1039; /* *p *mulxf3_truncdf */

        default:
          return -1;
        }

    case NEG:
      x8 = XEXP (x5, 0);
      if (GET_CODE (x8) != MULT)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      x10 = XEXP (x8, 0);
      operands[1] = x10;
      x11 = XEXP (x8, 1);
      operands[2] = x11;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!fr_register_operand (operands[0], E_SFmode)
              || GET_MODE (x4) != E_SFmode)
            return -1;
          switch (GET_MODE (x5))
            {
            case E_DFmode:
              if (GET_MODE (x8) != E_DFmode
                  || !fr_reg_or_fp01_operand (operands[1], E_DFmode)
                  || !fr_reg_or_fp01_operand (operands[2], E_DFmode))
                return -1;
              return 1024; /* *p *nmuldf3_trunc */

            case E_XFmode:
              if (GET_MODE (x8) != E_XFmode
                  || !xfreg_or_fp01_operand (operands[1], E_XFmode)
                  || !xfreg_or_fp01_operand (operands[2], E_XFmode))
                return -1;
              return 1048; /* *p *nmulxf3_truncsf */

            default:
              return -1;
            }

        case E_DFmode:
          if (!fr_register_operand (operands[0], E_DFmode)
              || GET_MODE (x4) != E_DFmode
              || GET_MODE (x5) != E_XFmode
              || GET_MODE (x8) != E_XFmode
              || !xfreg_or_fp01_operand (operands[1], E_XFmode)
              || !xfreg_or_fp01_operand (operands[2], E_XFmode))
            return -1;
          return 1049; /* *p *nmulxf3_truncdf */

        default:
          return -1;
        }

    case FMA:
      x6 = XEXP (x1, 0);
      operands[4] = x6;
      x7 = XEXP (x6, 0);
      operands[5] = x7;
      x9 = XEXP (x5, 1);
      operands[2] = x9;
      x8 = XEXP (x5, 0);
      switch (GET_CODE (x8))
        {
        case CONST_DOUBLE:
        case REG:
        case SUBREG:
          operands[1] = x8;
          x12 = XEXP (x5, 2);
          switch (GET_CODE (x12))
            {
            case CONST_DOUBLE:
            case REG:
            case SUBREG:
              operands[3] = x12;
              switch (pattern116 (x4))
                {
                case 0:
                  if (!fr_reg_or_fp01_operand (operands[1], E_DFmode)
                      || !fr_reg_or_fp01_operand (operands[2], E_DFmode)
                      || !fr_reg_or_signed_fp01_operand (operands[3], E_DFmode))
                    return -1;
                  return 1026; /* *p *fmadf_trunc_sf */

                case 1:
                  if (!fr_reg_or_fp01_operand (operands[1], E_XFmode)
                      || !fr_reg_or_fp01_operand (operands[2], E_XFmode)
                      || !fr_reg_or_signed_fp01_operand (operands[3], E_XFmode))
                    return -1;
                  return 1051; /* *p *fmaxf_trunc_sf */

                case 2:
                  if (!fr_reg_or_fp01_operand (operands[1], E_XFmode)
                      || !fr_reg_or_fp01_operand (operands[2], E_XFmode)
                      || !fr_reg_or_signed_fp01_operand (operands[3], E_XFmode))
                    return -1;
                  return 1052; /* *p *fmaxf_trunc_df */

                default:
                  return -1;
                }

            case NEG:
              x13 = XEXP (x12, 0);
              operands[3] = x13;
              switch (pattern116 (x4))
                {
                case 0:
                  if (pattern135 (x12, 
E_DFmode) != 0)
                    return -1;
                  return 1028; /* *p *fmsdf_trunc_sf */

                case 1:
                  if (pattern135 (x12, 
E_XFmode) != 0)
                    return -1;
                  return 1054; /* *p *fmsxf_trunc_sf */

                case 2:
                  if (pattern135 (x12, 
E_XFmode) != 0)
                    return -1;
                  return 1055; /* *p *fmsxf_trunc_df */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NEG:
          x10 = XEXP (x8, 0);
          operands[1] = x10;
          x12 = XEXP (x5, 2);
          operands[3] = x12;
          switch (pattern116 (x4))
            {
            case 0:
              if (pattern131 (x8, 
E_DFmode) != 0)
                return -1;
              return 1030; /* *p *fnmadf_trunc_sf */

            case 1:
              if (pattern131 (x8, 
E_XFmode) != 0)
                return -1;
              return 1057; /* *p *fnmaxf_trunc_sf */

            case 2:
              if (pattern131 (x8, 
E_XFmode) != 0)
                return -1;
              return 1058; /* *p *fnmaxf_trunc_df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_13 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_9 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case UNSPEC:
          if (XVECLEN (x4, 0) != 1
              || !gr_register_operand (operands[0], E_DImode))
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          switch (XINT (x4, 1))
            {
            case 31:
              switch (pattern70 (x4))
                {
                case 0:
                  return 16; /* zero_extendqidi2_advanced */

                case 1:
                  return 17; /* zero_extendhidi2_advanced */

                case 2:
                  return 18; /* zero_extendsidi2_advanced */

                default:
                  return -1;
                }

            case 32:
              switch (pattern70 (x4))
                {
                case 0:
                  return 28; /* zero_extendqidi2_speculative */

                case 1:
                  return 29; /* zero_extendhidi2_speculative */

                case 2:
                  return 30; /* zero_extendsidi2_speculative */

                default:
                  return -1;
                }

            case 34:
              switch (pattern70 (x4))
                {
                case 0:
                  return 49; /* zero_extendqidi2_speculative_advanced */

                case 1:
                  return 50; /* zero_extendhidi2_speculative_advanced */

                case 2:
                  return 51; /* zero_extendsidi2_speculative_advanced */

                default:
                  return -1;
                }

            case 33:
              switch (pattern70 (x4))
                {
                case 0:
                  return 52; /* zero_extendqidi2_speculative_a */

                case 1:
                  return 53; /* zero_extendhidi2_speculative_a */

                case 2:
                  return 54; /* zero_extendsidi2_speculative_a */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x4;
          if (gr_register_operand (operands[0], E_DImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_QImode:
                  if (gr_nonimmediate_operand (operands[1], E_QImode))
                    return 135; /* zero_extendqidi2 */
                  break;

                case E_HImode:
                  if (gr_nonimmediate_operand (operands[1], E_HImode))
                    return 136; /* zero_extendhidi2 */
                  break;

                default:
                  break;
                }
            }
          if (!grfr_nonimmediate_operand (operands[1], E_SImode)
              || !grfr_register_operand (operands[0], E_DImode))
            return -1;
          return 137; /* zero_extendsidi2 */

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      return recog_12 (x1, insn, pnum_clobbers);

    case LO_SUM:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!got_symbolic_operand (operands[2], E_VOIDmode)
          || !
#line 785 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
        return -1;
      return 111; /* *load_symptr_low */

    case SIGN_EXTEND:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (gr_register_operand (operands[0], E_DImode))
        {
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (gr_register_operand (operands[1], E_QImode))
                return 132; /* extendqidi2 */
              break;

            case E_HImode:
              if (gr_register_operand (operands[1], E_HImode))
                return 133; /* extendhidi2 */
              break;

            default:
              break;
            }
        }
      if (!grfr_register_operand (operands[1], E_SImode)
          || !grfr_register_operand (operands[0], E_DImode))
        return -1;
      return 134; /* extendsidi2 */

    case FLOAT_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!fr_register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !fr_reg_or_fp01_operand (operands[1], E_SFmode))
            return -1;
          return 138; /* extendsfdf2 */

        case E_XFmode:
          if (!fr_register_operand (operands[0], E_XFmode)
              || GET_MODE (x2) != E_XFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!fr_reg_or_fp01_operand (operands[1], E_SFmode))
                return -1;
              return 139; /* extendsfxf2 */

            case E_DFmode:
              if (!fr_reg_or_fp01_operand (operands[1], E_DFmode))
                return -1;
              return 140; /* extenddfxf2 */

            default:
              return -1;
            }

        case E_RFmode:
          if (!fr_register_operand (operands[0], E_RFmode)
              || GET_MODE (x2) != E_RFmode)
            return -1;
          switch (pattern47 ())
            {
            case 0:
              return 505; /* extendsfrf2 */

            case 1:
              return 506; /* extenddfrf2 */

            case 2:
              return 507; /* extendxfrf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      return recog_11 (x1, insn, pnum_clobbers);

    case FLOAT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!fr_reg_or_fp01_operand (operands[1], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_RFmode:
          if (!fr_register_operand (operands[0], E_RFmode)
              || GET_MODE (x2) != E_RFmode)
            return -1;
          return 144; /* floatdirf2 */

        case E_XFmode:
          if (!fr_register_operand (operands[0], E_XFmode)
              || GET_MODE (x2) != E_XFmode)
            return -1;
          return 145; /* floatdixf2 */

        default:
          return -1;
        }

    case FIX:
      switch (pattern0 (x1))
        {
        case 0:
          return 146; /* fix_truncsfdi2 */

        case 1:
          return 147; /* fix_truncdfdi2 */

        case 2:
          return 148; /* fix_truncxfdi2 */

        case 3:
          return 149; /* fix_truncrfdi2 */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!fr_reg_or_fp01_operand (operands[1], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!fr_register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode)
            return -1;
          return 150; /* floatunsdisf2 */

        case E_DFmode:
          if (!fr_register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode)
            return -1;
          return 151; /* floatunsdidf2 */

        case E_XFmode:
          if (!fr_register_operand (operands[0], E_XFmode)
              || GET_MODE (x2) != E_XFmode)
            return -1;
          return 152; /* floatunsdixf2 */

        case E_RFmode:
          if (!fr_register_operand (operands[0], E_RFmode)
              || GET_MODE (x2) != E_RFmode)
            return -1;
          return 153; /* floatunsdirf2 */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern0 (x1))
        {
        case 0:
          return 154; /* fixuns_truncsfdi2 */

        case 1:
          return 155; /* fixuns_truncdfdi2 */

        case 2:
          return 156; /* fixuns_truncxfdi2 */

        case 3:
          return 157; /* fixuns_truncrfdi2 */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      if (pattern1 (x1) != 0)
        return -1;
      return 158; /* extv */

    case ZERO_EXTRACT:
      if (pattern1 (x1) != 0)
        return -1;
      return 159; /* extzv */

    case LSHIFTRT:
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) == CONST_INT)
        {
          res = recog_2 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern24 (x2) != 0)
            return -1;
          return 295; /* lshrdi3 */

        case E_V4HImode:
          if (pattern25 (x2, 
E_V4HImode) != 0)
            return -1;
          return 428; /* lshrv4hi3 */

        case E_V2SImode:
          if (pattern25 (x2, 
E_V2SImode) != 0)
            return -1;
          return 429; /* lshrv2si3 */

        default:
          return -1;
        }

    case NOT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_BImode:
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_BImode)
              || GET_MODE (x2) != E_BImode
              || !register_operand (operands[1], E_BImode))
            return -1;
          *pnum_clobbers = 1;
          return 171; /* one_cmplbi2 */

        case E_SImode:
          if (!gr_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !gr_register_operand (operands[1], E_SImode))
            return -1;
          return 303; /* one_cmplsi2 */

        case E_DImode:
          if (!gr_register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !gr_register_operand (operands[1], E_DImode))
            return -1;
          return 308; /* one_cmpldi2 */

        case E_V8QImode:
          if (!gr_register_operand (operands[0], E_V8QImode)
              || GET_MODE (x2) != E_V8QImode
              || !gr_register_operand (operands[1], E_V8QImode))
            return -1;
          return 383; /* one_cmplv8qi2 */

        case E_V4HImode:
          if (!gr_register_operand (operands[0], E_V4HImode)
              || GET_MODE (x2) != E_V4HImode
              || !gr_register_operand (operands[1], E_V4HImode))
            return -1;
          return 384; /* one_cmplv4hi2 */

        case E_V2SImode:
          if (!gr_register_operand (operands[0], E_V2SImode)
              || GET_MODE (x2) != E_V2SImode
              || !gr_register_operand (operands[1], E_V2SImode))
            return -1;
          return 385; /* one_cmplv2si2 */

        default:
          return -1;
        }

    case MULT:
      return recog_16 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_14 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      return recog_15 (x1, insn, pnum_clobbers);

    case POPCOUNT:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!gr_register_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!gr_register_operand (operands[1], E_DImode))
        return -1;
      return 217; /* popcountdi2 */

    case BSWAP:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!gr_register_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!gr_register_operand (operands[1], E_DImode))
        return -1;
      return 218; /* bswapdi2 */

    case ABS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!fr_register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !fr_reg_or_fp01_operand (operands[1], E_SFmode))
            return -1;
          return 228; /* abssf2 */

        case E_DFmode:
          if (!fr_register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !fr_reg_or_fp01_operand (operands[1], E_DFmode))
            return -1;
          return 245; /* absdf2 */

        case E_XFmode:
          if (!fr_register_operand (operands[0], E_XFmode)
              || GET_MODE (x2) != E_XFmode
              || !xfreg_or_fp01_operand (operands[1], E_XFmode))
            return -1;
          return 269; /* absxf2 */

        case E_V2SFmode:
          if (!fr_register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x2) != E_V2SFmode
              || !fr_register_operand (operands[1], E_V2SFmode))
            return -1;
          return 459; /* absv2sf2 */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern7 (x1))
        {
        case 0:
          return 233; /* sminsf3 */

        case 1:
          return 250; /* smindf3 */

        case 2:
          return 274; /* sminxf3 */

        case 3:
          return 423; /* *sminv4hi3 */

        case 4:
          return 468; /* sminv2sf3 */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern7 (x1))
        {
        case 0:
          return 234; /* smaxsf3 */

        case 1:
          return 251; /* smaxdf3 */

        case 2:
          return 275; /* smaxxf3 */

        case 3:
          return 421; /* *smaxv4hi3 */

        case 4:
          return 467; /* smaxv2sf3 */

        default:
          return -1;
        }

    case FMA:
      return recog_17 (x1, insn, pnum_clobbers);

    case ASHIFT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern25 (x2, 
E_SImode) != 0)
            return -1;
          return 288; /* *ashlsi3_internal */

        case E_DImode:
          if (pattern24 (x2) != 0)
            return -1;
          return 291; /* ashldi3 */

        case E_TImode:
          if (pattern29 (x2) != 0)
            return -1;
          return 298; /* *ashlti3_internal */

        case E_V4HImode:
          if (pattern25 (x2, 
E_V4HImode) != 0)
            return -1;
          return 424; /* ashlv4hi3 */

        case E_V2SImode:
          if (pattern25 (x2, 
E_V2SImode) != 0)
            return -1;
          return 425; /* ashlv2si3 */

        default:
          return -1;
        }

    case ROTATERT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern25 (x2, 
E_SImode) != 0)
            return -1;
          return 289; /* *rotrsi3_internal */

        case E_DImode:
          if (pattern30 (x2) != 0)
            return -1;
          return 296; /* *rotrdi3_internal */

        default:
          return -1;
        }

    case ROTATE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern31 (x2) != 0)
            return -1;
          return 290; /* *rotlsi3_internal */

        case E_DImode:
          if (pattern30 (x2) != 0)
            return -1;
          return 297; /* *rotldi3_internal */

        case E_TImode:
          if (pattern29 (x2) != 0)
            return -1;
          return 301; /* *rotlti3_internal */

        default:
          return -1;
        }

    case ASHIFTRT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern24 (x2) != 0)
            return -1;
          return 294; /* ashrdi3 */

        case E_TImode:
          if (pattern29 (x2) != 0)
            return -1;
          return 299; /* *ashrti3_internal */

        case E_V4HImode:
          if (pattern25 (x2, 
E_V4HImode) != 0)
            return -1;
          return 426; /* ashrv4hi3 */

        case E_V2SImode:
          if (pattern25 (x2, 
E_V2SImode) != 0)
            return -1;
          return 427; /* ashrv2si3 */

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_CODE (x2))
        {
        case NE:
        case EQ:
        case GT:
        case LE:
        case GTU:
        case LEU:
          res = recog_3 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case GE:
        case LT:
        case GEU:
        case LTU:
          operands[1] = x2;
          if (adjusted_comparison_operator (operands[1], E_BImode)
              && register_operand (operands[0], E_BImode))
            {
              x4 = XEXP (x2, 0);
              operands[2] = x4;
              x7 = XEXP (x2, 1);
              operands[3] = x7;
              switch (GET_MODE (operands[2]))
                {
                case E_SImode:
                  if (gr_register_operand (operands[2], E_SImode)
                      && gr_reg_or_8bit_adjusted_operand (operands[3], E_SImode))
                    return 310; /* *cmpsi_adjusted */
                  break;

                case E_DImode:
                  if (gr_register_operand (operands[2], E_DImode)
                      && gr_reg_or_8bit_adjusted_operand (operands[3], E_DImode))
                    return 312; /* *cmpdi_adjusted */
                  break;

                default:
                  break;
                }
            }
          break;

        default:
          break;
        }
      switch (GET_MODE (operands[0]))
        {
        case E_BImode:
          if (!register_operand (operands[0], E_BImode))
            return -1;
          operands[1] = x2;
          if (!comparison_operator (operands[1], E_BImode))
            return -1;
          x4 = XEXP (x2, 0);
          operands[2] = x4;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          switch (GET_MODE (operands[2]))
            {
            case E_SFmode:
              if (!fr_reg_or_fp01_operand (operands[2], E_SFmode)
                  || !fr_reg_or_fp01_operand (operands[3], E_SFmode))
                return -1;
              return 313; /* *cmpsf_internal */

            case E_DFmode:
              if (!fr_reg_or_fp01_operand (operands[2], E_DFmode)
                  || !fr_reg_or_fp01_operand (operands[3], E_DFmode))
                return -1;
              return 314; /* *cmpdf_internal */

            case E_XFmode:
              if (!xfreg_or_fp01_operand (operands[2], E_XFmode)
                  || !xfreg_or_fp01_operand (operands[3], E_XFmode))
                return -1;
              return 315; /* *cmpxf_internal */

            default:
              return -1;
            }

        case E_V2SFmode:
          if (!fr_register_operand (operands[0], E_V2SFmode))
            return -1;
          operands[3] = x2;
          if (!comparison_operator (operands[3], E_V2SFmode))
            return -1;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (!fr_reg_or_0_operand (operands[1], E_V2SFmode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[2] = x7;
          if (!fr_reg_or_0_operand (operands[2], E_V2SFmode))
            return -1;
          return 469; /* *fpcmp */

        default:
          return -1;
        }

    case PLUS:
    case MINUS:
    case AND:
    case IOR:
    case XOR:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_CODE (x2))
        {
        case PLUS:
          res = recog_4 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case MINUS:
          res = recog_5 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case AND:
          res = recog_6 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case IOR:
          res = recog_7 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case XOR:
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          x7 = XEXP (x2, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern21 (x2, 
E_DImode) == 0)
                return 307; /* xordi3 */
              break;

            case E_V8QImode:
              if (pattern21 (x2, 
E_V8QImode) == 0)
                return 395; /* xorv8qi3 */
              break;

            case E_V4HImode:
              if (pattern21 (x2, 
E_V4HImode) == 0)
                return 396; /* xorv4hi3 */
              break;

            case E_V2SImode:
              if (pattern21 (x2, 
E_V2SImode) == 0)
                return 397; /* xorv2si3 */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (!gr_register_operand (operands[0], E_SImode))
        return -1;
      operands[5] = x2;
      if (!condop_operator (operands[5], E_SImode))
        return -1;
      switch (pattern34 (x2))
        {
        case 0:
          return 327; /* *cond_opsi2_internal */

        case 1:
          return 328; /* *cond_opsi2_internal_b */

        default:
          return -1;
        }

    case PC:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      return 377; /* ip_value */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 2
          || XINT (x2, 1) != 10
          || GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x8 = XVECEXP (x2, 0, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XVECEXP (x2, 0, 1);
      operands[2] = x9;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 379; /* probe_stack_range */

    case SS_PLUS:
      switch (pattern9 (x1))
        {
        case 0:
          return 404; /* *ssaddv8qi3 */

        case 1:
          return 405; /* *ssaddv4hi3 */

        default:
          return -1;
        }

    case US_PLUS:
      switch (pattern9 (x1))
        {
        case 0:
          return 406; /* *usaddv8qi3 */

        case 1:
          return 407; /* *usaddv4hi3 */

        default:
          return -1;
        }

    case SS_MINUS:
      switch (pattern9 (x1))
        {
        case 0:
          return 411; /* *sssubv8qi3 */

        case 1:
          return 412; /* *sssubv4hi3 */

        default:
          return -1;
        }

    case US_MINUS:
      switch (pattern9 (x1))
        {
        case 0:
          return 413; /* *ussubv8qi3 */

        case 1:
          return 414; /* *ussubv4hi3 */

        default:
          return -1;
        }

    case UMAX:
      if (pattern10 (x1) != 0)
        return -1;
      return 420; /* *umaxv8qi3 */

    case UMIN:
      if (pattern10 (x1) != 0)
        return -1;
      return 422; /* *uminv8qi3 */

    case VEC_CONCAT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case SS_TRUNCATE:
          x7 = XEXP (x2, 1);
          if (GET_CODE (x7) != SS_TRUNCATE)
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          x10 = XEXP (x7, 0);
          operands[2] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern64 (x2, 
E_V4HImode, 
E_V4QImode, 
E_V8QImode) != 0)
                return -1;
              return 436; /* vec_pack_ssat_v4hi */

            case E_V4HImode:
              if (pattern64 (x2, 
E_V2SImode, 
E_V2HImode, 
E_V4HImode) != 0)
                return -1;
              return 438; /* vec_pack_ssat_v2si */

            default:
              return -1;
            }

        case US_TRUNCATE:
          if (GET_MODE (x4) != E_V4QImode)
            return -1;
          x7 = XEXP (x2, 1);
          if (GET_CODE (x7) != US_TRUNCATE
              || GET_MODE (x7) != E_V4QImode
              || !gr_register_operand (operands[0], E_V8QImode)
              || GET_MODE (x2) != E_V8QImode)
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!gr_reg_or_0_operand (operands[1], E_V4HImode))
            return -1;
          x10 = XEXP (x7, 0);
          operands[2] = x10;
          if (!gr_reg_or_0_operand (operands[2], E_V4HImode))
            return -1;
          return 437; /* vec_pack_usat_v4hi */

        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[1] = x4;
          x7 = XEXP (x2, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (!gr_register_operand (operands[0], E_V2SImode)
                  || GET_MODE (x2) != E_V2SImode
                  || !gr_reg_or_0_operand (operands[1], E_SImode)
                  || !gr_reg_or_0_operand (operands[2], E_SImode))
                return -1;
              return 457; /* *vecinit_v2si */

            case E_V2SFmode:
              if (pattern2 (x2, 
E_V2SFmode) != 0)
                return -1;
              return 471; /* fpack */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      return recog_10 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (!gr_register_operand (operands[0], E_V8QImode)
              || GET_MODE (x2) != E_V8QImode
              || !gr_register_operand (operands[1], E_QImode))
            return -1;
          return 448; /* mux1_brcst_qi */

        case E_V4HImode:
          if (!gr_register_operand (operands[0], E_V4HImode)
              || GET_MODE (x2) != E_V4HImode
              || !gr_register_operand (operands[1], E_HImode))
            return -1;
          return 454; /* *mux2_brcst_hi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
