/* Generated automatically by the program `genopinit'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "optabs.h"

struct optab_pat {
  unsigned scode;
  enum insn_code icode;
};

static const struct optab_pat pats[NUM_OPTAB_PATTERNS] = {
  { 0x101406, CODE_FOR_extendqihi2 },
  { 0x101407, CODE_FOR_extendqisi2 },
  { 0x101408, CODE_FOR_extendqidi2 },
  { 0x101807, CODE_FOR_extendhisi2 },
  { 0x101808, CODE_FOR_extendhidi2 },
  { 0x101c08, CODE_FOR_extendsidi2 },
  { 0x10741e, CODE_FOR_extendsfdf2 },
  { 0x20781d, CODE_FOR_truncdfsf2 },
  { 0x301406, CODE_FOR_zero_extendqihi2 },
  { 0x301407, CODE_FOR_zero_extendqisi2 },
  { 0x301408, CODE_FOR_zero_extendqidi2 },
  { 0x301807, CODE_FOR_zero_extendhisi2 },
  { 0x301808, CODE_FOR_zero_extendhidi2 },
  { 0x301c08, CODE_FOR_zero_extendsidi2 },
  { 0x601c1d, CODE_FOR_floatsisf2 },
  { 0x601c1e, CODE_FOR_floatsidf2 },
  { 0x60201d, CODE_FOR_floatdisf2 },
  { 0x60201e, CODE_FOR_floatdidf2 },
  { 0x60d048, CODE_FOR_floatv4siv4sf2 },
  { 0x60d449, CODE_FOR_floatv2div2df2 },
  { 0x60e44a, CODE_FOR_floatv8siv8sf2 },
  { 0x60e84b, CODE_FOR_floatv4div4df2 },
  { 0x70d048, CODE_FOR_floatunsv4siv4sf2 },
  { 0x70d449, CODE_FOR_floatunsv2div2df2 },
  { 0x70e44a, CODE_FOR_floatunsv8siv8sf2 },
  { 0x70e84b, CODE_FOR_floatunsv4div4df2 },
  { 0x807407, CODE_FOR_lrintsfsi2 },
  { 0x807408, CODE_FOR_lrintsfdi2 },
  { 0x807807, CODE_FOR_lrintdfsi2 },
  { 0x807808, CODE_FOR_lrintdfdi2 },
  { 0x812034, CODE_FOR_lrintv4sfv4si2 },
  { 0x812435, CODE_FOR_lrintv2dfv2di2 },
  { 0x812839, CODE_FOR_lrintv8sfv8si2 },
  { 0x812c3a, CODE_FOR_lrintv4dfv4di2 },
  { 0xa07407, CODE_FOR_lfloorsfsi2 },
  { 0xa07408, CODE_FOR_lfloorsfdi2 },
  { 0xa07807, CODE_FOR_lfloordfsi2 },
  { 0xa07808, CODE_FOR_lfloordfdi2 },
  { 0xa12034, CODE_FOR_lfloorv4sfv4si2 },
  { 0xa12435, CODE_FOR_lfloorv2dfv2di2 },
  { 0xa12839, CODE_FOR_lfloorv8sfv8si2 },
  { 0xa12c3a, CODE_FOR_lfloorv4dfv4di2 },
  { 0xb07407, CODE_FOR_lceilsfsi2 },
  { 0xb07408, CODE_FOR_lceilsfdi2 },
  { 0xb07807, CODE_FOR_lceildfsi2 },
  { 0xb07808, CODE_FOR_lceildfdi2 },
  { 0xb12034, CODE_FOR_lceilv4sfv4si2 },
  { 0xb12435, CODE_FOR_lceilv2dfv2di2 },
  { 0xb12839, CODE_FOR_lceilv8sfv8si2 },
  { 0xb12c3a, CODE_FOR_lceilv4dfv4di2 },
  { 0x1207407, CODE_FOR_fix_truncsfsi2 },
  { 0x1207408, CODE_FOR_fix_truncsfdi2 },
  { 0x1207807, CODE_FOR_fix_truncdfsi2 },
  { 0x1207808, CODE_FOR_fix_truncdfdi2 },
  { 0x1212034, CODE_FOR_fix_truncv4sfv4si2 },
  { 0x1212435, CODE_FOR_fix_truncv2dfv2di2 },
  { 0x1212839, CODE_FOR_fix_truncv8sfv8si2 },
  { 0x1212c3a, CODE_FOR_fix_truncv4dfv4di2 },
  { 0x1307407, CODE_FOR_fixuns_truncsfsi2 },
  { 0x1307408, CODE_FOR_fixuns_truncsfdi2 },
  { 0x1307807, CODE_FOR_fixuns_truncdfsi2 },
  { 0x1307808, CODE_FOR_fixuns_truncdfdi2 },
  { 0x1312034, CODE_FOR_fixuns_truncv4sfv4si2 },
  { 0x1312435, CODE_FOR_fixuns_truncv2dfv2di2 },
  { 0x1312839, CODE_FOR_fixuns_truncv8sfv8si2 },
  { 0x1312c3a, CODE_FOR_fixuns_truncv4dfv4di2 },
  { 0x1401c08, CODE_FOR_mulsidi3 },
  { 0x1402009, CODE_FOR_mulditi3 },
  { 0x1501c08, CODE_FOR_umulsidi3 },
  { 0x1502009, CODE_FOR_umulditi3 },
  { 0x2001c05, CODE_FOR_crc_revqisi4 },
  { 0x2001c06, CODE_FOR_crc_revhisi4 },
  { 0x2001c07, CODE_FOR_crc_revsisi4 },
  { 0x270c832, CODE_FOR_vcond_mask_v16qiv16qi },
  { 0x270cc33, CODE_FOR_vcond_mask_v8hiv8hi },
  { 0x270d034, CODE_FOR_vcond_mask_v4siv4si },
  { 0x270d048, CODE_FOR_vcond_mask_v4sfv4si },
  { 0x270d435, CODE_FOR_vcond_mask_v2div2di },
  { 0x270d449, CODE_FOR_vcond_mask_v2dfv2di },
  { 0x270dc37, CODE_FOR_vcond_mask_v32qiv32qi },
  { 0x270e038, CODE_FOR_vcond_mask_v16hiv16hi },
  { 0x270e439, CODE_FOR_vcond_mask_v8siv8si },
  { 0x270e44a, CODE_FOR_vcond_mask_v8sfv8si },
  { 0x270e83a, CODE_FOR_vcond_mask_v4div4di },
  { 0x270e84b, CODE_FOR_vcond_mask_v4dfv4di },
  { 0x280c832, CODE_FOR_vec_cmpv16qiv16qi },
  { 0x280cc33, CODE_FOR_vec_cmpv8hiv8hi },
  { 0x280d034, CODE_FOR_vec_cmpv4siv4si },
  { 0x280d048, CODE_FOR_vec_cmpv4sfv4si },
  { 0x280d435, CODE_FOR_vec_cmpv2div2di },
  { 0x280d449, CODE_FOR_vec_cmpv2dfv2di },
  { 0x280dc37, CODE_FOR_vec_cmpv32qiv32qi },
  { 0x280e038, CODE_FOR_vec_cmpv16hiv16hi },
  { 0x280e439, CODE_FOR_vec_cmpv8siv8si },
  { 0x280e44a, CODE_FOR_vec_cmpv8sfv8si },
  { 0x280e83a, CODE_FOR_vec_cmpv4div4di },
  { 0x280e84b, CODE_FOR_vec_cmpv4dfv4di },
  { 0x290c832, CODE_FOR_vec_cmpuv16qiv16qi },
  { 0x290cc33, CODE_FOR_vec_cmpuv8hiv8hi },
  { 0x290d034, CODE_FOR_vec_cmpuv4siv4si },
  { 0x290d435, CODE_FOR_vec_cmpuv2div2di },
  { 0x290dc37, CODE_FOR_vec_cmpuv32qiv32qi },
  { 0x290e038, CODE_FOR_vec_cmpuv16hiv16hi },
  { 0x290e439, CODE_FOR_vec_cmpuv8siv8si },
  { 0x290e83a, CODE_FOR_vec_cmpuv4div4di },
  { 0x3501432, CODE_FOR_vec_extractv16qiqi },
  { 0x3501437, CODE_FOR_vec_extractv32qiqi },
  { 0x3501833, CODE_FOR_vec_extractv8hihi },
  { 0x3501838, CODE_FOR_vec_extractv16hihi },
  { 0x3501c34, CODE_FOR_vec_extractv4sisi },
  { 0x3501c39, CODE_FOR_vec_extractv8sisi },
  { 0x3502035, CODE_FOR_vec_extractv2didi },
  { 0x350203a, CODE_FOR_vec_extractv4didi },
  { 0x3507448, CODE_FOR_vec_extractv4sfsf },
  { 0x350744a, CODE_FOR_vec_extractv8sfsf },
  { 0x3507849, CODE_FOR_vec_extractv2dfdf },
  { 0x350784b, CODE_FOR_vec_extractv4dfdf },
  { 0x3601432, CODE_FOR_vec_initv16qiqi },
  { 0x3601437, CODE_FOR_vec_initv32qiqi },
  { 0x3601833, CODE_FOR_vec_initv8hihi },
  { 0x3601838, CODE_FOR_vec_initv16hihi },
  { 0x3601c34, CODE_FOR_vec_initv4sisi },
  { 0x3601c39, CODE_FOR_vec_initv8sisi },
  { 0x3602035, CODE_FOR_vec_initv2didi },
  { 0x360203a, CODE_FOR_vec_initv4didi },
  { 0x3607448, CODE_FOR_vec_initv4sfsf },
  { 0x360744a, CODE_FOR_vec_initv8sfsf },
  { 0x3607849, CODE_FOR_vec_initv2dfdf },
  { 0x360784b, CODE_FOR_vec_initv4dfdf },
  { 0x360c837, CODE_FOR_vec_initv32qiv16qi },
  { 0x360cc38, CODE_FOR_vec_initv16hiv8hi },
  { 0x360d039, CODE_FOR_vec_initv8siv4si },
  { 0x360d43a, CODE_FOR_vec_initv4div2di },
  { 0x361204a, CODE_FOR_vec_initv8sfv4sf },
  { 0x361244b, CODE_FOR_vec_initv4dfv2df },
  { 0x370c833, CODE_FOR_sdot_prodv8hiv16qi },
  { 0x370cc34, CODE_FOR_sdot_prodv4siv8hi },
  { 0x370d035, CODE_FOR_sdot_prodv2div4si },
  { 0x370d436, CODE_FOR_sdot_prodv1tiv2di },
  { 0x370dc38, CODE_FOR_sdot_prodv16hiv32qi },
  { 0x370e039, CODE_FOR_sdot_prodv8siv16hi },
  { 0x370e43a, CODE_FOR_sdot_prodv4div8si },
  { 0x370e83b, CODE_FOR_sdot_prodv2tiv4di },
  { 0x380c833, CODE_FOR_udot_prodv8hiv16qi },
  { 0x380cc34, CODE_FOR_udot_prodv4siv8hi },
  { 0x380d035, CODE_FOR_udot_prodv2div4si },
  { 0x380d436, CODE_FOR_udot_prodv1tiv2di },
  { 0x380dc38, CODE_FOR_udot_prodv16hiv32qi },
  { 0x380e039, CODE_FOR_udot_prodv8siv16hi },
  { 0x380e43a, CODE_FOR_udot_prodv4div8si },
  { 0x380e83b, CODE_FOR_udot_prodv2tiv4di },
  { 0x3b00007, CODE_FOR_addsi3 },
  { 0x3b00008, CODE_FOR_adddi3 },
  { 0x3b0001d, CODE_FOR_addsf3 },
  { 0x3b0001e, CODE_FOR_adddf3 },
  { 0x3b00032, CODE_FOR_addv16qi3 },
  { 0x3b00033, CODE_FOR_addv8hi3 },
  { 0x3b00034, CODE_FOR_addv4si3 },
  { 0x3b00035, CODE_FOR_addv2di3 },
  { 0x3b00037, CODE_FOR_addv32qi3 },
  { 0x3b00038, CODE_FOR_addv16hi3 },
  { 0x3b00039, CODE_FOR_addv8si3 },
  { 0x3b0003a, CODE_FOR_addv4di3 },
  { 0x3b00048, CODE_FOR_addv4sf3 },
  { 0x3b00049, CODE_FOR_addv2df3 },
  { 0x3b0004a, CODE_FOR_addv8sf3 },
  { 0x3b0004b, CODE_FOR_addv4df3 },
  { 0x3d00032, CODE_FOR_ssaddv16qi3 },
  { 0x3d00033, CODE_FOR_ssaddv8hi3 },
  { 0x3d00034, CODE_FOR_ssaddv4si3 },
  { 0x3d00035, CODE_FOR_ssaddv2di3 },
  { 0x3d00037, CODE_FOR_ssaddv32qi3 },
  { 0x3d00038, CODE_FOR_ssaddv16hi3 },
  { 0x3d00039, CODE_FOR_ssaddv8si3 },
  { 0x3d0003a, CODE_FOR_ssaddv4di3 },
  { 0x3e00032, CODE_FOR_usaddv16qi3 },
  { 0x3e00033, CODE_FOR_usaddv8hi3 },
  { 0x3e00034, CODE_FOR_usaddv4si3 },
  { 0x3e00035, CODE_FOR_usaddv2di3 },
  { 0x3e00037, CODE_FOR_usaddv32qi3 },
  { 0x3e00038, CODE_FOR_usaddv16hi3 },
  { 0x3e00039, CODE_FOR_usaddv8si3 },
  { 0x3e0003a, CODE_FOR_usaddv4di3 },
  { 0x3f00007, CODE_FOR_subsi3 },
  { 0x3f00008, CODE_FOR_subdi3 },
  { 0x3f0001d, CODE_FOR_subsf3 },
  { 0x3f0001e, CODE_FOR_subdf3 },
  { 0x3f00032, CODE_FOR_subv16qi3 },
  { 0x3f00033, CODE_FOR_subv8hi3 },
  { 0x3f00034, CODE_FOR_subv4si3 },
  { 0x3f00035, CODE_FOR_subv2di3 },
  { 0x3f00037, CODE_FOR_subv32qi3 },
  { 0x3f00038, CODE_FOR_subv16hi3 },
  { 0x3f00039, CODE_FOR_subv8si3 },
  { 0x3f0003a, CODE_FOR_subv4di3 },
  { 0x3f00048, CODE_FOR_subv4sf3 },
  { 0x3f00049, CODE_FOR_subv2df3 },
  { 0x3f0004a, CODE_FOR_subv8sf3 },
  { 0x3f0004b, CODE_FOR_subv4df3 },
  { 0x4300007, CODE_FOR_mulsi3 },
  { 0x4300008, CODE_FOR_muldi3 },
  { 0x430001d, CODE_FOR_mulsf3 },
  { 0x430001e, CODE_FOR_muldf3 },
  { 0x4300032, CODE_FOR_mulv16qi3 },
  { 0x4300033, CODE_FOR_mulv8hi3 },
  { 0x4300034, CODE_FOR_mulv4si3 },
  { 0x4300035, CODE_FOR_mulv2di3 },
  { 0x4300037, CODE_FOR_mulv32qi3 },
  { 0x4300038, CODE_FOR_mulv16hi3 },
  { 0x4300039, CODE_FOR_mulv8si3 },
  { 0x430003a, CODE_FOR_mulv4di3 },
  { 0x4300048, CODE_FOR_mulv4sf3 },
  { 0x4300049, CODE_FOR_mulv2df3 },
  { 0x430004a, CODE_FOR_mulv8sf3 },
  { 0x430004b, CODE_FOR_mulv4df3 },
  { 0x4700007, CODE_FOR_divsi3 },
  { 0x4700008, CODE_FOR_divdi3 },
  { 0x470001d, CODE_FOR_divsf3 },
  { 0x470001e, CODE_FOR_divdf3 },
  { 0x4700032, CODE_FOR_divv16qi3 },
  { 0x4700033, CODE_FOR_divv8hi3 },
  { 0x4700034, CODE_FOR_divv4si3 },
  { 0x4700035, CODE_FOR_divv2di3 },
  { 0x4700037, CODE_FOR_divv32qi3 },
  { 0x4700038, CODE_FOR_divv16hi3 },
  { 0x4700039, CODE_FOR_divv8si3 },
  { 0x470003a, CODE_FOR_divv4di3 },
  { 0x4700048, CODE_FOR_divv4sf3 },
  { 0x4700049, CODE_FOR_divv2df3 },
  { 0x470004a, CODE_FOR_divv8sf3 },
  { 0x470004b, CODE_FOR_divv4df3 },
  { 0x4a00007, CODE_FOR_udivsi3 },
  { 0x4a00008, CODE_FOR_udivdi3 },
  { 0x4a00032, CODE_FOR_udivv16qi3 },
  { 0x4a00033, CODE_FOR_udivv8hi3 },
  { 0x4a00034, CODE_FOR_udivv4si3 },
  { 0x4a00035, CODE_FOR_udivv2di3 },
  { 0x4a00037, CODE_FOR_udivv32qi3 },
  { 0x4a00038, CODE_FOR_udivv16hi3 },
  { 0x4a00039, CODE_FOR_udivv8si3 },
  { 0x4a0003a, CODE_FOR_udivv4di3 },
  { 0x4e00007, CODE_FOR_modsi3 },
  { 0x4e00008, CODE_FOR_moddi3 },
  { 0x4e00032, CODE_FOR_modv16qi3 },
  { 0x4e00033, CODE_FOR_modv8hi3 },
  { 0x4e00034, CODE_FOR_modv4si3 },
  { 0x4e00035, CODE_FOR_modv2di3 },
  { 0x4e00037, CODE_FOR_modv32qi3 },
  { 0x4e00038, CODE_FOR_modv16hi3 },
  { 0x4e00039, CODE_FOR_modv8si3 },
  { 0x4e0003a, CODE_FOR_modv4di3 },
  { 0x4f00007, CODE_FOR_umodsi3 },
  { 0x4f00008, CODE_FOR_umoddi3 },
  { 0x4f00032, CODE_FOR_umodv16qi3 },
  { 0x4f00033, CODE_FOR_umodv8hi3 },
  { 0x4f00034, CODE_FOR_umodv4si3 },
  { 0x4f00035, CODE_FOR_umodv2di3 },
  { 0x4f00037, CODE_FOR_umodv32qi3 },
  { 0x4f00038, CODE_FOR_umodv16hi3 },
  { 0x4f00039, CODE_FOR_umodv8si3 },
  { 0x4f0003a, CODE_FOR_umodv4di3 },
  { 0x5000048, CODE_FOR_ftruncv4sf2 },
  { 0x5000049, CODE_FOR_ftruncv2df2 },
  { 0x500004a, CODE_FOR_ftruncv8sf2 },
  { 0x500004b, CODE_FOR_ftruncv4df2 },
  { 0x5100007, CODE_FOR_andsi3 },
  { 0x5100008, CODE_FOR_anddi3 },
  { 0x5100032, CODE_FOR_andv16qi3 },
  { 0x5100033, CODE_FOR_andv8hi3 },
  { 0x5100034, CODE_FOR_andv4si3 },
  { 0x5100035, CODE_FOR_andv2di3 },
  { 0x5100037, CODE_FOR_andv32qi3 },
  { 0x5100038, CODE_FOR_andv16hi3 },
  { 0x5100039, CODE_FOR_andv8si3 },
  { 0x510003a, CODE_FOR_andv4di3 },
  { 0x5100048, CODE_FOR_andv4sf3 },
  { 0x5100049, CODE_FOR_andv2df3 },
  { 0x510004a, CODE_FOR_andv8sf3 },
  { 0x510004b, CODE_FOR_andv4df3 },
  { 0x5200007, CODE_FOR_iorsi3 },
  { 0x5200008, CODE_FOR_iordi3 },
  { 0x5200032, CODE_FOR_iorv16qi3 },
  { 0x5200033, CODE_FOR_iorv8hi3 },
  { 0x5200034, CODE_FOR_iorv4si3 },
  { 0x5200035, CODE_FOR_iorv2di3 },
  { 0x5200037, CODE_FOR_iorv32qi3 },
  { 0x5200038, CODE_FOR_iorv16hi3 },
  { 0x5200039, CODE_FOR_iorv8si3 },
  { 0x520003a, CODE_FOR_iorv4di3 },
  { 0x5200048, CODE_FOR_iorv4sf3 },
  { 0x5200049, CODE_FOR_iorv2df3 },
  { 0x520004a, CODE_FOR_iorv8sf3 },
  { 0x520004b, CODE_FOR_iorv4df3 },
  { 0x5300007, CODE_FOR_xorsi3 },
  { 0x5300008, CODE_FOR_xordi3 },
  { 0x5300032, CODE_FOR_xorv16qi3 },
  { 0x5300033, CODE_FOR_xorv8hi3 },
  { 0x5300034, CODE_FOR_xorv4si3 },
  { 0x5300035, CODE_FOR_xorv2di3 },
  { 0x5300037, CODE_FOR_xorv32qi3 },
  { 0x5300038, CODE_FOR_xorv16hi3 },
  { 0x5300039, CODE_FOR_xorv8si3 },
  { 0x530003a, CODE_FOR_xorv4di3 },
  { 0x5300048, CODE_FOR_xorv4sf3 },
  { 0x5300049, CODE_FOR_xorv2df3 },
  { 0x530004a, CODE_FOR_xorv8sf3 },
  { 0x530004b, CODE_FOR_xorv4df3 },
  { 0x5400007, CODE_FOR_ashlsi3 },
  { 0x5400008, CODE_FOR_ashldi3 },
  { 0x5400032, CODE_FOR_ashlv16qi3 },
  { 0x5400033, CODE_FOR_ashlv8hi3 },
  { 0x5400034, CODE_FOR_ashlv4si3 },
  { 0x5400035, CODE_FOR_ashlv2di3 },
  { 0x5400037, CODE_FOR_ashlv32qi3 },
  { 0x5400038, CODE_FOR_ashlv16hi3 },
  { 0x5400039, CODE_FOR_ashlv8si3 },
  { 0x540003a, CODE_FOR_ashlv4di3 },
  { 0x5700007, CODE_FOR_ashrsi3 },
  { 0x5700008, CODE_FOR_ashrdi3 },
  { 0x5700032, CODE_FOR_ashrv16qi3 },
  { 0x5700033, CODE_FOR_ashrv8hi3 },
  { 0x5700034, CODE_FOR_ashrv4si3 },
  { 0x5700035, CODE_FOR_ashrv2di3 },
  { 0x5700037, CODE_FOR_ashrv32qi3 },
  { 0x5700038, CODE_FOR_ashrv16hi3 },
  { 0x5700039, CODE_FOR_ashrv8si3 },
  { 0x570003a, CODE_FOR_ashrv4di3 },
  { 0x5800007, CODE_FOR_lshrsi3 },
  { 0x5800008, CODE_FOR_lshrdi3 },
  { 0x5800032, CODE_FOR_lshrv16qi3 },
  { 0x5800033, CODE_FOR_lshrv8hi3 },
  { 0x5800034, CODE_FOR_lshrv4si3 },
  { 0x5800035, CODE_FOR_lshrv2di3 },
  { 0x5800037, CODE_FOR_lshrv32qi3 },
  { 0x5800038, CODE_FOR_lshrv16hi3 },
  { 0x5800039, CODE_FOR_lshrv8si3 },
  { 0x580003a, CODE_FOR_lshrv4di3 },
  { 0x5900007, CODE_FOR_rotlsi3 },
  { 0x5900008, CODE_FOR_rotldi3 },
  { 0x5900032, CODE_FOR_rotlv16qi3 },
  { 0x5900033, CODE_FOR_rotlv8hi3 },
  { 0x5900034, CODE_FOR_rotlv4si3 },
  { 0x5900035, CODE_FOR_rotlv2di3 },
  { 0x5900037, CODE_FOR_rotlv32qi3 },
  { 0x5900038, CODE_FOR_rotlv16hi3 },
  { 0x5900039, CODE_FOR_rotlv8si3 },
  { 0x590003a, CODE_FOR_rotlv4di3 },
  { 0x5a00007, CODE_FOR_rotrsi3 },
  { 0x5a00008, CODE_FOR_rotrdi3 },
  { 0x5a00032, CODE_FOR_rotrv16qi3 },
  { 0x5a00033, CODE_FOR_rotrv8hi3 },
  { 0x5a00034, CODE_FOR_rotrv4si3 },
  { 0x5a00035, CODE_FOR_rotrv2di3 },
  { 0x5a00037, CODE_FOR_rotrv32qi3 },
  { 0x5a00038, CODE_FOR_rotrv16hi3 },
  { 0x5a00039, CODE_FOR_rotrv8si3 },
  { 0x5a0003a, CODE_FOR_rotrv4di3 },
  { 0x5b00032, CODE_FOR_vashlv16qi3 },
  { 0x5b00033, CODE_FOR_vashlv8hi3 },
  { 0x5b00034, CODE_FOR_vashlv4si3 },
  { 0x5b00035, CODE_FOR_vashlv2di3 },
  { 0x5b00037, CODE_FOR_vashlv32qi3 },
  { 0x5b00038, CODE_FOR_vashlv16hi3 },
  { 0x5b00039, CODE_FOR_vashlv8si3 },
  { 0x5b0003a, CODE_FOR_vashlv4di3 },
  { 0x5c00032, CODE_FOR_vashrv16qi3 },
  { 0x5c00033, CODE_FOR_vashrv8hi3 },
  { 0x5c00034, CODE_FOR_vashrv4si3 },
  { 0x5c00035, CODE_FOR_vashrv2di3 },
  { 0x5c00037, CODE_FOR_vashrv32qi3 },
  { 0x5c00038, CODE_FOR_vashrv16hi3 },
  { 0x5c00039, CODE_FOR_vashrv8si3 },
  { 0x5c0003a, CODE_FOR_vashrv4di3 },
  { 0x5d00032, CODE_FOR_vlshrv16qi3 },
  { 0x5d00033, CODE_FOR_vlshrv8hi3 },
  { 0x5d00034, CODE_FOR_vlshrv4si3 },
  { 0x5d00035, CODE_FOR_vlshrv2di3 },
  { 0x5d00037, CODE_FOR_vlshrv32qi3 },
  { 0x5d00038, CODE_FOR_vlshrv16hi3 },
  { 0x5d00039, CODE_FOR_vlshrv8si3 },
  { 0x5d0003a, CODE_FOR_vlshrv4di3 },
  { 0x5e00032, CODE_FOR_vrotlv16qi3 },
  { 0x5e00033, CODE_FOR_vrotlv8hi3 },
  { 0x5e00034, CODE_FOR_vrotlv4si3 },
  { 0x5e00035, CODE_FOR_vrotlv2di3 },
  { 0x5e00037, CODE_FOR_vrotlv32qi3 },
  { 0x5e00038, CODE_FOR_vrotlv16hi3 },
  { 0x5e00039, CODE_FOR_vrotlv8si3 },
  { 0x5e0003a, CODE_FOR_vrotlv4di3 },
  { 0x5f00032, CODE_FOR_vrotrv16qi3 },
  { 0x5f00033, CODE_FOR_vrotrv8hi3 },
  { 0x5f00034, CODE_FOR_vrotrv4si3 },
  { 0x5f00035, CODE_FOR_vrotrv2di3 },
  { 0x5f00037, CODE_FOR_vrotrv32qi3 },
  { 0x5f00038, CODE_FOR_vrotrv16hi3 },
  { 0x5f00039, CODE_FOR_vrotrv8si3 },
  { 0x5f0003a, CODE_FOR_vrotrv4di3 },
  { 0x600001d, CODE_FOR_sminsf3 },
  { 0x600001e, CODE_FOR_smindf3 },
  { 0x6000032, CODE_FOR_sminv16qi3 },
  { 0x6000033, CODE_FOR_sminv8hi3 },
  { 0x6000034, CODE_FOR_sminv4si3 },
  { 0x6000035, CODE_FOR_sminv2di3 },
  { 0x6000037, CODE_FOR_sminv32qi3 },
  { 0x6000038, CODE_FOR_sminv16hi3 },
  { 0x6000039, CODE_FOR_sminv8si3 },
  { 0x600003a, CODE_FOR_sminv4di3 },
  { 0x6000048, CODE_FOR_sminv4sf3 },
  { 0x6000049, CODE_FOR_sminv2df3 },
  { 0x600004a, CODE_FOR_sminv8sf3 },
  { 0x600004b, CODE_FOR_sminv4df3 },
  { 0x610001d, CODE_FOR_smaxsf3 },
  { 0x610001e, CODE_FOR_smaxdf3 },
  { 0x6100032, CODE_FOR_smaxv16qi3 },
  { 0x6100033, CODE_FOR_smaxv8hi3 },
  { 0x6100034, CODE_FOR_smaxv4si3 },
  { 0x6100035, CODE_FOR_smaxv2di3 },
  { 0x6100037, CODE_FOR_smaxv32qi3 },
  { 0x6100038, CODE_FOR_smaxv16hi3 },
  { 0x6100039, CODE_FOR_smaxv8si3 },
  { 0x610003a, CODE_FOR_smaxv4di3 },
  { 0x6100048, CODE_FOR_smaxv4sf3 },
  { 0x6100049, CODE_FOR_smaxv2df3 },
  { 0x610004a, CODE_FOR_smaxv8sf3 },
  { 0x610004b, CODE_FOR_smaxv4df3 },
  { 0x6200032, CODE_FOR_uminv16qi3 },
  { 0x6200033, CODE_FOR_uminv8hi3 },
  { 0x6200034, CODE_FOR_uminv4si3 },
  { 0x6200035, CODE_FOR_uminv2di3 },
  { 0x6200037, CODE_FOR_uminv32qi3 },
  { 0x6200038, CODE_FOR_uminv16hi3 },
  { 0x6200039, CODE_FOR_uminv8si3 },
  { 0x620003a, CODE_FOR_uminv4di3 },
  { 0x6300032, CODE_FOR_umaxv16qi3 },
  { 0x6300033, CODE_FOR_umaxv8hi3 },
  { 0x6300034, CODE_FOR_umaxv4si3 },
  { 0x6300035, CODE_FOR_umaxv2di3 },
  { 0x6300037, CODE_FOR_umaxv32qi3 },
  { 0x6300038, CODE_FOR_umaxv16hi3 },
  { 0x6300039, CODE_FOR_umaxv8si3 },
  { 0x630003a, CODE_FOR_umaxv4di3 },
  { 0x6400007, CODE_FOR_negsi2 },
  { 0x6400008, CODE_FOR_negdi2 },
  { 0x640001d, CODE_FOR_negsf2 },
  { 0x640001e, CODE_FOR_negdf2 },
  { 0x6400032, CODE_FOR_negv16qi2 },
  { 0x6400033, CODE_FOR_negv8hi2 },
  { 0x6400034, CODE_FOR_negv4si2 },
  { 0x6400035, CODE_FOR_negv2di2 },
  { 0x6400037, CODE_FOR_negv32qi2 },
  { 0x6400038, CODE_FOR_negv16hi2 },
  { 0x6400039, CODE_FOR_negv8si2 },
  { 0x640003a, CODE_FOR_negv4di2 },
  { 0x6400048, CODE_FOR_negv4sf2 },
  { 0x6400049, CODE_FOR_negv2df2 },
  { 0x640004a, CODE_FOR_negv8sf2 },
  { 0x640004b, CODE_FOR_negv4df2 },
  { 0x680001d, CODE_FOR_abssf2 },
  { 0x680001e, CODE_FOR_absdf2 },
  { 0x6800032, CODE_FOR_absv16qi2 },
  { 0x6800033, CODE_FOR_absv8hi2 },
  { 0x6800034, CODE_FOR_absv4si2 },
  { 0x6800035, CODE_FOR_absv2di2 },
  { 0x6800037, CODE_FOR_absv32qi2 },
  { 0x6800038, CODE_FOR_absv16hi2 },
  { 0x6800039, CODE_FOR_absv8si2 },
  { 0x680003a, CODE_FOR_absv4di2 },
  { 0x6800048, CODE_FOR_absv4sf2 },
  { 0x6800049, CODE_FOR_absv2df2 },
  { 0x680004a, CODE_FOR_absv8sf2 },
  { 0x680004b, CODE_FOR_absv4df2 },
  { 0x6a00007, CODE_FOR_one_cmplsi2 },
  { 0x6a00008, CODE_FOR_one_cmpldi2 },
  { 0x6a00032, CODE_FOR_one_cmplv16qi2 },
  { 0x6a00033, CODE_FOR_one_cmplv8hi2 },
  { 0x6a00034, CODE_FOR_one_cmplv4si2 },
  { 0x6a00035, CODE_FOR_one_cmplv2di2 },
  { 0x6a00037, CODE_FOR_one_cmplv32qi2 },
  { 0x6a00038, CODE_FOR_one_cmplv16hi2 },
  { 0x6a00039, CODE_FOR_one_cmplv8si2 },
  { 0x6a0003a, CODE_FOR_one_cmplv4di2 },
  { 0x6b00006, CODE_FOR_bswaphi2 },
  { 0x6b00007, CODE_FOR_bswapsi2 },
  { 0x6b00008, CODE_FOR_bswapdi2 },
  { 0x6d00007, CODE_FOR_clzsi2 },
  { 0x6d00008, CODE_FOR_clzdi2 },
  { 0x6d00032, CODE_FOR_clzv16qi2 },
  { 0x6d00033, CODE_FOR_clzv8hi2 },
  { 0x6d00034, CODE_FOR_clzv4si2 },
  { 0x6d00035, CODE_FOR_clzv2di2 },
  { 0x6d00037, CODE_FOR_clzv32qi2 },
  { 0x6d00038, CODE_FOR_clzv16hi2 },
  { 0x6d00039, CODE_FOR_clzv8si2 },
  { 0x6d0003a, CODE_FOR_clzv4di2 },
  { 0x6e00007, CODE_FOR_ctzsi2 },
  { 0x6e00008, CODE_FOR_ctzdi2 },
  { 0x7000007, CODE_FOR_popcountsi2 },
  { 0x7000008, CODE_FOR_popcountdi2 },
  { 0x7000032, CODE_FOR_popcountv16qi2 },
  { 0x7000033, CODE_FOR_popcountv8hi2 },
  { 0x7000034, CODE_FOR_popcountv4si2 },
  { 0x7000035, CODE_FOR_popcountv2di2 },
  { 0x7000037, CODE_FOR_popcountv32qi2 },
  { 0x7000038, CODE_FOR_popcountv16hi2 },
  { 0x7000039, CODE_FOR_popcountv8si2 },
  { 0x700003a, CODE_FOR_popcountv4di2 },
  { 0x7c0001d, CODE_FOR_sqrtsf2 },
  { 0x7c0001e, CODE_FOR_sqrtdf2 },
  { 0x7c00048, CODE_FOR_sqrtv4sf2 },
  { 0x7c00049, CODE_FOR_sqrtv2df2 },
  { 0x7c0004a, CODE_FOR_sqrtv8sf2 },
  { 0x7c0004b, CODE_FOR_sqrtv4df2 },
  { 0x8b00003, CODE_FOR_movfcc },
  { 0x8b00005, CODE_FOR_movqi },
  { 0x8b00006, CODE_FOR_movhi },
  { 0x8b00007, CODE_FOR_movsi },
  { 0x8b00008, CODE_FOR_movdi },
  { 0x8b0001d, CODE_FOR_movsf },
  { 0x8b0001e, CODE_FOR_movdf },
  { 0x8b00032, CODE_FOR_movv16qi },
  { 0x8b00033, CODE_FOR_movv8hi },
  { 0x8b00034, CODE_FOR_movv4si },
  { 0x8b00035, CODE_FOR_movv2di },
  { 0x8b00036, CODE_FOR_movv1ti },
  { 0x8b00037, CODE_FOR_movv32qi },
  { 0x8b00038, CODE_FOR_movv16hi },
  { 0x8b00039, CODE_FOR_movv8si },
  { 0x8b0003a, CODE_FOR_movv4di },
  { 0x8b0003b, CODE_FOR_movv2ti },
  { 0x8b00048, CODE_FOR_movv4sf },
  { 0x8b00049, CODE_FOR_movv2df },
  { 0x8b0004a, CODE_FOR_movv8sf },
  { 0x8b0004b, CODE_FOR_movv4df },
  { 0x8d00032, CODE_FOR_movmisalignv16qi },
  { 0x8d00033, CODE_FOR_movmisalignv8hi },
  { 0x8d00034, CODE_FOR_movmisalignv4si },
  { 0x8d00035, CODE_FOR_movmisalignv2di },
  { 0x8d00036, CODE_FOR_movmisalignv1ti },
  { 0x8d00037, CODE_FOR_movmisalignv32qi },
  { 0x8d00038, CODE_FOR_movmisalignv16hi },
  { 0x8d00039, CODE_FOR_movmisalignv8si },
  { 0x8d0003a, CODE_FOR_movmisalignv4di },
  { 0x8d0003b, CODE_FOR_movmisalignv2ti },
  { 0x8d00048, CODE_FOR_movmisalignv4sf },
  { 0x8d00049, CODE_FOR_movmisalignv2df },
  { 0x8d0004a, CODE_FOR_movmisalignv8sf },
  { 0x8d0004b, CODE_FOR_movmisalignv4df },
  { 0x8f00007, CODE_FOR_insvsi },
  { 0x8f00008, CODE_FOR_insvdi },
  { 0x9100007, CODE_FOR_extzvsi },
  { 0x9100008, CODE_FOR_extzvdi },
  { 0x9800005, CODE_FOR_cbranchqi4 },
  { 0x9800007, CODE_FOR_cbranchsi4 },
  { 0x9800008, CODE_FOR_cbranchdi4 },
  { 0x980001d, CODE_FOR_cbranchsf4 },
  { 0x980001e, CODE_FOR_cbranchdf4 },
  { 0x9800032, CODE_FOR_cbranchv16qi4 },
  { 0x9800033, CODE_FOR_cbranchv8hi4 },
  { 0x9800034, CODE_FOR_cbranchv4si4 },
  { 0x9800035, CODE_FOR_cbranchv2di4 },
  { 0x9800037, CODE_FOR_cbranchv32qi4 },
  { 0x9800038, CODE_FOR_cbranchv16hi4 },
  { 0x9800039, CODE_FOR_cbranchv8si4 },
  { 0x980003a, CODE_FOR_cbranchv4di4 },
  { 0x9e00007, CODE_FOR_movsicc },
  { 0x9e00008, CODE_FOR_movdicc },
  { 0x9e0001d, CODE_FOR_movsfcc },
  { 0x9e0001e, CODE_FOR_movdfcc },
  { 0xd500007, CODE_FOR_cstoresi4 },
  { 0xd500008, CODE_FOR_cstoredi4 },
  { 0xd50001d, CODE_FOR_cstoresf4 },
  { 0xd50001e, CODE_FOR_cstoredf4 },
  { 0xe200007, CODE_FOR_smulsi3_highpart },
  { 0xe200008, CODE_FOR_smuldi3_highpart },
  { 0xe200032, CODE_FOR_smulv16qi3_highpart },
  { 0xe200033, CODE_FOR_smulv8hi3_highpart },
  { 0xe200034, CODE_FOR_smulv4si3_highpart },
  { 0xe200035, CODE_FOR_smulv2di3_highpart },
  { 0xe200037, CODE_FOR_smulv32qi3_highpart },
  { 0xe200038, CODE_FOR_smulv16hi3_highpart },
  { 0xe200039, CODE_FOR_smulv8si3_highpart },
  { 0xe20003a, CODE_FOR_smulv4di3_highpart },
  { 0xe300007, CODE_FOR_umulsi3_highpart },
  { 0xe300008, CODE_FOR_umuldi3_highpart },
  { 0xe300032, CODE_FOR_umulv16qi3_highpart },
  { 0xe300033, CODE_FOR_umulv8hi3_highpart },
  { 0xe300034, CODE_FOR_umulv4si3_highpart },
  { 0xe300035, CODE_FOR_umulv2di3_highpart },
  { 0xe300037, CODE_FOR_umulv32qi3_highpart },
  { 0xe300038, CODE_FOR_umulv16hi3_highpart },
  { 0xe300039, CODE_FOR_umulv8si3_highpart },
  { 0xe30003a, CODE_FOR_umulv4di3_highpart },
  { 0xe700007, CODE_FOR_cpymemsi },
  { 0xec0001d, CODE_FOR_fmasf4 },
  { 0xec0001e, CODE_FOR_fmadf4 },
  { 0xec00048, CODE_FOR_fmav4sf4 },
  { 0xec00049, CODE_FOR_fmav2df4 },
  { 0xec0004a, CODE_FOR_fmav8sf4 },
  { 0xec0004b, CODE_FOR_fmav4df4 },
  { 0xed0001d, CODE_FOR_fmssf4 },
  { 0xed0001e, CODE_FOR_fmsdf4 },
  { 0xed00048, CODE_FOR_fmsv4sf4 },
  { 0xed00049, CODE_FOR_fmsv2df4 },
  { 0xed0004a, CODE_FOR_fmsv8sf4 },
  { 0xed0004b, CODE_FOR_fmsv4df4 },
  { 0xee0001d, CODE_FOR_fnmasf4 },
  { 0xee0001e, CODE_FOR_fnmadf4 },
  { 0xee00048, CODE_FOR_fnmav4sf4 },
  { 0xee00049, CODE_FOR_fnmav2df4 },
  { 0xee0004a, CODE_FOR_fnmav8sf4 },
  { 0xee0004b, CODE_FOR_fnmav4df4 },
  { 0xef0001d, CODE_FOR_fnmssf4 },
  { 0xef0001e, CODE_FOR_fnmsdf4 },
  { 0xf00001d, CODE_FOR_rintsf2 },
  { 0xf00001e, CODE_FOR_rintdf2 },
  { 0xf000048, CODE_FOR_rintv4sf2 },
  { 0xf000049, CODE_FOR_rintv2df2 },
  { 0xf00004a, CODE_FOR_rintv8sf2 },
  { 0xf00004b, CODE_FOR_rintv4df2 },
  { 0xf20001d, CODE_FOR_roundevensf2 },
  { 0xf20001e, CODE_FOR_roundevendf2 },
  { 0xf200048, CODE_FOR_roundevenv4sf2 },
  { 0xf200049, CODE_FOR_roundevenv2df2 },
  { 0xf20004a, CODE_FOR_roundevenv8sf2 },
  { 0xf20004b, CODE_FOR_roundevenv4df2 },
  { 0xf30001d, CODE_FOR_floorsf2 },
  { 0xf30001e, CODE_FOR_floordf2 },
  { 0xf300048, CODE_FOR_floorv4sf2 },
  { 0xf300049, CODE_FOR_floorv2df2 },
  { 0xf30004a, CODE_FOR_floorv8sf2 },
  { 0xf30004b, CODE_FOR_floorv4df2 },
  { 0xf40001d, CODE_FOR_ceilsf2 },
  { 0xf40001e, CODE_FOR_ceildf2 },
  { 0xf400048, CODE_FOR_ceilv4sf2 },
  { 0xf400049, CODE_FOR_ceilv2df2 },
  { 0xf40004a, CODE_FOR_ceilv8sf2 },
  { 0xf40004b, CODE_FOR_ceilv4df2 },
  { 0xf50001d, CODE_FOR_btruncsf2 },
  { 0xf50001e, CODE_FOR_btruncdf2 },
  { 0xf500048, CODE_FOR_btruncv4sf2 },
  { 0xf500049, CODE_FOR_btruncv2df2 },
  { 0xf50004a, CODE_FOR_btruncv8sf2 },
  { 0xf50004b, CODE_FOR_btruncv4df2 },
  { 0xfe0001d, CODE_FOR_copysignsf3 },
  { 0xfe0001e, CODE_FOR_copysigndf3 },
  { 0xfe00048, CODE_FOR_copysignv4sf3 },
  { 0xfe00049, CODE_FOR_copysignv2df3 },
  { 0xfe0004a, CODE_FOR_copysignv8sf3 },
  { 0xfe0004b, CODE_FOR_copysignv4df3 },
  { 0xff0001d, CODE_FOR_xorsignsf3 },
  { 0xff0001e, CODE_FOR_xorsigndf3 },
  { 0xff00048, CODE_FOR_xorsignv4sf3 },
  { 0xff00049, CODE_FOR_xorsignv2df3 },
  { 0xff0004a, CODE_FOR_xorsignv8sf3 },
  { 0xff0004b, CODE_FOR_xorsignv4df3 },
  { 0x1110001d, CODE_FOR_isinfsf2 },
  { 0x1110001e, CODE_FOR_isinfdf2 },
  { 0x1120001d, CODE_FOR_isfinitesf2 },
  { 0x1120001e, CODE_FOR_isfinitedf2 },
  { 0x1130001d, CODE_FOR_isnormalsf2 },
  { 0x1130001e, CODE_FOR_isnormaldf2 },
  { 0x1150001d, CODE_FOR_ldexpsf3 },
  { 0x1150001e, CODE_FOR_ldexpdf3 },
  { 0x11a0001d, CODE_FOR_logbsf2 },
  { 0x11a0001e, CODE_FOR_logbdf2 },
  { 0x11a00048, CODE_FOR_logbv4sf2 },
  { 0x11a00049, CODE_FOR_logbv2df2 },
  { 0x11a0004a, CODE_FOR_logbv8sf2 },
  { 0x11a0004b, CODE_FOR_logbv4df2 },
  { 0x11d0001d, CODE_FOR_rsqrtsf2 },
  { 0x11d0001e, CODE_FOR_rsqrtdf2 },
  { 0x11d00048, CODE_FOR_rsqrtv4sf2 },
  { 0x11d00049, CODE_FOR_rsqrtv2df2 },
  { 0x11d0004a, CODE_FOR_rsqrtv8sf2 },
  { 0x11d0004b, CODE_FOR_rsqrtv4df2 },
  { 0x1290001d, CODE_FOR_fmaxsf3 },
  { 0x1290001e, CODE_FOR_fmaxdf3 },
  { 0x12900048, CODE_FOR_fmaxv4sf3 },
  { 0x12900049, CODE_FOR_fmaxv2df3 },
  { 0x1290004a, CODE_FOR_fmaxv8sf3 },
  { 0x1290004b, CODE_FOR_fmaxv4df3 },
  { 0x12a0001d, CODE_FOR_fminsf3 },
  { 0x12a0001e, CODE_FOR_fmindf3 },
  { 0x12a00048, CODE_FOR_fminv4sf3 },
  { 0x12a00049, CODE_FOR_fminv2df3 },
  { 0x12a0004a, CODE_FOR_fminv8sf3 },
  { 0x12a0004b, CODE_FOR_fminv4df3 },
  { 0x12b00048, CODE_FOR_reduc_fmax_scal_v4sf },
  { 0x12b00049, CODE_FOR_reduc_fmax_scal_v2df },
  { 0x12b0004a, CODE_FOR_reduc_fmax_scal_v8sf },
  { 0x12b0004b, CODE_FOR_reduc_fmax_scal_v4df },
  { 0x12c00048, CODE_FOR_reduc_fmin_scal_v4sf },
  { 0x12c00049, CODE_FOR_reduc_fmin_scal_v2df },
  { 0x12c0004a, CODE_FOR_reduc_fmin_scal_v8sf },
  { 0x12c0004b, CODE_FOR_reduc_fmin_scal_v4df },
  { 0x12d00032, CODE_FOR_reduc_smax_scal_v16qi },
  { 0x12d00033, CODE_FOR_reduc_smax_scal_v8hi },
  { 0x12d00034, CODE_FOR_reduc_smax_scal_v4si },
  { 0x12d00035, CODE_FOR_reduc_smax_scal_v2di },
  { 0x12d00037, CODE_FOR_reduc_smax_scal_v32qi },
  { 0x12d00038, CODE_FOR_reduc_smax_scal_v16hi },
  { 0x12d00039, CODE_FOR_reduc_smax_scal_v8si },
  { 0x12d0003a, CODE_FOR_reduc_smax_scal_v4di },
  { 0x12d00048, CODE_FOR_reduc_smax_scal_v4sf },
  { 0x12d00049, CODE_FOR_reduc_smax_scal_v2df },
  { 0x12d0004a, CODE_FOR_reduc_smax_scal_v8sf },
  { 0x12d0004b, CODE_FOR_reduc_smax_scal_v4df },
  { 0x12e00032, CODE_FOR_reduc_smin_scal_v16qi },
  { 0x12e00033, CODE_FOR_reduc_smin_scal_v8hi },
  { 0x12e00034, CODE_FOR_reduc_smin_scal_v4si },
  { 0x12e00035, CODE_FOR_reduc_smin_scal_v2di },
  { 0x12e00037, CODE_FOR_reduc_smin_scal_v32qi },
  { 0x12e00038, CODE_FOR_reduc_smin_scal_v16hi },
  { 0x12e00039, CODE_FOR_reduc_smin_scal_v8si },
  { 0x12e0003a, CODE_FOR_reduc_smin_scal_v4di },
  { 0x12e00048, CODE_FOR_reduc_smin_scal_v4sf },
  { 0x12e00049, CODE_FOR_reduc_smin_scal_v2df },
  { 0x12e0004a, CODE_FOR_reduc_smin_scal_v8sf },
  { 0x12e0004b, CODE_FOR_reduc_smin_scal_v4df },
  { 0x12f00034, CODE_FOR_reduc_plus_scal_v4si },
  { 0x12f00035, CODE_FOR_reduc_plus_scal_v2di },
  { 0x12f00039, CODE_FOR_reduc_plus_scal_v8si },
  { 0x12f0003a, CODE_FOR_reduc_plus_scal_v4di },
  { 0x12f00048, CODE_FOR_reduc_plus_scal_v4sf },
  { 0x12f00049, CODE_FOR_reduc_plus_scal_v2df },
  { 0x12f0004a, CODE_FOR_reduc_plus_scal_v8sf },
  { 0x12f0004b, CODE_FOR_reduc_plus_scal_v4df },
  { 0x13000032, CODE_FOR_reduc_umax_scal_v16qi },
  { 0x13000033, CODE_FOR_reduc_umax_scal_v8hi },
  { 0x13000034, CODE_FOR_reduc_umax_scal_v4si },
  { 0x13000035, CODE_FOR_reduc_umax_scal_v2di },
  { 0x13000037, CODE_FOR_reduc_umax_scal_v32qi },
  { 0x13000038, CODE_FOR_reduc_umax_scal_v16hi },
  { 0x13000039, CODE_FOR_reduc_umax_scal_v8si },
  { 0x1300003a, CODE_FOR_reduc_umax_scal_v4di },
  { 0x13100032, CODE_FOR_reduc_umin_scal_v16qi },
  { 0x13100033, CODE_FOR_reduc_umin_scal_v8hi },
  { 0x13100034, CODE_FOR_reduc_umin_scal_v4si },
  { 0x13100035, CODE_FOR_reduc_umin_scal_v2di },
  { 0x13100037, CODE_FOR_reduc_umin_scal_v32qi },
  { 0x13100038, CODE_FOR_reduc_umin_scal_v16hi },
  { 0x13100039, CODE_FOR_reduc_umin_scal_v8si },
  { 0x1310003a, CODE_FOR_reduc_umin_scal_v4di },
  { 0x13200032, CODE_FOR_reduc_and_scal_v16qi },
  { 0x13200033, CODE_FOR_reduc_and_scal_v8hi },
  { 0x13200034, CODE_FOR_reduc_and_scal_v4si },
  { 0x13200035, CODE_FOR_reduc_and_scal_v2di },
  { 0x13200037, CODE_FOR_reduc_and_scal_v32qi },
  { 0x13200038, CODE_FOR_reduc_and_scal_v16hi },
  { 0x13200039, CODE_FOR_reduc_and_scal_v8si },
  { 0x1320003a, CODE_FOR_reduc_and_scal_v4di },
  { 0x13300032, CODE_FOR_reduc_ior_scal_v16qi },
  { 0x13300033, CODE_FOR_reduc_ior_scal_v8hi },
  { 0x13300034, CODE_FOR_reduc_ior_scal_v4si },
  { 0x13300035, CODE_FOR_reduc_ior_scal_v2di },
  { 0x13300037, CODE_FOR_reduc_ior_scal_v32qi },
  { 0x13300038, CODE_FOR_reduc_ior_scal_v16hi },
  { 0x13300039, CODE_FOR_reduc_ior_scal_v8si },
  { 0x1330003a, CODE_FOR_reduc_ior_scal_v4di },
  { 0x13400032, CODE_FOR_reduc_xor_scal_v16qi },
  { 0x13400033, CODE_FOR_reduc_xor_scal_v8hi },
  { 0x13400034, CODE_FOR_reduc_xor_scal_v4si },
  { 0x13400035, CODE_FOR_reduc_xor_scal_v2di },
  { 0x13400037, CODE_FOR_reduc_xor_scal_v32qi },
  { 0x13400038, CODE_FOR_reduc_xor_scal_v16hi },
  { 0x13400039, CODE_FOR_reduc_xor_scal_v8si },
  { 0x1340003a, CODE_FOR_reduc_xor_scal_v4di },
  { 0x13b00032, CODE_FOR_uabdv16qi3 },
  { 0x13b00033, CODE_FOR_uabdv8hi3 },
  { 0x13b00034, CODE_FOR_uabdv4si3 },
  { 0x13b00035, CODE_FOR_uabdv2di3 },
  { 0x13b00037, CODE_FOR_uabdv32qi3 },
  { 0x13b00038, CODE_FOR_uabdv16hi3 },
  { 0x13b00039, CODE_FOR_uabdv8si3 },
  { 0x13b0003a, CODE_FOR_uabdv4di3 },
  { 0x13c00032, CODE_FOR_sabdv16qi3 },
  { 0x13c00033, CODE_FOR_sabdv8hi3 },
  { 0x13c00034, CODE_FOR_sabdv4si3 },
  { 0x13c00035, CODE_FOR_sabdv2di3 },
  { 0x13c00037, CODE_FOR_sabdv32qi3 },
  { 0x13c00038, CODE_FOR_sabdv16hi3 },
  { 0x13c00039, CODE_FOR_sabdv8si3 },
  { 0x13c0003a, CODE_FOR_sabdv4di3 },
  { 0x13d00032, CODE_FOR_avgv16qi3_floor },
  { 0x13d00033, CODE_FOR_avgv8hi3_floor },
  { 0x13d00034, CODE_FOR_avgv4si3_floor },
  { 0x13d00037, CODE_FOR_avgv32qi3_floor },
  { 0x13d00038, CODE_FOR_avgv16hi3_floor },
  { 0x13d00039, CODE_FOR_avgv8si3_floor },
  { 0x13e00032, CODE_FOR_uavgv16qi3_floor },
  { 0x13e00033, CODE_FOR_uavgv8hi3_floor },
  { 0x13e00034, CODE_FOR_uavgv4si3_floor },
  { 0x13e00037, CODE_FOR_uavgv32qi3_floor },
  { 0x13e00038, CODE_FOR_uavgv16hi3_floor },
  { 0x13e00039, CODE_FOR_uavgv8si3_floor },
  { 0x13f00032, CODE_FOR_avgv16qi3_ceil },
  { 0x13f00033, CODE_FOR_avgv8hi3_ceil },
  { 0x13f00034, CODE_FOR_avgv4si3_ceil },
  { 0x13f00037, CODE_FOR_avgv32qi3_ceil },
  { 0x13f00038, CODE_FOR_avgv16hi3_ceil },
  { 0x13f00039, CODE_FOR_avgv8si3_ceil },
  { 0x14000032, CODE_FOR_uavgv16qi3_ceil },
  { 0x14000033, CODE_FOR_uavgv8hi3_ceil },
  { 0x14000034, CODE_FOR_uavgv4si3_ceil },
  { 0x14000037, CODE_FOR_uavgv32qi3_ceil },
  { 0x14000038, CODE_FOR_uavgv16hi3_ceil },
  { 0x14000039, CODE_FOR_uavgv8si3_ceil },
  { 0x14300032, CODE_FOR_usadv16qi },
  { 0x14300037, CODE_FOR_usadv32qi },
  { 0x14400032, CODE_FOR_ssadv16qi },
  { 0x14400037, CODE_FOR_ssadv32qi },
  { 0x14a00049, CODE_FOR_vec_pack_sfix_trunc_v2df },
  { 0x14a0004b, CODE_FOR_vec_pack_sfix_trunc_v4df },
  { 0x14c00033, CODE_FOR_vec_pack_trunc_v8hi },
  { 0x14c00034, CODE_FOR_vec_pack_trunc_v4si },
  { 0x14c00035, CODE_FOR_vec_pack_trunc_v2di },
  { 0x14c00038, CODE_FOR_vec_pack_trunc_v16hi },
  { 0x14c00039, CODE_FOR_vec_pack_trunc_v8si },
  { 0x14c0003a, CODE_FOR_vec_pack_trunc_v4di },
  { 0x14c00049, CODE_FOR_vec_pack_trunc_v2df },
  { 0x14c0004b, CODE_FOR_vec_pack_trunc_v4df },
  { 0x15000035, CODE_FOR_vec_packs_float_v2di },
  { 0x1500003a, CODE_FOR_vec_packs_float_v4di },
  { 0x15200032, CODE_FOR_vec_permv16qi },
  { 0x15200033, CODE_FOR_vec_permv8hi },
  { 0x15200034, CODE_FOR_vec_permv4si },
  { 0x15200035, CODE_FOR_vec_permv2di },
  { 0x15200037, CODE_FOR_vec_permv32qi },
  { 0x15200038, CODE_FOR_vec_permv16hi },
  { 0x15200039, CODE_FOR_vec_permv8si },
  { 0x1520003a, CODE_FOR_vec_permv4di },
  { 0x15200048, CODE_FOR_vec_permv4sf },
  { 0x15200049, CODE_FOR_vec_permv2df },
  { 0x1520004a, CODE_FOR_vec_permv8sf },
  { 0x1520004b, CODE_FOR_vec_permv4df },
  { 0x15400032, CODE_FOR_vec_setv16qi },
  { 0x15400033, CODE_FOR_vec_setv8hi },
  { 0x15400034, CODE_FOR_vec_setv4si },
  { 0x15400035, CODE_FOR_vec_setv2di },
  { 0x15400039, CODE_FOR_vec_setv8si },
  { 0x1540003a, CODE_FOR_vec_setv4di },
  { 0x15400048, CODE_FOR_vec_setv4sf },
  { 0x15400049, CODE_FOR_vec_setv2df },
  { 0x1540004a, CODE_FOR_vec_setv8sf },
  { 0x1540004b, CODE_FOR_vec_setv4df },
  { 0x15700048, CODE_FOR_vec_unpack_sfix_trunc_hi_v4sf },
  { 0x1570004a, CODE_FOR_vec_unpack_sfix_trunc_hi_v8sf },
  { 0x15800048, CODE_FOR_vec_unpack_sfix_trunc_lo_v4sf },
  { 0x1580004a, CODE_FOR_vec_unpack_sfix_trunc_lo_v8sf },
  { 0x15b00034, CODE_FOR_vec_unpacks_float_hi_v4si },
  { 0x15b00039, CODE_FOR_vec_unpacks_float_hi_v8si },
  { 0x15c00034, CODE_FOR_vec_unpacks_float_lo_v4si },
  { 0x15c00039, CODE_FOR_vec_unpacks_float_lo_v8si },
  { 0x15d00032, CODE_FOR_vec_unpacks_hi_v16qi },
  { 0x15d00033, CODE_FOR_vec_unpacks_hi_v8hi },
  { 0x15d00034, CODE_FOR_vec_unpacks_hi_v4si },
  { 0x15d00037, CODE_FOR_vec_unpacks_hi_v32qi },
  { 0x15d00038, CODE_FOR_vec_unpacks_hi_v16hi },
  { 0x15d00039, CODE_FOR_vec_unpacks_hi_v8si },
  { 0x15d00048, CODE_FOR_vec_unpacks_hi_v4sf },
  { 0x15d0004a, CODE_FOR_vec_unpacks_hi_v8sf },
  { 0x15e00032, CODE_FOR_vec_unpacks_lo_v16qi },
  { 0x15e00033, CODE_FOR_vec_unpacks_lo_v8hi },
  { 0x15e00034, CODE_FOR_vec_unpacks_lo_v4si },
  { 0x15e00037, CODE_FOR_vec_unpacks_lo_v32qi },
  { 0x15e00038, CODE_FOR_vec_unpacks_lo_v16hi },
  { 0x15e00039, CODE_FOR_vec_unpacks_lo_v8si },
  { 0x15e00048, CODE_FOR_vec_unpacks_lo_v4sf },
  { 0x15e0004a, CODE_FOR_vec_unpacks_lo_v8sf },
  { 0x16300032, CODE_FOR_vec_unpacku_hi_v16qi },
  { 0x16300033, CODE_FOR_vec_unpacku_hi_v8hi },
  { 0x16300034, CODE_FOR_vec_unpacku_hi_v4si },
  { 0x16300037, CODE_FOR_vec_unpacku_hi_v32qi },
  { 0x16300038, CODE_FOR_vec_unpacku_hi_v16hi },
  { 0x16300039, CODE_FOR_vec_unpacku_hi_v8si },
  { 0x16400032, CODE_FOR_vec_unpacku_lo_v16qi },
  { 0x16400033, CODE_FOR_vec_unpacku_lo_v8hi },
  { 0x16400034, CODE_FOR_vec_unpacku_lo_v4si },
  { 0x16400037, CODE_FOR_vec_unpacku_lo_v32qi },
  { 0x16400038, CODE_FOR_vec_unpacku_lo_v16hi },
  { 0x16400039, CODE_FOR_vec_unpacku_lo_v8si },
  { 0x16500032, CODE_FOR_vec_widen_smult_even_v16qi },
  { 0x16500033, CODE_FOR_vec_widen_smult_even_v8hi },
  { 0x16500034, CODE_FOR_vec_widen_smult_even_v4si },
  { 0x16500035, CODE_FOR_vec_widen_smult_even_v2di },
  { 0x16500037, CODE_FOR_vec_widen_smult_even_v32qi },
  { 0x16500038, CODE_FOR_vec_widen_smult_even_v16hi },
  { 0x16500039, CODE_FOR_vec_widen_smult_even_v8si },
  { 0x1650003a, CODE_FOR_vec_widen_smult_even_v4di },
  { 0x16600037, CODE_FOR_vec_widen_smult_hi_v32qi },
  { 0x16600038, CODE_FOR_vec_widen_smult_hi_v16hi },
  { 0x16700037, CODE_FOR_vec_widen_smult_lo_v32qi },
  { 0x16700038, CODE_FOR_vec_widen_smult_lo_v16hi },
  { 0x16800032, CODE_FOR_vec_widen_smult_odd_v16qi },
  { 0x16800033, CODE_FOR_vec_widen_smult_odd_v8hi },
  { 0x16800034, CODE_FOR_vec_widen_smult_odd_v4si },
  { 0x16800035, CODE_FOR_vec_widen_smult_odd_v2di },
  { 0x16800037, CODE_FOR_vec_widen_smult_odd_v32qi },
  { 0x16800038, CODE_FOR_vec_widen_smult_odd_v16hi },
  { 0x16800039, CODE_FOR_vec_widen_smult_odd_v8si },
  { 0x1680003a, CODE_FOR_vec_widen_smult_odd_v4di },
  { 0x16a00037, CODE_FOR_vec_widen_ssub_hi_v32qi },
  { 0x16a00038, CODE_FOR_vec_widen_ssub_hi_v16hi },
  { 0x16b00037, CODE_FOR_vec_widen_ssub_lo_v32qi },
  { 0x16b00038, CODE_FOR_vec_widen_ssub_lo_v16hi },
  { 0x16f00037, CODE_FOR_vec_widen_sadd_hi_v32qi },
  { 0x16f00038, CODE_FOR_vec_widen_sadd_hi_v16hi },
  { 0x17000037, CODE_FOR_vec_widen_sadd_lo_v32qi },
  { 0x17000038, CODE_FOR_vec_widen_sadd_lo_v16hi },
  { 0x17a00032, CODE_FOR_vec_widen_umult_even_v16qi },
  { 0x17a00033, CODE_FOR_vec_widen_umult_even_v8hi },
  { 0x17a00034, CODE_FOR_vec_widen_umult_even_v4si },
  { 0x17a00035, CODE_FOR_vec_widen_umult_even_v2di },
  { 0x17a00037, CODE_FOR_vec_widen_umult_even_v32qi },
  { 0x17a00038, CODE_FOR_vec_widen_umult_even_v16hi },
  { 0x17a00039, CODE_FOR_vec_widen_umult_even_v8si },
  { 0x17a0003a, CODE_FOR_vec_widen_umult_even_v4di },
  { 0x17b00037, CODE_FOR_vec_widen_umult_hi_v32qi },
  { 0x17b00038, CODE_FOR_vec_widen_umult_hi_v16hi },
  { 0x17c00037, CODE_FOR_vec_widen_umult_lo_v32qi },
  { 0x17c00038, CODE_FOR_vec_widen_umult_lo_v16hi },
  { 0x17d00032, CODE_FOR_vec_widen_umult_odd_v16qi },
  { 0x17d00033, CODE_FOR_vec_widen_umult_odd_v8hi },
  { 0x17d00034, CODE_FOR_vec_widen_umult_odd_v4si },
  { 0x17d00035, CODE_FOR_vec_widen_umult_odd_v2di },
  { 0x17d00037, CODE_FOR_vec_widen_umult_odd_v32qi },
  { 0x17d00038, CODE_FOR_vec_widen_umult_odd_v16hi },
  { 0x17d00039, CODE_FOR_vec_widen_umult_odd_v8si },
  { 0x17d0003a, CODE_FOR_vec_widen_umult_odd_v4di },
  { 0x18100037, CODE_FOR_vec_widen_usub_hi_v32qi },
  { 0x18100038, CODE_FOR_vec_widen_usub_hi_v16hi },
  { 0x18200037, CODE_FOR_vec_widen_usub_lo_v32qi },
  { 0x18200038, CODE_FOR_vec_widen_usub_lo_v16hi },
  { 0x18600037, CODE_FOR_vec_widen_uadd_hi_v32qi },
  { 0x18600038, CODE_FOR_vec_widen_uadd_hi_v16hi },
  { 0x18700037, CODE_FOR_vec_widen_uadd_lo_v32qi },
  { 0x18700038, CODE_FOR_vec_widen_uadd_lo_v16hi },
  { 0x19a00005, CODE_FOR_atomic_addqi },
  { 0x19a00006, CODE_FOR_atomic_addhi },
  { 0x19a00007, CODE_FOR_atomic_addsi },
  { 0x19a00008, CODE_FOR_atomic_adddi },
  { 0x19c00007, CODE_FOR_atomic_andsi },
  { 0x19c00008, CODE_FOR_atomic_anddi },
  { 0x1a000005, CODE_FOR_atomic_compare_and_swapqi },
  { 0x1a000006, CODE_FOR_atomic_compare_and_swaphi },
  { 0x1a000007, CODE_FOR_atomic_compare_and_swapsi },
  { 0x1a000008, CODE_FOR_atomic_compare_and_swapdi },
  { 0x1a100005, CODE_FOR_atomic_exchangeqi },
  { 0x1a100006, CODE_FOR_atomic_exchangehi },
  { 0x1a100007, CODE_FOR_atomic_exchangesi },
  { 0x1a100008, CODE_FOR_atomic_exchangedi },
  { 0x1a200005, CODE_FOR_atomic_fetch_addqi },
  { 0x1a200006, CODE_FOR_atomic_fetch_addhi },
  { 0x1a200007, CODE_FOR_atomic_fetch_addsi },
  { 0x1a200008, CODE_FOR_atomic_fetch_adddi },
  { 0x1a300005, CODE_FOR_atomic_fetch_andqi },
  { 0x1a300006, CODE_FOR_atomic_fetch_andhi },
  { 0x1a300007, CODE_FOR_atomic_fetch_andsi },
  { 0x1a300008, CODE_FOR_atomic_fetch_anddi },
  { 0x1a400005, CODE_FOR_atomic_fetch_nandqi },
  { 0x1a400006, CODE_FOR_atomic_fetch_nandhi },
  { 0x1a500005, CODE_FOR_atomic_fetch_orqi },
  { 0x1a500006, CODE_FOR_atomic_fetch_orhi },
  { 0x1a500007, CODE_FOR_atomic_fetch_orsi },
  { 0x1a500008, CODE_FOR_atomic_fetch_ordi },
  { 0x1a600005, CODE_FOR_atomic_fetch_subqi },
  { 0x1a600006, CODE_FOR_atomic_fetch_subhi },
  { 0x1a700005, CODE_FOR_atomic_fetch_xorqi },
  { 0x1a700006, CODE_FOR_atomic_fetch_xorhi },
  { 0x1a700007, CODE_FOR_atomic_fetch_xorsi },
  { 0x1a700008, CODE_FOR_atomic_fetch_xordi },
  { 0x1a800005, CODE_FOR_atomic_loadqi },
  { 0x1a800006, CODE_FOR_atomic_loadhi },
  { 0x1a800007, CODE_FOR_atomic_loadsi },
  { 0x1a800008, CODE_FOR_atomic_loaddi },
  { 0x1ac00007, CODE_FOR_atomic_orsi },
  { 0x1ac00008, CODE_FOR_atomic_ordi },
  { 0x1ad00005, CODE_FOR_atomic_storeqi },
  { 0x1ad00006, CODE_FOR_atomic_storehi },
  { 0x1ad00007, CODE_FOR_atomic_storesi },
  { 0x1ad00008, CODE_FOR_atomic_storedi },
  { 0x1b100007, CODE_FOR_atomic_xorsi },
  { 0x1b100008, CODE_FOR_atomic_xordi },
  { 0x1b700007, CODE_FOR_get_thread_pointersi },
  { 0x1b700008, CODE_FOR_get_thread_pointerdi },
  { 0x1c300007, CODE_FOR_andnsi3 },
  { 0x1c300008, CODE_FOR_andndi3 },
  { 0x1c300032, CODE_FOR_andnv16qi3 },
  { 0x1c300033, CODE_FOR_andnv8hi3 },
  { 0x1c300034, CODE_FOR_andnv4si3 },
  { 0x1c300035, CODE_FOR_andnv2di3 },
  { 0x1c300037, CODE_FOR_andnv32qi3 },
  { 0x1c300038, CODE_FOR_andnv16hi3 },
  { 0x1c300039, CODE_FOR_andnv8si3 },
  { 0x1c30003a, CODE_FOR_andnv4di3 },
  { 0x1c300048, CODE_FOR_andnv4sf3 },
  { 0x1c300049, CODE_FOR_andnv2df3 },
  { 0x1c30004a, CODE_FOR_andnv8sf3 },
  { 0x1c30004b, CODE_FOR_andnv4df3 },
  { 0x1c400007, CODE_FOR_iornsi3 },
  { 0x1c400008, CODE_FOR_iorndi3 },
  { 0x1c400032, CODE_FOR_iornv16qi3 },
  { 0x1c400033, CODE_FOR_iornv8hi3 },
  { 0x1c400034, CODE_FOR_iornv4si3 },
  { 0x1c400035, CODE_FOR_iornv2di3 },
  { 0x1c400037, CODE_FOR_iornv32qi3 },
  { 0x1c400038, CODE_FOR_iornv16hi3 },
  { 0x1c400039, CODE_FOR_iornv8si3 },
  { 0x1c40003a, CODE_FOR_iornv4di3 },
};

static void
init_optabs_00 (struct target_optabs *optabs)
{
  bool *ena = optabs->pat_enable;
  ena[0] = HAVE_extendqihi2;
  ena[1] = HAVE_extendqisi2;
  ena[2] = HAVE_extendqidi2;
  ena[3] = HAVE_extendhisi2;
  ena[4] = HAVE_extendhidi2;
  ena[5] = HAVE_extendsidi2;
  ena[6] = HAVE_extendsfdf2;
  ena[7] = HAVE_truncdfsf2;
  ena[8] = HAVE_zero_extendqihi2;
  ena[9] = HAVE_zero_extendqisi2;
  ena[10] = HAVE_zero_extendqidi2;
  ena[11] = HAVE_zero_extendhisi2;
  ena[12] = HAVE_zero_extendhidi2;
  ena[13] = HAVE_zero_extendsidi2;
  ena[14] = HAVE_floatsisf2;
  ena[15] = HAVE_floatsidf2;
  ena[16] = HAVE_floatdisf2;
  ena[17] = HAVE_floatdidf2;
  ena[18] = HAVE_floatv4siv4sf2;
  ena[19] = HAVE_floatv2div2df2;
  ena[20] = HAVE_floatv8siv8sf2;
  ena[21] = HAVE_floatv4div4df2;
  ena[22] = HAVE_floatunsv4siv4sf2;
  ena[23] = HAVE_floatunsv2div2df2;
  ena[24] = HAVE_floatunsv8siv8sf2;
  ena[25] = HAVE_floatunsv4div4df2;
  ena[26] = HAVE_lrintsfsi2;
  ena[27] = HAVE_lrintsfdi2;
  ena[28] = HAVE_lrintdfsi2;
  ena[29] = HAVE_lrintdfdi2;
  ena[30] = HAVE_lrintv4sfv4si2;
  ena[31] = HAVE_lrintv2dfv2di2;
  ena[32] = HAVE_lrintv8sfv8si2;
  ena[33] = HAVE_lrintv4dfv4di2;
  ena[34] = HAVE_lfloorsfsi2;
  ena[35] = HAVE_lfloorsfdi2;
  ena[36] = HAVE_lfloordfsi2;
  ena[37] = HAVE_lfloordfdi2;
  ena[38] = HAVE_lfloorv4sfv4si2;
  ena[39] = HAVE_lfloorv2dfv2di2;
  ena[40] = HAVE_lfloorv8sfv8si2;
  ena[41] = HAVE_lfloorv4dfv4di2;
  ena[42] = HAVE_lceilsfsi2;
  ena[43] = HAVE_lceilsfdi2;
  ena[44] = HAVE_lceildfsi2;
  ena[45] = HAVE_lceildfdi2;
  ena[46] = HAVE_lceilv4sfv4si2;
  ena[47] = HAVE_lceilv2dfv2di2;
  ena[48] = HAVE_lceilv8sfv8si2;
  ena[49] = HAVE_lceilv4dfv4di2;
  ena[50] = HAVE_fix_truncsfsi2;
  ena[51] = HAVE_fix_truncsfdi2;
  ena[52] = HAVE_fix_truncdfsi2;
  ena[53] = HAVE_fix_truncdfdi2;
  ena[54] = HAVE_fix_truncv4sfv4si2;
  ena[55] = HAVE_fix_truncv2dfv2di2;
  ena[56] = HAVE_fix_truncv8sfv8si2;
  ena[57] = HAVE_fix_truncv4dfv4di2;
  ena[58] = HAVE_fixuns_truncsfsi2;
  ena[59] = HAVE_fixuns_truncsfdi2;
  ena[60] = HAVE_fixuns_truncdfsi2;
  ena[61] = HAVE_fixuns_truncdfdi2;
  ena[62] = HAVE_fixuns_truncv4sfv4si2;
  ena[63] = HAVE_fixuns_truncv2dfv2di2;
  ena[64] = HAVE_fixuns_truncv8sfv8si2;
  ena[65] = HAVE_fixuns_truncv4dfv4di2;
  ena[66] = HAVE_mulsidi3;
  ena[67] = HAVE_mulditi3;
  ena[68] = HAVE_umulsidi3;
  ena[69] = HAVE_umulditi3;
  ena[70] = HAVE_crc_revqisi4;
  ena[71] = HAVE_crc_revhisi4;
  ena[72] = HAVE_crc_revsisi4;
  ena[73] = HAVE_vcond_mask_v16qiv16qi;
  ena[74] = HAVE_vcond_mask_v8hiv8hi;
  ena[75] = HAVE_vcond_mask_v4siv4si;
  ena[76] = HAVE_vcond_mask_v4sfv4si;
  ena[77] = HAVE_vcond_mask_v2div2di;
  ena[78] = HAVE_vcond_mask_v2dfv2di;
  ena[79] = HAVE_vcond_mask_v32qiv32qi;
  ena[80] = HAVE_vcond_mask_v16hiv16hi;
  ena[81] = HAVE_vcond_mask_v8siv8si;
  ena[82] = HAVE_vcond_mask_v8sfv8si;
  ena[83] = HAVE_vcond_mask_v4div4di;
  ena[84] = HAVE_vcond_mask_v4dfv4di;
  ena[85] = HAVE_vec_cmpv16qiv16qi;
  ena[86] = HAVE_vec_cmpv8hiv8hi;
  ena[87] = HAVE_vec_cmpv4siv4si;
  ena[88] = HAVE_vec_cmpv4sfv4si;
  ena[89] = HAVE_vec_cmpv2div2di;
  ena[90] = HAVE_vec_cmpv2dfv2di;
  ena[91] = HAVE_vec_cmpv32qiv32qi;
  ena[92] = HAVE_vec_cmpv16hiv16hi;
  ena[93] = HAVE_vec_cmpv8siv8si;
  ena[94] = HAVE_vec_cmpv8sfv8si;
  ena[95] = HAVE_vec_cmpv4div4di;
  ena[96] = HAVE_vec_cmpv4dfv4di;
  ena[97] = HAVE_vec_cmpuv16qiv16qi;
  ena[98] = HAVE_vec_cmpuv8hiv8hi;
  ena[99] = HAVE_vec_cmpuv4siv4si;
  ena[100] = HAVE_vec_cmpuv2div2di;
  ena[101] = HAVE_vec_cmpuv32qiv32qi;
  ena[102] = HAVE_vec_cmpuv16hiv16hi;
  ena[103] = HAVE_vec_cmpuv8siv8si;
  ena[104] = HAVE_vec_cmpuv4div4di;
  ena[105] = HAVE_vec_extractv16qiqi;
  ena[106] = HAVE_vec_extractv32qiqi;
  ena[107] = HAVE_vec_extractv8hihi;
  ena[108] = HAVE_vec_extractv16hihi;
  ena[109] = HAVE_vec_extractv4sisi;
  ena[110] = HAVE_vec_extractv8sisi;
  ena[111] = HAVE_vec_extractv2didi;
  ena[112] = HAVE_vec_extractv4didi;
  ena[113] = HAVE_vec_extractv4sfsf;
  ena[114] = HAVE_vec_extractv8sfsf;
  ena[115] = HAVE_vec_extractv2dfdf;
  ena[116] = HAVE_vec_extractv4dfdf;
  ena[117] = HAVE_vec_initv16qiqi;
  ena[118] = HAVE_vec_initv32qiqi;
  ena[119] = HAVE_vec_initv8hihi;
  ena[120] = HAVE_vec_initv16hihi;
  ena[121] = HAVE_vec_initv4sisi;
  ena[122] = HAVE_vec_initv8sisi;
  ena[123] = HAVE_vec_initv2didi;
  ena[124] = HAVE_vec_initv4didi;
  ena[125] = HAVE_vec_initv4sfsf;
  ena[126] = HAVE_vec_initv8sfsf;
  ena[127] = HAVE_vec_initv2dfdf;
  ena[128] = HAVE_vec_initv4dfdf;
  ena[129] = HAVE_vec_initv32qiv16qi;
  ena[130] = HAVE_vec_initv16hiv8hi;
  ena[131] = HAVE_vec_initv8siv4si;
  ena[132] = HAVE_vec_initv4div2di;
  ena[133] = HAVE_vec_initv8sfv4sf;
  ena[134] = HAVE_vec_initv4dfv2df;
  ena[135] = HAVE_sdot_prodv8hiv16qi;
  ena[136] = HAVE_sdot_prodv4siv8hi;
  ena[137] = HAVE_sdot_prodv2div4si;
  ena[138] = HAVE_sdot_prodv1tiv2di;
  ena[139] = HAVE_sdot_prodv16hiv32qi;
  ena[140] = HAVE_sdot_prodv8siv16hi;
  ena[141] = HAVE_sdot_prodv4div8si;
  ena[142] = HAVE_sdot_prodv2tiv4di;
  ena[143] = HAVE_udot_prodv8hiv16qi;
  ena[144] = HAVE_udot_prodv4siv8hi;
  ena[145] = HAVE_udot_prodv2div4si;
  ena[146] = HAVE_udot_prodv1tiv2di;
  ena[147] = HAVE_udot_prodv16hiv32qi;
  ena[148] = HAVE_udot_prodv8siv16hi;
  ena[149] = HAVE_udot_prodv4div8si;
  ena[150] = HAVE_udot_prodv2tiv4di;
  ena[151] = HAVE_addsi3;
  ena[152] = HAVE_adddi3;
  ena[153] = HAVE_addsf3;
  ena[154] = HAVE_adddf3;
  ena[155] = HAVE_addv16qi3;
  ena[156] = HAVE_addv8hi3;
  ena[157] = HAVE_addv4si3;
  ena[158] = HAVE_addv2di3;
  ena[159] = HAVE_addv32qi3;
  ena[160] = HAVE_addv16hi3;
  ena[161] = HAVE_addv8si3;
  ena[162] = HAVE_addv4di3;
  ena[163] = HAVE_addv4sf3;
  ena[164] = HAVE_addv2df3;
  ena[165] = HAVE_addv8sf3;
  ena[166] = HAVE_addv4df3;
  ena[167] = HAVE_ssaddv16qi3;
  ena[168] = HAVE_ssaddv8hi3;
  ena[169] = HAVE_ssaddv4si3;
  ena[170] = HAVE_ssaddv2di3;
  ena[171] = HAVE_ssaddv32qi3;
  ena[172] = HAVE_ssaddv16hi3;
  ena[173] = HAVE_ssaddv8si3;
  ena[174] = HAVE_ssaddv4di3;
  ena[175] = HAVE_usaddv16qi3;
  ena[176] = HAVE_usaddv8hi3;
  ena[177] = HAVE_usaddv4si3;
  ena[178] = HAVE_usaddv2di3;
  ena[179] = HAVE_usaddv32qi3;
  ena[180] = HAVE_usaddv16hi3;
  ena[181] = HAVE_usaddv8si3;
  ena[182] = HAVE_usaddv4di3;
  ena[183] = HAVE_subsi3;
  ena[184] = HAVE_subdi3;
  ena[185] = HAVE_subsf3;
  ena[186] = HAVE_subdf3;
  ena[187] = HAVE_subv16qi3;
  ena[188] = HAVE_subv8hi3;
  ena[189] = HAVE_subv4si3;
  ena[190] = HAVE_subv2di3;
  ena[191] = HAVE_subv32qi3;
  ena[192] = HAVE_subv16hi3;
  ena[193] = HAVE_subv8si3;
  ena[194] = HAVE_subv4di3;
  ena[195] = HAVE_subv4sf3;
  ena[196] = HAVE_subv2df3;
  ena[197] = HAVE_subv8sf3;
  ena[198] = HAVE_subv4df3;
  ena[199] = HAVE_mulsi3;
  ena[200] = HAVE_muldi3;
  ena[201] = HAVE_mulsf3;
  ena[202] = HAVE_muldf3;
  ena[203] = HAVE_mulv16qi3;
  ena[204] = HAVE_mulv8hi3;
  ena[205] = HAVE_mulv4si3;
  ena[206] = HAVE_mulv2di3;
  ena[207] = HAVE_mulv32qi3;
  ena[208] = HAVE_mulv16hi3;
  ena[209] = HAVE_mulv8si3;
  ena[210] = HAVE_mulv4di3;
  ena[211] = HAVE_mulv4sf3;
  ena[212] = HAVE_mulv2df3;
  ena[213] = HAVE_mulv8sf3;
  ena[214] = HAVE_mulv4df3;
  ena[215] = HAVE_divsi3;
  ena[216] = HAVE_divdi3;
  ena[217] = HAVE_divsf3;
  ena[218] = HAVE_divdf3;
  ena[219] = HAVE_divv16qi3;
  ena[220] = HAVE_divv8hi3;
  ena[221] = HAVE_divv4si3;
  ena[222] = HAVE_divv2di3;
  ena[223] = HAVE_divv32qi3;
  ena[224] = HAVE_divv16hi3;
  ena[225] = HAVE_divv8si3;
  ena[226] = HAVE_divv4di3;
  ena[227] = HAVE_divv4sf3;
  ena[228] = HAVE_divv2df3;
  ena[229] = HAVE_divv8sf3;
  ena[230] = HAVE_divv4df3;
  ena[231] = HAVE_udivsi3;
  ena[232] = HAVE_udivdi3;
  ena[233] = HAVE_udivv16qi3;
  ena[234] = HAVE_udivv8hi3;
  ena[235] = HAVE_udivv4si3;
  ena[236] = HAVE_udivv2di3;
  ena[237] = HAVE_udivv32qi3;
  ena[238] = HAVE_udivv16hi3;
  ena[239] = HAVE_udivv8si3;
  ena[240] = HAVE_udivv4di3;
  ena[241] = HAVE_modsi3;
  ena[242] = HAVE_moddi3;
  ena[243] = HAVE_modv16qi3;
  ena[244] = HAVE_modv8hi3;
  ena[245] = HAVE_modv4si3;
  ena[246] = HAVE_modv2di3;
  ena[247] = HAVE_modv32qi3;
  ena[248] = HAVE_modv16hi3;
  ena[249] = HAVE_modv8si3;
  ena[250] = HAVE_modv4di3;
  ena[251] = HAVE_umodsi3;
  ena[252] = HAVE_umoddi3;
  ena[253] = HAVE_umodv16qi3;
  ena[254] = HAVE_umodv8hi3;
  ena[255] = HAVE_umodv4si3;
  ena[256] = HAVE_umodv2di3;
  ena[257] = HAVE_umodv32qi3;
  ena[258] = HAVE_umodv16hi3;
  ena[259] = HAVE_umodv8si3;
  ena[260] = HAVE_umodv4di3;
  ena[261] = HAVE_ftruncv4sf2;
  ena[262] = HAVE_ftruncv2df2;
  ena[263] = HAVE_ftruncv8sf2;
  ena[264] = HAVE_ftruncv4df2;
  ena[265] = HAVE_andsi3;
  ena[266] = HAVE_anddi3;
  ena[267] = HAVE_andv16qi3;
  ena[268] = HAVE_andv8hi3;
  ena[269] = HAVE_andv4si3;
  ena[270] = HAVE_andv2di3;
  ena[271] = HAVE_andv32qi3;
  ena[272] = HAVE_andv16hi3;
  ena[273] = HAVE_andv8si3;
  ena[274] = HAVE_andv4di3;
  ena[275] = HAVE_andv4sf3;
  ena[276] = HAVE_andv2df3;
  ena[277] = HAVE_andv8sf3;
  ena[278] = HAVE_andv4df3;
  ena[279] = HAVE_iorsi3;
  ena[280] = HAVE_iordi3;
  ena[281] = HAVE_iorv16qi3;
  ena[282] = HAVE_iorv8hi3;
  ena[283] = HAVE_iorv4si3;
  ena[284] = HAVE_iorv2di3;
  ena[285] = HAVE_iorv32qi3;
  ena[286] = HAVE_iorv16hi3;
  ena[287] = HAVE_iorv8si3;
  ena[288] = HAVE_iorv4di3;
  ena[289] = HAVE_iorv4sf3;
  ena[290] = HAVE_iorv2df3;
  ena[291] = HAVE_iorv8sf3;
  ena[292] = HAVE_iorv4df3;
  ena[293] = HAVE_xorsi3;
  ena[294] = HAVE_xordi3;
  ena[295] = HAVE_xorv16qi3;
  ena[296] = HAVE_xorv8hi3;
  ena[297] = HAVE_xorv4si3;
  ena[298] = HAVE_xorv2di3;
  ena[299] = HAVE_xorv32qi3;
  ena[300] = HAVE_xorv16hi3;
  ena[301] = HAVE_xorv8si3;
  ena[302] = HAVE_xorv4di3;
  ena[303] = HAVE_xorv4sf3;
  ena[304] = HAVE_xorv2df3;
  ena[305] = HAVE_xorv8sf3;
  ena[306] = HAVE_xorv4df3;
  ena[307] = HAVE_ashlsi3;
  ena[308] = HAVE_ashldi3;
  ena[309] = HAVE_ashlv16qi3;
  ena[310] = HAVE_ashlv8hi3;
  ena[311] = HAVE_ashlv4si3;
  ena[312] = HAVE_ashlv2di3;
  ena[313] = HAVE_ashlv32qi3;
  ena[314] = HAVE_ashlv16hi3;
  ena[315] = HAVE_ashlv8si3;
  ena[316] = HAVE_ashlv4di3;
  ena[317] = HAVE_ashrsi3;
  ena[318] = HAVE_ashrdi3;
  ena[319] = HAVE_ashrv16qi3;
  ena[320] = HAVE_ashrv8hi3;
  ena[321] = HAVE_ashrv4si3;
  ena[322] = HAVE_ashrv2di3;
  ena[323] = HAVE_ashrv32qi3;
  ena[324] = HAVE_ashrv16hi3;
  ena[325] = HAVE_ashrv8si3;
  ena[326] = HAVE_ashrv4di3;
  ena[327] = HAVE_lshrsi3;
  ena[328] = HAVE_lshrdi3;
  ena[329] = HAVE_lshrv16qi3;
  ena[330] = HAVE_lshrv8hi3;
  ena[331] = HAVE_lshrv4si3;
  ena[332] = HAVE_lshrv2di3;
  ena[333] = HAVE_lshrv32qi3;
  ena[334] = HAVE_lshrv16hi3;
  ena[335] = HAVE_lshrv8si3;
  ena[336] = HAVE_lshrv4di3;
  ena[337] = HAVE_rotlsi3;
  ena[338] = HAVE_rotldi3;
  ena[339] = HAVE_rotlv16qi3;
  ena[340] = HAVE_rotlv8hi3;
  ena[341] = HAVE_rotlv4si3;
  ena[342] = HAVE_rotlv2di3;
  ena[343] = HAVE_rotlv32qi3;
  ena[344] = HAVE_rotlv16hi3;
  ena[345] = HAVE_rotlv8si3;
  ena[346] = HAVE_rotlv4di3;
  ena[347] = HAVE_rotrsi3;
  ena[348] = HAVE_rotrdi3;
  ena[349] = HAVE_rotrv16qi3;
  ena[350] = HAVE_rotrv8hi3;
  ena[351] = HAVE_rotrv4si3;
  ena[352] = HAVE_rotrv2di3;
  ena[353] = HAVE_rotrv32qi3;
  ena[354] = HAVE_rotrv16hi3;
  ena[355] = HAVE_rotrv8si3;
  ena[356] = HAVE_rotrv4di3;
  ena[357] = HAVE_vashlv16qi3;
  ena[358] = HAVE_vashlv8hi3;
  ena[359] = HAVE_vashlv4si3;
  ena[360] = HAVE_vashlv2di3;
  ena[361] = HAVE_vashlv32qi3;
  ena[362] = HAVE_vashlv16hi3;
  ena[363] = HAVE_vashlv8si3;
  ena[364] = HAVE_vashlv4di3;
  ena[365] = HAVE_vashrv16qi3;
  ena[366] = HAVE_vashrv8hi3;
  ena[367] = HAVE_vashrv4si3;
  ena[368] = HAVE_vashrv2di3;
  ena[369] = HAVE_vashrv32qi3;
  ena[370] = HAVE_vashrv16hi3;
  ena[371] = HAVE_vashrv8si3;
  ena[372] = HAVE_vashrv4di3;
  ena[373] = HAVE_vlshrv16qi3;
  ena[374] = HAVE_vlshrv8hi3;
  ena[375] = HAVE_vlshrv4si3;
  ena[376] = HAVE_vlshrv2di3;
  ena[377] = HAVE_vlshrv32qi3;
  ena[378] = HAVE_vlshrv16hi3;
  ena[379] = HAVE_vlshrv8si3;
  ena[380] = HAVE_vlshrv4di3;
  ena[381] = HAVE_vrotlv16qi3;
  ena[382] = HAVE_vrotlv8hi3;
  ena[383] = HAVE_vrotlv4si3;
  ena[384] = HAVE_vrotlv2di3;
  ena[385] = HAVE_vrotlv32qi3;
  ena[386] = HAVE_vrotlv16hi3;
  ena[387] = HAVE_vrotlv8si3;
  ena[388] = HAVE_vrotlv4di3;
  ena[389] = HAVE_vrotrv16qi3;
  ena[390] = HAVE_vrotrv8hi3;
  ena[391] = HAVE_vrotrv4si3;
  ena[392] = HAVE_vrotrv2di3;
  ena[393] = HAVE_vrotrv32qi3;
  ena[394] = HAVE_vrotrv16hi3;
  ena[395] = HAVE_vrotrv8si3;
  ena[396] = HAVE_vrotrv4di3;
  ena[397] = HAVE_sminsf3;
  ena[398] = HAVE_smindf3;
  ena[399] = HAVE_sminv16qi3;
  ena[400] = HAVE_sminv8hi3;
  ena[401] = HAVE_sminv4si3;
  ena[402] = HAVE_sminv2di3;
  ena[403] = HAVE_sminv32qi3;
  ena[404] = HAVE_sminv16hi3;
  ena[405] = HAVE_sminv8si3;
  ena[406] = HAVE_sminv4di3;
  ena[407] = HAVE_sminv4sf3;
  ena[408] = HAVE_sminv2df3;
  ena[409] = HAVE_sminv8sf3;
  ena[410] = HAVE_sminv4df3;
  ena[411] = HAVE_smaxsf3;
  ena[412] = HAVE_smaxdf3;
  ena[413] = HAVE_smaxv16qi3;
  ena[414] = HAVE_smaxv8hi3;
  ena[415] = HAVE_smaxv4si3;
  ena[416] = HAVE_smaxv2di3;
  ena[417] = HAVE_smaxv32qi3;
  ena[418] = HAVE_smaxv16hi3;
  ena[419] = HAVE_smaxv8si3;
  ena[420] = HAVE_smaxv4di3;
  ena[421] = HAVE_smaxv4sf3;
  ena[422] = HAVE_smaxv2df3;
  ena[423] = HAVE_smaxv8sf3;
  ena[424] = HAVE_smaxv4df3;
  ena[425] = HAVE_uminv16qi3;
  ena[426] = HAVE_uminv8hi3;
  ena[427] = HAVE_uminv4si3;
  ena[428] = HAVE_uminv2di3;
  ena[429] = HAVE_uminv32qi3;
  ena[430] = HAVE_uminv16hi3;
  ena[431] = HAVE_uminv8si3;
  ena[432] = HAVE_uminv4di3;
  ena[433] = HAVE_umaxv16qi3;
  ena[434] = HAVE_umaxv8hi3;
  ena[435] = HAVE_umaxv4si3;
  ena[436] = HAVE_umaxv2di3;
  ena[437] = HAVE_umaxv32qi3;
  ena[438] = HAVE_umaxv16hi3;
  ena[439] = HAVE_umaxv8si3;
  ena[440] = HAVE_umaxv4di3;
  ena[441] = HAVE_negsi2;
  ena[442] = HAVE_negdi2;
  ena[443] = HAVE_negsf2;
  ena[444] = HAVE_negdf2;
  ena[445] = HAVE_negv16qi2;
  ena[446] = HAVE_negv8hi2;
  ena[447] = HAVE_negv4si2;
  ena[448] = HAVE_negv2di2;
  ena[449] = HAVE_negv32qi2;
  ena[450] = HAVE_negv16hi2;
  ena[451] = HAVE_negv8si2;
  ena[452] = HAVE_negv4di2;
  ena[453] = HAVE_negv4sf2;
  ena[454] = HAVE_negv2df2;
  ena[455] = HAVE_negv8sf2;
  ena[456] = HAVE_negv4df2;
  ena[457] = HAVE_abssf2;
  ena[458] = HAVE_absdf2;
  ena[459] = HAVE_absv16qi2;
  ena[460] = HAVE_absv8hi2;
  ena[461] = HAVE_absv4si2;
  ena[462] = HAVE_absv2di2;
  ena[463] = HAVE_absv32qi2;
  ena[464] = HAVE_absv16hi2;
  ena[465] = HAVE_absv8si2;
  ena[466] = HAVE_absv4di2;
  ena[467] = HAVE_absv4sf2;
  ena[468] = HAVE_absv2df2;
  ena[469] = HAVE_absv8sf2;
  ena[470] = HAVE_absv4df2;
  ena[471] = HAVE_one_cmplsi2;
  ena[472] = HAVE_one_cmpldi2;
  ena[473] = HAVE_one_cmplv16qi2;
  ena[474] = HAVE_one_cmplv8hi2;
  ena[475] = HAVE_one_cmplv4si2;
  ena[476] = HAVE_one_cmplv2di2;
  ena[477] = HAVE_one_cmplv32qi2;
  ena[478] = HAVE_one_cmplv16hi2;
  ena[479] = HAVE_one_cmplv8si2;
  ena[480] = HAVE_one_cmplv4di2;
  ena[481] = HAVE_bswaphi2;
  ena[482] = HAVE_bswapsi2;
  ena[483] = HAVE_bswapdi2;
  ena[484] = HAVE_clzsi2;
  ena[485] = HAVE_clzdi2;
  ena[486] = HAVE_clzv16qi2;
  ena[487] = HAVE_clzv8hi2;
  ena[488] = HAVE_clzv4si2;
  ena[489] = HAVE_clzv2di2;
  ena[490] = HAVE_clzv32qi2;
  ena[491] = HAVE_clzv16hi2;
  ena[492] = HAVE_clzv8si2;
  ena[493] = HAVE_clzv4di2;
  ena[494] = HAVE_ctzsi2;
  ena[495] = HAVE_ctzdi2;
  ena[496] = HAVE_popcountsi2;
  ena[497] = HAVE_popcountdi2;
  ena[498] = HAVE_popcountv16qi2;
  ena[499] = HAVE_popcountv8hi2;
  ena[500] = HAVE_popcountv4si2;
  ena[501] = HAVE_popcountv2di2;
  ena[502] = HAVE_popcountv32qi2;
  ena[503] = HAVE_popcountv16hi2;
  ena[504] = HAVE_popcountv8si2;
  ena[505] = HAVE_popcountv4di2;
  ena[506] = HAVE_sqrtsf2;
  ena[507] = HAVE_sqrtdf2;
  ena[508] = HAVE_sqrtv4sf2;
  ena[509] = HAVE_sqrtv2df2;
  ena[510] = HAVE_sqrtv8sf2;
  ena[511] = HAVE_sqrtv4df2;
  ena[512] = HAVE_movfcc;
  ena[513] = HAVE_movqi;
  ena[514] = HAVE_movhi;
  ena[515] = HAVE_movsi;
  ena[516] = HAVE_movdi;
  ena[517] = HAVE_movsf;
  ena[518] = HAVE_movdf;
  ena[519] = HAVE_movv16qi;
  ena[520] = HAVE_movv8hi;
  ena[521] = HAVE_movv4si;
  ena[522] = HAVE_movv2di;
  ena[523] = HAVE_movv1ti;
  ena[524] = HAVE_movv32qi;
  ena[525] = HAVE_movv16hi;
  ena[526] = HAVE_movv8si;
  ena[527] = HAVE_movv4di;
  ena[528] = HAVE_movv2ti;
  ena[529] = HAVE_movv4sf;
  ena[530] = HAVE_movv2df;
  ena[531] = HAVE_movv8sf;
  ena[532] = HAVE_movv4df;
  ena[533] = HAVE_movmisalignv16qi;
  ena[534] = HAVE_movmisalignv8hi;
  ena[535] = HAVE_movmisalignv4si;
  ena[536] = HAVE_movmisalignv2di;
  ena[537] = HAVE_movmisalignv1ti;
  ena[538] = HAVE_movmisalignv32qi;
  ena[539] = HAVE_movmisalignv16hi;
  ena[540] = HAVE_movmisalignv8si;
  ena[541] = HAVE_movmisalignv4di;
  ena[542] = HAVE_movmisalignv2ti;
  ena[543] = HAVE_movmisalignv4sf;
  ena[544] = HAVE_movmisalignv2df;
  ena[545] = HAVE_movmisalignv8sf;
  ena[546] = HAVE_movmisalignv4df;
  ena[547] = HAVE_insvsi;
  ena[548] = HAVE_insvdi;
  ena[549] = HAVE_extzvsi;
  ena[550] = HAVE_extzvdi;
  ena[551] = HAVE_cbranchqi4;
  ena[552] = HAVE_cbranchsi4;
  ena[553] = HAVE_cbranchdi4;
  ena[554] = HAVE_cbranchsf4;
  ena[555] = HAVE_cbranchdf4;
  ena[556] = HAVE_cbranchv16qi4;
  ena[557] = HAVE_cbranchv8hi4;
  ena[558] = HAVE_cbranchv4si4;
  ena[559] = HAVE_cbranchv2di4;
  ena[560] = HAVE_cbranchv32qi4;
  ena[561] = HAVE_cbranchv16hi4;
  ena[562] = HAVE_cbranchv8si4;
  ena[563] = HAVE_cbranchv4di4;
  ena[564] = HAVE_movsicc;
  ena[565] = HAVE_movdicc;
  ena[566] = HAVE_movsfcc;
  ena[567] = HAVE_movdfcc;
  ena[568] = HAVE_cstoresi4;
  ena[569] = HAVE_cstoredi4;
  ena[570] = HAVE_cstoresf4;
  ena[571] = HAVE_cstoredf4;
  ena[572] = HAVE_smulsi3_highpart;
  ena[573] = HAVE_smuldi3_highpart;
  ena[574] = HAVE_smulv16qi3_highpart;
  ena[575] = HAVE_smulv8hi3_highpart;
  ena[576] = HAVE_smulv4si3_highpart;
  ena[577] = HAVE_smulv2di3_highpart;
  ena[578] = HAVE_smulv32qi3_highpart;
  ena[579] = HAVE_smulv16hi3_highpart;
  ena[580] = HAVE_smulv8si3_highpart;
  ena[581] = HAVE_smulv4di3_highpart;
  ena[582] = HAVE_umulsi3_highpart;
  ena[583] = HAVE_umuldi3_highpart;
  ena[584] = HAVE_umulv16qi3_highpart;
  ena[585] = HAVE_umulv8hi3_highpart;
  ena[586] = HAVE_umulv4si3_highpart;
  ena[587] = HAVE_umulv2di3_highpart;
  ena[588] = HAVE_umulv32qi3_highpart;
  ena[589] = HAVE_umulv16hi3_highpart;
  ena[590] = HAVE_umulv8si3_highpart;
  ena[591] = HAVE_umulv4di3_highpart;
  ena[592] = HAVE_cpymemsi;
  ena[593] = HAVE_fmasf4;
  ena[594] = HAVE_fmadf4;
  ena[595] = HAVE_fmav4sf4;
  ena[596] = HAVE_fmav2df4;
  ena[597] = HAVE_fmav8sf4;
  ena[598] = HAVE_fmav4df4;
  ena[599] = HAVE_fmssf4;
  ena[600] = HAVE_fmsdf4;
  ena[601] = HAVE_fmsv4sf4;
  ena[602] = HAVE_fmsv2df4;
  ena[603] = HAVE_fmsv8sf4;
  ena[604] = HAVE_fmsv4df4;
  ena[605] = HAVE_fnmasf4;
  ena[606] = HAVE_fnmadf4;
  ena[607] = HAVE_fnmav4sf4;
  ena[608] = HAVE_fnmav2df4;
  ena[609] = HAVE_fnmav8sf4;
  ena[610] = HAVE_fnmav4df4;
  ena[611] = HAVE_fnmssf4;
  ena[612] = HAVE_fnmsdf4;
  ena[613] = HAVE_rintsf2;
  ena[614] = HAVE_rintdf2;
  ena[615] = HAVE_rintv4sf2;
  ena[616] = HAVE_rintv2df2;
  ena[617] = HAVE_rintv8sf2;
  ena[618] = HAVE_rintv4df2;
  ena[619] = HAVE_roundevensf2;
  ena[620] = HAVE_roundevendf2;
  ena[621] = HAVE_roundevenv4sf2;
  ena[622] = HAVE_roundevenv2df2;
  ena[623] = HAVE_roundevenv8sf2;
  ena[624] = HAVE_roundevenv4df2;
  ena[625] = HAVE_floorsf2;
  ena[626] = HAVE_floordf2;
  ena[627] = HAVE_floorv4sf2;
  ena[628] = HAVE_floorv2df2;
  ena[629] = HAVE_floorv8sf2;
  ena[630] = HAVE_floorv4df2;
  ena[631] = HAVE_ceilsf2;
  ena[632] = HAVE_ceildf2;
  ena[633] = HAVE_ceilv4sf2;
  ena[634] = HAVE_ceilv2df2;
  ena[635] = HAVE_ceilv8sf2;
  ena[636] = HAVE_ceilv4df2;
  ena[637] = HAVE_btruncsf2;
  ena[638] = HAVE_btruncdf2;
  ena[639] = HAVE_btruncv4sf2;
  ena[640] = HAVE_btruncv2df2;
  ena[641] = HAVE_btruncv8sf2;
  ena[642] = HAVE_btruncv4df2;
  ena[643] = HAVE_copysignsf3;
  ena[644] = HAVE_copysigndf3;
  ena[645] = HAVE_copysignv4sf3;
  ena[646] = HAVE_copysignv2df3;
  ena[647] = HAVE_copysignv8sf3;
  ena[648] = HAVE_copysignv4df3;
  ena[649] = HAVE_xorsignsf3;
  ena[650] = HAVE_xorsigndf3;
  ena[651] = HAVE_xorsignv4sf3;
  ena[652] = HAVE_xorsignv2df3;
  ena[653] = HAVE_xorsignv8sf3;
  ena[654] = HAVE_xorsignv4df3;
  ena[655] = HAVE_isinfsf2;
  ena[656] = HAVE_isinfdf2;
  ena[657] = HAVE_isfinitesf2;
  ena[658] = HAVE_isfinitedf2;
  ena[659] = HAVE_isnormalsf2;
  ena[660] = HAVE_isnormaldf2;
  ena[661] = HAVE_ldexpsf3;
  ena[662] = HAVE_ldexpdf3;
  ena[663] = HAVE_logbsf2;
  ena[664] = HAVE_logbdf2;
  ena[665] = HAVE_logbv4sf2;
  ena[666] = HAVE_logbv2df2;
  ena[667] = HAVE_logbv8sf2;
  ena[668] = HAVE_logbv4df2;
  ena[669] = HAVE_rsqrtsf2;
  ena[670] = HAVE_rsqrtdf2;
  ena[671] = HAVE_rsqrtv4sf2;
  ena[672] = HAVE_rsqrtv2df2;
  ena[673] = HAVE_rsqrtv8sf2;
  ena[674] = HAVE_rsqrtv4df2;
  ena[675] = HAVE_fmaxsf3;
  ena[676] = HAVE_fmaxdf3;
  ena[677] = HAVE_fmaxv4sf3;
  ena[678] = HAVE_fmaxv2df3;
  ena[679] = HAVE_fmaxv8sf3;
  ena[680] = HAVE_fmaxv4df3;
  ena[681] = HAVE_fminsf3;
  ena[682] = HAVE_fmindf3;
  ena[683] = HAVE_fminv4sf3;
  ena[684] = HAVE_fminv2df3;
  ena[685] = HAVE_fminv8sf3;
  ena[686] = HAVE_fminv4df3;
  ena[687] = HAVE_reduc_fmax_scal_v4sf;
  ena[688] = HAVE_reduc_fmax_scal_v2df;
  ena[689] = HAVE_reduc_fmax_scal_v8sf;
  ena[690] = HAVE_reduc_fmax_scal_v4df;
  ena[691] = HAVE_reduc_fmin_scal_v4sf;
  ena[692] = HAVE_reduc_fmin_scal_v2df;
  ena[693] = HAVE_reduc_fmin_scal_v8sf;
  ena[694] = HAVE_reduc_fmin_scal_v4df;
  ena[695] = HAVE_reduc_smax_scal_v16qi;
  ena[696] = HAVE_reduc_smax_scal_v8hi;
  ena[697] = HAVE_reduc_smax_scal_v4si;
  ena[698] = HAVE_reduc_smax_scal_v2di;
  ena[699] = HAVE_reduc_smax_scal_v32qi;
  ena[700] = HAVE_reduc_smax_scal_v16hi;
  ena[701] = HAVE_reduc_smax_scal_v8si;
  ena[702] = HAVE_reduc_smax_scal_v4di;
  ena[703] = HAVE_reduc_smax_scal_v4sf;
  ena[704] = HAVE_reduc_smax_scal_v2df;
  ena[705] = HAVE_reduc_smax_scal_v8sf;
  ena[706] = HAVE_reduc_smax_scal_v4df;
  ena[707] = HAVE_reduc_smin_scal_v16qi;
  ena[708] = HAVE_reduc_smin_scal_v8hi;
  ena[709] = HAVE_reduc_smin_scal_v4si;
  ena[710] = HAVE_reduc_smin_scal_v2di;
  ena[711] = HAVE_reduc_smin_scal_v32qi;
  ena[712] = HAVE_reduc_smin_scal_v16hi;
  ena[713] = HAVE_reduc_smin_scal_v8si;
  ena[714] = HAVE_reduc_smin_scal_v4di;
  ena[715] = HAVE_reduc_smin_scal_v4sf;
  ena[716] = HAVE_reduc_smin_scal_v2df;
  ena[717] = HAVE_reduc_smin_scal_v8sf;
  ena[718] = HAVE_reduc_smin_scal_v4df;
  ena[719] = HAVE_reduc_plus_scal_v4si;
  ena[720] = HAVE_reduc_plus_scal_v2di;
  ena[721] = HAVE_reduc_plus_scal_v8si;
  ena[722] = HAVE_reduc_plus_scal_v4di;
  ena[723] = HAVE_reduc_plus_scal_v4sf;
  ena[724] = HAVE_reduc_plus_scal_v2df;
  ena[725] = HAVE_reduc_plus_scal_v8sf;
  ena[726] = HAVE_reduc_plus_scal_v4df;
  ena[727] = HAVE_reduc_umax_scal_v16qi;
  ena[728] = HAVE_reduc_umax_scal_v8hi;
  ena[729] = HAVE_reduc_umax_scal_v4si;
  ena[730] = HAVE_reduc_umax_scal_v2di;
  ena[731] = HAVE_reduc_umax_scal_v32qi;
  ena[732] = HAVE_reduc_umax_scal_v16hi;
  ena[733] = HAVE_reduc_umax_scal_v8si;
  ena[734] = HAVE_reduc_umax_scal_v4di;
  ena[735] = HAVE_reduc_umin_scal_v16qi;
  ena[736] = HAVE_reduc_umin_scal_v8hi;
  ena[737] = HAVE_reduc_umin_scal_v4si;
  ena[738] = HAVE_reduc_umin_scal_v2di;
  ena[739] = HAVE_reduc_umin_scal_v32qi;
  ena[740] = HAVE_reduc_umin_scal_v16hi;
  ena[741] = HAVE_reduc_umin_scal_v8si;
  ena[742] = HAVE_reduc_umin_scal_v4di;
  ena[743] = HAVE_reduc_and_scal_v16qi;
  ena[744] = HAVE_reduc_and_scal_v8hi;
  ena[745] = HAVE_reduc_and_scal_v4si;
  ena[746] = HAVE_reduc_and_scal_v2di;
  ena[747] = HAVE_reduc_and_scal_v32qi;
  ena[748] = HAVE_reduc_and_scal_v16hi;
  ena[749] = HAVE_reduc_and_scal_v8si;
  ena[750] = HAVE_reduc_and_scal_v4di;
  ena[751] = HAVE_reduc_ior_scal_v16qi;
  ena[752] = HAVE_reduc_ior_scal_v8hi;
  ena[753] = HAVE_reduc_ior_scal_v4si;
  ena[754] = HAVE_reduc_ior_scal_v2di;
  ena[755] = HAVE_reduc_ior_scal_v32qi;
  ena[756] = HAVE_reduc_ior_scal_v16hi;
  ena[757] = HAVE_reduc_ior_scal_v8si;
  ena[758] = HAVE_reduc_ior_scal_v4di;
  ena[759] = HAVE_reduc_xor_scal_v16qi;
  ena[760] = HAVE_reduc_xor_scal_v8hi;
  ena[761] = HAVE_reduc_xor_scal_v4si;
  ena[762] = HAVE_reduc_xor_scal_v2di;
  ena[763] = HAVE_reduc_xor_scal_v32qi;
  ena[764] = HAVE_reduc_xor_scal_v16hi;
  ena[765] = HAVE_reduc_xor_scal_v8si;
  ena[766] = HAVE_reduc_xor_scal_v4di;
  ena[767] = HAVE_uabdv16qi3;
  ena[768] = HAVE_uabdv8hi3;
  ena[769] = HAVE_uabdv4si3;
  ena[770] = HAVE_uabdv2di3;
  ena[771] = HAVE_uabdv32qi3;
  ena[772] = HAVE_uabdv16hi3;
  ena[773] = HAVE_uabdv8si3;
  ena[774] = HAVE_uabdv4di3;
  ena[775] = HAVE_sabdv16qi3;
  ena[776] = HAVE_sabdv8hi3;
  ena[777] = HAVE_sabdv4si3;
  ena[778] = HAVE_sabdv2di3;
  ena[779] = HAVE_sabdv32qi3;
  ena[780] = HAVE_sabdv16hi3;
  ena[781] = HAVE_sabdv8si3;
  ena[782] = HAVE_sabdv4di3;
  ena[783] = HAVE_avgv16qi3_floor;
  ena[784] = HAVE_avgv8hi3_floor;
  ena[785] = HAVE_avgv4si3_floor;
  ena[786] = HAVE_avgv32qi3_floor;
  ena[787] = HAVE_avgv16hi3_floor;
  ena[788] = HAVE_avgv8si3_floor;
  ena[789] = HAVE_uavgv16qi3_floor;
  ena[790] = HAVE_uavgv8hi3_floor;
  ena[791] = HAVE_uavgv4si3_floor;
  ena[792] = HAVE_uavgv32qi3_floor;
  ena[793] = HAVE_uavgv16hi3_floor;
  ena[794] = HAVE_uavgv8si3_floor;
  ena[795] = HAVE_avgv16qi3_ceil;
  ena[796] = HAVE_avgv8hi3_ceil;
  ena[797] = HAVE_avgv4si3_ceil;
  ena[798] = HAVE_avgv32qi3_ceil;
  ena[799] = HAVE_avgv16hi3_ceil;
  ena[800] = HAVE_avgv8si3_ceil;
  ena[801] = HAVE_uavgv16qi3_ceil;
  ena[802] = HAVE_uavgv8hi3_ceil;
  ena[803] = HAVE_uavgv4si3_ceil;
  ena[804] = HAVE_uavgv32qi3_ceil;
  ena[805] = HAVE_uavgv16hi3_ceil;
  ena[806] = HAVE_uavgv8si3_ceil;
  ena[807] = HAVE_usadv16qi;
  ena[808] = HAVE_usadv32qi;
  ena[809] = HAVE_ssadv16qi;
  ena[810] = HAVE_ssadv32qi;
  ena[811] = HAVE_vec_pack_sfix_trunc_v2df;
  ena[812] = HAVE_vec_pack_sfix_trunc_v4df;
  ena[813] = HAVE_vec_pack_trunc_v8hi;
  ena[814] = HAVE_vec_pack_trunc_v4si;
  ena[815] = HAVE_vec_pack_trunc_v2di;
  ena[816] = HAVE_vec_pack_trunc_v16hi;
  ena[817] = HAVE_vec_pack_trunc_v8si;
  ena[818] = HAVE_vec_pack_trunc_v4di;
  ena[819] = HAVE_vec_pack_trunc_v2df;
  ena[820] = HAVE_vec_pack_trunc_v4df;
  ena[821] = HAVE_vec_packs_float_v2di;
  ena[822] = HAVE_vec_packs_float_v4di;
  ena[823] = HAVE_vec_permv16qi;
  ena[824] = HAVE_vec_permv8hi;
  ena[825] = HAVE_vec_permv4si;
  ena[826] = HAVE_vec_permv2di;
  ena[827] = HAVE_vec_permv32qi;
  ena[828] = HAVE_vec_permv16hi;
  ena[829] = HAVE_vec_permv8si;
  ena[830] = HAVE_vec_permv4di;
  ena[831] = HAVE_vec_permv4sf;
  ena[832] = HAVE_vec_permv2df;
  ena[833] = HAVE_vec_permv8sf;
  ena[834] = HAVE_vec_permv4df;
  ena[835] = HAVE_vec_setv16qi;
  ena[836] = HAVE_vec_setv8hi;
  ena[837] = HAVE_vec_setv4si;
  ena[838] = HAVE_vec_setv2di;
  ena[839] = HAVE_vec_setv8si;
  ena[840] = HAVE_vec_setv4di;
  ena[841] = HAVE_vec_setv4sf;
  ena[842] = HAVE_vec_setv2df;
  ena[843] = HAVE_vec_setv8sf;
  ena[844] = HAVE_vec_setv4df;
  ena[845] = HAVE_vec_unpack_sfix_trunc_hi_v4sf;
  ena[846] = HAVE_vec_unpack_sfix_trunc_hi_v8sf;
  ena[847] = HAVE_vec_unpack_sfix_trunc_lo_v4sf;
  ena[848] = HAVE_vec_unpack_sfix_trunc_lo_v8sf;
  ena[849] = HAVE_vec_unpacks_float_hi_v4si;
  ena[850] = HAVE_vec_unpacks_float_hi_v8si;
  ena[851] = HAVE_vec_unpacks_float_lo_v4si;
  ena[852] = HAVE_vec_unpacks_float_lo_v8si;
  ena[853] = HAVE_vec_unpacks_hi_v16qi;
  ena[854] = HAVE_vec_unpacks_hi_v8hi;
  ena[855] = HAVE_vec_unpacks_hi_v4si;
  ena[856] = HAVE_vec_unpacks_hi_v32qi;
  ena[857] = HAVE_vec_unpacks_hi_v16hi;
  ena[858] = HAVE_vec_unpacks_hi_v8si;
  ena[859] = HAVE_vec_unpacks_hi_v4sf;
  ena[860] = HAVE_vec_unpacks_hi_v8sf;
  ena[861] = HAVE_vec_unpacks_lo_v16qi;
  ena[862] = HAVE_vec_unpacks_lo_v8hi;
  ena[863] = HAVE_vec_unpacks_lo_v4si;
  ena[864] = HAVE_vec_unpacks_lo_v32qi;
  ena[865] = HAVE_vec_unpacks_lo_v16hi;
  ena[866] = HAVE_vec_unpacks_lo_v8si;
  ena[867] = HAVE_vec_unpacks_lo_v4sf;
  ena[868] = HAVE_vec_unpacks_lo_v8sf;
  ena[869] = HAVE_vec_unpacku_hi_v16qi;
  ena[870] = HAVE_vec_unpacku_hi_v8hi;
  ena[871] = HAVE_vec_unpacku_hi_v4si;
  ena[872] = HAVE_vec_unpacku_hi_v32qi;
  ena[873] = HAVE_vec_unpacku_hi_v16hi;
  ena[874] = HAVE_vec_unpacku_hi_v8si;
  ena[875] = HAVE_vec_unpacku_lo_v16qi;
  ena[876] = HAVE_vec_unpacku_lo_v8hi;
  ena[877] = HAVE_vec_unpacku_lo_v4si;
  ena[878] = HAVE_vec_unpacku_lo_v32qi;
  ena[879] = HAVE_vec_unpacku_lo_v16hi;
  ena[880] = HAVE_vec_unpacku_lo_v8si;
  ena[881] = HAVE_vec_widen_smult_even_v16qi;
  ena[882] = HAVE_vec_widen_smult_even_v8hi;
  ena[883] = HAVE_vec_widen_smult_even_v4si;
  ena[884] = HAVE_vec_widen_smult_even_v2di;
  ena[885] = HAVE_vec_widen_smult_even_v32qi;
  ena[886] = HAVE_vec_widen_smult_even_v16hi;
  ena[887] = HAVE_vec_widen_smult_even_v8si;
  ena[888] = HAVE_vec_widen_smult_even_v4di;
  ena[889] = HAVE_vec_widen_smult_hi_v32qi;
  ena[890] = HAVE_vec_widen_smult_hi_v16hi;
  ena[891] = HAVE_vec_widen_smult_lo_v32qi;
  ena[892] = HAVE_vec_widen_smult_lo_v16hi;
  ena[893] = HAVE_vec_widen_smult_odd_v16qi;
  ena[894] = HAVE_vec_widen_smult_odd_v8hi;
  ena[895] = HAVE_vec_widen_smult_odd_v4si;
  ena[896] = HAVE_vec_widen_smult_odd_v2di;
  ena[897] = HAVE_vec_widen_smult_odd_v32qi;
  ena[898] = HAVE_vec_widen_smult_odd_v16hi;
  ena[899] = HAVE_vec_widen_smult_odd_v8si;
  ena[900] = HAVE_vec_widen_smult_odd_v4di;
  ena[901] = HAVE_vec_widen_ssub_hi_v32qi;
  ena[902] = HAVE_vec_widen_ssub_hi_v16hi;
  ena[903] = HAVE_vec_widen_ssub_lo_v32qi;
  ena[904] = HAVE_vec_widen_ssub_lo_v16hi;
  ena[905] = HAVE_vec_widen_sadd_hi_v32qi;
  ena[906] = HAVE_vec_widen_sadd_hi_v16hi;
  ena[907] = HAVE_vec_widen_sadd_lo_v32qi;
  ena[908] = HAVE_vec_widen_sadd_lo_v16hi;
  ena[909] = HAVE_vec_widen_umult_even_v16qi;
  ena[910] = HAVE_vec_widen_umult_even_v8hi;
  ena[911] = HAVE_vec_widen_umult_even_v4si;
  ena[912] = HAVE_vec_widen_umult_even_v2di;
  ena[913] = HAVE_vec_widen_umult_even_v32qi;
  ena[914] = HAVE_vec_widen_umult_even_v16hi;
  ena[915] = HAVE_vec_widen_umult_even_v8si;
  ena[916] = HAVE_vec_widen_umult_even_v4di;
  ena[917] = HAVE_vec_widen_umult_hi_v32qi;
  ena[918] = HAVE_vec_widen_umult_hi_v16hi;
  ena[919] = HAVE_vec_widen_umult_lo_v32qi;
  ena[920] = HAVE_vec_widen_umult_lo_v16hi;
  ena[921] = HAVE_vec_widen_umult_odd_v16qi;
  ena[922] = HAVE_vec_widen_umult_odd_v8hi;
  ena[923] = HAVE_vec_widen_umult_odd_v4si;
  ena[924] = HAVE_vec_widen_umult_odd_v2di;
  ena[925] = HAVE_vec_widen_umult_odd_v32qi;
  ena[926] = HAVE_vec_widen_umult_odd_v16hi;
  ena[927] = HAVE_vec_widen_umult_odd_v8si;
  ena[928] = HAVE_vec_widen_umult_odd_v4di;
  ena[929] = HAVE_vec_widen_usub_hi_v32qi;
  ena[930] = HAVE_vec_widen_usub_hi_v16hi;
  ena[931] = HAVE_vec_widen_usub_lo_v32qi;
  ena[932] = HAVE_vec_widen_usub_lo_v16hi;
  ena[933] = HAVE_vec_widen_uadd_hi_v32qi;
  ena[934] = HAVE_vec_widen_uadd_hi_v16hi;
  ena[935] = HAVE_vec_widen_uadd_lo_v32qi;
  ena[936] = HAVE_vec_widen_uadd_lo_v16hi;
  ena[937] = HAVE_atomic_addqi;
  ena[938] = HAVE_atomic_addhi;
  ena[939] = HAVE_atomic_addsi;
  ena[940] = HAVE_atomic_adddi;
  ena[941] = HAVE_atomic_andsi;
  ena[942] = HAVE_atomic_anddi;
  ena[943] = HAVE_atomic_compare_and_swapqi;
  ena[944] = HAVE_atomic_compare_and_swaphi;
  ena[945] = HAVE_atomic_compare_and_swapsi;
  ena[946] = HAVE_atomic_compare_and_swapdi;
  ena[947] = HAVE_atomic_exchangeqi;
  ena[948] = HAVE_atomic_exchangehi;
  ena[949] = HAVE_atomic_exchangesi;
  ena[950] = HAVE_atomic_exchangedi;
  ena[951] = HAVE_atomic_fetch_addqi;
  ena[952] = HAVE_atomic_fetch_addhi;
  ena[953] = HAVE_atomic_fetch_addsi;
  ena[954] = HAVE_atomic_fetch_adddi;
  ena[955] = HAVE_atomic_fetch_andqi;
  ena[956] = HAVE_atomic_fetch_andhi;
  ena[957] = HAVE_atomic_fetch_andsi;
  ena[958] = HAVE_atomic_fetch_anddi;
  ena[959] = HAVE_atomic_fetch_nandqi;
  ena[960] = HAVE_atomic_fetch_nandhi;
  ena[961] = HAVE_atomic_fetch_orqi;
  ena[962] = HAVE_atomic_fetch_orhi;
  ena[963] = HAVE_atomic_fetch_orsi;
  ena[964] = HAVE_atomic_fetch_ordi;
  ena[965] = HAVE_atomic_fetch_subqi;
  ena[966] = HAVE_atomic_fetch_subhi;
  ena[967] = HAVE_atomic_fetch_xorqi;
  ena[968] = HAVE_atomic_fetch_xorhi;
  ena[969] = HAVE_atomic_fetch_xorsi;
  ena[970] = HAVE_atomic_fetch_xordi;
  ena[971] = HAVE_atomic_loadqi;
  ena[972] = HAVE_atomic_loadhi;
  ena[973] = HAVE_atomic_loadsi;
  ena[974] = HAVE_atomic_loaddi;
  ena[975] = HAVE_atomic_orsi;
  ena[976] = HAVE_atomic_ordi;
  ena[977] = HAVE_atomic_storeqi;
  ena[978] = HAVE_atomic_storehi;
  ena[979] = HAVE_atomic_storesi;
  ena[980] = HAVE_atomic_storedi;
  ena[981] = HAVE_atomic_xorsi;
  ena[982] = HAVE_atomic_xordi;
  ena[983] = HAVE_get_thread_pointersi;
  ena[984] = HAVE_get_thread_pointerdi;
  ena[985] = HAVE_andnsi3;
  ena[986] = HAVE_andndi3;
  ena[987] = HAVE_andnv16qi3;
  ena[988] = HAVE_andnv8hi3;
  ena[989] = HAVE_andnv4si3;
  ena[990] = HAVE_andnv2di3;
  ena[991] = HAVE_andnv32qi3;
  ena[992] = HAVE_andnv16hi3;
  ena[993] = HAVE_andnv8si3;
  ena[994] = HAVE_andnv4di3;
  ena[995] = HAVE_andnv4sf3;
  ena[996] = HAVE_andnv2df3;
  ena[997] = HAVE_andnv8sf3;
  ena[998] = HAVE_andnv4df3;
  ena[999] = HAVE_iornsi3;
}

static void
init_optabs_01 (struct target_optabs *optabs)
{
  bool *ena = optabs->pat_enable;
  ena[1000] = HAVE_iorndi3;
  ena[1001] = HAVE_iornv16qi3;
  ena[1002] = HAVE_iornv8hi3;
  ena[1003] = HAVE_iornv4si3;
  ena[1004] = HAVE_iornv2di3;
  ena[1005] = HAVE_iornv32qi3;
  ena[1006] = HAVE_iornv16hi3;
  ena[1007] = HAVE_iornv8si3;
  ena[1008] = HAVE_iornv4di3;
}

void
init_all_optabs (struct target_optabs *optabs)
{
  init_optabs_00 (optabs);
  init_optabs_01 (optabs);
}

/* Returns TRUE if the target supports any of the partial vector
   optabs: while_ult_optab, len_load_optab, len_store_optab,
   mask_len_load_optab or mask_len_store_optab,
   for any mode.  */
bool
partial_vectors_supported_p (void)
{
	return false;
}
static int
lookup_handler (unsigned scode)
{
  int l = 0, h = ARRAY_SIZE (pats), m;
  while (h > l)
    {
      m = (h + l) / 2;
      if (scode == pats[m].scode)
        return m;
      else if (scode < pats[m].scode)
        h = m;
      else
        l = m + 1;
    }
  return -1;
}

enum insn_code
raw_optab_handler (unsigned scode)
{
  int i = lookup_handler (scode);
  return (i >= 0 && this_fn_optabs->pat_enable[i]
          ? pats[i].icode : CODE_FOR_nothing);
}

bool
swap_optab_enable (optab op, machine_mode m, bool set)
{
  unsigned scode = (op << 20) | m;
  int i = lookup_handler (scode);
  if (i >= 0)
    {
      bool ret = this_fn_optabs->pat_enable[i];
      this_fn_optabs->pat_enable[i] = set;
      return ret;
    }
  else
    {
      gcc_assert (!set);
      return false;
    }
}

const struct convert_optab_libcall_d convlib_def[NUM_CONVLIB_OPTABS] = {
  { "extend", gen_extend_conv_libfunc },
  { "trunc", gen_trunc_conv_libfunc },
  { NULL, NULL },
  { "fix", gen_fp_to_int_conv_libfunc },
  { "fixuns", gen_fp_to_int_conv_libfunc },
  { "float", gen_int_to_fp_conv_libfunc },
  { NULL, gen_ufloat_conv_libfunc },
  { "lrint", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lround", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lfloor", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lceil", gen_int_to_fp_nondecimal_conv_libfunc },
  { "fract", gen_fract_conv_libfunc },
  { "fractuns", gen_fractuns_conv_libfunc },
  { "satfract", gen_satfract_conv_libfunc },
  { "satfractuns", gen_satfractuns_conv_libfunc },
  { "ustrunc", NULL },
  { "sstrunc", NULL },
};

const struct optab_libcall_d normlib_def[NUM_NORMLIB_OPTABS] = {
  { '3', "add", gen_int_fp_fixed_libfunc },
  { '3', "add", gen_intv_fp_libfunc },
  { '3', "ssadd", gen_signed_fixed_libfunc },
  { '3', "usadd", gen_unsigned_fixed_libfunc },
  { '3', "sub", gen_int_fp_fixed_libfunc },
  { '3', "sub", gen_intv_fp_libfunc },
  { '3', "sssub", gen_signed_fixed_libfunc },
  { '3', "ussub", gen_unsigned_fixed_libfunc },
  { '3', "mul", gen_int_fp_fixed_libfunc },
  { '3', "mul", gen_intv_fp_libfunc },
  { '3', "ssmul", gen_signed_fixed_libfunc },
  { '3', "usmul", gen_unsigned_fixed_libfunc },
  { '3', "div", gen_int_fp_signed_fixed_libfunc },
  { '3', "divv", gen_int_libfunc },
  { '3', "ssdiv", gen_signed_fixed_libfunc },
  { '3', "udiv", gen_int_unsigned_fixed_libfunc },
  { '3', "usdiv", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "mod", gen_int_libfunc },
  { '3', "umod", gen_int_libfunc },
  { '2', "ftrunc", gen_fp_libfunc },
  { '3', "and", gen_int_libfunc },
  { '3', "ior", gen_int_libfunc },
  { '3', "xor", gen_int_libfunc },
  { '3', "ashl", gen_int_fixed_libfunc },
  { '3', "ssashl", gen_signed_fixed_libfunc },
  { '3', "usashl", gen_unsigned_fixed_libfunc },
  { '3', "ashr", gen_int_signed_fixed_libfunc },
  { '3', "lshr", gen_int_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "min", gen_int_fp_libfunc },
  { '3', "max", gen_int_fp_libfunc },
  { '3', "umin", gen_int_libfunc },
  { '3', "umax", gen_int_libfunc },
  { '2', "neg", gen_int_fp_fixed_libfunc },
  { '2', "neg", gen_intv_fp_libfunc },
  { '2', "ssneg", gen_signed_fixed_libfunc },
  { '2', "usneg", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '2', "one_cmpl", gen_int_libfunc },
  { '\0', NULL, NULL },
  { '2', "ffs", gen_int_libfunc },
  { '2', "clz", gen_int_libfunc },
  { '2', "ctz", gen_int_libfunc },
  { '2', "clrsb", gen_int_libfunc },
  { '2', "popcount", gen_int_libfunc },
  { '2', "parity", gen_int_libfunc },
  { '2', "cmp", gen_int_fp_fixed_libfunc },
  { '2', "ucmp", gen_int_libfunc },
  { '2', "eq", gen_fp_libfunc },
  { '2', "ne", gen_fp_libfunc },
  { '2', "gt", gen_fp_libfunc },
  { '2', "ge", gen_fp_libfunc },
  { '2', "lt", gen_fp_libfunc },
  { '2', "le", gen_fp_libfunc },
  { '2', "unord", gen_fp_libfunc },
  { '2', "powi", gen_fp_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
};

enum rtx_code const optab_to_code_[NUM_OPTABS] = {
  UNKNOWN,
  SIGN_EXTEND,
  TRUNCATE,
  ZERO_EXTEND,
  FIX,
  UNSIGNED_FIX,
  FLOAT,
  UNSIGNED_FLOAT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FRACT_CONVERT,
  UNSIGNED_FRACT_CONVERT,
  SAT_FRACT,
  UNSIGNED_SAT_FRACT,
  US_TRUNCATE,
  SS_TRUNCATE,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  PLUS,
  PLUS,
  SS_PLUS,
  US_PLUS,
  MINUS,
  MINUS,
  SS_MINUS,
  US_MINUS,
  MULT,
  MULT,
  SS_MULT,
  US_MULT,
  DIV,
  DIV,
  SS_DIV,
  UDIV,
  US_DIV,
  UNKNOWN,
  UNKNOWN,
  MOD,
  UMOD,
  UNKNOWN,
  AND,
  IOR,
  XOR,
  ASHIFT,
  SS_ASHIFT,
  US_ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  SMIN,
  SMAX,
  UMIN,
  UMAX,
  NEG,
  NEG,
  SS_NEG,
  US_NEG,
  ABS,
  ABS,
  NOT,
  BSWAP,
  FFS,
  CLZ,
  CTZ,
  CLRSB,
  POPCOUNT,
  PARITY,
  UNKNOWN,
  UNKNOWN,
  EQ,
  NE,
  GT,
  GE,
  LT,
  LE,
  UNORDERED,
  UNKNOWN,
  SQRT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  SET,
  STRICT_LOW_PART,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  COMPARE,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FMA,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  VEC_DUPLICATE,
  VEC_SERIES,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
};

const optab code_to_optab_[NUM_RTX_CODE] = {
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  mov_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  movstrict_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  cbranch_optab,
  add_optab,
  sub_optab,
  neg_optab,
  smul_optab,
  ssmul_optab,
  usmul_optab,
  unknown_optab,
  unknown_optab,
  sdiv_optab,
  ssdiv_optab,
  usdiv_optab,
  smod_optab,
  udiv_optab,
  umod_optab,
  and_optab,
  ior_optab,
  xor_optab,
  one_cmpl_optab,
  ashl_optab,
  rotl_optab,
  ashr_optab,
  lshr_optab,
  rotr_optab,
  smin_optab,
  smax_optab,
  umin_optab,
  umax_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  ne_optab,
  eq_optab,
  ge_optab,
  gt_optab,
  le_optab,
  lt_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unord_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  abs_optab,
  sqrt_optab,
  bswap_optab,
  ffs_optab,
  clrsb_optab,
  clz_optab,
  ctz_optab,
  popcount_optab,
  parity_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  vec_duplicate_optab,
  vec_series_optab,
  ssadd_optab,
  usadd_optab,
  sssub_optab,
  ssneg_optab,
  usneg_optab,
  unknown_optab,
  ssashl_optab,
  usashl_optab,
  ussub_optab,
  unknown_optab,
  unknown_optab,
  fma_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
};

