/* Generated automatically by the program `genextract'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "diagnostic-core.h"

/* This variable is used as the "location" of any missing operand
   whose numbers are skipped by a given pattern.  */
static rtx junk ATTRIBUTE_UNUSED;

void
insn_extract (rtx_insn *insn)
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED; /* only for peepholes */

  if (flag_checking)
    {
      memset (ro, 0xab, sizeof (*ro) * MAX_RECOG_OPERANDS);
      memset (ro_loc, 0xab, sizeof (*ro_loc) * MAX_RECOG_OPERANDS);
    }

  switch (INSN_CODE (insn))
    {
    default:
      /* Control reaches here if insn_extract has been called with an
         unrecognizable insn (code -1), or an insn whose INSN_CODE
         corresponds to a DEFINE_EXPAND in the machine description;
         either way, a bug.  */
      if (INSN_CODE (insn) < 0)
        fatal_insn ("unrecognizable insn:", insn);
      else
        fatal_insn ("insn with invalid code number:", insn);

    case 1765:  /* msa_bnz_v_b */
    case 1764:  /* msa_bz_v_b */
    case 1763:  /* msa_bnz_v_h */
    case 1762:  /* msa_bz_v_h */
    case 1761:  /* msa_bnz_v_w */
    case 1760:  /* msa_bz_v_w */
    case 1759:  /* msa_bnz_v_d */
    case 1758:  /* msa_bz_v_d */
    case 1757:  /* msa_bnz_v_w_f */
    case 1756:  /* msa_bz_v_w_f */
    case 1755:  /* msa_bnz_v_d_f */
    case 1754:  /* msa_bz_v_d_f */
    case 1753:  /* msa_bnz_b */
    case 1752:  /* msa_bz_b */
    case 1751:  /* msa_bnz_h */
    case 1750:  /* msa_bz_h */
    case 1749:  /* msa_bnz_w */
    case 1748:  /* msa_bz_w */
    case 1747:  /* msa_bnz_d */
    case 1746:  /* msa_bz_d */
    case 1745:  /* msa_bnz_w_f */
    case 1744:  /* msa_bz_w_f */
    case 1743:  /* msa_bnz_d_f */
    case 1742:  /* msa_bz_d_f */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 1581:  /* msa_hsub_u_d */
    case 1580:  /* msa_hsub_s_d */
    case 1579:  /* msa_hadd_u_d */
    case 1578:  /* msa_hadd_s_d */
    case 1577:  /* msa_hsub_u_w */
    case 1576:  /* msa_hsub_s_w */
    case 1575:  /* msa_hadd_u_w */
    case 1574:  /* msa_hadd_s_w */
    case 1573:  /* msa_hsub_u_h */
    case 1572:  /* msa_hsub_s_h */
    case 1571:  /* msa_hadd_u_h */
    case 1570:  /* msa_hadd_s_h */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      break;

    case 1481:  /* msa_dpsub_u_h */
    case 1480:  /* msa_dpsub_s_h */
    case 1479:  /* msa_dpsub_u_w */
    case 1478:  /* msa_dpsub_s_w */
    case 1477:  /* msa_dpsub_u_d */
    case 1476:  /* msa_dpsub_s_d */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 1), 0), 0), 0);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 1), 1), 0), 0);
      recog_data.dup_num[1] = 3;
      break;

    case 1475:  /* msa_dpadd_u_h */
    case 1474:  /* msa_dpadd_s_h */
    case 1473:  /* msa_dpadd_u_w */
    case 1472:  /* msa_dpadd_s_w */
    case 1471:  /* msa_dpadd_u_d */
    case 1470:  /* msa_dpadd_s_d */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0), 0), 0);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 1), 0), 0);
      recog_data.dup_num[1] = 3;
      break;

    case 1469:  /* msa_dotp_u_h */
    case 1468:  /* msa_dotp_s_h */
    case 1467:  /* msa_dotp_u_w */
    case 1466:  /* msa_dotp_s_w */
    case 1465:  /* msa_dotp_u_d */
    case 1464:  /* msa_dotp_s_d */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 1), 0), 0);
      recog_data.dup_num[1] = 2;
      break;

    case 1435:  /* msa_bsel_b */
    case 1434:  /* msa_bsel_h */
    case 1433:  /* msa_bsel_w */
    case 1432:  /* msa_bsel_d */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 1423:  /* msa_bmz_b */
    case 1422:  /* msa_bmz_h */
    case 1421:  /* msa_bmz_w */
    case 1420:  /* msa_bmz_d */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 1);
      recog_data.dup_num[0] = 3;
      break;

    case 1419:  /* msa_bmnz_b */
    case 1418:  /* msa_bmnz_h */
    case 1417:  /* msa_bmnz_w */
    case 1416:  /* msa_bmnz_d */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0);
      recog_data.dup_num[0] = 3;
      break;

    case 1731:  /* msa_splati_b */
    case 1730:  /* msa_splati_h */
    case 1729:  /* msa_splati_w */
    case 1728:  /* msa_splati_d */
    case 1727:  /* msa_splati_w_f */
    case 1726:  /* msa_splati_d_f */
    case 1255:  /* msa_copy_s_w_f_64bit */
    case 1254:  /* msa_copy_s_w_64bit */
    case 1253:  /* msa_copy_u_w */
    case 1252:  /* msa_copy_u_b */
    case 1251:  /* msa_copy_s_b */
    case 1250:  /* msa_copy_u_h */
    case 1249:  /* msa_copy_s_h */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 0));
      break;

    case 1246:  /* msa_insve_b */
    case 1245:  /* msa_insve_h */
    case 1244:  /* msa_insve_w */
    case 1243:  /* msa_insve_d */
    case 1242:  /* msa_insve_w_f */
    case 1241:  /* msa_insve_d_f */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 1132:  /* loongson_vec_init1_v8qi */
    case 1131:  /* loongson_vec_init1_v4hi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      break;

    case 1123:  /* jraddiusp */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 2), 1), 1));
      break;

    case 1120:  /* *load_word_multiple */
    case 1119:  /* *store_word_multiple */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 1118:  /* ssmsubsqdq4 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 2);
      recog_data.dup_num[0] = 3;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[2] = 1;
      break;

    case 1117:  /* ssmaddsqdq4 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 2);
      recog_data.dup_num[0] = 3;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[2] = 1;
      break;

    case 1116:  /* ssmulsq3 */
    case 1115:  /* ssmulhq3 */
    case 1114:  /* ssmulv2hq3 */
    case 1031:  /* mulv2hi3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[1] = 1;
      break;

    case 1018:  /* mips_bposge */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 992:  /* mips_wrdsp */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 5), 1), 0, 1);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 5), 1), 0, 0);
      recog_data.dup_num[1] = 0;
      recog_data.dup_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 4), 1), 0, 1);
      recog_data.dup_num[2] = 1;
      recog_data.dup_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 4), 1), 0, 0);
      recog_data.dup_num[3] = 0;
      recog_data.dup_loc[4] = &XVECEXP (XEXP (XVECEXP (pat, 0, 3), 1), 0, 1);
      recog_data.dup_num[4] = 1;
      recog_data.dup_loc[5] = &XVECEXP (XEXP (XVECEXP (pat, 0, 3), 1), 0, 0);
      recog_data.dup_num[5] = 0;
      recog_data.dup_loc[6] = &XVECEXP (XEXP (XVECEXP (pat, 0, 2), 1), 0, 1);
      recog_data.dup_num[6] = 1;
      recog_data.dup_loc[7] = &XVECEXP (XEXP (XVECEXP (pat, 0, 2), 1), 0, 0);
      recog_data.dup_num[7] = 0;
      recog_data.dup_loc[8] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1);
      recog_data.dup_num[8] = 1;
      recog_data.dup_loc[9] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[9] = 0;
      break;

    case 989:  /* mips_extpdp */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 2), 1), 0, 1);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 2), 1), 0, 0);
      recog_data.dup_num[1] = 1;
      recog_data.dup_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1);
      recog_data.dup_num[2] = 2;
      recog_data.dup_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[3] = 1;
      break;

    case 1061:  /* mips_dpsqx_sa_w_ph */
    case 1060:  /* mips_dpsqx_s_w_ph */
    case 1059:  /* mips_dpaqx_sa_w_ph */
    case 1058:  /* mips_dpaqx_s_w_ph */
    case 967:  /* mips_maq_sa_w_phr */
    case 966:  /* mips_maq_sa_w_phl */
    case 965:  /* mips_maq_s_w_phr */
    case 964:  /* mips_maq_s_w_phl */
    case 963:  /* mips_dpsq_sa_l_w */
    case 962:  /* mips_dpaq_sa_l_w */
    case 961:  /* mips_mulsaq_s_w_ph */
    case 960:  /* mips_dpsq_s_w_ph */
    case 959:  /* mips_dpaq_s_w_ph */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 2));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 2);
      recog_data.dup_num[0] = 3;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[2] = 1;
      break;

    case 1035:  /* mips_mulq_s_w */
    case 1034:  /* mips_mulq_s_ph */
    case 1033:  /* mips_mulq_rs_w */
    case 1032:  /* mips_mul_s_ph */
    case 954:  /* mips_muleq_s_w_phr */
    case 953:  /* mips_muleq_s_w_phl */
    case 952:  /* mips_mulq_rs_ph */
    case 951:  /* mips_muleu_s_ph_qbr */
    case 950:  /* mips_muleu_s_ph_qbl */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[1] = 1;
      break;

    case 1019:  /* mips_absq_s_qb */
    case 927:  /* mips_absq_s_ph */
    case 926:  /* mips_absq_s_w */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[0] = 1;
      break;

    case 1045:  /* mips_subu_s_ph */
    case 1044:  /* mips_subu_ph */
    case 1028:  /* mips_cmpgdu_le_qb */
    case 1027:  /* mips_cmpgdu_lt_qb */
    case 1026:  /* mips_cmpgdu_eq_qb */
    case 1021:  /* mips_addu_s_ph */
    case 991:  /* mips_mthlip */
    case 988:  /* mips_extp */
    case 987:  /* mips_extr_s_h */
    case 986:  /* mips_extr_rs_w */
    case 985:  /* mips_extr_r_w */
    case 984:  /* mips_extr_w */
    case 945:  /* mips_shll_s_ph */
    case 944:  /* mips_shll_s_w */
    case 943:  /* mips_shll_qb */
    case 942:  /* mips_shll_ph */
    case 931:  /* mips_precrqu_s_qb_ph */
    case 930:  /* mips_precrq_rs_ph_w */
    case 923:  /* mips_addwc */
    case 922:  /* mips_addsc */
    case 921:  /* mips_subu_s_qb */
    case 920:  /* mips_subq_s_ph */
    case 919:  /* mips_subq_s_w */
    case 916:  /* mips_addu_s_qb */
    case 915:  /* mips_addq_s_ph */
    case 914:  /* mips_addq_s_w */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[1] = 1;
      break;

    case 1113:  /* sssubv2ha3 */
    case 1112:  /* sssubv2hq3 */
    case 1111:  /* sssubsa3 */
    case 1110:  /* sssubha3 */
    case 1109:  /* sssubsq3 */
    case 1108:  /* sssubhq3 */
    case 1107:  /* ussubv2uha3 */
    case 1106:  /* ussubv2uhq3 */
    case 1105:  /* ussubv4uqq3 */
    case 1104:  /* ussubuha3 */
    case 1103:  /* ussubuhq3 */
    case 1102:  /* ussubuqq3 */
    case 1087:  /* ssaddv2ha3 */
    case 1086:  /* ssaddv2hq3 */
    case 1085:  /* ssaddsa3 */
    case 1084:  /* ssaddha3 */
    case 1083:  /* ssaddsq3 */
    case 1082:  /* ssaddhq3 */
    case 1081:  /* usaddv2uha3 */
    case 1080:  /* usaddv2uhq3 */
    case 1079:  /* usaddv4uqq3 */
    case 1078:  /* usadduha3 */
    case 1077:  /* usadduhq3 */
    case 1076:  /* usadduqq3 */
    case 1020:  /* mips_addu_ph */
    case 918:  /* subv4qi3 */
    case 917:  /* subv2hi3 */
    case 913:  /* addv4qi3 */
    case 912:  /* addv2hi3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[1] = 1;
      break;

    case 899:  /* *branch_upper_lower_inverted */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0, 1));
      break;

    case 898:  /* *branch_upper_lower */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0, 1));
      break;

    case 897:  /* bc1any2f */
    case 896:  /* bc1any2t */
    case 895:  /* bc1any4f */
    case 894:  /* bc1any4t */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 877:  /* mips_cabs_cond_4s */
    case 876:  /* mips_c_cond_4s */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (pat, 1), 0, 2));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (pat, 1), 0, 3));
      ro[5] = *(ro_loc[5] = &XVECEXP (XEXP (pat, 1), 0, 4));
      break;

    case 1259:  /* msa_copy_s_d_f */
    case 1258:  /* msa_copy_s_d */
    case 1257:  /* msa_copy_s_w_f */
    case 1256:  /* msa_copy_s_w */
    case 867:  /* vec_extractv2sfsf */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      break;

    case 865:  /* vec_perm_const_ps */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 1));
      break;

    case 861:  /* atomic_fetch_adddi_ldadd */
    case 860:  /* atomic_fetch_addsi_ldadd */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 859:  /* atomic_fetch_adddi_llsc */
    case 858:  /* atomic_fetch_addsi_llsc */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XVECEXP (pat, 0, 2), 0, 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 857:  /* atomic_exchangedi_swap */
    case 856:  /* atomic_exchangesi_swap */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 855:  /* atomic_exchangedi_llsc */
    case 854:  /* atomic_exchangesi_llsc */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XVECEXP (pat, 0, 2), 0, 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 853:  /* atomic_compare_and_swapdi */
    case 852:  /* atomic_compare_and_swapsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XVECEXP (pat, 0, 2), 1), 0, 2));
      ro[5] = *(ro_loc[5] = &XVECEXP (XVECEXP (pat, 0, 3), 0, 0));
      ro[6] = *(ro_loc[6] = &XVECEXP (XVECEXP (pat, 0, 3), 0, 1));
      ro[7] = *(ro_loc[7] = &XVECEXP (XVECEXP (pat, 0, 3), 0, 2));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 2), 0);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 2), 1), 0, 1);
      recog_data.dup_num[1] = 3;
      recog_data.dup_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 2), 1), 0, 0);
      recog_data.dup_num[2] = 2;
      recog_data.dup_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[3] = 2;
      break;

    case 851:  /* test_and_set_12 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 2));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 850:  /* sync_lock_test_and_setdi */
    case 849:  /* sync_lock_test_and_setsi */
    case 848:  /* sync_new_nanddi */
    case 847:  /* sync_new_nandsi */
    case 846:  /* sync_old_nanddi */
    case 845:  /* sync_old_nandsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 842:  /* sync_new_anddi */
    case 841:  /* sync_new_xordi */
    case 840:  /* sync_new_iordi */
    case 839:  /* sync_new_andsi */
    case 838:  /* sync_new_xorsi */
    case 837:  /* sync_new_iorsi */
    case 836:  /* sync_old_anddi */
    case 835:  /* sync_old_xordi */
    case 834:  /* sync_old_iordi */
    case 833:  /* sync_old_andsi */
    case 832:  /* sync_old_xorsi */
    case 831:  /* sync_old_iorsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 1);
      recog_data.dup_num[1] = 1;
      break;

    case 830:  /* sync_anddi */
    case 829:  /* sync_xordi */
    case 828:  /* sync_iordi */
    case 827:  /* sync_andsi */
    case 826:  /* sync_xorsi */
    case 825:  /* sync_iorsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1);
      recog_data.dup_num[0] = 0;
      break;

    case 824:  /* sync_new_subdi */
    case 823:  /* sync_new_subsi */
    case 822:  /* sync_new_adddi */
    case 821:  /* sync_new_addsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 0);
      recog_data.dup_num[1] = 1;
      recog_data.dup_loc[2] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 1);
      recog_data.dup_num[2] = 2;
      break;

    case 820:  /* sync_old_subdi */
    case 819:  /* sync_old_subsi */
    case 818:  /* sync_old_adddi */
    case 817:  /* sync_old_addsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 814:  /* sync_new_nand_12 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 2));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 3));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 3);
      recog_data.dup_num[1] = 4;
      recog_data.dup_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 2);
      recog_data.dup_num[2] = 3;
      recog_data.dup_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1);
      recog_data.dup_num[3] = 2;
      recog_data.dup_loc[4] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[4] = 1;
      break;

    case 813:  /* sync_old_nand_12 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 2));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 2), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 812:  /* sync_nand_12 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 3));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 2);
      recog_data.dup_num[0] = 0;
      break;

    case 811:  /* sync_new_and_12 */
    case 810:  /* sync_new_xor_12 */
    case 809:  /* sync_new_ior_12 */
    case 808:  /* sync_new_sub_12 */
    case 807:  /* sync_new_add_12 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 2));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 3), 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 3);
      recog_data.dup_num[1] = 4;
      recog_data.dup_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 2);
      recog_data.dup_num[2] = 3;
      recog_data.dup_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1);
      recog_data.dup_num[3] = 2;
      recog_data.dup_loc[4] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[4] = 1;
      recog_data.dup_loc[5] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 3), 0);
      recog_data.dup_num[5] = 0;
      break;

    case 806:  /* sync_old_and_12 */
    case 805:  /* sync_old_xor_12 */
    case 804:  /* sync_old_ior_12 */
    case 803:  /* sync_old_sub_12 */
    case 802:  /* sync_old_add_12 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 2), 1));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 2), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 2), 0);
      recog_data.dup_num[1] = 0;
      break;

    case 801:  /* sync_and_12 */
    case 800:  /* sync_xor_12 */
    case 799:  /* sync_ior_12 */
    case 798:  /* sync_sub_12 */
    case 797:  /* sync_add_12 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 2), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 2), 0);
      recog_data.dup_num[0] = 0;
      break;

    case 816:  /* sync_subdi */
    case 815:  /* sync_subsi */
    case 796:  /* sync_adddi */
    case 795:  /* sync_addsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0);
      recog_data.dup_num[0] = 0;
      break;

    case 794:  /* compare_and_swap_12 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 2));
      ro[5] = *(ro_loc[5] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 3));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 793:  /* sync_compare_and_swapdi */
    case 792:  /* sync_compare_and_swapsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 791:  /* *memory_barrier */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0);
      recog_data.dup_num[0] = 0;
      break;

    case 1621:  /* msa_min_a_b */
    case 1620:  /* msa_min_a_h */
    case 1619:  /* msa_min_a_w */
    case 1618:  /* msa_min_a_d */
    case 1609:  /* msa_max_a_b */
    case 1608:  /* msa_max_a_h */
    case 1607:  /* msa_max_a_w */
    case 1606:  /* msa_max_a_d */
    case 1553:  /* msa_fmin_a_w */
    case 1552:  /* msa_fmin_a_d */
    case 1549:  /* msa_fmax_a_w */
    case 1548:  /* msa_fmax_a_d */
    case 786:  /* fmax_a_df */
    case 785:  /* fmax_a_sf */
    case 784:  /* fmin_a_df */
    case 783:  /* fmin_a_sf */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 1);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (pat, 1), 2);
      recog_data.dup_num[1] = 2;
      break;

    case 782:  /* fmaxdf3 */
    case 781:  /* fmaxsf3 */
    case 780:  /* fmindf3 */
    case 779:  /* fminsf3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0));
      break;

    case 774:  /* *join2_loadhi */
    case 773:  /* *join2_loadhi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0));
      break;

    case 1127:  /* *movepsfsf */
    case 1126:  /* *movepsfsi */
    case 1125:  /* *movepsisf */
    case 1124:  /* *movepsisi */
    case 1122:  /* *swp */
    case 1121:  /* *lwp */
    case 772:  /* *join2_load_storedf */
    case 771:  /* *join2_load_storesf */
    case 770:  /* *join2_load_storesi */
    case 769:  /* *join2_load_storehi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 1));
      break;

    case 768:  /* mips_set_fcsr_mips16_di */
    case 767:  /* mips_set_fcsr_mips16_si */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      break;

    case 765:  /* mips_get_fcsr_mips16_di */
    case 764:  /* mips_get_fcsr_mips16_si */
    case 762:  /* *tls_get_tp_mips16_call_di */
    case 761:  /* *tls_get_tp_mips16_call_si */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      break;

    case 760:  /* tls_get_tp_mips16_di */
    case 759:  /* tls_get_tp_mips16_si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      break;

    case 756:  /* tls_get_tp_di */
    case 755:  /* tls_get_tp_si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      break;

    case 754:  /* *mips16e_save_restore */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 1735:  /* msa_ctcmsa */
    case 751:  /* consttable_int */
    case 750:  /* consttable_tls_reloc */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (pat, 0, 1));
      break;

    case 863:  /* *movcc_v2sf_di */
    case 862:  /* *movcc_v2sf_si */
    case 737:  /* *movdf_on_cce */
    case 736:  /* *movsf_on_cce */
    case 735:  /* *movdf_on_cc */
    case 734:  /* *movsf_on_cc */
    case 733:  /* *movdf_on_di */
    case 732:  /* *movsf_on_di */
    case 731:  /* *movdf_on_si */
    case 730:  /* *movsf_on_si */
    case 721:  /* movdi_on_cce_mips16e2 */
    case 720:  /* movsi_on_cce_mips16e2 */
    case 719:  /* movdi_on_cc_mips16e2 */
    case 718:  /* movsi_on_cc_mips16e2 */
    case 717:  /* movdi_on_di_mips16e2 */
    case 716:  /* movsi_on_di_mips16e2 */
    case 715:  /* movdi_on_si_mips16e2 */
    case 714:  /* movsi_on_si_mips16e2 */
    case 713:  /* movdi_on_cce */
    case 712:  /* movsi_on_cce */
    case 711:  /* movdi_on_cc */
    case 710:  /* movsi_on_cc */
    case 709:  /* movdi_on_di */
    case 708:  /* movsi_on_di */
    case 707:  /* movdi_on_si */
    case 706:  /* movsi_on_si */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 702:  /* *prefetch_indexed_di */
    case 701:  /* *prefetch_indexed_si */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 1));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 2));
      break;

    case 700:  /* prefetch */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 2));
      break;

    case 697:  /* call_value_direct_split */
    case 696:  /* call_value_internal_direct */
    case 695:  /* call_value_split */
    case 694:  /* call_value_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 693:  /* call_direct_split */
    case 692:  /* call_internal_direct */
    case 691:  /* call_split */
    case 690:  /* call_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 699:  /* call_value_multiple_split */
    case 698:  /* call_value_multiple_internal */
    case 689:  /* sibcall_value_multiple_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 1148:  /* loongson_pandn_d */
    case 1147:  /* loongson_pandn_b */
    case 1146:  /* loongson_pandn_h */
    case 1145:  /* loongson_pandn_w */
    case 688:  /* sibcall_value_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 687:  /* sibcall_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 678:  /* eh_set_lr_di */
    case 677:  /* eh_set_lr_si */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 680:  /* restore_gp_di */
    case 679:  /* restore_gp_si */
    case 669:  /* simple_return_internal */
    case 668:  /* return_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 667:  /* mips_hb_return_internal */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 1), 0, 0));
      break;

    case 661:  /* casesi_internal_mips16_di */
    case 660:  /* casesi_internal_mips16_si */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 659:  /* tablejump_di */
    case 658:  /* tablejump_si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0));
      break;

    case 657:  /* indirect_jump_and_restore_di */
    case 656:  /* indirect_jump_and_restore_si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 1));
      break;

    case 653:  /* *jump_mips16 */
    case 652:  /* *jump_pic */
    case 651:  /* *jump_absolute */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 502:  /* *branch_bit1di_inverted */
    case 501:  /* *branch_bit0di_inverted */
    case 500:  /* *branch_bit1si_inverted */
    case 499:  /* *branch_bit0si_inverted */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 2));
      break;

    case 498:  /* *branch_bit1di */
    case 497:  /* *branch_bit0di */
    case 496:  /* *branch_bit1si */
    case 495:  /* *branch_bit0si */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 2));
      break;

    case 490:  /* *branch_equalitydi_inverted */
    case 489:  /* *branch_equalitysi_inverted */
    case 486:  /* *branch_orderdi_inverted */
    case 485:  /* *branch_ordersi_inverted */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 488:  /* *branch_equalitydi */
    case 487:  /* *branch_equalitysi */
    case 484:  /* *branch_orderdi */
    case 483:  /* *branch_ordersi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 494:  /* *branch_equalitydi_mips16_inverted */
    case 493:  /* *branch_equalitysi_mips16_inverted */
    case 482:  /* *branch_fp_inverted_ccf */
    case 481:  /* *branch_fp_inverted_cce */
    case 480:  /* *branch_fp_inverted_cc */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 492:  /* *branch_equalitydi_mips16 */
    case 491:  /* *branch_equalitysi_mips16 */
    case 479:  /* *branch_fp_ccf */
    case 478:  /* *branch_fp_cce */
    case 477:  /* *branch_fp_cc */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 977:  /* mips_cmpu_le_qb */
    case 976:  /* mips_cmp_le_ph */
    case 975:  /* mips_cmpu_lt_qb */
    case 974:  /* mips_cmp_lt_ph */
    case 973:  /* mips_cmpu_eq_qb */
    case 972:  /* mips_cmp_eq_ph */
    case 449:  /* mips_cache */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 766:  /* *mips_set_fcsr */
    case 753:  /* align */
    case 752:  /* consttable_float */
    case 749:  /* consttable_end */
    case 748:  /* consttable */
    case 444:  /* synci */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      break;

    case 655:  /* indirect_jump_di */
    case 654:  /* indirect_jump_si */
    case 442:  /* use_cprestore_di */
    case 441:  /* use_cprestore_si */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      break;

    case 438:  /* potential_cprestore_di */
    case 437:  /* potential_cprestore_si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 370:  /* *lwxs */
    case 369:  /* *lwxs */
    case 368:  /* *lwxs */
    case 367:  /* *lwxs */
    case 366:  /* *lwxs */
    case 365:  /* *lwxs */
    case 364:  /* *lwxs */
    case 363:  /* *lwxs */
    case 362:  /* *lwxs */
    case 361:  /* *lwxs */
    case 360:  /* *lwxs */
    case 359:  /* *lwxs */
    case 358:  /* *lwxs */
    case 357:  /* *lwxs */
    case 356:  /* *lwxs */
    case 355:  /* *lwxs */
    case 354:  /* *lwxs */
    case 353:  /* *lwxs */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 352:  /* *sdxc1_di */
    case 351:  /* *sdxc1_di */
    case 350:  /* *swxc1_di */
    case 349:  /* *sdxc1_si */
    case 348:  /* *sdxc1_si */
    case 347:  /* *swxc1_si */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 0), 0), 1));
      break;

    case 763:  /* *mips_get_fcsr */
    case 446:  /* rdhwr_synci_step_di */
    case 445:  /* rdhwr_synci_step_si */
    case 318:  /* *movdi_ra */
    case 317:  /* *movsi_ra */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      break;

    case 314:  /* *lowsi_mips16_gp */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 1273:  /* movv16qi_msa */
    case 1272:  /* movv8hi_msa */
    case 1271:  /* movv4si_msa */
    case 1270:  /* movv2di_msa */
    case 1269:  /* movv4sf_msa */
    case 1268:  /* movv2df_msa */
    case 1130:  /* movv8qi_internal */
    case 1129:  /* movv4hi_internal */
    case 1128:  /* movv2si_internal */
    case 386:  /* *movv2sf */
    case 385:  /* *movtf_mips16 */
    case 384:  /* *movtf */
    case 383:  /* *movti_mips16 */
    case 382:  /* *movti */
    case 381:  /* *movdf_mips16 */
    case 380:  /* *movdf_softfloat */
    case 379:  /* *movdf_hardfloat */
    case 378:  /* *movsf_mips16 */
    case 377:  /* *movsf_softfloat */
    case 376:  /* *movsf_hardfloat */
    case 375:  /* movccf */
    case 374:  /* *movqi_mips16 */
    case 373:  /* *movqi_internal */
    case 372:  /* *movhi_mips16 */
    case 371:  /* *movhi_internal */
    case 340:  /* *movv4uqq_mips16 */
    case 339:  /* *movv4qq_mips16 */
    case 338:  /* *movv2uha_mips16 */
    case 337:  /* *movv2ha_mips16 */
    case 336:  /* *movv2uhq_mips16 */
    case 335:  /* *movv2hq_mips16 */
    case 334:  /* *movv4qi_mips16 */
    case 333:  /* *movv2hi_mips16 */
    case 332:  /* *movsi_mips16 */
    case 331:  /* *movv4uqq_internal */
    case 330:  /* *movv4qq_internal */
    case 329:  /* *movv2uha_internal */
    case 328:  /* *movv2ha_internal */
    case 327:  /* *movv2uhq_internal */
    case 326:  /* *movv2hq_internal */
    case 325:  /* *movv4qi_internal */
    case 324:  /* *movv2hi_internal */
    case 323:  /* *movsi_internal */
    case 322:  /* *movdi_64bit_mips16 */
    case 321:  /* *movdi_64bit */
    case 320:  /* *movdi_32bit_mips16 */
    case 319:  /* *movdi_32bit */
    case 307:  /* *got_dispdi */
    case 306:  /* *got_dispsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 1740:  /* msa_fexupr_w */
    case 1738:  /* msa_fexupl_w */
    case 1734:  /* msa_cfcmsa */
    case 1733:  /* msa_splati_w_f_scalar */
    case 1732:  /* msa_splati_d_f_scalar */
    case 1641:  /* msa_nloc_b */
    case 1640:  /* msa_nloc_h */
    case 1639:  /* msa_nloc_w */
    case 1638:  /* msa_nloc_d */
    case 1563:  /* msa_ftint_u_w */
    case 1562:  /* msa_ftint_u_d */
    case 1561:  /* msa_ftint_s_w */
    case 1560:  /* msa_ftint_s_d */
    case 1559:  /* msa_frsqrt_w */
    case 1558:  /* msa_frsqrt_d */
    case 1557:  /* msa_frint_w */
    case 1556:  /* msa_frint_d */
    case 1555:  /* msa_frcp_w */
    case 1554:  /* msa_frcp_d */
    case 1545:  /* msa_flog2_w */
    case 1544:  /* msa_flog2_d */
    case 1537:  /* msa_ffqr_w */
    case 1536:  /* msa_ffqr_d */
    case 1535:  /* msa_ffql_w */
    case 1534:  /* msa_ffql_d */
    case 1483:  /* msa_fclass_w */
    case 1482:  /* msa_fclass_d */
    case 1190:  /* reduc_uplus_v8qi */
    case 1189:  /* loongson_biadd */
    case 1183:  /* loongson_pmovmskb */
    case 993:  /* mips_rddsp */
    case 971:  /* mips_repl_ph */
    case 970:  /* mips_repl_qb */
    case 968:  /* mips_bitrev */
    case 941:  /* mips_preceu_ph_qbra */
    case 940:  /* mips_preceu_ph_qbla */
    case 939:  /* mips_preceu_ph_qbr */
    case 938:  /* mips_preceu_ph_qbl */
    case 937:  /* mips_precequ_ph_qbra */
    case 936:  /* mips_precequ_ph_qbla */
    case 935:  /* mips_precequ_ph_qbr */
    case 934:  /* mips_precequ_ph_qbl */
    case 933:  /* mips_preceq_w_phr */
    case 932:  /* mips_preceq_w_phl */
    case 925:  /* mips_raddu_w_qb */
    case 908:  /* mips_recip1_ps */
    case 907:  /* mips_recip1_d */
    case 906:  /* mips_recip1_s */
    case 902:  /* mips_rsqrt1_ps */
    case 901:  /* mips_rsqrt1_d */
    case 900:  /* mips_rsqrt1_s */
    case 873:  /* *mips_abs_ps */
    case 871:  /* mips_cvt_ps_pw */
    case 870:  /* mips_cvt_pw_ps */
    case 844:  /* sync_nanddi */
    case 843:  /* sync_nandsi */
    case 790:  /* fclass_df */
    case 789:  /* fclass_sf */
    case 788:  /* rintdf2 */
    case 787:  /* rintsf2 */
    case 682:  /* move_gpdi */
    case 681:  /* move_gpsi */
    case 676:  /* cop0_move */
    case 675:  /* mips_rdpgpr_di */
    case 674:  /* mips_rdpgpr_si */
    case 476:  /* dshd */
    case 475:  /* dsbh */
    case 474:  /* wsbh */
    case 440:  /* cprestore_di */
    case 439:  /* cprestore_si */
    case 436:  /* copygp_mips16_di */
    case 435:  /* copygp_mips16_si */
    case 431:  /* loadgp_absolute_di */
    case 430:  /* loadgp_absolute_si */
    case 427:  /* mfhc1tf */
    case 426:  /* mfhc1v8qi */
    case 425:  /* mfhc1v4hi */
    case 424:  /* mfhc1v2si */
    case 423:  /* mfhc1v2sf */
    case 422:  /* mfhc1di */
    case 421:  /* mfhc1df */
    case 399:  /* load_lowtf */
    case 398:  /* load_lowv8qi */
    case 397:  /* load_lowv4hi */
    case 396:  /* load_lowv2si */
    case 395:  /* load_lowv2sf */
    case 394:  /* load_lowdi */
    case 393:  /* load_lowdf */
    case 389:  /* mfhidi_ti */
    case 388:  /* mfhisi_ti */
    case 387:  /* mfhisi_di */
    case 301:  /* *unshifted_high */
    case 300:  /* *unshifted_high */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      break;

    case 299:  /* *lea64 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 297:  /* mov_sdr_mips16e2 */
    case 296:  /* mov_swr_mips16e2 */
    case 293:  /* mov_sdr */
    case 292:  /* mov_swr */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 2);
      recog_data.dup_num[0] = 0;
      break;

    case 1719:  /* msa_sldi_b */
    case 1718:  /* msa_sldi_h */
    case 1717:  /* msa_sldi_w */
    case 1716:  /* msa_sldi_d */
    case 1715:  /* msa_sldi_w_f */
    case 1714:  /* msa_sldi_d_f */
    case 1713:  /* msa_sld_b */
    case 1712:  /* msa_sld_h */
    case 1711:  /* msa_sld_w */
    case 1710:  /* msa_sld_d */
    case 1709:  /* msa_sld_w_f */
    case 1708:  /* msa_sld_d_f */
    case 1633:  /* msa_msubr_q_h */
    case 1632:  /* msa_msubr_q_w */
    case 1631:  /* msa_msub_q_h */
    case 1630:  /* msa_msub_q_w */
    case 1605:  /* msa_maddr_q_h */
    case 1604:  /* msa_maddr_q_w */
    case 1603:  /* msa_madd_q_h */
    case 1602:  /* msa_madd_q_w */
    case 1415:  /* msa_binsri_b */
    case 1414:  /* msa_binsri_h */
    case 1413:  /* msa_binsri_w */
    case 1412:  /* msa_binsri_d */
    case 1411:  /* msa_binsr_b */
    case 1410:  /* msa_binsr_h */
    case 1409:  /* msa_binsr_w */
    case 1408:  /* msa_binsr_d */
    case 1407:  /* msa_binsli_b */
    case 1406:  /* msa_binsli_h */
    case 1405:  /* msa_binsli_w */
    case 1404:  /* msa_binsli_d */
    case 1403:  /* msa_binsl_b */
    case 1402:  /* msa_binsl_h */
    case 1401:  /* msa_binsl_w */
    case 1400:  /* msa_binsl_d */
    case 1267:  /* vec_permv16qi */
    case 1266:  /* vec_permv8hi */
    case 1265:  /* vec_permv4si */
    case 1264:  /* vec_permv2di */
    case 1263:  /* vec_permv4sf */
    case 1262:  /* vec_permv2df */
    case 1177:  /* *vec_setv4hi */
    case 1057:  /* mips_dpsx_w_ph */
    case 1056:  /* mips_dpax_w_ph */
    case 1040:  /* mips_prepend */
    case 1039:  /* mips_precr_sra_r_ph_w */
    case 1038:  /* mips_precr_sra_ph_w */
    case 1036:  /* mips_mulsa_w_ph */
    case 1030:  /* mips_dps_w_ph */
    case 1029:  /* mips_dpa_w_ph */
    case 1025:  /* mips_balign */
    case 1024:  /* mips_append */
    case 958:  /* mips_dpsu_h_qbr */
    case 957:  /* mips_dpsu_h_qbl */
    case 956:  /* mips_dpau_h_qbr */
    case 955:  /* mips_dpau_h_qbl */
    case 879:  /* mips_cabs_cond_ps */
    case 878:  /* mips_c_cond_ps */
    case 875:  /* mips_cabs_cond_d */
    case 874:  /* mips_cabs_cond_s */
    case 868:  /* mips_alnv_ps */
    case 864:  /* mips_cond_move_tf_ps */
    case 289:  /* mov_ldr */
    case 288:  /* mov_lwr */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (pat, 1), 0, 2));
      break;

    case 1736:  /* msa_fexdo_h */
    case 1725:  /* msa_splat_b */
    case 1724:  /* msa_splat_h */
    case 1723:  /* msa_splat_w */
    case 1722:  /* msa_splat_d */
    case 1721:  /* msa_splat_w_f */
    case 1720:  /* msa_splat_d_f */
    case 1707:  /* msa_subsus_u_b */
    case 1706:  /* msa_subsus_u_h */
    case 1705:  /* msa_subsus_u_w */
    case 1704:  /* msa_subsus_u_d */
    case 1703:  /* msa_subsuu_s_b */
    case 1702:  /* msa_subsuu_s_h */
    case 1701:  /* msa_subsuu_s_w */
    case 1700:  /* msa_subsuu_s_d */
    case 1699:  /* msa_subs_u_b */
    case 1698:  /* msa_subs_u_h */
    case 1697:  /* msa_subs_u_w */
    case 1696:  /* msa_subs_u_d */
    case 1695:  /* msa_subs_s_b */
    case 1694:  /* msa_subs_s_h */
    case 1693:  /* msa_subs_s_w */
    case 1692:  /* msa_subs_s_d */
    case 1691:  /* msa_srlri_b */
    case 1690:  /* msa_srlri_h */
    case 1689:  /* msa_srlri_w */
    case 1688:  /* msa_srlri_d */
    case 1687:  /* msa_srlr_b */
    case 1686:  /* msa_srlr_h */
    case 1685:  /* msa_srlr_w */
    case 1684:  /* msa_srlr_d */
    case 1683:  /* msa_srari_b */
    case 1682:  /* msa_srari_h */
    case 1681:  /* msa_srari_w */
    case 1680:  /* msa_srari_d */
    case 1679:  /* msa_srar_b */
    case 1678:  /* msa_srar_h */
    case 1677:  /* msa_srar_w */
    case 1676:  /* msa_srar_d */
    case 1669:  /* msa_sat_u_b */
    case 1668:  /* msa_sat_u_h */
    case 1667:  /* msa_sat_u_w */
    case 1666:  /* msa_sat_u_d */
    case 1665:  /* msa_sat_s_b */
    case 1664:  /* msa_sat_s_h */
    case 1663:  /* msa_sat_s_w */
    case 1662:  /* msa_sat_s_d */
    case 1637:  /* msa_mulr_q_h */
    case 1636:  /* msa_mulr_q_w */
    case 1635:  /* msa_mul_q_h */
    case 1634:  /* msa_mul_q_w */
    case 1569:  /* msa_ftq_w */
    case 1568:  /* msa_ftq_h */
    case 1529:  /* msa_fexp2_w */
    case 1528:  /* msa_fexp2_d */
    case 1527:  /* msa_fslt_w */
    case 1526:  /* msa_fsle_w */
    case 1525:  /* msa_fsult_w */
    case 1524:  /* msa_fsule_w */
    case 1523:  /* msa_fsune_w */
    case 1522:  /* msa_fsueq_w */
    case 1521:  /* msa_fsne_w */
    case 1520:  /* msa_fseq_w */
    case 1519:  /* msa_fsor_w */
    case 1518:  /* msa_fsun_w */
    case 1517:  /* msa_fsaf_w */
    case 1516:  /* msa_fslt_d */
    case 1515:  /* msa_fsle_d */
    case 1514:  /* msa_fsult_d */
    case 1513:  /* msa_fsule_d */
    case 1512:  /* msa_fsune_d */
    case 1511:  /* msa_fsueq_d */
    case 1510:  /* msa_fsne_d */
    case 1509:  /* msa_fseq_d */
    case 1508:  /* msa_fsor_d */
    case 1507:  /* msa_fsun_d */
    case 1506:  /* msa_fsaf_d */
    case 1487:  /* msa_fcune_w */
    case 1486:  /* msa_fcune_d */
    case 1485:  /* msa_fcaf_w */
    case 1484:  /* msa_fcaf_d */
    case 1443:  /* msa_bseti_b */
    case 1442:  /* msa_bseti_h */
    case 1441:  /* msa_bseti_w */
    case 1440:  /* msa_bseti_d */
    case 1439:  /* msa_bset_b */
    case 1438:  /* msa_bset_h */
    case 1437:  /* msa_bset_w */
    case 1436:  /* msa_bset_d */
    case 1431:  /* msa_bnegi_b */
    case 1430:  /* msa_bnegi_h */
    case 1429:  /* msa_bnegi_w */
    case 1428:  /* msa_bnegi_d */
    case 1427:  /* msa_bneg_b */
    case 1426:  /* msa_bneg_h */
    case 1425:  /* msa_bneg_w */
    case 1424:  /* msa_bneg_d */
    case 1399:  /* msa_bclri_b */
    case 1398:  /* msa_bclri_h */
    case 1397:  /* msa_bclri_w */
    case 1396:  /* msa_bclri_d */
    case 1395:  /* msa_bclr_b */
    case 1394:  /* msa_bclr_h */
    case 1393:  /* msa_bclr_w */
    case 1392:  /* msa_bclr_d */
    case 1391:  /* msa_aver_u_b */
    case 1390:  /* msa_aver_u_h */
    case 1389:  /* msa_aver_u_w */
    case 1388:  /* msa_aver_u_d */
    case 1387:  /* msa_aver_s_b */
    case 1386:  /* msa_aver_s_h */
    case 1385:  /* msa_aver_s_w */
    case 1384:  /* msa_aver_s_d */
    case 1383:  /* msa_ave_u_b */
    case 1382:  /* msa_ave_u_h */
    case 1381:  /* msa_ave_u_w */
    case 1380:  /* msa_ave_u_d */
    case 1379:  /* msa_ave_s_b */
    case 1378:  /* msa_ave_s_h */
    case 1377:  /* msa_ave_s_w */
    case 1376:  /* msa_ave_s_d */
    case 1375:  /* msa_asub_u_b */
    case 1374:  /* msa_asub_u_h */
    case 1373:  /* msa_asub_u_w */
    case 1372:  /* msa_asub_u_d */
    case 1371:  /* msa_asub_s_b */
    case 1370:  /* msa_asub_s_h */
    case 1369:  /* msa_asub_s_w */
    case 1368:  /* msa_asub_s_d */
    case 1226:  /* vec_shr_di */
    case 1225:  /* vec_shr_v8qi */
    case 1224:  /* vec_shr_v4hi */
    case 1223:  /* vec_shr_v2si */
    case 1222:  /* vec_shl_di */
    case 1221:  /* vec_shl_v8qi */
    case 1220:  /* vec_shl_v4hi */
    case 1219:  /* vec_shl_v2si */
    case 1202:  /* loongson_psubd */
    case 1192:  /* loongson_pshufh */
    case 1191:  /* loongson_psadbh */
    case 1188:  /* loongson_pasubub */
    case 1187:  /* loongson_pmuluw */
    case 1185:  /* smulv4hi3_highpart */
    case 1184:  /* umulv4hi3_highpart */
    case 1178:  /* loongson_pmaddhw */
    case 1172:  /* loongson_pextrh */
    case 1171:  /* loongson_pcmpgtb */
    case 1170:  /* loongson_pcmpgth */
    case 1169:  /* loongson_pcmpgtw */
    case 1168:  /* loongson_pcmpeqb */
    case 1167:  /* loongson_pcmpeqh */
    case 1166:  /* loongson_pcmpeqw */
    case 1165:  /* loongson_pavgb */
    case 1164:  /* loongson_pavgh */
    case 1140:  /* loongson_paddd */
    case 1055:  /* mips_subqh_r_w */
    case 1054:  /* mips_subqh_w */
    case 1053:  /* mips_subqh_r_ph */
    case 1052:  /* mips_subqh_ph */
    case 1051:  /* mips_addqh_r_w */
    case 1050:  /* mips_addqh_w */
    case 1049:  /* mips_addqh_r_ph */
    case 1048:  /* mips_addqh_ph */
    case 1047:  /* mips_subuh_r_qb */
    case 1046:  /* mips_subuh_qb */
    case 1043:  /* mips_shrl_ph */
    case 1042:  /* mips_shra_r_qb */
    case 1041:  /* mips_shra_qb */
    case 1037:  /* mips_precr_qb_ph */
    case 1023:  /* mips_adduh_r_qb */
    case 1022:  /* mips_adduh_qb */
    case 990:  /* mips_shilo */
    case 983:  /* mips_packrl_ph */
    case 982:  /* mips_pick_qb */
    case 981:  /* mips_pick_ph */
    case 980:  /* mips_cmpgu_le_qb */
    case 979:  /* mips_cmpgu_lt_qb */
    case 978:  /* mips_cmpgu_eq_qb */
    case 969:  /* mips_insv */
    case 949:  /* mips_shra_r_ph */
    case 948:  /* mips_shra_r_w */
    case 947:  /* mips_shra_ph */
    case 946:  /* mips_shrl_qb */
    case 929:  /* mips_precrq_ph_w */
    case 928:  /* mips_precrq_qb_ph */
    case 924:  /* mips_modsub */
    case 911:  /* mips_recip2_ps */
    case 910:  /* mips_recip2_d */
    case 909:  /* mips_recip2_s */
    case 905:  /* mips_rsqrt2_ps */
    case 904:  /* mips_rsqrt2_d */
    case 903:  /* mips_rsqrt2_s */
    case 872:  /* mips_mulr_ps */
    case 869:  /* mips_addr_ps */
    case 684:  /* load_calldi */
    case 683:  /* load_callsi */
    case 664:  /* probe_stack_range_di */
    case 663:  /* probe_stack_range_si */
    case 434:  /* loadgp_rtp_di */
    case 433:  /* loadgp_rtp_si */
    case 429:  /* loadgp_newabi_di */
    case 428:  /* loadgp_newabi_si */
    case 420:  /* mthc1tf */
    case 419:  /* mthc1v8qi */
    case 418:  /* mthc1v4hi */
    case 417:  /* mthc1v2si */
    case 416:  /* mthc1v2sf */
    case 415:  /* mthc1di */
    case 414:  /* mthc1df */
    case 413:  /* store_wordtf */
    case 412:  /* store_wordv8qi */
    case 411:  /* store_wordv4hi */
    case 410:  /* store_wordv2si */
    case 409:  /* store_wordv2sf */
    case 408:  /* store_worddi */
    case 407:  /* store_worddf */
    case 406:  /* load_hightf */
    case 405:  /* load_highv8qi */
    case 404:  /* load_highv4hi */
    case 403:  /* load_highv2si */
    case 402:  /* load_highv2sf */
    case 401:  /* load_highdi */
    case 400:  /* load_highdf */
    case 392:  /* mthidi_ti */
    case 391:  /* mthisi_ti */
    case 390:  /* mthisi_di */
    case 311:  /* load_gotdi */
    case 310:  /* load_gotsi */
    case 295:  /* mov_sdl_mips16e2 */
    case 294:  /* mov_swl_mips16e2 */
    case 291:  /* mov_sdl */
    case 290:  /* mov_swl */
    case 287:  /* mov_ldl */
    case 286:  /* mov_lwl */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 283:  /* *insvdi */
    case 282:  /* *insvsi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 1));
      break;

    case 281:  /* *inshisi_extended */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0), 0);
      recog_data.dup_num[0] = 0;
      break;

    case 280:  /* *insqisi_extended */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0);
      recog_data.dup_num[0] = 0;
      break;

    case 279:  /* *extzv_truncsi_exts */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 268:  /* fix_truncsfsi2_macro */
    case 266:  /* fix_truncdfsi2_macro */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 216:  /* *mips.md:3596 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 1741:  /* msa_fexupr_d */
    case 1739:  /* msa_fexupl_d */
    case 263:  /* *extendhi_truncateqi_exts */
    case 262:  /* *extenddi_truncatehi_exts */
    case 261:  /* *extendsi_truncatehi_exts */
    case 260:  /* *extenddi_truncateqi_exts */
    case 259:  /* *extendsi_truncateqi_exts */
    case 258:  /* *extendhi_truncateqi */
    case 257:  /* *extendsi_truncatehi */
    case 256:  /* *extendsi_truncateqi */
    case 255:  /* *extenddi_truncatehi */
    case 254:  /* *extenddi_truncateqi */
    case 237:  /* *zero_extendhi_truncqi */
    case 236:  /* *zero_extenddi_trunchi */
    case 235:  /* *zero_extendsi_trunchi */
    case 234:  /* *zero_extenddi_truncqi */
    case 233:  /* *zero_extendsi_truncqi */
    case 209:  /* *lshr32_truncsi */
    case 208:  /* *lshr32_trunchi */
    case 207:  /* *lshr32_truncqi */
    case 177:  /* *popcountdi2_trunc */
    case 172:  /* *clodi2 */
    case 171:  /* *closi2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 162:  /* *rsqrtv2sfa */
    case 161:  /* *rsqrtdfa */
    case 160:  /* *rsqrtsfa */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 1661:  /* popcountv16qi2 */
    case 1660:  /* popcountv8hi2 */
    case 1659:  /* popcountv4si2 */
    case 1658:  /* popcountv2di2 */
    case 1645:  /* clzv16qi2 */
    case 1644:  /* clzv8hi2 */
    case 1643:  /* clzv4si2 */
    case 1642:  /* clzv2di2 */
    case 1567:  /* fixuns_truncv4sfv4si2 */
    case 1566:  /* fixuns_truncv2dfv2di2 */
    case 1565:  /* fix_truncv4sfv4si2 */
    case 1564:  /* fix_truncv2dfv2di2 */
    case 1543:  /* msa_fill_b */
    case 1542:  /* msa_fill_h */
    case 1541:  /* msa_fill_w */
    case 1540:  /* msa_fill_d */
    case 1539:  /* msa_fill_w_f */
    case 1538:  /* msa_fill_d_f */
    case 1533:  /* floatunsv4siv4sf2 */
    case 1532:  /* floatunsv2div2df2 */
    case 1531:  /* floatv4siv4sf2 */
    case 1530:  /* floatv2div2df2 */
    case 1351:  /* sqrtv4sf2 */
    case 1350:  /* sqrtv2df2 */
    case 1325:  /* one_cmplv16qi2 */
    case 1324:  /* one_cmplv8hi2 */
    case 1323:  /* one_cmplv4si2 */
    case 1322:  /* one_cmplv2di2 */
    case 1261:  /* negv4sf2 */
    case 1260:  /* negv2df2 */
    case 1234:  /* msa_vec_extract_w_f */
    case 1233:  /* msa_vec_extract_d_f */
    case 1229:  /* vec_loongson_extract_lo_v8qi */
    case 1228:  /* vec_loongson_extract_lo_v4hi */
    case 1227:  /* vec_loongson_extract_lo_v2si */
    case 1163:  /* one_cmplv8qi2 */
    case 1162:  /* one_cmplv4hi2 */
    case 1161:  /* one_cmplv2si2 */
    case 546:  /* *sgeu_didi */
    case 545:  /* *sge_didi */
    case 544:  /* *sgeu_sidi */
    case 543:  /* *sge_sidi */
    case 542:  /* *sgeu_disi */
    case 541:  /* *sge_disi */
    case 540:  /* *sgeu_sisi */
    case 539:  /* *sge_sisi */
    case 518:  /* *sne_zero_didi */
    case 517:  /* *sne_zero_sidi */
    case 516:  /* *sne_zero_disi */
    case 515:  /* *sne_zero_sisi */
    case 510:  /* *seq_zero_didi_mips16 */
    case 509:  /* *seq_zero_sidi_mips16 */
    case 508:  /* *seq_zero_disi_mips16 */
    case 507:  /* *seq_zero_sisi_mips16 */
    case 506:  /* *seq_zero_didi */
    case 505:  /* *seq_zero_sidi */
    case 504:  /* *seq_zero_disi */
    case 503:  /* *seq_zero_sisi */
    case 473:  /* bswapdi2 */
    case 472:  /* bswapsi2 */
    case 471:  /* bswaphi2 */
    case 309:  /* *got_pagedi */
    case 308:  /* *got_pagesi */
    case 303:  /* *xgot_hidi */
    case 302:  /* *xgot_hisi */
    case 298:  /* *lea_high64 */
    case 274:  /* floatdisf2 */
    case 273:  /* floatsisf2 */
    case 272:  /* floatdidf2 */
    case 271:  /* floatsidf2 */
    case 270:  /* fix_truncsfdi2 */
    case 269:  /* fix_truncdfdi2 */
    case 267:  /* fix_truncsfsi2_insn */
    case 265:  /* fix_truncdfsi2_insn */
    case 264:  /* extendsfdf2 */
    case 253:  /* *extendqihi2_seb */
    case 252:  /* *extendqihi2 */
    case 251:  /* *extendqihi2_mips16e */
    case 250:  /* *extendhidi2_seh */
    case 249:  /* *extendhisi2_seh */
    case 248:  /* *extendqidi2_seb */
    case 247:  /* *extendqisi2_seb */
    case 246:  /* *extendhidi2 */
    case 245:  /* *extendhisi2 */
    case 244:  /* *extendqidi2 */
    case 243:  /* *extendqisi2 */
    case 242:  /* *extendhidi2_mips16e */
    case 241:  /* *extendhisi2_mips16e */
    case 240:  /* *extendqidi2_mips16e */
    case 239:  /* *extendqisi2_mips16e */
    case 238:  /* extendsidi2 */
    case 232:  /* *zero_extendqihi2_mips16 */
    case 231:  /* *zero_extendqihi2 */
    case 230:  /* *zero_extendhidi2_mips16 */
    case 229:  /* *zero_extendhisi2_mips16 */
    case 228:  /* *zero_extendqidi2_mips16 */
    case 227:  /* *zero_extendqisi2_mips16 */
    case 226:  /* *zero_extendhidi2_mips16e */
    case 225:  /* *zero_extendhisi2_mips16e */
    case 224:  /* *zero_extendqidi2_mips16e */
    case 223:  /* *zero_extendqisi2_mips16e */
    case 222:  /* *zero_extendhidi2 */
    case 221:  /* *zero_extendhisi2 */
    case 220:  /* *zero_extendqidi2 */
    case 219:  /* *zero_extendqisi2 */
    case 218:  /* *zero_extendsidi2_dext */
    case 217:  /* *zero_extendsidi2 */
    case 203:  /* truncdisi2 */
    case 202:  /* truncdihi2 */
    case 201:  /* truncdiqi2 */
    case 200:  /* truncdfsf2 */
    case 184:  /* one_cmpldi2 */
    case 183:  /* one_cmplsi2 */
    case 182:  /* negv2sf2 */
    case 181:  /* negdf2 */
    case 180:  /* negsf2 */
    case 179:  /* negdi2 */
    case 178:  /* negsi2 */
    case 176:  /* popcountdi2 */
    case 175:  /* popcountsi2 */
    case 174:  /* ctzdi2 */
    case 173:  /* ctzsi2 */
    case 170:  /* clzdi2 */
    case 169:  /* clzsi2 */
    case 168:  /* absv2sf2 */
    case 167:  /* absdf2 */
    case 166:  /* abssf2 */
    case 159:  /* sqrtv2sf2 */
    case 158:  /* sqrtdf2 */
    case 157:  /* sqrtsf2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 893:  /* sungt_ps */
    case 892:  /* sunge_ps */
    case 891:  /* sgt_ps */
    case 890:  /* sge_ps */
    case 889:  /* sne_ps */
    case 888:  /* sltgt_ps */
    case 887:  /* sordered_ps */
    case 886:  /* sle_ps */
    case 885:  /* slt_ps */
    case 884:  /* seq_ps */
    case 883:  /* sunle_ps */
    case 882:  /* sunlt_ps */
    case 881:  /* suneq_ps */
    case 880:  /* sunordered_ps */
    case 148:  /* udivmoddi4_hilo_ti */
    case 147:  /* divmoddi4_hilo_ti */
    case 146:  /* udivmodsi4_hilo_ti */
    case 145:  /* divmodsi4_hilo_ti */
    case 144:  /* udivmodsi4_hilo_di */
    case 143:  /* divmodsi4_hilo_di */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1));
      break;

    case 142:  /* udivmoddi4_mips16 */
    case 141:  /* udivmodsi4_mips16 */
    case 138:  /* divmoddi4_mips16 */
    case 137:  /* divmodsi4_mips16 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 140:  /* *udivmoddi4 */
    case 139:  /* *udivmodsi4 */
    case 136:  /* *divmoddi4 */
    case 135:  /* *divmodsi4 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 1293:  /* msa_msubv_b */
    case 1292:  /* msa_msubv_h */
    case 1291:  /* msa_msubv_w */
    case 1290:  /* msa_msubv_d */
    case 128:  /* *nmsub4v2sf_fastmath */
    case 127:  /* *nmsub4df_fastmath */
    case 126:  /* *nmsub4sf_fastmath */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      break;

    case 125:  /* *nmadd4v2sf_fastmath */
    case 124:  /* *nmadd4df_fastmath */
    case 123:  /* *nmadd4sf_fastmath */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 122:  /* *nmsub4v2sf */
    case 121:  /* *nmsub4df */
    case 120:  /* *nmsub4sf */
    case 119:  /* *nmadd4v2sf */
    case 118:  /* *nmadd4df */
    case 117:  /* *nmadd4sf */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 1289:  /* msa_maddv_b */
    case 1288:  /* msa_maddv_h */
    case 1287:  /* msa_maddv_w */
    case 1286:  /* msa_maddv_d */
    case 464:  /* dlsa */
    case 463:  /* lsa */
    case 285:  /* *cinsdi */
    case 284:  /* *cinssi */
    case 116:  /* *msub4v2sf */
    case 115:  /* *msub4df */
    case 114:  /* *msub4sf */
    case 113:  /* *madd4v2sf */
    case 112:  /* *madd4df */
    case 111:  /* *madd4sf */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 110:  /* *fnmsv2sf4_nmadd4 */
    case 109:  /* *fnmsdf4_nmadd4 */
    case 108:  /* *fnmssf4_nmadd4 */
    case 107:  /* *fnmsv2sf4_nmadd3 */
    case 106:  /* *fnmsdf4_nmadd3 */
    case 105:  /* *fnmssf4_nmadd3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 1349:  /* fnmav4sf4 */
    case 1348:  /* fnmav2df4 */
    case 1248:  /* msa_insve_w_f_scalar */
    case 1247:  /* msa_insve_d_f_scalar */
    case 1240:  /* msa_insert_b */
    case 1239:  /* msa_insert_h */
    case 1238:  /* msa_insert_w */
    case 1237:  /* msa_insert_d */
    case 1236:  /* msa_insert_w_f */
    case 1235:  /* msa_insert_d_f */
    case 747:  /* *seldf */
    case 746:  /* *selsf */
    case 745:  /* *selnedi_using_di */
    case 744:  /* *seleqdi_using_di */
    case 743:  /* *selnesi_using_di */
    case 742:  /* *seleqsi_using_di */
    case 741:  /* *selnedi_using_si */
    case 740:  /* *seleqdi_using_si */
    case 739:  /* *selnesi_using_si */
    case 738:  /* *seleqsi_using_si */
    case 104:  /* *fnmav2sf4_nmsub4 */
    case 103:  /* *fnmadf4_nmsub4 */
    case 102:  /* *fnmasf4_nmsub4 */
    case 101:  /* *fnmav2sf4_nmsub3 */
    case 100:  /* *fnmadf4_nmsub3 */
    case 99:  /* *fnmasf4_nmsub3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 98:  /* *fmsv2sf4_msub4 */
    case 97:  /* *fmsdf4_msub4 */
    case 96:  /* *fmssf4_msub4 */
    case 95:  /* *fmsv2sf4_msub3 */
    case 94:  /* *fmsdf4_msub3 */
    case 93:  /* *fmssf4_msub3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 1347:  /* fmav4sf4 */
    case 1346:  /* fmav2df4 */
    case 729:  /* movdi_on_di_ne_mips16e2 */
    case 728:  /* movsi_on_di_ne_mips16e2 */
    case 727:  /* movdi_on_si_ne_mips16e2 */
    case 726:  /* movsi_on_si_ne_mips16e2 */
    case 725:  /* movdi_on_di_ne */
    case 724:  /* movsi_on_di_ne */
    case 723:  /* movdi_on_si_ne */
    case 722:  /* movsi_on_si_ne */
    case 278:  /* *extzvdi */
    case 277:  /* *extzvsi */
    case 276:  /* *extvdi */
    case 275:  /* *extvsi */
    case 92:  /* *fmav2sf4_maddf */
    case 91:  /* *fmadf4_maddf */
    case 90:  /* *fmasf4_maddf */
    case 89:  /* *fmav2sf4_madd4 */
    case 88:  /* *fmadf4_madd4 */
    case 87:  /* *fmasf4_madd4 */
    case 86:  /* *fmav2sf4_madd3 */
    case 85:  /* *fmadf4_madd3 */
    case 84:  /* *fmasf4_madd3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 83:  /* umaddsidi4 */
    case 82:  /* maddsidi4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 81:  /* madsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 1);
      recog_data.dup_num[0] = 0;
      break;

    case 72:  /* *umulsi3_highpart_neg_mulhi_internal */
    case 71:  /* *smulsi3_highpart_neg_mulhi_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 76:  /* umuldi3_highpart_internal */
    case 75:  /* smuldi3_highpart_internal */
    case 70:  /* umulsi3_highpart_mulhi_internal */
    case 69:  /* smulsi3_highpart_mulhi_internal */
    case 68:  /* umulsi3_highpart_internal */
    case 67:  /* smulsi3_highpart_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 74:  /* umuldi3_highpart_r6 */
    case 73:  /* smuldi3_highpart_r6 */
    case 66:  /* umulsi3_highpart_r6 */
    case 65:  /* smulsi3_highpart_r6 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1), 0));
      break;

    case 64:  /* umsubsidi4 */
    case 63:  /* msubsidi4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 62:  /* *mulsu_di */
    case 61:  /* *muls_di */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      break;

    case 58:  /* umulsidi3_64bit_hilo */
    case 57:  /* mulsidi3_64bit_hilo */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0));
      break;

    case 56:  /* umulsidi3_64bit */
    case 55:  /* mulsidi3_64bit */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 80:  /* umulditi3_r4000 */
    case 79:  /* mulditi3_r4000 */
    case 59:  /* mulsidi3_64bit_dmul */
    case 54:  /* umulsidi3_32bit_r4000 */
    case 53:  /* mulsidi3_32bit_r4000 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 1737:  /* vec_pack_trunc_v2df */
    case 1649:  /* msa_nor_b */
    case 1648:  /* msa_nor_h */
    case 1647:  /* msa_nor_w */
    case 1646:  /* msa_nor_d */
    case 1359:  /* msa_adds_a_b */
    case 1358:  /* msa_adds_a_h */
    case 1357:  /* msa_adds_a_w */
    case 1356:  /* msa_adds_a_d */
    case 1355:  /* msa_add_a_b */
    case 1354:  /* msa_add_a_h */
    case 1353:  /* msa_add_a_w */
    case 1352:  /* msa_add_a_d */
    case 1232:  /* vec_pack_trunc_v8hi */
    case 1231:  /* vec_pack_trunc_v4si */
    case 1230:  /* vec_pack_trunc_v2di */
    case 1160:  /* *loongson_nor */
    case 1159:  /* *loongson_nor */
    case 1158:  /* *loongson_nor */
    case 1136:  /* vec_pack_usat_v4hi */
    case 1135:  /* vec_pack_ssat_v4hi */
    case 1134:  /* vec_pack_ssat_v2si */
    case 199:  /* *nordi3 */
    case 198:  /* *norsi3 */
    case 78:  /* umulditi3_internal */
    case 77:  /* mulditi3_internal */
    case 60:  /* mulsidi3_64bit_r6dmul */
    case 52:  /* umulsidi3_32bit */
    case 51:  /* mulsidi3_32bit */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 50:  /* *muls */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 48:  /* *msac2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 0;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1), 0);
      recog_data.dup_num[1] = 1;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1), 1);
      recog_data.dup_num[2] = 2;
      recog_data.dup_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0);
      recog_data.dup_num[3] = 0;
      break;

    case 47:  /* *macc2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[2] = 0;
      recog_data.dup_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1);
      recog_data.dup_num[3] = 0;
      break;

    case 49:  /* *mul_sub_si */
    case 46:  /* *msac_using_macc */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 45:  /* *msac */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 44:  /* *macc */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 43:  /* *mul_acc_si_r3900 */
    case 42:  /* *mul_acc_si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 41:  /* muldi3_r4000 */
    case 40:  /* mulsi3_r4000 */
    case 37:  /* muldi3_mul3 */
    case 36:  /* mulsi3_mul3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 1017:  /* *mips_lwux_di_ext */
    case 1016:  /* *mips_lwx_di_ext */
    case 1015:  /* *mips_lwux_si_ext */
    case 1014:  /* *mips_lwx_si_ext */
    case 1009:  /* mips_lhux_extdi_di */
    case 1008:  /* mips_lhx_extdi_di */
    case 1007:  /* mips_lhux_extsi_di */
    case 1006:  /* mips_lhx_extsi_di */
    case 1005:  /* mips_lbux_extdi_di */
    case 1004:  /* mips_lbx_extdi_di */
    case 1003:  /* mips_lbux_extsi_di */
    case 1002:  /* mips_lbx_extsi_di */
    case 1001:  /* mips_lhux_extdi_si */
    case 1000:  /* mips_lhx_extdi_si */
    case 999:  /* mips_lhux_extsi_si */
    case 998:  /* mips_lhx_extsi_si */
    case 997:  /* mips_lbux_extdi_si */
    case 996:  /* mips_lbx_extdi_si */
    case 995:  /* mips_lbux_extsi_si */
    case 994:  /* mips_lbx_extsi_si */
    case 22:  /* *baddu_didi */
    case 21:  /* *baddu_disi */
    case 20:  /* *baddu_si_el */
    case 19:  /* *baddu_si_eb */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      break;

    case 1657:  /* msa_pckod_w_f */
    case 1656:  /* msa_pckod_w */
    case 1655:  /* msa_pckod_h */
    case 1654:  /* msa_pckod_b */
    case 1653:  /* msa_pckev_w_f */
    case 1652:  /* msa_pckev_w */
    case 1651:  /* msa_pckev_h */
    case 1650:  /* msa_pckev_b */
    case 1601:  /* msa_ilvr_d_f */
    case 1600:  /* msa_ilvr_d */
    case 1599:  /* msa_ilvr_w_f */
    case 1598:  /* msa_ilvr_w */
    case 1597:  /* msa_ilvr_h */
    case 1596:  /* msa_ilvr_b */
    case 1595:  /* msa_ilvod_w_f */
    case 1594:  /* msa_ilvod_w */
    case 1593:  /* msa_ilvod_h */
    case 1592:  /* msa_ilvod_b */
    case 1591:  /* msa_ilvl_d_f */
    case 1590:  /* msa_ilvl_d */
    case 1589:  /* msa_ilvl_w_f */
    case 1588:  /* msa_ilvl_w */
    case 1587:  /* msa_ilvl_h */
    case 1586:  /* msa_ilvl_b */
    case 1585:  /* msa_ilvev_w_f */
    case 1584:  /* msa_ilvev_w */
    case 1583:  /* msa_ilvev_h */
    case 1582:  /* msa_ilvev_b */
    case 1218:  /* *loongson_punpcklwd_hi */
    case 1217:  /* *loongson_punpcklwd_qi */
    case 1216:  /* loongson_punpcklwd */
    case 1215:  /* *loongson_punpcklhw_qi */
    case 1214:  /* loongson_punpcklhw */
    case 1213:  /* loongson_punpcklbh */
    case 1212:  /* loongson_punpckhwd_hi */
    case 1211:  /* loongson_punpckhwd_qi */
    case 1210:  /* loongson_punpckhwd */
    case 1209:  /* loongson_punpckhhw_qi */
    case 1208:  /* loongson_punpckhhw */
    case 1207:  /* loongson_punpckhbh */
    case 1176:  /* loongson_pinsrh_3 */
    case 1175:  /* loongson_pinsrh_2 */
    case 1174:  /* loongson_pinsrh_1 */
    case 1173:  /* loongson_pinsrh_0 */
    case 1013:  /* mips_ldx_di */
    case 1012:  /* mips_lwx_di */
    case 1011:  /* mips_ldx_si */
    case 1010:  /* mips_lwx_si */
    case 459:  /* *lshrsi3_extend */
    case 458:  /* *ashrsi3_extend */
    case 457:  /* *ashlsi3_extend */
    case 346:  /* *ldxc1_di */
    case 345:  /* *ldxc1_di */
    case 344:  /* *lwxc1_di */
    case 343:  /* *ldxc1_si */
    case 342:  /* *ldxc1_si */
    case 341:  /* *lwxc1_si */
    case 215:  /* *lshr_truncsi_exts */
    case 214:  /* *ashr_truncsi_exts */
    case 213:  /* *lshr_trunchi_exts */
    case 212:  /* *ashr_trunchi_exts */
    case 211:  /* *lshr_truncqi_exts */
    case 210:  /* *ashr_truncqi_exts */
    case 206:  /* *ashr_truncsi */
    case 205:  /* *ashr_trunchi */
    case 204:  /* *ashr_truncqi */
    case 165:  /* *rsqrtv2sfb */
    case 164:  /* *rsqrtdfb */
    case 163:  /* *rsqrtsfb */
    case 28:  /* *subsi3_extended */
    case 18:  /* *addsi3_extended_mips16 */
    case 17:  /* *addsi3_extended */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 1675:  /* msa_shf_b */
    case 1674:  /* msa_shf_h */
    case 1673:  /* msa_shf_w */
    case 1672:  /* msa_shf_d */
    case 1671:  /* msa_shf_w_f */
    case 1670:  /* msa_shf_d_f */
    case 1629:  /* uminv16qi3 */
    case 1628:  /* uminv8hi3 */
    case 1627:  /* uminv4si3 */
    case 1626:  /* uminv2di3 */
    case 1625:  /* sminv16qi3 */
    case 1624:  /* sminv8hi3 */
    case 1623:  /* sminv4si3 */
    case 1622:  /* sminv2di3 */
    case 1617:  /* umaxv16qi3 */
    case 1616:  /* umaxv8hi3 */
    case 1615:  /* umaxv4si3 */
    case 1614:  /* umaxv2di3 */
    case 1613:  /* smaxv16qi3 */
    case 1612:  /* smaxv8hi3 */
    case 1611:  /* smaxv4si3 */
    case 1610:  /* smaxv2di3 */
    case 1551:  /* sminv4sf3 */
    case 1550:  /* sminv2df3 */
    case 1547:  /* smaxv4sf3 */
    case 1546:  /* smaxv2df3 */
    case 1505:  /* msa_fcult_w */
    case 1504:  /* msa_fcule_w */
    case 1503:  /* msa_fcueq_w */
    case 1502:  /* msa_fclt_w */
    case 1501:  /* msa_fcle_w */
    case 1500:  /* msa_fcne_w */
    case 1499:  /* msa_fceq_w */
    case 1498:  /* msa_fcor_w */
    case 1497:  /* msa_fcun_w */
    case 1496:  /* msa_fcult_d */
    case 1495:  /* msa_fcule_d */
    case 1494:  /* msa_fcueq_d */
    case 1493:  /* msa_fclt_d */
    case 1492:  /* msa_fcle_d */
    case 1491:  /* msa_fcne_d */
    case 1490:  /* msa_fceq_d */
    case 1489:  /* msa_fcor_d */
    case 1488:  /* msa_fcun_d */
    case 1463:  /* msa_clt_u_b */
    case 1462:  /* msa_clt_s_b */
    case 1461:  /* msa_cle_u_b */
    case 1460:  /* msa_cle_s_b */
    case 1459:  /* msa_ceq_b */
    case 1458:  /* msa_clt_u_h */
    case 1457:  /* msa_clt_s_h */
    case 1456:  /* msa_cle_u_h */
    case 1455:  /* msa_cle_s_h */
    case 1454:  /* msa_ceq_h */
    case 1453:  /* msa_clt_u_w */
    case 1452:  /* msa_clt_s_w */
    case 1451:  /* msa_cle_u_w */
    case 1450:  /* msa_cle_s_w */
    case 1449:  /* msa_ceq_w */
    case 1448:  /* msa_clt_u_d */
    case 1447:  /* msa_clt_s_d */
    case 1446:  /* msa_cle_u_d */
    case 1445:  /* msa_cle_s_d */
    case 1444:  /* msa_ceq_d */
    case 1367:  /* usaddv16qi3 */
    case 1366:  /* usaddv8hi3 */
    case 1365:  /* usaddv4si3 */
    case 1364:  /* usaddv2di3 */
    case 1363:  /* ssaddv16qi3 */
    case 1362:  /* ssaddv8hi3 */
    case 1361:  /* ssaddv4si3 */
    case 1360:  /* ssaddv2di3 */
    case 1345:  /* divv4sf3 */
    case 1344:  /* divv2df3 */
    case 1343:  /* mulv4sf3 */
    case 1342:  /* mulv2df3 */
    case 1341:  /* subv4sf3 */
    case 1340:  /* subv2df3 */
    case 1339:  /* addv4sf3 */
    case 1338:  /* addv2df3 */
    case 1337:  /* vashlv16qi3 */
    case 1336:  /* vashlv8hi3 */
    case 1335:  /* vashlv4si3 */
    case 1334:  /* vashlv2di3 */
    case 1333:  /* vashrv16qi3 */
    case 1332:  /* vashrv8hi3 */
    case 1331:  /* vashrv4si3 */
    case 1330:  /* vashrv2di3 */
    case 1329:  /* vlshrv16qi3 */
    case 1328:  /* vlshrv8hi3 */
    case 1327:  /* vlshrv4si3 */
    case 1326:  /* vlshrv2di3 */
    case 1321:  /* andv16qi3 */
    case 1320:  /* andv8hi3 */
    case 1319:  /* andv4si3 */
    case 1318:  /* andv2di3 */
    case 1317:  /* iorv16qi3 */
    case 1316:  /* iorv8hi3 */
    case 1315:  /* iorv4si3 */
    case 1314:  /* iorv2di3 */
    case 1313:  /* xorv16qi3 */
    case 1312:  /* xorv8hi3 */
    case 1311:  /* xorv4si3 */
    case 1310:  /* xorv2di3 */
    case 1309:  /* umodv16qi3 */
    case 1308:  /* umodv8hi3 */
    case 1307:  /* umodv4si3 */
    case 1306:  /* umodv2di3 */
    case 1305:  /* modv16qi3 */
    case 1304:  /* modv8hi3 */
    case 1303:  /* modv4si3 */
    case 1302:  /* modv2di3 */
    case 1301:  /* udivv16qi3 */
    case 1300:  /* udivv8hi3 */
    case 1299:  /* udivv4si3 */
    case 1298:  /* udivv2di3 */
    case 1297:  /* divv16qi3 */
    case 1296:  /* divv8hi3 */
    case 1295:  /* divv4si3 */
    case 1294:  /* divv2di3 */
    case 1285:  /* mulv16qi3 */
    case 1284:  /* mulv8hi3 */
    case 1283:  /* mulv4si3 */
    case 1282:  /* mulv2di3 */
    case 1281:  /* subv16qi3 */
    case 1280:  /* subv8hi3 */
    case 1279:  /* subv4si3 */
    case 1278:  /* subv2di3 */
    case 1277:  /* addv16qi3 */
    case 1276:  /* addv8hi3 */
    case 1275:  /* addv4si3 */
    case 1274:  /* addv2di3 */
    case 1206:  /* ussubv8qi3 */
    case 1205:  /* ussubv4hi3 */
    case 1204:  /* sssubv8qi3 */
    case 1203:  /* sssubv4hi3 */
    case 1201:  /* subv8qi3 */
    case 1200:  /* subv4hi3 */
    case 1199:  /* subv2si3 */
    case 1198:  /* lshrv4hi3 */
    case 1197:  /* lshrv2si3 */
    case 1196:  /* ashrv4hi3 */
    case 1195:  /* ashrv2si3 */
    case 1194:  /* ashlv4hi3 */
    case 1193:  /* ashlv2si3 */
    case 1186:  /* mulv4hi3 */
    case 1182:  /* uminv8qi3 */
    case 1181:  /* sminv4hi3 */
    case 1180:  /* umaxv8qi3 */
    case 1179:  /* smaxv4hi3 */
    case 1157:  /* xorv8qi3 */
    case 1156:  /* xorv4hi3 */
    case 1155:  /* xorv2si3 */
    case 1154:  /* iorv8qi3 */
    case 1153:  /* iorv4hi3 */
    case 1152:  /* iorv2si3 */
    case 1151:  /* andv8qi3 */
    case 1150:  /* andv4hi3 */
    case 1149:  /* andv2si3 */
    case 1144:  /* usaddv8qi3 */
    case 1143:  /* usaddv4hi3 */
    case 1142:  /* ssaddv8qi3 */
    case 1141:  /* ssaddv4hi3 */
    case 1139:  /* addv8qi3 */
    case 1138:  /* addv4hi3 */
    case 1137:  /* addv2si3 */
    case 1133:  /* *vec_concatv2si */
    case 1101:  /* subuda3 */
    case 1100:  /* subusa3 */
    case 1099:  /* subuha3 */
    case 1098:  /* subda3 */
    case 1097:  /* subsa3 */
    case 1096:  /* subha3 */
    case 1095:  /* subudq3 */
    case 1094:  /* subusq3 */
    case 1093:  /* subuhq3 */
    case 1092:  /* subuqq3 */
    case 1091:  /* subdq3 */
    case 1090:  /* subsq3 */
    case 1089:  /* subhq3 */
    case 1088:  /* subqq3 */
    case 1075:  /* adduda3 */
    case 1074:  /* addusa3 */
    case 1073:  /* adduha3 */
    case 1072:  /* addda3 */
    case 1071:  /* addsa3 */
    case 1070:  /* addha3 */
    case 1069:  /* addudq3 */
    case 1068:  /* addusq3 */
    case 1067:  /* adduhq3 */
    case 1066:  /* adduqq3 */
    case 1065:  /* adddq3 */
    case 1064:  /* addsq3 */
    case 1063:  /* addhq3 */
    case 1062:  /* addqq3 */
    case 866:  /* vec_concatv2sf */
    case 778:  /* smaxdf3 */
    case 777:  /* smaxsf3 */
    case 776:  /* smindf3 */
    case 775:  /* sminsf3 */
    case 650:  /* sungt_df_using_ccf */
    case 649:  /* sunge_df_using_ccf */
    case 648:  /* sgt_df_using_ccf */
    case 647:  /* sge_df_using_ccf */
    case 646:  /* sungt_sf_using_ccf */
    case 645:  /* sunge_sf_using_ccf */
    case 644:  /* sgt_sf_using_ccf */
    case 643:  /* sge_sf_using_ccf */
    case 642:  /* sungt_df_using_cce */
    case 641:  /* sunge_df_using_cce */
    case 640:  /* sgt_df_using_cce */
    case 639:  /* sge_df_using_cce */
    case 638:  /* sungt_sf_using_cce */
    case 637:  /* sunge_sf_using_cce */
    case 636:  /* sgt_sf_using_cce */
    case 635:  /* sge_sf_using_cce */
    case 634:  /* sungt_df_using_cc */
    case 633:  /* sunge_df_using_cc */
    case 632:  /* sgt_df_using_cc */
    case 631:  /* sge_df_using_cc */
    case 630:  /* sungt_sf_using_cc */
    case 629:  /* sunge_sf_using_cc */
    case 628:  /* sgt_sf_using_cc */
    case 627:  /* sge_sf_using_cc */
    case 626:  /* sne_df_using_ccf */
    case 625:  /* sltgt_df_using_ccf */
    case 624:  /* sordered_df_using_ccf */
    case 623:  /* sle_df_using_ccf */
    case 622:  /* slt_df_using_ccf */
    case 621:  /* seq_df_using_ccf */
    case 620:  /* sunle_df_using_ccf */
    case 619:  /* sunlt_df_using_ccf */
    case 618:  /* suneq_df_using_ccf */
    case 617:  /* sunordered_df_using_ccf */
    case 616:  /* sne_sf_using_ccf */
    case 615:  /* sltgt_sf_using_ccf */
    case 614:  /* sordered_sf_using_ccf */
    case 613:  /* sle_sf_using_ccf */
    case 612:  /* slt_sf_using_ccf */
    case 611:  /* seq_sf_using_ccf */
    case 610:  /* sunle_sf_using_ccf */
    case 609:  /* sunlt_sf_using_ccf */
    case 608:  /* suneq_sf_using_ccf */
    case 607:  /* sunordered_sf_using_ccf */
    case 606:  /* sle_df_using_cce */
    case 605:  /* slt_df_using_cce */
    case 604:  /* seq_df_using_cce */
    case 603:  /* sunle_df_using_cce */
    case 602:  /* sunlt_df_using_cce */
    case 601:  /* suneq_df_using_cce */
    case 600:  /* sunordered_df_using_cce */
    case 599:  /* sle_sf_using_cce */
    case 598:  /* slt_sf_using_cce */
    case 597:  /* seq_sf_using_cce */
    case 596:  /* sunle_sf_using_cce */
    case 595:  /* sunlt_sf_using_cce */
    case 594:  /* suneq_sf_using_cce */
    case 593:  /* sunordered_sf_using_cce */
    case 592:  /* sle_df_using_cc */
    case 591:  /* slt_df_using_cc */
    case 590:  /* seq_df_using_cc */
    case 589:  /* sunle_df_using_cc */
    case 588:  /* sunlt_df_using_cc */
    case 587:  /* suneq_df_using_cc */
    case 586:  /* sunordered_df_using_cc */
    case 585:  /* sle_sf_using_cc */
    case 584:  /* slt_sf_using_cc */
    case 583:  /* seq_sf_using_cc */
    case 582:  /* sunle_sf_using_cc */
    case 581:  /* sunlt_sf_using_cc */
    case 580:  /* suneq_sf_using_cc */
    case 579:  /* sunordered_sf_using_cc */
    case 578:  /* *sleu_didi_mips16 */
    case 577:  /* *sle_didi_mips16 */
    case 576:  /* *sleu_sidi_mips16 */
    case 575:  /* *sle_sidi_mips16 */
    case 574:  /* *sleu_disi_mips16 */
    case 573:  /* *sle_disi_mips16 */
    case 572:  /* *sleu_sisi_mips16 */
    case 571:  /* *sle_sisi_mips16 */
    case 570:  /* *sleu_didi */
    case 569:  /* *sle_didi */
    case 568:  /* *sleu_sidi */
    case 567:  /* *sle_sidi */
    case 566:  /* *sleu_disi */
    case 565:  /* *sle_disi */
    case 564:  /* *sleu_sisi */
    case 563:  /* *sle_sisi */
    case 562:  /* *sltu_didi_mips16 */
    case 561:  /* *slt_didi_mips16 */
    case 560:  /* *sltu_sidi_mips16 */
    case 559:  /* *slt_sidi_mips16 */
    case 558:  /* *sltu_disi_mips16 */
    case 557:  /* *slt_disi_mips16 */
    case 556:  /* *sltu_sisi_mips16 */
    case 555:  /* *slt_sisi_mips16 */
    case 554:  /* *sltu_didi */
    case 553:  /* *slt_didi */
    case 552:  /* *sltu_sidi */
    case 551:  /* *slt_sidi */
    case 550:  /* *sltu_disi */
    case 549:  /* *slt_disi */
    case 548:  /* *sltu_sisi */
    case 547:  /* *slt_sisi */
    case 538:  /* *sgtu_didi_mips16 */
    case 537:  /* *sgt_didi_mips16 */
    case 536:  /* *sgtu_sidi_mips16 */
    case 535:  /* *sgt_sidi_mips16 */
    case 534:  /* *sgtu_disi_mips16 */
    case 533:  /* *sgt_disi_mips16 */
    case 532:  /* *sgtu_sisi_mips16 */
    case 531:  /* *sgt_sisi_mips16 */
    case 530:  /* *sgtu_didi */
    case 529:  /* *sgt_didi */
    case 528:  /* *sgtu_sidi */
    case 527:  /* *sgt_sidi */
    case 526:  /* *sgtu_disi */
    case 525:  /* *sgt_disi */
    case 524:  /* *sgtu_sisi */
    case 523:  /* *sgt_sisi */
    case 522:  /* *sne_didi_sne */
    case 521:  /* *sne_sidi_sne */
    case 520:  /* *sne_disi_sne */
    case 519:  /* *sne_sisi_sne */
    case 514:  /* *seq_didi_seq */
    case 513:  /* *seq_sidi_seq */
    case 512:  /* *seq_disi_seq */
    case 511:  /* *seq_sisi_seq */
    case 470:  /* rotrdi3 */
    case 469:  /* rotrsi3 */
    case 468:  /* *mips.md:5982 */
    case 467:  /* *lshrdi3_mips16 */
    case 466:  /* *ashrdi3_mips16 */
    case 465:  /* *ashldi3_mips16 */
    case 462:  /* *lshrsi3_mips16 */
    case 461:  /* *ashrsi3_mips16 */
    case 460:  /* *ashlsi3_mips16 */
    case 456:  /* *lshrdi3 */
    case 455:  /* *ashrdi3 */
    case 454:  /* *ashldi3 */
    case 453:  /* *lshrsi3 */
    case 452:  /* *ashrsi3 */
    case 451:  /* *ashlsi3 */
    case 316:  /* *lowdi_mips16 */
    case 315:  /* *lowsi_mips16 */
    case 313:  /* *lowdi */
    case 312:  /* *lowsi */
    case 305:  /* *xgot_lodi */
    case 304:  /* *xgot_losi */
    case 197:  /* *xordi3_mips16 */
    case 196:  /* *xorsi3_mips16 */
    case 195:  /* *xordi3 */
    case 194:  /* *xorsi3 */
    case 193:  /* *iordi3_mips16 */
    case 192:  /* *iorsi3_mips16 */
    case 191:  /* *iorsi3_mips16_asmacro */
    case 190:  /* *iordi3 */
    case 189:  /* *iorsi3 */
    case 188:  /* *anddi3_mips16 */
    case 187:  /* *andsi3_mips16 */
    case 186:  /* *anddi3 */
    case 185:  /* *andsi3 */
    case 156:  /* umoddi3 */
    case 155:  /* moddi3 */
    case 154:  /* umodsi3 */
    case 153:  /* modsi3 */
    case 152:  /* udivdi3 */
    case 151:  /* divdi3 */
    case 150:  /* udivsi3 */
    case 149:  /* divsi3 */
    case 134:  /* *recipv2sf3 */
    case 133:  /* *recipdf3 */
    case 132:  /* *recipsf3 */
    case 131:  /* *divv2sf3 */
    case 130:  /* *divdf3 */
    case 129:  /* *divsf3 */
    case 39:  /* muldi3_internal */
    case 38:  /* mulsi3_internal */
    case 35:  /* muldi3_mul3_nohilo */
    case 34:  /* mulsi3_mul3_nohilo */
    case 33:  /* mulv2sf3 */
    case 32:  /* *muldf3_r4300 */
    case 31:  /* *mulsf3_r4300 */
    case 30:  /* *muldf3 */
    case 29:  /* *mulsf3 */
    case 27:  /* subdi3 */
    case 26:  /* subsi3 */
    case 25:  /* subv2sf3 */
    case 24:  /* subdf3 */
    case 23:  /* subsf3 */
    case 16:  /* *adddi3_mips16 */
    case 15:  /* *addsi3_mips16 */
    case 14:  /* *adddi3 */
    case 13:  /* *addsi3 */
    case 12:  /* addv2sf3 */
    case 11:  /* adddf3 */
    case 10:  /* addsf3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 9:  /* *conditional_trapdi */
    case 8:  /* *conditional_trapsi */
    case 7:  /* *conditional_trap_regdi */
    case 6:  /* *conditional_trap_regsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 1));
      break;

    case 758:  /* *tls_get_tp_di_split */
    case 757:  /* *tls_get_tp_si_split */
    case 705:  /* insn_pseudo */
    case 704:  /* hazard_nop */
    case 703:  /* nop */
    case 686:  /* update_got_version */
    case 685:  /* set_got_version */
    case 673:  /* mips_ehb */
    case 672:  /* mips_di */
    case 671:  /* mips_deret */
    case 670:  /* mips_eret */
    case 666:  /* *simple_return */
    case 665:  /* *return */
    case 662:  /* blockage */
    case 450:  /* r10k_cache_barrier */
    case 448:  /* clear_hazard_di */
    case 447:  /* clear_hazard_si */
    case 443:  /* sync */
    case 432:  /* loadgp_blockage */
    case 5:  /* trap */
    case 4:  /* ls2_falu2_turn_enabled_insn */
    case 3:  /* ls2_falu1_turn_enabled_insn */
    case 2:  /* ls2_alu2_turn_enabled_insn */
    case 1:  /* ls2_alu1_turn_enabled_insn */
      break;

    }
}
