/* Generated automatically by the program `genopinit'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "optabs.h"

struct optab_pat {
  unsigned scode;
  enum insn_code icode;
};

static const struct optab_pat pats[NUM_OPTAB_PATTERNS] = {
  { 0x101006, CODE_FOR_extendqisi2 },
  { 0x101406, CODE_FOR_extendhisi2 },
  { 0x301006, CODE_FOR_zero_extendqisi2 },
  { 0x301406, CODE_FOR_zero_extendhisi2 },
  { 0x60181b, CODE_FOR_floatsisf2 },
  { 0x70181b, CODE_FOR_floatunssisf2 },
  { 0x1206c06, CODE_FOR_fix_truncsfsi2 },
  { 0x1306c06, CODE_FOR_fixuns_truncsfsi2 },
  { 0x1401406, CODE_FOR_mulhisi3 },
  { 0x1401807, CODE_FOR_mulsidi3 },
  { 0x1501406, CODE_FOR_umulhisi3 },
  { 0x1501807, CODE_FOR_umulsidi3 },
  { 0x3b00006, CODE_FOR_addsi3 },
  { 0x3b00007, CODE_FOR_adddi3 },
  { 0x3b0001b, CODE_FOR_addsf3 },
  { 0x3f00006, CODE_FOR_subsi3 },
  { 0x3f00007, CODE_FOR_subdi3 },
  { 0x3f0001b, CODE_FOR_subsf3 },
  { 0x4300006, CODE_FOR_mulsi3 },
  { 0x430001b, CODE_FOR_mulsf3 },
  { 0x4700006, CODE_FOR_divsi3 },
  { 0x4a00006, CODE_FOR_udivsi3 },
  { 0x4e00006, CODE_FOR_modsi3 },
  { 0x4f00006, CODE_FOR_umodsi3 },
  { 0x5100006, CODE_FOR_andsi3 },
  { 0x5200006, CODE_FOR_iorsi3 },
  { 0x5300006, CODE_FOR_xorsi3 },
  { 0x5400006, CODE_FOR_ashlsi3 },
  { 0x5700006, CODE_FOR_ashrsi3 },
  { 0x5800006, CODE_FOR_lshrsi3 },
  { 0x5900006, CODE_FOR_rotlsi3 },
  { 0x5a00006, CODE_FOR_rotrsi3 },
  { 0x6000006, CODE_FOR_sminsi3 },
  { 0x6100006, CODE_FOR_smaxsi3 },
  { 0x6200006, CODE_FOR_uminsi3 },
  { 0x6300006, CODE_FOR_umaxsi3 },
  { 0x6400006, CODE_FOR_negsi2 },
  { 0x640001b, CODE_FOR_negsf2 },
  { 0x6800006, CODE_FOR_abssi2 },
  { 0x680001b, CODE_FOR_abssf2 },
  { 0x6a00006, CODE_FOR_one_cmplsi2 },
  { 0x6b00005, CODE_FOR_bswaphi2 },
  { 0x6b00006, CODE_FOR_bswapsi2 },
  { 0x6b00007, CODE_FOR_bswapdi2 },
  { 0x6c00006, CODE_FOR_ffssi2 },
  { 0x6d00006, CODE_FOR_clzsi2 },
  { 0x6e00006, CODE_FOR_ctzsi2 },
  { 0x6f00006, CODE_FOR_clrsbsi2 },
  { 0x7d00004, CODE_FOR_sync_old_addqi },
  { 0x7d00005, CODE_FOR_sync_old_addhi },
  { 0x7e00004, CODE_FOR_sync_old_subqi },
  { 0x7e00005, CODE_FOR_sync_old_subhi },
  { 0x7f00004, CODE_FOR_sync_old_iorqi },
  { 0x7f00005, CODE_FOR_sync_old_iorhi },
  { 0x8000004, CODE_FOR_sync_old_andqi },
  { 0x8000005, CODE_FOR_sync_old_andhi },
  { 0x8100004, CODE_FOR_sync_old_xorqi },
  { 0x8100005, CODE_FOR_sync_old_xorhi },
  { 0x8200004, CODE_FOR_sync_old_nandqi },
  { 0x8200005, CODE_FOR_sync_old_nandhi },
  { 0x8300004, CODE_FOR_sync_new_addqi },
  { 0x8300005, CODE_FOR_sync_new_addhi },
  { 0x8400004, CODE_FOR_sync_new_subqi },
  { 0x8400005, CODE_FOR_sync_new_subhi },
  { 0x8500004, CODE_FOR_sync_new_iorqi },
  { 0x8500005, CODE_FOR_sync_new_iorhi },
  { 0x8600004, CODE_FOR_sync_new_andqi },
  { 0x8600005, CODE_FOR_sync_new_andhi },
  { 0x8700004, CODE_FOR_sync_new_xorqi },
  { 0x8700005, CODE_FOR_sync_new_xorhi },
  { 0x8800004, CODE_FOR_sync_new_nandqi },
  { 0x8800005, CODE_FOR_sync_new_nandhi },
  { 0x8900004, CODE_FOR_sync_compare_and_swapqi },
  { 0x8900005, CODE_FOR_sync_compare_and_swaphi },
  { 0x8900006, CODE_FOR_sync_compare_and_swapsi },
  { 0x8a00004, CODE_FOR_sync_lock_test_and_setqi },
  { 0x8a00005, CODE_FOR_sync_lock_test_and_sethi },
  { 0x8b00004, CODE_FOR_movqi },
  { 0x8b00005, CODE_FOR_movhi },
  { 0x8b00006, CODE_FOR_movsi },
  { 0x8b00007, CODE_FOR_movdi },
  { 0x8b0001b, CODE_FOR_movsf },
  { 0x8b0001c, CODE_FOR_movdf },
  { 0x9000006, CODE_FOR_extvsi },
  { 0x9100006, CODE_FOR_extzvsi },
  { 0x9800006, CODE_FOR_cbranchsi4 },
  { 0x980001b, CODE_FOR_cbranchsf4 },
  { 0x9e00006, CODE_FOR_movsicc },
  { 0x9e0001b, CODE_FOR_movsfcc },
  { 0xd500006, CODE_FOR_cstoresi4 },
  { 0xd50001b, CODE_FOR_cstoresf4 },
  { 0xe300006, CODE_FOR_umulsi3_highpart },
  { 0xe700006, CODE_FOR_cpymemsi },
  { 0xe900006, CODE_FOR_setmemsi },
  { 0xec0001b, CODE_FOR_fmasf4 },
  { 0xee0001b, CODE_FOR_fnmasf4 },
  { 0x19200004, CODE_FOR_sync_addqi },
  { 0x19200005, CODE_FOR_sync_addhi },
  { 0x19300004, CODE_FOR_sync_andqi },
  { 0x19300005, CODE_FOR_sync_andhi },
  { 0x19400004, CODE_FOR_sync_iorqi },
  { 0x19400005, CODE_FOR_sync_iorhi },
  { 0x19500006, CODE_FOR_sync_lock_releasesi },
  { 0x19600004, CODE_FOR_sync_nandqi },
  { 0x19600005, CODE_FOR_sync_nandhi },
  { 0x19700004, CODE_FOR_sync_subqi },
  { 0x19700005, CODE_FOR_sync_subhi },
  { 0x19800004, CODE_FOR_sync_xorqi },
  { 0x19800005, CODE_FOR_sync_xorhi },
  { 0x1b700006, CODE_FOR_get_thread_pointersi },
  { 0x1b800006, CODE_FOR_set_thread_pointersi },
};

void
init_all_optabs (struct target_optabs *optabs)
{
  bool *ena = optabs->pat_enable;
  ena[0] = HAVE_extendqisi2;
  ena[1] = HAVE_extendhisi2;
  ena[2] = HAVE_zero_extendqisi2;
  ena[3] = HAVE_zero_extendhisi2;
  ena[4] = HAVE_floatsisf2;
  ena[5] = HAVE_floatunssisf2;
  ena[6] = HAVE_fix_truncsfsi2;
  ena[7] = HAVE_fixuns_truncsfsi2;
  ena[8] = HAVE_mulhisi3;
  ena[9] = HAVE_mulsidi3;
  ena[10] = HAVE_umulhisi3;
  ena[11] = HAVE_umulsidi3;
  ena[12] = HAVE_addsi3;
  ena[13] = HAVE_adddi3;
  ena[14] = HAVE_addsf3;
  ena[15] = HAVE_subsi3;
  ena[16] = HAVE_subdi3;
  ena[17] = HAVE_subsf3;
  ena[18] = HAVE_mulsi3;
  ena[19] = HAVE_mulsf3;
  ena[20] = HAVE_divsi3;
  ena[21] = HAVE_udivsi3;
  ena[22] = HAVE_modsi3;
  ena[23] = HAVE_umodsi3;
  ena[24] = HAVE_andsi3;
  ena[25] = HAVE_iorsi3;
  ena[26] = HAVE_xorsi3;
  ena[27] = HAVE_ashlsi3;
  ena[28] = HAVE_ashrsi3;
  ena[29] = HAVE_lshrsi3;
  ena[30] = HAVE_rotlsi3;
  ena[31] = HAVE_rotrsi3;
  ena[32] = HAVE_sminsi3;
  ena[33] = HAVE_smaxsi3;
  ena[34] = HAVE_uminsi3;
  ena[35] = HAVE_umaxsi3;
  ena[36] = HAVE_negsi2;
  ena[37] = HAVE_negsf2;
  ena[38] = HAVE_abssi2;
  ena[39] = HAVE_abssf2;
  ena[40] = HAVE_one_cmplsi2;
  ena[41] = HAVE_bswaphi2;
  ena[42] = HAVE_bswapsi2;
  ena[43] = HAVE_bswapdi2;
  ena[44] = HAVE_ffssi2;
  ena[45] = HAVE_clzsi2;
  ena[46] = HAVE_ctzsi2;
  ena[47] = HAVE_clrsbsi2;
  ena[48] = HAVE_sync_old_addqi;
  ena[49] = HAVE_sync_old_addhi;
  ena[50] = HAVE_sync_old_subqi;
  ena[51] = HAVE_sync_old_subhi;
  ena[52] = HAVE_sync_old_iorqi;
  ena[53] = HAVE_sync_old_iorhi;
  ena[54] = HAVE_sync_old_andqi;
  ena[55] = HAVE_sync_old_andhi;
  ena[56] = HAVE_sync_old_xorqi;
  ena[57] = HAVE_sync_old_xorhi;
  ena[58] = HAVE_sync_old_nandqi;
  ena[59] = HAVE_sync_old_nandhi;
  ena[60] = HAVE_sync_new_addqi;
  ena[61] = HAVE_sync_new_addhi;
  ena[62] = HAVE_sync_new_subqi;
  ena[63] = HAVE_sync_new_subhi;
  ena[64] = HAVE_sync_new_iorqi;
  ena[65] = HAVE_sync_new_iorhi;
  ena[66] = HAVE_sync_new_andqi;
  ena[67] = HAVE_sync_new_andhi;
  ena[68] = HAVE_sync_new_xorqi;
  ena[69] = HAVE_sync_new_xorhi;
  ena[70] = HAVE_sync_new_nandqi;
  ena[71] = HAVE_sync_new_nandhi;
  ena[72] = HAVE_sync_compare_and_swapqi;
  ena[73] = HAVE_sync_compare_and_swaphi;
  ena[74] = HAVE_sync_compare_and_swapsi;
  ena[75] = HAVE_sync_lock_test_and_setqi;
  ena[76] = HAVE_sync_lock_test_and_sethi;
  ena[77] = HAVE_movqi;
  ena[78] = HAVE_movhi;
  ena[79] = HAVE_movsi;
  ena[80] = HAVE_movdi;
  ena[81] = HAVE_movsf;
  ena[82] = HAVE_movdf;
  ena[83] = HAVE_extvsi;
  ena[84] = HAVE_extzvsi;
  ena[85] = HAVE_cbranchsi4;
  ena[86] = HAVE_cbranchsf4;
  ena[87] = HAVE_movsicc;
  ena[88] = HAVE_movsfcc;
  ena[89] = HAVE_cstoresi4;
  ena[90] = HAVE_cstoresf4;
  ena[91] = HAVE_umulsi3_highpart;
  ena[92] = HAVE_cpymemsi;
  ena[93] = HAVE_setmemsi;
  ena[94] = HAVE_fmasf4;
  ena[95] = HAVE_fnmasf4;
  ena[96] = HAVE_sync_addqi;
  ena[97] = HAVE_sync_addhi;
  ena[98] = HAVE_sync_andqi;
  ena[99] = HAVE_sync_andhi;
  ena[100] = HAVE_sync_iorqi;
  ena[101] = HAVE_sync_iorhi;
  ena[102] = HAVE_sync_lock_releasesi;
  ena[103] = HAVE_sync_nandqi;
  ena[104] = HAVE_sync_nandhi;
  ena[105] = HAVE_sync_subqi;
  ena[106] = HAVE_sync_subhi;
  ena[107] = HAVE_sync_xorqi;
  ena[108] = HAVE_sync_xorhi;
  ena[109] = HAVE_get_thread_pointersi;
  ena[110] = HAVE_set_thread_pointersi;
}

/* Returns TRUE if the target supports any of the partial vector
   optabs: while_ult_optab, len_load_optab, len_store_optab,
   mask_len_load_optab or mask_len_store_optab,
   for any mode.  */
bool
partial_vectors_supported_p (void)
{
	return false;
}
static int
lookup_handler (unsigned scode)
{
  int l = 0, h = ARRAY_SIZE (pats), m;
  while (h > l)
    {
      m = (h + l) / 2;
      if (scode == pats[m].scode)
        return m;
      else if (scode < pats[m].scode)
        h = m;
      else
        l = m + 1;
    }
  return -1;
}

enum insn_code
raw_optab_handler (unsigned scode)
{
  int i = lookup_handler (scode);
  return (i >= 0 && this_fn_optabs->pat_enable[i]
          ? pats[i].icode : CODE_FOR_nothing);
}

bool
swap_optab_enable (optab op, machine_mode m, bool set)
{
  unsigned scode = (op << 20) | m;
  int i = lookup_handler (scode);
  if (i >= 0)
    {
      bool ret = this_fn_optabs->pat_enable[i];
      this_fn_optabs->pat_enable[i] = set;
      return ret;
    }
  else
    {
      gcc_assert (!set);
      return false;
    }
}

const struct convert_optab_libcall_d convlib_def[NUM_CONVLIB_OPTABS] = {
  { "extend", gen_extend_conv_libfunc },
  { "trunc", gen_trunc_conv_libfunc },
  { NULL, NULL },
  { "fix", gen_fp_to_int_conv_libfunc },
  { "fixuns", gen_fp_to_int_conv_libfunc },
  { "float", gen_int_to_fp_conv_libfunc },
  { NULL, gen_ufloat_conv_libfunc },
  { "lrint", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lround", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lfloor", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lceil", gen_int_to_fp_nondecimal_conv_libfunc },
  { "fract", gen_fract_conv_libfunc },
  { "fractuns", gen_fractuns_conv_libfunc },
  { "satfract", gen_satfract_conv_libfunc },
  { "satfractuns", gen_satfractuns_conv_libfunc },
  { "ustrunc", NULL },
  { "sstrunc", NULL },
};

const struct optab_libcall_d normlib_def[NUM_NORMLIB_OPTABS] = {
  { '3', "add", gen_int_fp_fixed_libfunc },
  { '3', "add", gen_intv_fp_libfunc },
  { '3', "ssadd", gen_signed_fixed_libfunc },
  { '3', "usadd", gen_unsigned_fixed_libfunc },
  { '3', "sub", gen_int_fp_fixed_libfunc },
  { '3', "sub", gen_intv_fp_libfunc },
  { '3', "sssub", gen_signed_fixed_libfunc },
  { '3', "ussub", gen_unsigned_fixed_libfunc },
  { '3', "mul", gen_int_fp_fixed_libfunc },
  { '3', "mul", gen_intv_fp_libfunc },
  { '3', "ssmul", gen_signed_fixed_libfunc },
  { '3', "usmul", gen_unsigned_fixed_libfunc },
  { '3', "div", gen_int_fp_signed_fixed_libfunc },
  { '3', "divv", gen_int_libfunc },
  { '3', "ssdiv", gen_signed_fixed_libfunc },
  { '3', "udiv", gen_int_unsigned_fixed_libfunc },
  { '3', "usdiv", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "mod", gen_int_libfunc },
  { '3', "umod", gen_int_libfunc },
  { '2', "ftrunc", gen_fp_libfunc },
  { '3', "and", gen_int_libfunc },
  { '3', "ior", gen_int_libfunc },
  { '3', "xor", gen_int_libfunc },
  { '3', "ashl", gen_int_fixed_libfunc },
  { '3', "ssashl", gen_signed_fixed_libfunc },
  { '3', "usashl", gen_unsigned_fixed_libfunc },
  { '3', "ashr", gen_int_signed_fixed_libfunc },
  { '3', "lshr", gen_int_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "min", gen_int_fp_libfunc },
  { '3', "max", gen_int_fp_libfunc },
  { '3', "umin", gen_int_libfunc },
  { '3', "umax", gen_int_libfunc },
  { '2', "neg", gen_int_fp_fixed_libfunc },
  { '2', "neg", gen_intv_fp_libfunc },
  { '2', "ssneg", gen_signed_fixed_libfunc },
  { '2', "usneg", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '2', "one_cmpl", gen_int_libfunc },
  { '\0', NULL, NULL },
  { '2', "ffs", gen_int_libfunc },
  { '2', "clz", gen_int_libfunc },
  { '2', "ctz", gen_int_libfunc },
  { '2', "clrsb", gen_int_libfunc },
  { '2', "popcount", gen_int_libfunc },
  { '2', "parity", gen_int_libfunc },
  { '2', "cmp", gen_int_fp_fixed_libfunc },
  { '2', "ucmp", gen_int_libfunc },
  { '2', "eq", gen_fp_libfunc },
  { '2', "ne", gen_fp_libfunc },
  { '2', "gt", gen_fp_libfunc },
  { '2', "ge", gen_fp_libfunc },
  { '2', "lt", gen_fp_libfunc },
  { '2', "le", gen_fp_libfunc },
  { '2', "unord", gen_fp_libfunc },
  { '2', "powi", gen_fp_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
};

enum rtx_code const optab_to_code_[NUM_OPTABS] = {
  UNKNOWN,
  SIGN_EXTEND,
  TRUNCATE,
  ZERO_EXTEND,
  FIX,
  UNSIGNED_FIX,
  FLOAT,
  UNSIGNED_FLOAT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FRACT_CONVERT,
  UNSIGNED_FRACT_CONVERT,
  SAT_FRACT,
  UNSIGNED_SAT_FRACT,
  US_TRUNCATE,
  SS_TRUNCATE,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  PLUS,
  PLUS,
  SS_PLUS,
  US_PLUS,
  MINUS,
  MINUS,
  SS_MINUS,
  US_MINUS,
  MULT,
  MULT,
  SS_MULT,
  US_MULT,
  DIV,
  DIV,
  SS_DIV,
  UDIV,
  US_DIV,
  UNKNOWN,
  UNKNOWN,
  MOD,
  UMOD,
  UNKNOWN,
  AND,
  IOR,
  XOR,
  ASHIFT,
  SS_ASHIFT,
  US_ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  SMIN,
  SMAX,
  UMIN,
  UMAX,
  NEG,
  NEG,
  SS_NEG,
  US_NEG,
  ABS,
  ABS,
  NOT,
  BSWAP,
  FFS,
  CLZ,
  CTZ,
  CLRSB,
  POPCOUNT,
  PARITY,
  UNKNOWN,
  UNKNOWN,
  EQ,
  NE,
  GT,
  GE,
  LT,
  LE,
  UNORDERED,
  UNKNOWN,
  SQRT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  SET,
  STRICT_LOW_PART,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  COMPARE,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FMA,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  VEC_DUPLICATE,
  VEC_SERIES,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
};

const optab code_to_optab_[NUM_RTX_CODE] = {
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  mov_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  movstrict_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  cbranch_optab,
  add_optab,
  sub_optab,
  neg_optab,
  smul_optab,
  ssmul_optab,
  usmul_optab,
  unknown_optab,
  unknown_optab,
  sdiv_optab,
  ssdiv_optab,
  usdiv_optab,
  smod_optab,
  udiv_optab,
  umod_optab,
  and_optab,
  ior_optab,
  xor_optab,
  one_cmpl_optab,
  ashl_optab,
  rotl_optab,
  ashr_optab,
  lshr_optab,
  rotr_optab,
  smin_optab,
  smax_optab,
  umin_optab,
  umax_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  ne_optab,
  eq_optab,
  ge_optab,
  gt_optab,
  le_optab,
  lt_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unord_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  abs_optab,
  sqrt_optab,
  bswap_optab,
  ffs_optab,
  clrsb_optab,
  clz_optab,
  ctz_optab,
  popcount_optab,
  parity_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  vec_duplicate_optab,
  vec_series_optab,
  ssadd_optab,
  usadd_optab,
  sssub_optab,
  ssneg_optab,
  usneg_optab,
  unknown_optab,
  ssashl_optab,
  usashl_optab,
  ussub_optab,
  unknown_optab,
  unknown_optab,
  fma_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
};

